;940705 1609
;****************************************************************************
;* PROGRAM NAME: CCDCC   .ASM   DATE:  3.10.1992    LINK INTO: CCDCONVT.BAS *
;* LANGUAGE: Turbo Assembler TASM 2.01                                      *
;* PURPOSE:  Procedures and functions for CCDCONVT                          *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.15 25-JUN-94 Added FITS format                               *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.14  1-JUN-94 Added Version Function CCDCCV = 114             *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.13 19-JAN-94 Introduced ST-6 Read/Write                      *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.12 26-SEP-93 Introduced Lynxx, ST4 and PIX Read/Write        *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.11 22-MAY-93 Changed for integer rotation                    *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.10 26-MAR-93 Redid it for PB3 and CCDUTIL 2.00               *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.03  4-MAR-93 Renamed to CCDUC from CCDFLIP.                  *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.02  8-NOV-92 Fixed serious bug in rotation part.             *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01 18-SEP-92 (17-OCT-92 extracted from CCDRTNS.ASM)          *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.00c                 *
;*            = declare function CCDCCV%()                                  *
;*            = declare sub DecLnx(integer,integer)                         *
;*            = declare sub EncLnx(integer,integer)                         *
;*            = declare sub EDCST4(integer,string,integer,integer)          *
;*            = declare sub EDCPix(integer,integer,integer)                 *
;*            = declare sub FLIPXY(integer,integer)                         *
;*            = declare sub RoTwic(integer,integer)                         *
;*            = declare sub MovLft(integer,integer)                         *
;*            = declare sub TwoGet(integer,integer,word,word)               *
;*            = declare sub TwoBin(integer,integer,word)                    *
;*            = declare function TwoLU%(integer,integer)                    *
;*            = declare function TwoLC%(integer,integer,integer)            *
;*            = declare function HotSpt%(integer,word)                      *
;*            = declare function Delta%(integer,integer,integer,integer)    *
;*            = declare function RdFit%(integer,integer,integer,integer)    *
;*            = declare function WrFits%(integer,integer,integer)           *
;*            = $link "CCDCC.OBJ"    and PBSTACK.OBJ !!                     *
;*             call FLIPXY(CCD%(1,1),Mode%)                                *
;*                                    Mode% = 1: Y-axis flip                *
;*                                    Mode% = 2: X-axis flip                *
;*                                    Mode% = 3: rotate 90 CCW             *
;*             call Pix43C(I1%,I2%,B$)                                     *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDCC                                                 *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
rows	equ	165			;165 rows
cols	equ	192			;192 columns
hrows	equ	 82			;half rows, 82 = fix(165/2)
hcols	equ	 96			;half columns, 96 = 192/2
dos	equ	 33			;DOS Function Interrupt 21h
readf	equ	 63			;DOS Function 3Fh Read
writef	equ	 64			;DOS Function 40h Write
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;PB3, alternate for PB2: Get$Loc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDCCV%
;----------------------------------------------------------------------------
;
CCDCCV		proc	far
		public	CCDCCV
;
                call	pbastk
		mov	ax,115		;V.1.15
		xor	bl,bl
                jmp	bakbas
;
CCDCCV	endp
;
;
; PROCEDURES
;============================================================================
;
; PROCEDURE  reads 12 bit Lynx file into CCD% and converts it to 16 bits
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call DecLnx(Handle%,CCD%(1,1))
;============================================================================
;
DECLNX	proc	far
	public	DECLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = DOS File-Handle
	mov	ah,readf		;AH = function read
	mov	cx,47520		;CX = number of bytes to read
	push	cx			;save bytes
	int	dos			;read whole file
	pop	cx			;restore bytes
	jc	decly1			;error
	cmp	ax,cx			;check all read
	jnz	decly1			;error
	lds	si,[bp+6]		;(DS:SI) = (CCD%(1,1))
	les	di,[bp+6]		;(ES:DI) = (CCD%(1,1))
	add	si,47519		;point to last byte loaded
	add	di,63359		;point to last byte in CCD%
	std				;set direction flag to descending
	mov	cx,23760		;23760 x 2 = 47520
	rep	movsw			;copy to last element
	inc	si			;point to first element
	inc	di			;point to first dest element at 15840
	xchg	si,di			;swap source and dest pointers
	push	es
	push	ds
	pop	es
	pop	ds			;swap source and dest segments
	mov	cx,15840		;15840 x 3 = 47520
	cld				;clear direction flag to ascending
decly0:	movsb				;copy low byte-1
	lodsb				;AL = byte-2H Byte-1H
	mov	ah,al			;AH copy of Byte-1H
	and	al,15			;remove high nibble
	stosb				;store Byte-1H
	movsb				;copy low byte-2
	mov	al,ah			;get Byte-2H
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1			;Byte-2H high- to low nibble
	stosb				;store Byte-2H
	loop	decly0			;repeat
	mov	ax,-1			;true flag
	jmp	short decly2		;store flag and return
decly1:	xor	ax,ax			;flag false
decly2:	les	di,[bp+10]		;point to Handle%
	stosw				;return flag
	mov	bl,2			;2 parameters
	jmp	bakbas
;
DECLNX	endp
;
;
; PROCEDURE  writes 12 bit Lynx file from 16-bit CCD%.
;            Byte-1: Pixel-1 low byte
;            Byte-2: Pixel-1 high byte at low nibble position
;            Byte-2: Pixel-2 high byte at high nibble position
;            Byte-3: Pixel-2 low byte
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EncLnx(Handle%,SyLyFlg%,CCD%(1,1))
;============================================================================
;
ENCLNX	proc	far
	public	ENCLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	les	di,[bp+6]		;(ES:DI) = (CCD%(1,1))
	mov	dx,si			;start of buffer
	mov	cx,15840		;15840 x 3 = 47520
encly2:	movsb				;copy byte-1L
	lodsb				;get byte-1H
	and	al,15			;clear high nibble
	mov	ah,al			;save byte-1H
	lodsb				;get byte-2L
	mov	bl,al			;put byte-2L aside
	lodsb				;get byte-2H
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1			;byte-2H to high nibble
	or	al,ah			;combine byte-2H and byte-1H
	stosb				;store both nibbles
	mov	al,bl			;get byte-2L
	stosb				;store byte-2L
	loop	encly2			;repeat
	mov	ah,writef		;function 40h write to file
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = handle
	mov	cx,47520		;CX = number of bytes to write
	push	cx			;save byte counter
	int	dos			;write it
	pop	cx			;restore byte count
	xor	dx,dx			;assume error
	jc	encly3			;error
	cmp	ax,cx			;test wether all bytes are written
	jnz	encly3			;jump if not
	dec	dx			;DX = -1 = True
encly3:	lds	si,[bp+10]
	mov	ds:[si],dx		;save flag
	mov	bl,2			;2 parameters
	jmp	bakbas
;
ENCLNX	endp
;
;
; PROCEDURE  either reads or writes ST4 File into/from CCB% and the 166th
;            line into/from R$. F% has 63 or 64 respectively.
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EDCST4(F%,R$,Handle%,CCB%(1))
;============================================================================
;
EDCST4	proc	far
	public	EDCST4
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 31680 bytes
	mov	cx,31680		;165 x 192
	push	cx			;save it for compare later on
	int	dos
	pop	cx			;restore counter
	mov	dx,0			;assume error
	jc	edcst0			;error
	cmp	ax,cx
	jnz	edcst0			;error
	lds	si,[bp+14]		;(DS:SI) = (R$)
	mov	cx,ds:[si]
	push	cx
	call	GetStrLoc		;locate R$
	mov	ds,dx			;segment
	mov	dx,ax			;offset
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	mov	cx,192			;1 x 192
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 192 bytes
	int	dos
	jc	edcst0			;error
	cmp	ax,192
	jnz	edcst0			;error
	mov	dx,-1			;no error flag
edcst0:	lds	si,[bp+10]		;(ES:DI) = (Handle%)
	mov	ds:[si],dx		;save flag
	mov	bl,4			;4 parameters
	jmp	bakbas
;
EDCST4	endp
;
;
; PROCEDURE reads PIX file into CCD%. Filepointer is set to 7
;    call DecPic(F%,Handle%,CCD%(1,1))
;----------------------------------------------------------------------------
;
EDCPIX	proc	far
	public	EDCPIX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	mov	dx,si			;DS:SI = buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = handle
	les	di,[bp+14]
	mov	ax,es:[di]		;F%
	mov	ah,al			;read or write
	mov	cx,63360		;165 * 192 * 2
	push	cx			;save byte counter
	int	dos
	pop	cx			;restore byte counter
	mov	dx,0			;assume error
	jc	edcpi0			;error
	cmp	ax,cx
	jnz	edcpi0			;error
	mov	dx,-1			;no error
edcpi0:	lds	si,[bp+10]		;access handle
	mov	ds:[si],dx		;return handle
	mov	bl,3			;2 parameters
	jmp	bakbas
;
EDCPIX	endp
;
;
; PROCEDURE  flips image along either X- or Y axis or rotates it 90 ccw
;----------------------------------------------------------------------------
;
FLIPXY	proc	far
	public	FLIPXY                  ;whatever name
;
; First, we get the start address of CCD%(1,1) and the Flip%-Mode
;
	call	pbastk			;save environment
	mov	ax,cx			;AX=Flag
	lds	si,[bp+10]		;(DS:SI) = (CCD%(1,1))
	dec	al			;if Y-axis (1), AL is now 0
	jnz	noty			;if not Y, test next
	jmp	yaxis			;if Y, handle it
noty:	dec	al			;if X-axis (2), AL is now 0
	jnz	notx			;if not X, test next
	jmp	xaxis			;if X, handle it
notx:	dec	al			;if CCW (3), AL is now 0
	jnz	notccw			;exit
	jmp	ccw			;if CCW, handle it
notccw:	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
; The Y-Axis flip is performed here. The flip is along the Y-axis and this
; flips left/right. The generalized procedure is:
;
;   for Rx = 1 to fix(X/2)         where X:  max. columns (192)
;     for Cy = 1 to Y                    Y:  max. rows (165)
;       Pa = (Rx-1) * Y + Cy-1           Rx: actual X-position
;       Pb = (X-Rx) * Y + Cy-1           Cy: actual Y-position
;     next Cy                            Pa: position of dot-A
;   next Rx                              Pb: position of dot-B
;
yaxis:	xor	bx,bx			;clear Rx
yaxis1:	inc	bx			;next Rx
	xor	cx,cx			;reset Cy
yaxis2:	inc	cx			;next Cy
	mov	ax,bx			;get Rx
	dec	ax			;calculate (Rx-1)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (Rx-1)*Y
	add	ax,cx			;calculate (Rx-1)*Y+Cy
	dec	ax			;calculate (Rx-1)*Y+Cy-1
	shl	ax,1			;calculate ((Rx-1)*Y+Cy-1)*2
	add	ax,si			;AX=offset to element-A
	push	ax			;save offset to element-A
	mov	ax,cols			;get columns
	sub	ax,bx			;calculate (X-Rx)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (X-Rx)*Y
	add	ax,cx			;calculate (X-Rx)*Y+Cy
	dec	ax			;calculate (X-Rx)*Y+Cy-1
	shl	ax,1			;calculate ((X-Rx)*Y+Cy-1)*2
	add	ax,si			;AX=offset to element-B
	pop	dx			;DX=offset to element-A
	push	si			;save offset to CCD%(1,1)
	mov	si,ax			;SI=address of element-B
	mov	di,dx			;DI=address of element-A
	mov	ax,[si]			;get element-B
	mov	dx,[di]			;get element-A
	mov	[si],dx			;store element-A at element-B
	mov	[di],ax			;store element-B at element-A
	pop	si			;restore offset to CCD%(1,1)
	cmp	cx,rows			;check if thru
	jc	yaxis2			;do all Cy
	cmp	bx,hcols		;check if thru
	jc	yaxis1			;do half of Rx
	jmp	flipex			;exit
;
; The X-Axis flip is performed here. The flip is along the X-axis and this
; flips up/down. The generalized procedure is:
;
;   for Cy = 1 to fix(Y/2)         where X:  max. columns (192)
;     for Rx = 1 to X                    Y:  max. rows (165)
;       Pa = (Rx-1) * Y + Cy-1           Rx: actual X-position
;       Pb = (Rx-1) * Y + Y-Cy           Cy: actual Y-position
;     next Rx                            Pa: position of dot-A
;   next Cy                              Pb: position of dot-B
;
xaxis:	xor	cx,cx			;clear Cy
xaxis1:	inc	cx			;next Cy
	xor	bx,bx			;reset Rx
xaxis2:	inc	bx			;next Rx
	mov	ax,bx			;get Rx
	dec	ax			;calculate (Rx-1)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (Rx-1)*Y
	mov	dx,ax			;save this one in DX
	add	ax,cx			;calculate (Rx-1)*Y+Cy
	dec	ax			;calculate (Rx-1)*Y+Cy-1
	shl	ax,1			;calculate ((Rx-1)*Y+Cy-1)*2
	add	ax,si			;AX=offset to element-A
	push	ax			;save address of element-A
	push	dx			;save (Rx-1)*Y
	mov	dx,rows			;get rows
	sub	dx,cx			;calculate (Y-Cy)
	pop	ax			;get (Rx-1)*Y
	add	dx,ax			;calculate (Rx-1)*Y + Y - Cy
	shl	dx,1			;calculate ((Rx-1)*Y+Y-Cy)*2
	add	dx,si			;DX=offset to element-B
	pop	ax			;restore offset to element-A
	push	si			;save offset to CCD%(1,1)
	mov	si,ax			;SI=address of element-A
	mov	di,dx			;DI=address of element-B
	mov	ax,[si]			;get element-A
	mov	dx,[di]			;get element-B
	mov	[si],dx			;store element-B at element-A
	mov	[di],ax			;store element-A at element-B
	pop	si			;restore offset to CCD%(1,1)
	cmp	bx,cols			;check if 192
	jc	xaxis2			;do all Rx
	cmp	cx,hrows		;check if 82
	jc	xaxis1			;do half of Cy
	jmp	flipex  		;exit
;
; We handle 90 degrees rotation in counterclock wise direction of a squarred
; image. The generalized procedure is:
;
;   for Rx = 1 to fix(Y/2)         where Y:  max. rows and columns (165)
;     for Cy = Rx to Y-Rx                Rx: actual X-position
;       Pa = (Rx-1) * Y + Cy-1           Cy: actual Y-position
;       Pb = (Cy-1) * Y + Y-Rx           Pa: top-left corner
;       Pc = (Y-Rx) * Y + Y-Cy           Pb: botton-left corner
;       Pd = (Y-Cy) * Y + Rx-1           Pc: botton-right corner
;     next Cy                            Pd: top-right corner
;   next Rx
;
; Moving is done in concentric circles from the edge inward. The positions
; move as follows: Save A, D-->A, C-->D, B-->C, Restore A to B.
;
ccw:	xor	bx,bx			;clear Rx
ccw1:	mov	cx,bx			;Cy = Rx
	inc	bx			;next Rx
ccw2:   inc	cx			;next Cy
	mov	ax,bx			;Rx
	dec	ax			;(Rx-1)
	mov	dx,rows			;Y = 165
	mul	dx			;(Rx-1)*Y
	add	ax,cx			;(Rx-1)*Y+Cy
	dec	ax			;(Rx-1)*Y+Cy-1
	shl	ax,1			;((Rx-1)*Y+Cy-1)*2
	add	ax,si			;address-A
	mov	di,ax			;DI=addr-A
	mov	ax,[di]			;get value-A
	push	ax			;save value-A
	mov	dx,rows			;Y
	mov	ax,dx			;Y
	sub	ax,cx			;(Y-Cy)
	mul	dx			;(Y-Cy)*Y
	add	ax,bx			;(Y-Cy)*Y+Rx
	dec	ax			;(Y-Cy)*Y+Rx-1
	shl	ax,1			;((Y-Cy)*Y+Rx-1)*2
	add	ax,si			;address-D
	push	si			;save CCD% base address
	mov	si,ax			;SI=address
	mov	ax,[si]			;get value-D
	mov	[di],ax			;move to addr-A
	mov	di,si			;DI=addr-D
	pop	si			;restore CCD% base address
	mov	dx,rows			;Y
	mov	ax,dx			;Y
	sub	ax,bx			;(Y-Rx)
	mul	dx			;(Y-Rx)*Y
	add	ax,rows			;(Y-Rx)*Y+Y
	sub	ax,cx			;(Y-Rx)*Y+Y-Cy
	shl	ax,1			;((Y-Rx)*Y+Y-Cy)*2
	add	ax,si			;addr-C
	push	si			;save CCD% base address
	mov	si,ax			;SI=address
	mov	ax,[si]			;get value-C
	mov	[di],ax			;move to addr-D
	mov	di,si			;DI=addr-C
	pop	si			;restore CCD% base address
	mov	dx,rows			;Y
	mov	ax,cx			;Cy
	dec	ax			;(Cy-1)
	mul	dx			;(Cy-1)*Y
	add	ax,rows			;(Cy-1)*Y+Y
	sub	ax,bx			;(Cy-1)*Y+Y-Rx
	shl	ax,1			;((Cy-1)*Y+Y-Rx)*2
	add	ax,si			;addr-B
	push	si			;save CCD% base address
	mov	si,ax			;SI=address
	mov	ax,[si]			;get value-B
	mov	[di],ax			;move to addr-C
	mov	di,si			;DI=addr-B
	pop	si			;restore CCD% base address
	pop	ax			;get value-A
	mov	[di],ax			;move value-A to B
	mov	ax,rows			;Y
	sub	ax,bx			;Y-Rx
	cmp	cx,ax			;Cy <= (Y-Rx)?
	jnc	ccw3
	jmp	ccw2
ccw3:	cmp	bx,hrows		;Y/2
	jnc	flipex			;all done
	jmp	ccw1			;for RX = 1 to Y/2
;
; Common exit for all three flippers
;
flipex:	mov	bl,2			;2 parameters
	jmp	bakbas
;
FLIPXY	endp
;
;
; PROCEDURE rotates twice by 180 without loosing part of image wordwise.
;           This is an improvement over FlipIt twice.
;    call RoTwic(CCD%(165,192),CCD%(1,1))
;----------------------------------------------------------------------------
;
ROTWIC	proc	far
	public	ROTWIC
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
        les	di,[bp+10]		;(ES:DI) = (CCD%(165,192))
        mov	cx,15840		;elements / 2
rotwi1:	mov	ax,ds:[si]		;get top left
	mov	bx,es:[di]		;get bottom right
        mov	es:[di],ax		;top left to bottom right
        mov	ds:[si],bx		;bottom right to top left
        inc	si
        inc	si			;next top source/dest
        dec	di
        dec	di			;next bottom source/dest
        loop	rotwi1			;all elements
	mov	bl,2			;one parameter
        jmp	bakbas
;
ROTWIC	endp
;
;
; PROCEDURE moves column word wise left within array from A% hence
;     call MovLft(CCQ%(1),A%)
;----------------------------------------------------------------------------
;
MOVLFT	proc	far
	public	MOVLFT
;
	call	pbastk			;A% [0:27]
	lds	si,[bp+10]		;(DS:SI) = (CCQ%(1))
	add	si,cx
	add	si,cx			;(DS:SI) = (CCQ%(A%))
	les	di,[bp+10]		;(ES:DI) = (CCQ%(1))
	mov	dx,27			;DX = 27+165=192
	xor	ax,ax			;AX = 0
	mov	bl,165			;row counter
	mov	bh,27			;fill counter
movlf1:	mov	cl,165			;165 - CH = 0 anyway
	rep	movsw			;move 165 words
	mov	cl,bh
	rep	stosw			;27 words to clear
	add	si,dx			;source + 27
	add	si,dx
	dec	bl			;next row
	jnz	movlf1
	mov	bl,2			;1 parameter
	jmp	bakbas
;
MOVLFT	endp
;
;
; PROCEDURE  combines two lines into one using averaging (binning).
;            Binned values are set into CCD%(1,1)+DO??.
;            18-bit calculation
;    call TwoBin(CCD%(1,1),CCQ%(1,1),DO??)
;----------------------------------------------------------------------------
;
TWOBIN	proc	far
	public	TWOBIN
;
	call	pbastk			;CX = Offset into CCD%
        lds	si,[bp+10]		;(DS:SI) = (CCQ%(1,1))
        les	di,[bp+14]		;(ES:DI) = (CCD%(1,1))
        add	di,cx			;start in CCD%
        mov	cx,187			;187 x 2 = 374
twobi0:	mov	bx,64			;result BH:DX BL sets Bit 6 and 7
	lodsw				;get value 1
        mov	dx,ds:[si]		;get value 2
        add	dx,ax			;1 + 2
        jnc	twobi1			;if no overflow
        add	bh,bl			;overflow to bh
twobi1:	add	si,748
        lodsw				;get value 3
        add	dx,ax			;1+2 + 3
        jnc	twobi2			;if no overflow
        add	bh,bl			;overflow into bh
twobi2:	mov	ax,ds:[si]		;get value 4
        add	ax,dx			;1+2+3 + 4
        jnc	twobi3			;if no overflow
        add	bh,bl			;overflow into bh
twobi3:	sub	si,748
        shr	ax,1			;divide by 2
        shr	ax,1			;divide by 4
        or	ah,bh			;add bits-16 and 17 to 14 and 15
        stosw				;save binned word
        loop	twobi0			;repeat for full line
        mov	bx,64			;clear overflow counter
	lodsw				;last column upper line
        mov	dx,ax
        add	si,748
        mov	ax,ds:[si]		;last column, lower line
        add	ax,dx
        jnc	twobi4			;if no overflow
        add	bh,bl			;overflow into bh
twobi4:	shr	ax,1			;divide by two
        or	ah,bh			;add bit-16 to 14
        stosw
        mov	bl,3			;3 parameters
        jmp	bakbas
;
TWOBIN	endp
;
;
; PROCEDURE  copies 2 lines with 192 words from CCQ, offset QO into CCD at
;            offset DS
;    call TWOGET(CCD%(1,1),CCQ%(1,1),DO??,QO??)
;----------------------------------------------------------------------------
;
TWOGET	proc	far
	public	TWOGET
;
	call	pbastk			;CX = QO
        lds	si,[bp+10]
        mov	bx,ds:[si]		;BX = DO
        lds	si,[bp+14]		;(DS:SI) = (CCQ%(1,1))
        les	di,[bp+18]		;(ES:DI) = (CCD%(1,1))
        add	si,cx			;point to start
        add	di,bx			;point to dest
        mov	bl,2			;two lines
twoge0: mov	cx,192			;192 words
	rep	movsw			;copy
        add	si,366			;jump to next line
        dec	bl			;one line done
        jnz	twoge0			;do both lines
        mov	bl,4			;4 parameters
        jmp	bakbas
;
TWOGET	endp
;
;
; FUNCTIONS
;============================================================================
;
; FUNCTION  reads two uncompressed ST6 lines into CCQ and returns True if ok
;    if TwoLU%(CCQ%(1,1),Handle%) then OK
;----------------------------------------------------------------------------
;
TWOLU	proc	far
	public	TWOLU
;
	call	pbastk			;CX = Handle
	mov	bx,cx			;BX = handle
        lds	si,[bp+10]		;(DS:SI) = (CCQ%(1,1))
        mov	dx,si			;DS:DX = Buffer
        mov	cx,1500			;2 lines  375 words
        mov	ah,readf
        int	dos			;read 2 lines
        mov	ax,-1			;assume ok
        jnc	twolu1
        xor	ax,ax 			;flag false
twolu1:	mov	bl,2			;2 parameters
	jmp	bakbas
;
TWOLU	endp
;
;
; FUNCTION  reads two compressed ST-6 lines into CCQ and returns true if ok
;    if TwoLC%(CCQ%(1,1),CCA%(1),Handle%) then OK
;----------------------------------------------------------------------------
;
TWOLC	proc	far
	public	TWOLC
;
	call	pbastk			;CX = Handle
        mov	bx,cx			;BX = Handle
        lds	si,[bp+10]		;(DS:SI) = (CCA%(1))
        mov	dx,si			;DS:DX = Buffer
        mov	cx,2			;2 bytes for counter to read
        mov	ah,readf
        int	dos
        mov	ax,0			;assume error
        jc	twolc5			;exit on read error
        lodsw				;get bytes in DS:SI
        mov	cx,ax			;bytes to read
        add	dx,2			;buffer + 2
        mov	ah,readf
        int	dos			;read first compressed line
        mov	ax,0			;assume error
        jc	twolc5			;abort on read error
        add	dx,cx			;buffer + bytes read
        mov	si,dx			;pointer to next line start
        mov	cx,2			;2 bytes for counter to read
        mov	ah,readf
        int	dos
        mov	ax,0			;assume error
        jc	twolc5			;exit on read error
        lodsw				;get bytes in DS:SI
        mov	cx,ax			;bytes to read
        add	dx,2			;buffer + 2
        mov	ah,readf
        int	dos			;read second compressed line
        mov	ax,0			;assume error
        jc	twolc5			;abort on read error
;
	lds	si,[bp+10]		;(DS:SI) = (CCA%(1)) source
        les	di,[bp+14]		;(ES:DI) = (CCQ%(1,1)) destination
        mov	bh,128			;compare value
	mov	bl,2			;outer counter
twolc0:	lodsw				;get bytes to follow
	mov	cx,ax			;byte counter
        inc	cx			;compensate for one decrement
        cmp	ax,750			;750 bytes, if line uncompressed
        jnz	twolc1			;skip if compressed
        shr	cx,1			;remove incr and make words
        rep	movsw			;copy line
        jmp	short twolc4		;skip all compressed
twolc1:	dec	cx			;one word will be read
	jz	twolc4			;if zero exit inner loop
        dec	cx
        jz	twolc4
        lodsw				;read referrence word
twolc2:	stosw				;store word
	mov	dx,ax			;save referrence word
        xor	ah,ah			;assume next as positive
        dec	cx			;one byte will be read
        jz	twolc4			;if zero exit inner loop
        lodsb				;get delta byte
        cmp	al,bh			;is it 128
        jz	twolc1			;following word uncompressed
        jc	twolc3			;delta value is positive
        dec	ah			;AX now signed negative
twolc3:	add	ax,dx			;add positive or negative delta
	jmp	short twolc2		;save new value and continue
twolc4:	dec	bl			;one line done
	jnz	twolc0			;do two lines
        mov	ax,-1			;set success flag
twolc5:	mov	bl,3			;3 parameters
	jmp	bakbas
;
TWOLC	endp
;
;
; FUNCTION  returns number of hot spots above L% in CCD%. if there are less
;           then 256 (0.8%), they are considered as hot spots, if there are
;           more, zero is returned.
;    HotSpt% = (CCD%(1,1),L%)
;----------------------------------------------------------------------------
;
HOTSPT	proc	far
	public	HOTSPT
;
	call	pbastk			;CX = L%
        mov	bx,cx			;BX = L%
        lds	si,[bp+10]		;(DS:SI) = (CCD%(1,1))
        mov	cx,31680		;Elements
        xor	dx,dx			;counter
hotsp0:	lodsw				;get element
	cmp	ax,bx			;Element > Hot Spot?
        jc	hotsp1			;Element  Hot Spot
        inc	dx			;one Hot Spot
hotsp1:	loop	hotsp0			;do all elements
	xor	ax,ax			;assume more than 255 Hot Spots
        cmp	dh,ah			;if DH=0, less than 256 hot spots
        jnz	hotsp2			;more than 255 hot spots
        mov	al,dl			;get number hot spots
hotsp2:	mov	bl,2			;2 elements
	jmp	bakbas
;
HOTSPT	endp
;
;
; FUNCTION  encodes one line of ST-6 image in CCD% into delta in CCQ%. P%
;           has file position into CCD% as F%*2.
;    if not Delta%(CCQ%(1,1),CCD%(1,1),Handle%,F%*2) then goto WarnIO
;----------------------------------------------------------------------------
;
DELTA	proc	far
	public	DELTA
;
	call	pbastk			;CX = offset into CCD%
        lds	si,[bp+14]		;(DS:SI) = (CCD%(1,1))
        add	si,cx			;(DS:SI) = (CCD%(F%*2)) = srce
        les	di,[bp+18]		;(ES:DI) = (CCQ%(1,1)) = dest
        inc	di
        inc	di			;skip word for data length
        mov	cx,191			;1 + 191 words to do
;
	lodsw				;get reference word as first one
        stosw				;store reference word
delta1:	mov	dx,ax			;DX = reference word
	lodsw				;AX = next word
        mov	bx,ax			;BX = next word
        sub	ax,dx			;calculate delta
        call	range			;check AX [-127;+127]
        jz	delta2			;Z set = within range
        mov	al,128			;delta outside signed byte
        stosb				;new reference is going to follow
        mov	ax,bx			;get new reference word
        stosw				;store word
        jmp	short delta3		;skip
delta2:	stosb				;store delta byte
	add	ax,dx			;new reference word
delta3:	loop	delta1			;repeat
;
	mov	cx,92			;1 word + 182 bytes = 184 / 2 = 92
        mov	al,128			;prepare for reference word
        stosb				;new reference is going to follow
        xor	ax,ax			;new reference is zero
        rep	stosw			;fill up rest with zeroes
;
        mov	ax,di			;CCQ - buffer position
	lds	si,[bp+18]       	;(DS:SI) = (CCQ%(1,1))
        sub	ax,si			;calculate number of bytes
        mov	cx,ax			;CX = Bytes to write
        dec	ax
        dec	ax			;substract 2 bytes for counter
        mov	ds:[si],ax		;insert byte counter at line start
        les	di,[bp+10]		;(ES:DI) = (Handle%)
        mov	bx,es:[di]		;BX = DOS-handle
        mov	dx,si			;DS:DX = buffer start
        mov	ah,writef
        int	dos			;write line to file
        mov	ax,0			;assume write error
        jc	delta4			;return False if write error
        dec	ax			;set True
delta4:	mov	bl,4			;4 parameters
	jmp	bakbas
;
DELTA	endp
;
;
; FUNCTION returns false if read is successfull. Reads Z% bytes from
;          opened binary file with 8- or 16-bit data from FITS
;    if istrue RDFIT%(0%,Handle%,Z%,CCA%(1)) then goto error
;    if istrue RDFIT%(1%,Handle%,Z%,CCD%(1,1))
;----------------------------------------------------------------------------
;
RDFIT	proc	far
	public	RDFIT
;
	call	pbastk			;(DS:SI) = (CCA%(1))
	mov	dx,si			;(DS:DX) = Buffer
        les	di,[bp+10]
        mov	cx,es:[di]		;CX = bytes
	les	di,[bp+14]
	mov	bx,es:[di]		;BX = DOS File-Handle
        les	di,[bp+18]
        mov	al,es:[di]		;AL=0: 8bit, AL=1: 16bit
        dec	al
        jnz	rdfit0			;0-1 = <>0 : 8 bit
        shl	cx,1			;16-bit=words, bytes*2
rdfit0:	mov	ah,readf		;AH = function read
	int	dos			;read whole file
	jc	rdfit1			;error
	xor	ax,ax			;0 = no error
rdfit1:	mov	bl,4			;4 parameters
	jmp	bakbas
;
RDFIT	endp
;
;
; FUNCTION returns false if write ok. Writes FITS-Data. SF% is shift flag,
;          if 0 then bytes, if 1 words
;     if WrFits%(CCD%(1,1),Handle%,SF%) then print "Error"
;----------------------------------------------------------------------------
;
WRFITS	proc	far
	public	WRFITS
;
	call	pbastk			;DS:SI = SF%
        mov	dx,31680		;elements
	dec	cl			;if 1, then 0: words
        jnz	wrfit0			;skip multiply
        add	dx,dx			;words - bytes * 2
wrfit0: mov	cx,dx			;CX = bytes to write
	lds	si,[bp+10]		;(DS:SI) = Handle%
	mov	bx,ds:[si]		;BX = Handle%
        lds	si,[bp+14]		;(DS:SI) = (CCD%(1,1))
        mov	dx,si			;DS:DX = buffer
	mov	ah,writef		;DOS write, int 21
	int	dos			;write all
        jc	wrfit1			;error - return error code
        xor	ax,ax			;0 = no write error
wrfit1:	mov	bl,3			;3 parameters
        jmp	bakbas
;
WRFITS	endp
;
;
; SUBROUTINES
;============================================================================
;
; SUBROUTINE  returns Z if AX = [-127;127], else NZ
;----------------------------------------------------------------------------
;
RANGE	proc	near
;
	cmp	al,128			;check AL < 128
        jnc	range1			;if AL  128
        cmp	ah,0			;if AL [0;127] then AH 0 for Z
        ret				;Z: AX [0;127], else NZ
range1:	jnz	range2			;if AL [-127;-1]
	cmp	al,0			;AL = 128: reset Z
        ret				;NZ: out of range
range2:	cmp	ah,255			;if AL [-127;-1] then AH 255 for Z
	ret				;Z: AX [-127;-1], else NZ
;
RANGE	endp
;
;
code	ends
	end
;
;=======================-<920815 HoroSoft, CH-3952 Susten>-==================
;
