;970413 1840
;****************************************************************************
;* PROGRAM NAME: CCDFF   .ASM   DATE: 10. 2.1996    LINK INTO: CCDFITS .BAS *
;* LANGUAGE: Turbo Assembler TASM 2.01                                      *
;* PURPOSE:  Procedures and functions for CCDFITS                           *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.13  6-APR-96 Removed 4 functions and rearranged code         *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.12  1-APR-96 Added Strip                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.11 30-MAR-96 First release                                   *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01 22-MAR-96 add RGB and  word-to-string procedures          *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00 10-FEB-96 extracted from CCDCC.ASM                        *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.20                  *
;*            = declare function CCDFFV%()                                  *
;*            = declare sub DecLnx(integer,integer)                         *
;*            = declare sub EDCST4(integer,string,integer,integer)          *
;*            = declare sub EDCPix(integer,integer,integer)                 *
;*            = declare sub RGB16(integer,string,integer)                   *
;*            = declare sub RGBPal(integer,integer,string,integer)          *
;*            = declare sub SgWrdS(word,string)                             *
;*            = declare sub DbWrdS(dword,string)                            *
;*            = declare sub DivAry(integer,integer,integer,integer)         *
;*            = declare sub Rplcte(integer,integer,integer)                 *
;*            = declare function EDNST6%(integer,integer,integer)           *
;*            = declare function EDCST6%(integer,integer,integer)           *
;*            = declare function RdFit%(integer,integer,integer)            *
;*            = declare function WrFits%(integer,integer,integer,integer)   *
;*            = $link "CCDFF.OBJ"    and PBSTACK.OBJ !!                     *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDCC                                                 *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
rows	equ	165			;165 rows
cols	equ	192			;192 columns
hrows	equ	 82			;half rows, 82 = fix(165/2)
hcols	equ	 96			;half columns, 96 = 192/2
dos	equ	 33			;DOS Function Interrupt 21h
readf	equ	 63			;DOS Function 3Fh Read
writef	equ	 64			;DOS Function 40h Write
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;PB3, alternate for PB2: Get$Loc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDCCV%
;----------------------------------------------------------------------------
;
CCDFFV		proc	far
		public	CCDFFV
;
                call	pbastk
		mov	ax,113		;V.1.13
		xor	bl,bl
                jmp	bakbas
;
CCDFFV	endp
;
;
; FUNCTIONS
;============================================================================
;
; FUNCTION reads uncompressed ST6 and ST7 image data into CCQ for Elements%
;          words and returns True if ok
;    if EDNST6%(CCQ%(1,1),Handle%,Elements%) then OK
;----------------------------------------------------------------------------
;
EDNST6	proc	far
	public	EDNST6
;
        call	pbastk			;CX = Elements%
        push	cx			;save Elements%
        lds	si,[bp+10]		;access Handle%
        mov	bx,ds:[si]		;BX = Handle%
        lds	si,[bp+14]		;(DS:SI) = (CCQ%(1,1))
        mov	dx,si			;DS:DX = Buffer
        pop	cx			;get Elements%
        shl	cx,1			;Elements% x 2 = Bytes
        mov	ah,readf
        int	dos			;read 2 lines
        mov	ax,-1			;assume ok
        jnc	dnst61
        xor	ax,ax 			;flag false
dnst61:	mov	bl,3			;2 parameters
	jmp	bakbas
;
EDNST6	endp
;
;
; FUNCTION  reads one DBE-compressed ST6 or ST7 line and decompresses it
;   if EDCST6%(CCQ%(1,1),CCA%(1),Handle%) then OK
;----------------------------------------------------------------------------
;
EDCST6	proc	far
	public	EDCST6
;
	call	pbastk			;CX = Handle
        mov	bx,cx			;BX = Handle
        lds	si,[bp+10]		;(DS:SI) = (CCA%(1))
        mov	dx,si			;DS:DX = Buffer
        mov	cx,2			;2 bytes for counter to read
        mov	ah,readf
        int	dos
        mov	ax,0			;assume error
        jc	dcst65			;exit on read error
        lodsw				;get bytes in DS:SI
        mov	cx,ax			;bytes to read
        add	dx,2			;buffer + 2
        mov	ah,readf
        int	dos			;read first compressed line
        mov	ax,0			;assume error
        jc	dcst65			;abort on read error
;
	lds	si,[bp+10]		;(DS:SI) = (CCA%(1)) source
        les	di,[bp+14]		;(ES:DI) = (CCQ%(1,1)) destination
        mov	bh,128			;compare value
	lodsw				;get bytes to follow
	mov	cx,ax			;byte counter
        inc	cx			;compensate for one decrement
dcst61:	dec	cx			;one word will be read
	jz	dcst65			;if zero exit inner loop
        dec	cx
        jz	dcst65
        lodsw				;read referrence word
dcst62:	stosw				;store word
	mov	dx,ax			;save referrence word
        xor	ah,ah			;assume next as positive
        dec	cx			;one byte will be read
        jz	dcst65			;if zero exit inner loop
        lodsb				;get delta byte
        cmp	al,bh			;is it 128
        jz	dcst61			;following word uncompressed
        jc	dcst63			;delta value is positive
        dec	ah			;AX now signed negative
dcst63:	add	ax,dx			;add positive or negative delta
	jmp	short dcst62		;save new value and continue
;
dcst65:	mov	ax,-1			;set success flag
	mov	bl,3			;3 parameters
	jmp	bakbas
;
EDCST6	endp
;
;
; FUNCTION returns false if read is successfull. Reads Z% bytes from
;          opened binary file
;    if istrue RDFIT%(Handle%,Z%,CCA%(1)) then goto error
;----------------------------------------------------------------------------
;
RDFIT	proc	far
	public	RDFIT
;
	call	pbastk			;(DS:SI) = (CCA%(1))
	mov	dx,si			;(DS:DX) = Buffer
        les	di,[bp+10]
        mov	cx,es:[di]		;CX = bytes
	les	di,[bp+14]
	mov	bx,es:[di]		;BX = DOS File-Handle
	mov	ah,readf		;AH = function read
	int	dos			;read whole file
	jc	rdfit1			;error
	xor	ax,ax			;0 = no error
rdfit1:	mov	bl,3			;3 parameters
	jmp	bakbas
;
RDFIT	endp
;
;
; FUNCTION returns false if write ok. Writes FITS-Data. SF% is shift flag,
;          if 0 then bytes, if 1 words
;     if WrFits%(Elements%,CCD%(1,1),Handle%,SF%) then print "Error"
;----------------------------------------------------------------------------
;
WRFITS	proc	far
	public	WRFITS
;
	call	pbastk			;(DS:SI) = CX = SF%
        lds	si,[bp+18]		;access bytes
        mov	dx,ds:[si]		;elements
	dec	cl			;if 1, then 0: words
        jnz	wrfit0			;skip multiply
        add	dx,dx			;words - bytes * 2
wrfit0: mov	cx,dx			;CX = bytes to write
	lds	si,[bp+10]		;(DS:SI) = Handle%
	mov	bx,ds:[si]		;BX = Handle%
        lds	si,[bp+14]		;(DS:SI) = (CCD%(1,1))
        mov	dx,si			;DS:DX = buffer
	mov	ah,writef		;DOS write, int 21
	int	dos			;write all
        jc	wrfit1			;error - return error code
        xor	ax,ax			;0 = no write error
wrfit1:	mov	bl,4			;4 parameters
        jmp	bakbas
;
WRFITS	endp
;
;
; PROCEDURES
;============================================================================
;
; PROCEDURE  reads 12 bit Lynx file into CCD% and converts it to 16 bits
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call DecLnx(Handle%,CCD%(1,1))
;============================================================================
;
DECLNX	proc	far
	public	DECLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = DOS File-Handle
	mov	ah,readf		;AH = function read
	mov	cx,47520		;CX = number of bytes to read
	push	cx			;save bytes
	int	dos			;read whole file
	pop	cx			;restore bytes
	jc	decly1			;error
	cmp	ax,cx			;check all read
	jnz	decly1			;error
	lds	si,[bp+6]		;(DS:SI) = (CCD%(1,1))
	les	di,[bp+6]		;(ES:DI) = (CCD%(1,1))
	add	si,47519		;point to last byte loaded
	add	di,63359		;point to last byte in CCD%
	std				;set direction flag to descending
	mov	cx,23760		;23760 x 2 = 47520
	rep	movsw			;copy to last element
	inc	si			;point to first element
	inc	di			;point to first dest element at 15840
	xchg	si,di			;swap source and dest pointers
	push	es
	push	ds
	pop	es
	pop	ds			;swap source and dest segments
	mov	cx,15840		;15840 x 3 = 47520
	cld				;clear direction flag to ascending
decly0:	movsb				;copy low byte-1
	lodsb				;AL = byte-2H Byte-1H
	mov	ah,al			;AH copy of Byte-1H
	and	al,15			;remove high nibble
	stosb				;store Byte-1H
	movsb				;copy low byte-2
	mov	al,ah			;get Byte-2H
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1			;Byte-2H high- to low nibble
	stosb				;store Byte-2H
	loop	decly0			;repeat
	mov	ax,-1			;true flag
	jmp	short decly2		;store flag and return
decly1:	xor	ax,ax			;flag false
decly2:	les	di,[bp+10]		;point to Handle%
	stosw				;return flag
	mov	bl,2			;2 parameters
	jmp	bakbas
;
DECLNX	endp
;
;
; PROCEDURE  either reads or writes ST4 File into/from CCB% and the 166th
;            line into/from R$. F% has 63 or 64 respectively.
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EDCST4(F%,R$,Handle%,CCB%(1))
;============================================================================
;
EDCST4	proc	far
	public	EDCST4
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 31680 bytes
	mov	cx,31680		;165 x 192
	push	cx			;save it for compare later on
	int	dos
	pop	cx			;restore counter
	mov	dx,0			;assume error
	jc	edcst0			;error
	cmp	ax,cx
	jnz	edcst0			;error
	lds	si,[bp+14]		;(DS:SI) = (R$)
	mov	cx,ds:[si]
	push	cx
	call	GetStrLoc		;locate R$
	mov	ds,dx			;segment
	mov	dx,ax			;offset
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	mov	cx,192			;1 x 192
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 192 bytes
	int	dos
	jc	edcst0			;error
	cmp	ax,192
	jnz	edcst0			;error
	mov	dx,-1			;no error flag
edcst0:	lds	si,[bp+10]		;(ES:DI) = (Handle%)
	mov	ds:[si],dx		;save flag
	mov	bl,4			;4 parameters
	jmp	bakbas
;
EDCST4	endp
;
;
; PROCEDURE reads PIX file into CCD%. Filepointer is set to 7
;    call DecPic(F%,Handle%,CCD%(1,1))
;----------------------------------------------------------------------------
;
EDCPIX	proc	far
	public	EDCPIX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	mov	dx,si			;DS:SI = buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = handle
	les	di,[bp+14]
	mov	ax,es:[di]		;F%
	mov	ah,al			;read or write
	mov	cx,63360		;165 * 192 * 2
	push	cx			;save byte counter
	int	dos
	pop	cx			;restore byte counter
	mov	dx,0			;assume error
	jc	edcpi0			;error
	cmp	ax,cx
	jnz	edcpi0			;error
	mov	dx,-1			;no error
edcpi0:	lds	si,[bp+10]		;access handle
	mov	ds:[si],dx		;return handle
	mov	bl,3			;2 parameters
	jmp	bakbas
;
EDCPIX	endp
;
;
; PROCEDURE Multiplies from D$ byte red by 30, byte green by 59 and
;   byte blue by 11, adds them up into 2 bytes and stores them back in
;   CCA%(1) for E elements (an element has 3 bytes!) Since highest value
;   becomes 255*30 + 255*59 + 255*11 = 25500, the sum is divided by 2
;          call RGB16(CCA%(1),D$,E%)
;----------------------------------------------------------------------------
;
RGB16	proc	far
	public	RGB16
;
	call	pbastk			;(DS:SI)=CX -> Elements%
	lds	si,[bp+10]		;(DS:SI) = (D$)
	mov	ax,ds:[si]		;handle of D$
	push	ax			;handle onto stack
	call	GetStrLoc		;locate D$
	mov	ds,dx			;segment
	mov	si,ax			;offset
        les	di,[bp+14]		;(ES:DI) = (CCA%())
rgb160:	lodsb				;AL=red
        mov	dl,30			;30%
        mul	dl
        mov	bx,ax			;BX = red
        lodsb				;AL=green
        mov	dl,59			;59%
        mul	dl
        add	bx,ax			;BX=red+green
        lodsb				;AL=blue
        mov	dl,11			;11%
        mul	dl
        add	ax,bx			;AX=red+green+blue
        shr	ax,1
        stosw				;store back word
        loop	rgb160
	mov	bl,3			;3 parameters to remove
	jmp	bakbas			;restore environment
;
RGB16	endp
;
;
; PROCEDURE converts data in D$ to CCA%(1) using palette data in CCD%(1,1)
;   for E% elements. Sum is multiplied by 16 to stretch 0 to 12240
;   Palettes are funny! Obviously, people do not know that palette data
;   should bre stored as SHORT according to II or MM. Graphic Workshop for
;   Windows stores data in Intel format (II), palette data in Motorola
;   format, however. HiJaak and iPhoto, in their confusion, store the
;   palette byte in the high and low order byte location. So the palette
;   works for Intel and Motorola format. Here, the high and low order byte
;   are ORed together and the high order one is cleared. Hopefully, this
;   solves the problem of the confusers.
;          call RGBPal(CCA%(1),CCD%(1,1),D$,E%)
;----------------------------------------------------------------------------
;
RGBPal	proc	far
	public	RGBPal
;
	call	pbastk			;(DS:SI)=CX -> Elements%
	lds	si,[bp+10]		;(DS:SI) = (D$)
	mov	ax,ds:[si]		;handle of D$
	push	ax			;handle onto stack
	call	GetStrLoc		;locate D$
	mov	ds,dx			;segment
	mov	si,ax			;offset
        les	di,[bp+14]		;(ES:DI) = (CCD%())
	mov	dx,es
        mov	bx,di			;(DX:BX) = (CCD%())
        les	di,[bp+18]		;(ES:DI) = (CCA%())
RGBPa1: xor	ax,ax			;clear AX
	push	cx			;save (E%)
	lodsb				;AL = index into palette from D$
        shl	ax,1			;index * 2: SHORT = 2 bytes
	push	ds
        push	si			;save (D$)
        mov	ds,dx
        add	ax,bx			;AX points to red BX=SI-0
        mov	si,ax			;(DS:SI) points to red
	mov	cx,ds:[si]		;CX = red
        or	cl,ch			;for funny palettes
        xor	ch,ch
        push	cx			;save red
        add	ax,512			;AX points to green
        mov	si,ax			;(DS:SI) points to green
        mov	cx,ds:[si]		;CX = green
        or	cl,ch			;for funny palettes
        xor	ch,ch
        push	cx			;save green
        add	ax,512			;AX points to blue
        mov	si,ax			;(DS:SI) points to blue
        mov	ax,ds:[si]		;AX = blue
        or	al,ah
        xor	ah,ah
        pop	cx			;restore green
        add	ax,cx			;AX = green + blue
        pop	cx			;restore red
        add	ax,cx			;AX = red + green + blue
        mov	cl,4
        shl	ax,cl			;multiply by 16, extend range
        stosw				;store word
        pop	si
        pop	ds			;restore (DS:SI) = (D$)
        pop	cx			;restore E%
        loop	RGBPa1			;repeat
	mov	bl,4			;4 parameters to remove
	jmp	bakbas			;restore environment
;
RGBPal	endp
;
;
; PROCEDURE copies word variable into a 2-byte string
;          call SgWrdS(A???,A$)
;----------------------------------------------------------------------------
;
SGWRDS	proc	far
	public	SGWRDS
;
	call	pbastk			;(DS:SI)=CX -> Handle of A$
	push	cx			;handle onto stack
	call	GetStrLoc		;locate D$
	mov	es,dx			;segment
	mov	di,ax			;offset
        lds	si,[bp+10]		;(DS:SI) = (A???)
        movsw
	mov	bl,2			;2 parameters to remove
	jmp	bakbas			;restore environment
;
SGWRDS	endp
;
;
; PROCEDURE copies double word variable into a 4-byte string
;          call DbWrdS(A???,A$)
;----------------------------------------------------------------------------
;
DBWRDS	proc	far
	public	DBWRDS
;
	call	pbastk			;(DS:SI)=CX -> Handle of A$
	push	cx			;handle onto stack
	call	GetStrLoc		;locate D$
	mov	es,dx			;segment
	mov	di,ax			;offset
        lds	si,[bp+10]		;(DS:SI) = (A???)
        mov	cx,2			;2 x 2 bytes
        rep	movsw
	mov	bl,2			;2 parameters to remove
	jmp	bakbas			;restore environment
;
DBWRDS	endp
;
;
; PROCEDURE divides each element of array A by M for E elements.
;   Byte result is in CCD%(1,1)
;          call DivAry(CCD%(1,1),CCA%(1),M%,E%)
;----------------------------------------------------------------------------
;
DIVARY	proc	far
	public	DIVARY
;
	call	pbastk			;(DS:SI)=CX -> E%
        lds	si,[bp+10]		;(DS:SI)=(M%)
        mov	bx,ds:[si]		;BX=M%
        lds	si,[bp+14]		;(DS:SI)=(CCA%())
        les	di,[bp+18]		;(ES:DI)=(CCD%())
divar0:	lodsw				;AX=CCA%()
        div	bl			;AL = AX \ BL, AH = AX mod BL
        stosb				;AL into D$
        loop	divar0
	mov	bl,4			;4 parameters to remove
	jmp	bakbas			;restore environment
;
DIVARY	endp
;
;
; PROCEDURE inserts 2 black lines into CCD%, then replicates content in CCA%
;   for N1%-words into CCD% 10 times
;          call BStrip(CCD%(1,1),CCA%(1),N1%).
;----------------------------------------------------------------------------
;
RPLCTE	proc	far
	public	RPLCTE
;
	call	pbastk			;(DS:SI)=CX -> N1%
        lds	si,[bp+10]		;(DS:SI)=(CCA%())
        les	di,[bp+14]		;(ES:DI)=(CCD%())
        mov	bx,cx			;save N1%
        mov	dx,si			;save start in CCA%
	xor	ax,ax			;zero = black
        rep	stosw			;1st black line
        mov	cx,bx			;get N1%
        rep	stosw			;2nd black line
        mov	cx,bx			;get N1%
        mov	al,10			;10 gray scale lines
rplct0:	rep	movsw			;copy on line
        mov	cx,bx			;restoreN1%
        mov	si,dx			;get start of CCA%
	dec	al			;1 line done
        jnz	rplct0			;repeat
	mov	bl,3			;3 parameters to remove
	jmp	bakbas			;restore environment
;
RPLCTE	endp
;
;
code	ends
	end
;
;=======================-<920815 HoroSoft, CH-3952 Susten>-==================

