'970413 1022
'****************************************************************************
'* PROGRAM NAME: CCDFHEAD.INC   DATE: 18. 3.1996   INCLUDE IN: CCDFITS.BAS  *
'* LANGUAGE: Power BASIC 3.20  (Robert S.Zale)                              *
'* PURPOSE: Header File with declarations                                   *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.13 13-APR-97 Added Starlight Xpress and ST-7 formats          *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.12 30-MAR-96 First Release                                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01 20-MAR-96 We use it as the first include                   *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00 18-MAR-96 First use of a header                            *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ------------------------------------------------------------------------ *
'* NOTE:                                                                    *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
' COMPILER DIRECTIVES
'============================================================================
'
'$alias data as "DSEG"	'or data segment name as used in .OBJ
'$code seg "CODE"	'or code segment name as used in .OBJ
'$huge			'for arrays > 64K
$cpu 8086		'8086/80286/80386
$debug map off		'on/off
$debug path off		'on/off
$debug unit off		'on/off
$debug pbdebug off	'on/off
$dim array		'all/array/none
$dynamic		'$static
$error all off		'bounds/numeric/overflow/stack/all on/off
$event off		'on/off
$float procedure	'emulate/npx/procedure
$lib com-,lpt-,graph-,cga-,ega-,vga-,herc-,fullfloat-,iprint-
$optimize speed		'size/speed
$option cntlbreak off	'cntlbreak/gosub on/off
$stack 4096		'1536...32767
$com 0			'0...32767
$sound 1		'1...4096
$string 32		'1/2/4/8/16/32
$compile exe		'memory/exe/chain/unit
'
'
' PROGRAM NAME AND VERSION NUMBER
'============================================================================
'
CCDFitsH% = 113
VN$       = "CCDFITS V.1.18"
CCDFitsV% = 118
Version$  = "t.b.d."		'by language selection
'
'
' COMMON CONSTANTS
'============================================================================
'
%True      = -1			'LOGIC
%False     =  0
'
%Black     =  0			'COLORS, dark
%Blue      =  1
%Green     =  2
%Cyan      =  3
%Red       =  4
%Pink      =  5
%Brown     =  6
%White     =  7
%Gray      =  8			'COLORS, light
%LBlue     =  9
%LGreen    = 10
%LCyan     = 11
%LRed      = 12
%LPink     = 13
%Yellow    = 14
%LWhite    = 15
'
'
' DECLARATIONS
'============================================================================
'
' External Library: CLRSCRN.PBL.
'----------------------------------------------------------------------------
'
declare function ClrScrnV%()
declare sub ClsEC()
declare sub ClsLC()
declare sub ClsCL()
declare sub ClsVB()
declare sub HoroSoftLogo()
'
'
' External Library: ARRAYEXT.PBL.
'----------------------------------------------------------------------------
'
declare function ArrayExtV%()
declare sub AndMWA(integer,word,integer)
declare sub SubCWL(integer,word,integer,integer)
declare sub LmtHWC(integer,word,integer)
declare sub ShrMWA(integer,byte,integer)
declare sub FillWC(integer,integer,integer)
declare sub XDimWA(integer,integer,integer,integer)
declare sub CPYW2B(integer,integer,integer)
declare sub CPYB2W(integer,integer,integer)
declare sub CPYW2W(integer,integer,integer)
declare sub CpyB2B(integer,integer,integer)
declare sub StrVar(integer,integer,integer,string)
declare sub VarStr(integer,integer,integer,string)
declare sub MotInt(integer,integer)
declare sub MotStr(string,integer)
declare function MinWrd??(integer,integer)
declare function MaxWrd??(integer,integer)
declare function MinByt??(integer,integer)
declare function MaxByt??(integer,integer)
declare function CntWrd??(integer,word,integer)
'
'
' External Object: CCDFF.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function CCDFFV%()
declare sub DecLnx(integer,integer)
declare sub EDCST4(integer,string,integer,integer)
declare sub EDCPix(integer,integer,integer)
declare sub RGB16(integer,string,integer)
declare sub RGBPal(integer,integer,string,integer)
declare sub SgWrdS(word,string)
declare sub DbWrdS(dword,string)
declare sub DivAry(integer,integer,integer,integer)
declare sub Rplcte(integer,integer,integer)
declare function EDNST6%(integer,integer,integer)
declare function EDCST6%(integer,integer,integer)
declare function RdFit%(integer,integer,integer)
declare function WrFits%(integer,integer,integer,integer)
'
'
' External Object: RLCEGEN.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function RlceGenV%()
declare function DecBie%(integer,integer)
declare function RdBie%(integer,integer,integer)
'
'
' APPLICATION SPECIFIC CONSTANTS
'============================================================================
'
%DOSRead  = 63		'DOS function used at Encode/Decode for ST4 and ASI
%DOSWrite = 64		'  EDCST4
'
%LMN       = 31680	'eLeMeNts in arrays
%UnitAUX   = 1		'Input  file
%UnitFIT   = 2		'Output file
%UnitERR   = 3		'Error output file from TIFF-Head analysis
'
%LNX       =  1		'Menu Options
%STX       =  2		'  used for "on goto" and array-index
%SXP       =  3
%PIC       =  4
%PIX       =  5
%BYT       =  6
%RAW       =  7
%TIF       =  8
%FTI       =  9
%FHD       = 10
%FIT       = 11
'
'
' APPLICATION SPECIFIC VARIABLES
'============================================================================
'
' SHARED VARIABLES AND ARRAYS
'----------------------------------------------------------------------------
'
dim Idiom(0:2) as shared integer	'language, see Array Setup
'
'
' ARRAYS
'----------------------------------------------------------------------------
'
dim Card$(1:36)			'FITS-cards
dim ACrd$(1:36)			'FITS-cards
dim IOExt$(1:%FIT)		'file extension
dim BatchF$(1:16)		'Input Filename
dim BatchI$(1:16)		'Input Filespec
dim BatchO$(1:16)		'Output Filespec
dim Batch%(1:16)		'True if file here, else false
dim FilPos&(1:16)		'FITS fileposition
dim CCD%(1:165,1:192)           'image array
dim CCA%(1:31872)		'192*166 to hold ST4 images
dim CCQ%(1:192,1:165)		'for QuickPix PIX and aux
dim Tagses???(1:3,254:320)	'1=Typ, 2=Length, 3=Pointer, n=Tag#
'
'
' VARIABLES
'----------------------------------------------------------------------------
'
Chroma%  = %True		'assume color - used for ERROR3.INC
English% = %True		'assume english language selected
Virgin%  = %True		'if true, first run, used for path query
AOpen%   = %False		'True if %UnitAUX open
FOpen%   = %False		'True if %UnitFIT open
'
BP%      =      8		'Bits per Pixel
Cnt%     =      1		'counter, updates NoFiles%
CP%      =      1		'current page (editor)
Handle%  =      1		'FITS file handle
Handla%  =      1		'AUX file handle
InpOpt%  =      1		'selected option for input file conversion
LCnt%    =      1		'line counter (editor)
LSel%    =      1		'line selected (editor)
Moto%    =      0		'Motorola: True=MM, False=II, 5=not valid
MISwap%  =      0		'Swap Motorola to Intel = True
N0%      =      2		'NAXIS - number of images: 3 for RGB
N1%      =    192		'NAXIS1 - columns
N2%      =    165		'NAXIS2 - rows
NS%      =     12		'NaxisStrip 12 rows
NoFiles% =      1		'number of files to process
OP%      =      1		'old page (editor)
OSel%    =      1		'option select (editor)
PCnt%    =      1		'page counter (editor)
SD%      =      0		'start data at file beginning
SF%      =      0		'Shift Flag: 0=byte, 1=word (WRFITS)
ST6C%    =      0		'ST6-file compressed=true, else false
SBIG%    =      1		'1=ST4, 2=ST6, 3=ST7
SubOpt%  =      0		'Sub-Optiob for FITS conversion
Tags%    =      0 		'number of tags
XF%      =      0		'starlight Xpress Flag
'
BP??     =      8		'BitPerPixel for Fits to Tiff
Hi??     =      0		'Highest pixl value
Lo??     =      0		'Lowest pixel value
N0??     =      2		'NAXIS for Fits to Tiff
N1??     =    192		'NAXIS1 for Fits to Tiff
N2??     =    165		'NAXIS2 for Fits to Tiff
N3??     =      3		'NAXIS3 for Fits to Tiff
'
IFD&     =      0		'address of image file directory in TIFF
FL&      =      0		'File Length
LNXSize& =  47520		'filezize of Lynxx image
PIXSize& =  63367
SD&      =      0		'start data
ST4Size& =  31872
SXPSize& = 261120
'
GPCR$    = "(c) 1992-97 by H.-R.H. Wernli, CH-3952 Susten."
STCR$    = "Processed with " + VN$ + "; (c) H.-R.H.Wernli, CH-3952 Susten."
Nill$    = ""
SV$      = " "			'PowerBASIC Sub-Version letter
Fatal$   = "t.b.d."		'used for abort on error info
InpPath$ = "t.b.d."		'path/directory for input files
OutPath$ = "t.b.d."		'path/directory for output files
UsePath$ = "t.b.d."		'path/directory to be used
InpExt$  = "tbd"		'file extension for input files
OutExt$  = "tbd"		'file extension for output files
ST4Info$ = space$(192)		'ST4 trailer line 166
FH$      = "t.b.d."		'FITS head
EF$      = "t.b.d."		'Edit Fits
Ti$      = "t.b.d."		'TIFF input file name, used for .ERR
Txt269$  = Nill$		'TIFF Tag 269: OBJECT
Txt270$  = Nill$		'TIFF Tag 270: 8/16 bit data
Txt271$  = Nill$		'TIFF Tag 271: TELESCOP
Txt272$  = Nill$		'TIFF Tag 272: HISTORY
Txt305$  = Nill$		'TIFF Tag 305: CCDFITS Version
Txt306$  = Nill$		'TIFF Tag 306: date and time
Txt315$  = Nill$		'TIFF Tag 315: OBSERVER
Txt316$  = Nill$		'TIFF Tag 316: INSTRUME
'
'
' ARRAY SETUP
'----------------------------------------------------------------------------
'
Idiom%(0) = 0			'True=English, False=German
Idiom%(1) = 0			'SingleLine-Text offset (SLText)
Idiom%(2) = 0			'MultiLine-Text offset (MLText)
'
IOExt$(%LNX) = "LNX"		'input/output file extensions
IOExt$(%STX) = "STX"
IOExt$(%SXP) = "SXP"
IOExt$(%PIC) = "PIC"
IOExt$(%PIX) = "PIX"
IOExt$(%BYT) = "BYT"
IOExt$(%RAW) = "RAW"
IOExt$(%TIF) = "TIF"
IOExt$(%FTI) = "FIT"
IOExt$(%FHD) = "FIT"
IOExt$(%FIT) = "FIT"
'
'
' GENERAL PURPOSE AND NOT PARTICULARLY ASSIGNED VARIABLES
'----------------------------------------------------------------------------
'
F?       =     0		'loop counter
X?       =     1		'column counter
Y?       =     1		'line counter
'
A%       =     0		'auxilliary
B%       =     0		'block size
E%       =     0		'elements
F%       =     0		'alternate loop counter or superloop counter
H%       =     0		'half, handle
I%       =     0		'1=input, 2=output
L%       =     0		'length
N%       =     0		'loop counter, must be preserved from main
P%       =     0		'position
R%       =     0		'Rest
S%       =     0		'start
T%       =     0		'auxilliary
X%       =     1		'auxilliary, often used as column pointer
Y%       =     1		'auxilliary, often used as line pointer
V%       =     0		'auxilliary
W%       =     0		'auxilliary
Z%       =     0		'auxilliary
'
H??      =     0		'high word for Hi??
L??      =     0		'low word for Lo??
'
A???     =     0		'aux tag-value, also offset
B???     =     0		'aux tag-value, also bytes
C???     =     0		'aux tag-value and counter
S???     =     0		'Data or File length
SN???    =     0		'number of strips
SB???    =     0		'bytes per full strip
SL???    =     0		'lines per full strip
RB???    =     0		'bytes per rest strip
RL???    =     0		'lines per rest strip
'
P&       =     0		'file position pointer
S&       =     0		'size of file
Z&       =     0		'calculated filesize
'
A$	 =   Nill$		'aux
B$       =   Nill$		'aux
C$       =   Nill$		'aux
D$       =   Nill$		'data aux
E$       =   Nill$		'aux
F$       =   Nill$		'filename aux
G$       =   Nill$		'aux
H$       =   Nill$		'formatted Hi?? for Fitshead
L$       =   Nill$		'formatted Lo?? for Fitshead
Q$       =   Nill$		'query
R$       =   Nill$		'holds ST4-166 info line temporarily/raw
Z$       =   Nill$		'editor
'
'
'===================================-<960318>-=========-<HoroSoft>-==========

