'970413 1126
'****************************************************************************
'* PROGRAM NAME: CCDFSUB1.INC   DATE: 10. 2.1996   INCLUDE IN: CCDFITS .BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Subroutines for CCDFITS Converter Main-Subs: Menu               *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.17 13-APR-97 Added Starlight X-Press and ST-7 format          *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.16  6-APR-96 Overwholed read/write quite a bit, faster now    *
'*                Additional re-arrangements                                *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.15  2-APR-96 Added Grayscale strip at end of FITS image       *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.14 30-MAR-96 First release                                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.04 30-MAR-96 Added SubOption for FITS-Head and TIFF conv.     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03 22-MAR-96 Added TIFF to FITS                               *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02 11-MAR-96 Extracted from CCDFSUB.INC                       *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01 10-FEB-96 Copied and extracted from CCDCSUB.INC            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00 21-MAY-93 Extracted from CCDCONVT.BAS.                     *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDFSub1V% = 117
'
goto CCDFSub1
'
'
' Input-Lynxx - Lynxx files have 192 columns for one row and there are 165
'   lines. Two words are lines. Two words are compressed into three bytes.
'   Processing is done here.
'-----------------------------------------------------------------------------
'
ILNX:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
print BatchI$(N%);SLText$(12%)
Handle% = fileattr(%UnitAUX,2)
call DecLnx(Handle%,CCD%(1,1))
close %UnitAUX
AOpen% = %False
Fatal$ = SLText$(56%) + SLText$(25%) + SLText$(35%)
if not Handle% then goto WarnIO
FH$  = "Spectra Source Instruments, PC-Lynxx Image"
Lo?? = MinWrd??(CCD%(1,1),%LMN)
Hi?? = MaxWrd??(CCD%(1,1),%LMN)
BP%  =  16
N0%  =   2
N1%  = 192
N2%  = 165
E%   = %LMN
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
SF% = 1
call MotInt(CCD%(1,1),%LMN)
Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
if isfalse Z% then
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
end if
call FillFits(N1%,N2%,BP%)
if istrue Z% then goto WarnIO
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' Input-ST-X - ST4, ST6 or ST7. Patch added for Starlight X-Press format
'   SBIG=1: ST-4,  SBIG=2: ST-6,  SBIG=3: ST7
'----------------------------------------------------------------------------
'
ISTX:
'
if SBIG% = 1 then goto IST4 else goto IST67
'
'
' Input-ST-4 - ST4 files have 192 columns for a line and 165 lines. Each
'   pixel uses a byte. The 166th line holds information.
'-----------------------------------------------------------------------------
'
IST4:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
print BatchI$(N%);SLText$(12%)
R$ = space$(192)
Handle% = fileattr(%UnitAUX,2)
call EDCST4(%DOSRead,R$,Handle%,CCA%(1))
close %UnitAUX
AOpen% = %False
Fatal$ = SLText$(56%) + SLText$(26%) + SLText$(35%)
if not Handle% then goto WarnIO
FH$ = "Santa Barbara Instrument Group ST-4 Image."
Lo?? = MinByt??(CCA%(1),%LMN)
Hi?? = MaxByt??(CCA%(1),%LMN)
BP%  =   8
N0%  =   2
N1%  = 192
N2%  = 165
E%   = %LMN
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call ST4Fits(Card$(),R$,N0%)
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Handle% = WrFitH(BatchO$(N%),Card$(),FOpen%)
Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
SF% = 0
Z%  = WrFits%(E%,CCA%(1),Handle%,SF%)
if isfalse Z% then
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
end if
call FillFits(N1%,N2%,BP%)
if istrue Z% then goto WarnIO
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' Input-ST6 - ST6 files have 375 columns and 242 lines. Each pixel has one
'   word. A head with 2048 byte preceeds the image data. Data may be
'   compressed using delta line compression, or be uncompressed.
'   ST7 files may have up to 768 columns and 512 lines. Except for the
'   file header "ST-6 Image" vs. "ST-7 Image", the format is the same.
'   SBIG% is 2 for ST6 and 3 for ST7 (1 = St4).
'-----------------------------------------------------------------------------
'
IST67:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
get$ # %UnitAUX, 2048, D$
ST6C% = ST6Comp%(D$)
SF%   =  1
Lo??  =  0
Hi??  =  0
BP%   = 16
N0%   =  2
N1%   = ST6N1%(D$)
N2%   = ST6N2%(D$)
Z$    = chr$(52+SBIG%)		'52=4 St6=+2, ST7=+3
FH$   = "Santa Barbara Instrument Group ST-" + Z$ + " Image"
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call ST6Fits(Card$(),D$,N0%,SBIG%)
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
Fatal$  = SLText$(56%) + SLText$(74%) + SLText$(35%)
Handla% = fileattr(%UnitAUX,2)
Fatal$  = SLText$(56%) + SLText$(51%) + SLText$(35%)
Lo??    = 65535
Hi??    =     0
print BatchI$(N%);SLText$(12%)
if isfalse ST6C% then
  FL& = N1% * N2%
  if isfalse lof(%UnitAUX) = FL&*(BP%\8)+2048 then goto WarnSize
  Fatal$ = SLText$(56%) + SLText$(51%) + SLText$(35%)
  B% = FL& \ %LMN
  R% = FL& - B% * %LMN
  color %Cyan,%Black
  print SLText$(53%);
  Y% = csrlin
  X% = pos(Y%)
  color %LCyan,%Black
  if B% > 0 then
    for F% = 1 to B%
      if isfalse EDNST6%(CCQ%(1,1),Handla%,%LMN) then goto WarnIO
      call AndMWA(CCQ%(1,1),32767??,%LMN)
      L?? = MinWrd??(CCQ%(1,1),%LMN)
      H?? = MaxWrd??(CCQ%(1,1),%LMN)
      if L?? < Lo?? then Lo?? = L??
      if H?? > Hi?? then Hi?? = H??
      call MotInt(CCQ%(1,1),%LMN)
      Z% = WrFits%(%LMN,CCQ%(1,1),Handle%,SF%)
      locate Y%,X%
      print using "###";F%
    next F%
  end if
  if R% > 0 then
    if isfalse EDNST6%(CCQ%(1,1),Handla%,R%) then goto WarnIO
    call AndMWA(CCQ%(1,1),32767??,R%)
    L?? = MinWrd??(CCQ%(1,1),R%)
    H?? = MaxWrd??(CCQ%(1,1),R%)
    if L?? < Lo?? then Lo?? = L??
    if H?? > Hi?? then Hi?? = H??
    call MotInt(CCQ%(1,1),R%)
    Z% = WrFits%(R%,CCQ%(1,1),Handle%,SF%)
    locate Y%,X%
    print using "###";F%
  end if
else
  color %Cyan,%Black
  print SLText$(52%);
  color %LCyan,%Black
  Y% = csrlin
  X% = pos(Y%)
  for F% = 1 to N2%
    locate Y%,X%
    print using "####";F%;
    if isfalse EDCST6%(CCD%(1,1),CCA%(1),Handla%) then goto WarnIO
    call AndMWA(CCD%(1,1),32767??,N1%)
    L?? = MinWrd??(CCD%(1,1),N1%)
    H?? = MaxWrd??(CCD%(1,1),N1%)
    if L?? < Lo?? then Lo?? = L??
    if H?? > Hi?? then Hi?? = H??
    call MotInt(CCD%(1,1),N1%)
    Z% = WrFits%(N1%,CCD%(1,1),Handle%,SF%)
  next F%
end if
close %UnitAUX
AOpen% = %False
if isfalse Z% then
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
end if
call FillFits(N1%,N2%,BP%)
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' Input-SXP - Input Starlight X-Press files. The file contains 256 lines
'   with 510 columns and 2 bytes data in the intel format. This adds-up
'   to 261120 bytes. The first 4 lines contain unanalysed data such as
'   a color/grayscale palette. 4 x 510 x 2 = 4080 bytes. These 4080 bytes
'   or 4 lines are also included. The ADC is a 12bit one and the values
'   multiplied by 16 - here, they are divided back by 8 (0...16383)
'----------------------------------------------------------------------------
'
ISXP:
'
open BatchI$(N%) for binary as # %UnitAUX
Handla% = fileattr(%UnitAUX,2)
AOpen% = %True
FH$ = "Starlight Xpress format"
XF% =  %True
SF% =      1
N0% =      2
N1% =    510
N2% =    256
BP% =     16
Lo?? = 65535
Hi?? =     0
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
Fatal$ = SLText$(56%) + SLText$(67%) + SLText$(35%)
A% =  1020			'--bytes per line
L% =    32			'--lines per block
B% = 32640			'--bytes per block
T% =     8			'--number of blocks (turns)
MISwap% = %False
color %Cyan,%Black
print SLText$(68%);
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
for F% = 1 to T%
  Z% = RdAWrF%(CCA%(),Handla%,Handle%,B%,BP%,Hi??,Lo??,MISwap%,XF%)
  if istrue Z% then
    if Z% = 72 then Z% = 67
    Fatal$ = SLText$(56%) + SLText$(Z%) + SLText$(35%)
    goto WarnIO
  end if
  locate Y%,X%
  print using "###";F%
next F%
close %UnitAUX
AOpen% = %False
if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
  Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
  N2% = N2% + 12
end if
call FillFits(N1%,N2%,BP%)
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' Input-PIC - Input QMiPS PIC files. Bytes 2 & 3 (option base 0) point to
'   start of image data. Byte 68/69, 70/71 and 72/73 hold Naxis1, Naxis2
'   and BitPix respectively.
'----------------------------------------------------------------------------
'
IPIC:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
S&  = lof(%UnitAUX)
SD% = PicStart%(D$)
N0% = 2
call PicNax(S%,SD%,D$,N1%,N2%,BP%,Z&)
Fatal$ = SLText$(56%) + SLText$(75%) + SLText$(35%)
if S&  = Z& then
  FH$  = "CCD MiPS QMiPS 'PIC' Image"
  if BP% > 8 then
    L% = N1% * 2
    SF% = 1
  else
    L% = N1%
    SF% = 0
  end if
  Lo?? = 65535
  Hi?? =     0
  call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
  if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
  Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
  Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
  P& = S&
  A% = 16383 \ N1%
  T% = N2% \ A%
  R% = N2% - A% * T%
  B% = A% * L%
  color %Cyan,%Black
  print SLText$(53%);
  Y% = csrlin
  X% = pos(Y%)
  color %LCyan,%Black
  if T% > 0 then
    for F% = 1 to T%
      P& = P& - B%
      P% = B% + 1
      seek %UnitAUX, P&
      get$ # %UnitAUX, B%, D$
      call FindHiLo(D$,B%,BP%,Hi??,Lo??,CCA%())
      for I% = 1 to A%
        P% = P% - L%
        put$ # %UnitFIT, mid$(D$,P%,L%)
      next I%
      locate Y%,X%
      print using "###";F%
    next F%
  end if
  if R% > 0 then
    B% = R% * L%
    P% = B% + 1
    P& = P& - B%
    seek %UnitAUX, P&
    get$ # %UnitAUX, B%, D$
    call FindHiLo(D$,B%,BP%,Hi??,Lo??,CCA%())
    for I% = 1 to R%
      P% = P% - L%
      put$ # %UnitFIT, mid$(D$,P%,L%)
    next I%
    locate Y%,X%
    print using "###";F%
  end if
  close %UnitAUX
  AOpen% = %False
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
  call FillFits(N1%,N2%,BP%)
  call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
  call InsNaxCmt(Card$(),N2%,83%)
  Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
  close
  FOpen% = %False
else
  goto WarnIO
end if
return
'
'
' Input-Pixel - Pixel files have 192 columns with 165 lines each. Each pixel
'   uses one word.
'   Range [0;4095] --> [0;4095]
'-----------------------------------------------------------------------------
'
IPIX:
'
FH$ = "Electrim ED1000 Pixel Image"
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
print SLText$(41%);BatchI$(N%);
Handle% = fileattr(%UnitAUX,2)
seek # %UnitAUX,7
call EDCPix(%DOSRead,Handle%,CCD%(1,1))
close %UnitAUX
AOpen% = %False
Fatal$ = SLText$(56%) + SLText$(42%) + SLText$(35%)
if not Handle% then goto WarnIO
print " "
FH$ = "Electrim ED1000 Pixel Image"
Lo?? = MinWrd??(CCD%(1,1),%LMN)
Hi?? = MaxWrd??(CCD%(1,1),%LMN)
BP%  =  16
N0%  =   2
N1%  = 192
N2%  = 165
E%   = %LMN
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
SF% = 1
call MotInt(CCD%(1,1),%LMN)
Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
if isfalse Z% then
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
end if
call FillFits(N1%,N2%,BP%)
if istrue Z% then goto WarnIO
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' Input-Byte - Byte files have 165 lines with 192 columns each. There is one
'   byte for each pixel, compressed using RLCE (Run Length Count Encoding).
'   Range [0;255] --> [0;4095]
'----------------------------------------------------------------------------
'
IBYT:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
Handle% = fileattr(%UnitAUX,2)
Fatal$ = SLText$(56%) + SLText$(43%) + SLText$(35%)
print SLText$(20);" ";BatchI$(N%)
Z% = RdBie%(CCQ%(1,1),Handle%,31685%)
close %UnitAUX
AOpen% = %False
if Z% then goto WarnIO
print SLText$(44%);
S% = DecBie%(CCA%(1),CCQ%(1,1))
Fatal$ = SLText$(56%) + SLText$(45%) + str$(S%)
if istrue S% then goto WarnIO
call CpyB2W(CCQ%(1,1),CCA%(1),%LMN)
call XDimWA(CCD%(1,1),CCQ%(1,1),165%,192%)
call CpyW2B(CCA%(1),CCD%(1,1),%LMN)
print " "
FH$ = "HoroSoft CCDTOOLS/CCDUTIL Byte Image"
Lo?? = MinByt??(CCA%(1),%LMN)
Hi?? = MaxByt??(CCA%(1),%LMN)
BP%  =   8
N0%  =   2
N1%  = 192
N2%  = 165
E%   = %LMN
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
SF% = 0
Z% = WrFits%(E%,CCA%(1),Handle%,SF%)
if isfalse Z% then
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
end if
call FillFits(N1%,N2%,BP%)
if istrue Z% then goto WarnIO
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' Input RAW. Converts image array to FITS
'----------------------------------------------------------------------------
'
IRAW:
'
XF% = %False
color %LCyan,%Black
print BatchI$(N%)
color %Cyan,%Black
print
N0% = 2
print SLText$(24%);
input N1%
print SLText$(27%);
input N2%
print SLText$(28%);
input BP%
Fatal$ = SLText$(56%) + SLText$(34%)
F% = %True
if BP% =  8 then
  F% = %False
  SF% = 0
end if
if BP% = 16 then
  F% = %False
  SF% = 1
end if
if istrue F% then goto WarnIO
print SLText$(29%);
input SD%
if BP% = 16 then MISwap% = not Confirm%(SLText$(40%))
open BatchI$(N%) for binary as # %UnitAUX
Handla% = fileattr(%UnitAUX,2)
AOpen% = %True
S& = lof(%UnitAUX) - SD%
Z& = N1% * N2% * (BP% \ 8)
Fatal$ = SLText$(56%) + SLText$(73%) + SLText$(35%)
if S& >= Z& then
  seek %UnitAUX, SD%
  FH$ = "CCD Raw Image of unknown format"
  Lo?? = 65535
  Hi?? =     0
  call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
  if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
  Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
  Fatal$ = SLText$(56%) + SLText$(72%) + SLText$(35%)
  A% = N1% * (BP% \ 8)		'--bytes per line
  L% = %LMN \ A%		'--lines per block
  B% = L% * A%			'--bytes per block
  T% = N2% \ L%			'--number of blocks (turns)
  R% = N2% - (L% * T%)		'--rest, number of lines not yet done
  color %Cyan,%Black
  print SLText$(13%);
  Y% = csrlin
  X% = pos(Y%)
  color %LCyan,%Black
  if T% > 0 then
    for F% = 1 to T%
      Z% = RdAWrF%(CCA%(),Handla%,Handle%,B%,BP%,Hi??,Lo??,MISwap%,XF%)
      if istrue Z% then
        Fatal$ = SLText$(56%) + SLText$(Z%) + SLText$(35%)
        goto WarnIO
      end if
      locate Y%,X%
      print using "###";F%
    next F%
  end if
  if R% > 0 then
    B% = R% * A%			'--rest block length
    Z% = RdAWrF%(CCA%(),Handla%,Handle%,B%,BP%,Hi??,Lo??,MISwap%,XF%)
    if istrue Z% then
      Fatal$ = SLText$(56%) + SLText$(Z%) + SLText$(35%)
      goto WarnIO
    end if
    locate Y%,X%
    print using "###";F%
  end if
  close %UnitAUX
  AOpen% = %False
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
  call FillFits(N1%,N2%,BP%)
  call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
  call InsNaxCmt(Card$(),N2%,83%)
  Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
  close
  FOpen% = %False
else
  goto WarnIO
end if
return
'
'
' Input TIF. Converts TIFF to FITS
'----------------------------------------------------------------------------
'
ITIF:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
get$ # %UnitAUX, 8, D$
Moto% = IIMM%(D$)
if Moto% = 5 then
  Fatal$ = SLText$(56%) + SLText$(59%) + SLText$(35%)
  goto WarnIO
end if
if isfalse TiffV%(D$,Moto%) = 42 then
  Fatal$ = SLText$(56%) + SLText$(60%) + SLText$(35%)
  goto WarnIO
end if
MISwap% = Moto%
IFD& = TiffIFD&(D$,Moto%)
Tags% = Tagx%(D$,Moto%,IFD&)
seek # %UnitAUX, IFD&+2
get$ # %UnitAUX, Tags%*12, D$
for F% = 1 to Tags%
  call GetTag(D$,Moto%,Tagses???(),F%)
next F%
close
AOpen% = %False
FOpen% = %False
F% = %False
if istrue Tagses???(1,254) then
  if Tagses???(3,254) = 0 then F% = %True
end if
if istrue Tagses???(1,255) then
  if Tagses???(3,255) = 1 then F% = %True
end if
Fatal$ = SLText$(21%)
if isfalse F% then goto WrtErrFile
N1% = Tagses???(3,256)
N2% = Tagses???(3,257)
Fatal$ = SLText$(22%)
if (N1% = 0) or (N2% = 0) or (Tagses???(1,258) = 0) then goto WrtErrFile
Fatal$ = SLText$(61%)
if Tagses???(2,258) > 3 then goto WrtErrFile
if Tagses???(2,258) = 3 then
  open BatchI$(N%) for binary as # %UnitAUX
  AOpen% = %True
  seek # %UnitAUX, Tagses???(3,258)
  if Tagses???(1,258) = 4 then
    get$ # %UnitAUX, 12, D$
    close
    AOpen% = %False
    FOpen% = %False
    A??? = LongInt???(left$(D$,4),Moto%)
    B??? = LongInt???(mid$(D$,5,4),Moto%)
    C??? = LongInt???(right$(D$,4),Moto%)
  else
    get$ # %UnitAUX, 6, D$
    close
    AOpen% = %False
    FOpen% = %False
    A??? = ShortInt??(left$(D$,2),Moto%)
    B??? = ShortInt??(mid$(D$,3,2),Moto%)
    C??? = ShortInt??(right$(D$,2),Moto%)
  end if
  Fatal$ = SLText$(62%) + str$(A???) + "/" + str$(B???) + "/" + str$(C???)
  if (A??? <> 8) or (B??? <> 8) or (C??? <> 8) then goto WrtErrFile
  BP% = 8
  N0% = 3
else
  BP% = Tagses???(3,258)
  N0% = 2
  F% = %True
  if (BP% = 8) or (BP% = 16) then F% = %False
  Fatal$ = SLText$(63%)
  if istrue F% then goto WrtErrFile
end if
select case Tagses???(3,262)
  case 0, 1
    SubOpt% = 1
  case 2
    if Tagses???(3,284) = 1 then
      SubOpt% = 2
      BP% = 16
      N0% =  2
    else
      SubOpt% = 3
      BP% = 8
      N0% = 3
    end if
  case 3
    SubOpt% = 4
    BP% = 16
    N0% =  2
  case else
    Fatal$ = "PhotometricInterpretation-262 " + SLText$(79%)
    goto WrtErrFile
end select
Fatal$ = SLText$(76%)
if not Tagses???(3,259) = 1 then goto WrtErrFile
FH$ = "TIFF Image"
Lo?? = 0
Hi?? = 0
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
if isfalse Tagses???(3,269) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,269),Tagses???(3,269),%False)
  Card$(15+N0%) = "COMMENT   " + A$
end if
if isfalse Tagses???(3,271) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,271),Tagses???(3,271),%False)
  Card$(16+N0%) = "COMMENT   " + A$
end if
if isfalse Tagses???(3,272) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,272),Tagses???(3,272),%False)
  Card$(17+N0%) = "COMMENT   " + A$
end if
if isfalse Tagses???(3,305) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,305),Tagses???(3,305),%False)
  Card$(14+N0%) = "COMMENT   " + A$
end if
if isfalse Tagses???(3,306) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,306),Tagses???(3,306),%False)
  Card$(8+N0%) =  "DATE-OBS= " + A$
end if
if isfalse Tagses???(3,315) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,315),Tagses???(3,315),%True)
  Card$(12+N0%) = "OBSERVER= "+ A$
end if
if isfalse Tagses???(3,316) = 0 then
  A$ = TiffTxt$(BatchI$(N%),Tagses???(2,316),Tagses???(3,316),%True)
  Card$(10+N0%) = "INSTRUME= " + A$
end if
Fatal$ = SLText$(77%)
if not Tagses???(2,273) = Tagses???(2,279) then goto WrtErrFile
Fatal$ = SLText$(78%)
if Tagses???(3,262) = 3 then
  if not Tagses???(2,320) = 768 then goto WrtErrFile
end if
Lo?? = 65535
Hi?? =     0
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
color %Cyan,%Black
print SLText$(53%);
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
select case SubOpt%
  case 1					'gray
    if Tagses???(2,273) = 1 then
      B??? = Tagses???(3,279)
      seek# %UnitAUX, Tagses???(3,273)
      gosub PhotoI01
    else
      for I% = 1 to Tagses???(2,273)
        A??? = TiffPtr???(I%,Moto%,Tagses???(1,273),Tagses???(3,273))
        B??? = TiffPtr???(I%,Moto%,Tagses???(1,279),Tagses???(3,279))
        seek# %UnitAUX, A???
        gosub PhotoI01
      next I%
    end if
  case 2					'RGBrgbrgbrgb
    if Tagses???(2,273) = 1 then
      B??? = Tagses???(3,279)
      seek# %UnitAUX, Tagses???(3,273)
      gosub PhotoI2
    else
      for I% = 1 to Tagses???(2,273)
        A??? = TiffPtr???(I%,Moto%,Tagses???(1,273),Tagses???(3,273))
        B??? = TiffPtr???(I%,Moto%,Tagses???(1,279),Tagses???(3,279))
        seek# %UnitAUX, A???
        gosub PhotoI2
      next I%
    end if
  case 3					'RrrrGgggBbbb
    if Tagses???(2,273) = 1 then
      seek# %UnitAUX, Tagses???(3,273)
      B??? = Tagses???(3,279)
      gosub PhotoI01
    else
      for I% = 1 to Tagses???(2,273)
        A??? = TiffPtr???(I%,Moto%,Tagses???(1,273),Tagses???(3,273))
        B??? = TiffPtr???(I%,Moto%,Tagses???(1,279),Tagses???(3,279))
        seek# %UnitAUX, A???
        gosub PhotoI01
      next I%
    end if
  case 4					'palette
    seek# %UnitAUX, Tagses???(3,320)		'assume 3 x 256 SHORT
    get$# %UnitAUX, 1536, D$
    call StrVar(CCD%(1,1),1536%,0%,D$)
    if Tagses???(2,273) = 1 then
      B??? = Tagses???(3,279)
      seek# %UnitAUX, Tagses???(3,273)
      gosub PhotoI3
    else
      for I% = 1 to Tagses???(2,273)
        A??? = TiffPtr???(I%,Moto%,Tagses???(1,273),Tagses???(3,273))
        B??? = TiffPtr???(I%,Moto%,Tagses???(1,279),Tagses???(3,279))
        seek# %UnitAUX, A???
        gosub PhotoI3
      next I%
    end if
end select
close %UnitAUX
AOpen% = %False
if N0% = 2 then
  if istrue GrayScale%(CCA%(),CCD%(),BP%,N1%,Hi??,Lo??,E%) then
    Z% = WrFits%(E%,CCD%(1,1),Handle%,SF%)
    N2% = N2% + 12
  end if
else
  N2% = N2% * 3
end if
call FillFits(N1%,N2%,BP%)
call FitsHead(Card$(),VN$,BP%,N0%,N1%,N2%,Hi??,Lo??,FH$,BatchF$(N%),English%)
call InsNaxCmt(Card$(),N2%,83%)
Handle% = WrFitH%(BatchO$(N%),Card$(),FOpen%)
close
FOpen% = %False
return
'
'
' FITS Submenue. Subroutine continues at IFHD, IFTI or RmvBar in CCDFSUB2
'---------------------------------------------------------------------------
'
FITSub:
'
print LogOn$(Version$,%White,%Red);
color %LGreen,%Black
print Center$(BatchI$(N%),80);
color %White,%Black
print string$(80,"")
Y% = csrlin
locate Y%,1
color %LCyan,%Black
print Center$(SLText$(23%),80)
color %Cyan,%Black
call MLText(3%,15%,"tf")
do
  SubOpt% = Prompt%(20%,Q$)
  if SubOpt% > -1 and SubOpt% < 7 then exit loop
  print Outch$(Q$)
loop
print : print
select case SubOpt%
  case 0
    return		'--> CCDFITS.BAS
  case 1
    goto IFHD		'--> CCDFSUB2.INC
  case 2
    goto RmvBar		'--> CCDFSUB2.INC
  case 3, 4, 5, 6
    goto IFTI		'--> CCDFSUB2.INC
end select
return
'
'
CCDFSub1:
'
'===================================-<960321>-=========-<HoroSoft>-==========
'
