'960408 1335
'****************************************************************************
'* PROGRAM NAME: CCDFSUB2.INC   DATE: 10. 2.1996   INCLUDE IN: CCDFITS .BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Subroutines for CCDFITS Converter: common subs and Sub-Menu     *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.14  6-APR-96 Minor changes and rearrangements                 *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.13 30-MAR-96 First release                                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03 22-MAR-96 Added TIFF to FITS                               *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02 11-MAR-96 Extracted from CCDFSUB.INC                       *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01 10-FEB-96 Copied and extracted from CCDCSUB.INC            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00 21-MAY-93 Extracted from CCDCONVT.BAS.                     *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDFSub2V% = 114
'
goto CCDFSub2
'
'
' SUBROUTINE returns in A% a true flag if no Path/Drive error occured.
'----------------------------------------------------------------------------
'
ValidatePath:
'
E% = 0
D$ = curdir$
on error goto VPERR
chdir left$(UsePath$,len(UsePath$)-1)
chdir D$
VPRES:
if E% = 0 then A% = %True else A% = %False
on error goto ErrorHandling
return
VPERR:
E% = err
resume VPRES
'
'
' SUBROUTINE returns validated path. I% = 1 for Input, 2 for output
'----------------------------------------------------------------------------
'
GetDirPath:
'
do
  if I% then
    UsePath$ = IOPath$(SLText$(1%),InpPath$,SLText$(36%))
  else
    UsePath$ = IOPath$(SLText$(10%),OutPath$,SLText$(36%))
  end if
  gosub ValidatePath
  if A% then exit loop
  if not Redo%(SLText$(37%)) then
    Fatal$ = SLText$(38%)
    return NoJob
  end if
  locate csrlin-1,1
loop
return
'
'
' SUBROUTINE creates an error file if the TIFF head could not be properly
'   analysed or raster data format is not supported.
'   Subroutine actually ends at WarnIO-label.
'----------------------------------------------------------------------------
'
WrtErrFile:
'
Ti$ = StripExt$(BatchI$(N%)) + ".ERR"
open Ti$ for output as # %UnitERR
print# %UnitERR, Version$
print# %UnitERR, BatchI$(N%)
print# %UnitERR, "Report: ";Fatal$
print# %UnitERR, ""
if istrue Moto% then
  print# %UnitERR, "Motorola Format"
else
  print# %UnitERR, "Intel Format"
end if
print# %UnitERR, "IFD Addr:";IFD&
print# %UnitERR, "Tags Nr :";Tags%
for F% = 254 to 320
  if (Tagses???(1,F%) > 0) and (Tagses???(1,F%) < 6) then
    print# %UnitERR, "Tag";
    print# %UnitERR, using "####";F%;
    print# %UnitERR, " Typ ";
    select case Tagses???(1,F%)
      case 1
        print# %UnitERR, "BYTE ";
      case 2
        print# %UnitERR, "ASCII";
      case 3
        print# %UnitERR, "SHORT";
      case 4
        print# %UnitERR, "LONG ";
      case 5
        print# %UnitERR, "RATIO";
      case else
        print# %UnitERR, "*???*";
    end select
    print# %UnitERR, " Length/Lnge:";
    print# %UnitERR, using "#######";Tagses???(2,F%);
    print# %UnitERR, " Pointer/Zeiger:";
    print# %UnitERR, using "#######";Tagses???(3,F%)
  end if
next F%
close
if FileHere%(BatchO$(N%)) then kill BatchO$(N%)
Fatal$ = SLText$(56%)+SLText$(54%)+SLText$(35%)+" "+SLText$(55%)+Ti$
goto WarnIO
'
'
' Byte, Lynxx and ST4 direct DOS read or write error handler
'----------------------------------------------------------------------------
'
WarnIO:
'
beep
color %Yellow,%Red
print Center$(Fatal$,79%)
color %White,%Black
A$ = KeyIn$
if istrue AOpen% then close %UnitAUX
if istrue FOpen% then close %UnitFIT
return
'
'
' ST6 and PIC wrong filesize error handler
'----------------------------------------------------------------------------
'
WarnSize:
'
beep
color %Yellow,%Red
print Center$(SLText$(15%)+" "+SLText$(18%),80);
color %LWhite,%Red
print Center$(SLText$(56%)+SLText$(74%),80);
color %White,%Black
if istrue AOpen% then close %UnitAUX
if istrue FOpen% then close %UnitFIT
kill BatchO$(N%)
A$ = KeyIn$
return
'
'
' SUBROUTINE handles PhotometricInterpretation Tag 262 0 and 1 and 2 if
'   Tag 284 2
'----------------------------------------------------------------------------
'
PhotoI01:
'
B% = 16383
call BlockLen(B%,R%,T%,BP%,N1%,B???)
if T% > 0 then
  for F% = 1 to T%
    get$ # %UnitAUX, B%, D$
    call FindHiLo(D$,B%,BP%,Hi??,Lo??,CCA%())
    put$ # %UnitFIT, D$
    locate Y%,X%
    print using "###";F%
  next F%
end if
if R% > 0 then
  get$ # %UnitAUX, R%, D$
  call FindHiLo(D$,R%,BP%,Hi??,Lo??,CCA%())
  put$ # %UnitFIT, D$
  locate Y%,X%
  print using "###";F%
end if
return
'
'
' SUBROUTINE handles PhotometricInterpretation Tag 262 2 RGB and Tag 284 1
'   FitVal(16bit) = (RedByte*30 + GreenByte*59 + BlueByte*11) / 2
'   FitVal(max) = 12750
'----------------------------------------------------------------------------
'
PhotoI2:
'
B% = 16383
Z% = BP% + 8
call BlockLen(B%,R%,T%,Z%,N1%,B???)
V% = B% \ 3
W% = B% * 2 \ 3
if T% > 0 then
  for F% = 1 to T%
    get$ # %UnitAUX, B%, D$
    call RGB16(CCA%(1),D$,V%)
    D$ = string$(W%,chr$(0))
    L?? = MinWrd??(CCA%(1),W%)
    H?? = MaxWrd??(CCA%(1),W%)
    if L?? < Lo?? then Lo?? = L??
    if H?? > Hi?? then Hi?? = H??
    call MotInt(CCA%(1),W%)
    call VarStr(CCA%(1),W%,0%,D$)
    put$ # %UnitFIT, D$
    locate Y%,X%
    print using "###";F%
  next F%
end if
if R% > 0 then
  V% = R% \ 3
  W% = R% * 2 \ 3
  get$ # %UnitAUX, R%, D$
  call RGB16(CCA%(1),D$,V%)
  D$ = string$(W%,chr$(0))
  L?? = MinWrd??(CCA%(1),W%)
  H?? = MaxWrd??(CCA%(1),W%)
  if L?? < Lo?? then Lo?? = L??
  if H?? > Hi?? then Hi?? = H??
  call MotInt(CCA%(1),W%)
  call VarStr(CCA%(1),W%,0%,D$)
  put$ # %UnitFIT, D$
  locate Y%,X%
  print using "###";F%
end if
return
'
'
' SUBROUTINE handles PhotometricInterpretation Tag 262 3 Palette
'   FitVal(16bit) = (RedPal + GreenPal + BluePal) * 16
'   FitVal(max) = 12240
'   NOTE on TIFF-Palette:
'        The palette data have a length of 3 x 256 SHORT (Tag 320) = 1536
'        bytes. The SHORT value should be stored according to II or MM.
'        However, some store the data in Motorola format, even if the rest
'        of the file is in Intel format. Still others store the byte twice:
'        in the low and high byte position of the SHORT. The assembler
'        procedure RGBPal ORs the high and low order byte in SHORT. Silly:
'        no TIFF file has 48-bit colors = 281 Gc (Gigacolors).
'----------------------------------------------------------------------------
'
PhotoI3:
'
B% = 16383
Z% = BP% - 8
call BlockLen(B%,R%,T%,Z%,N1%,B???)
Z% = B% + B%
if T% > 0 then
  for F% = 1 to T%
    get$ # %UnitAUX, B%, D$
    call RGBPal(CCA%(1),CCD%(1,1),D$,B%)
    L?? = MinWrd??(CCA%(1),B%)
    H?? = MaxWrd??(CCA%(1),B%)
    if L?? < Lo?? then Lo?? = L??
    if H?? > Hi?? then Hi?? = H??
    call MotInt(CCA%(1),B%)
    D$ = string$(Z%,chr$(0))
    call VarStr(CCA%(1),Z%,0%,D$)
    put$ # %UnitFIT, D$
    locate Y%,X%
    print using "###";F%
  next F%
end if
if R% > 0 then
  Z% = R% + R%
  get$ # %UnitAUX, R%, D$
  call RGBPal(CCA%(1),CCD%(1,1),D$,R%)
  L?? = MinWrd??(CCA%(1),R%)
  H?? = MaxWrd??(CCA%(1),R%)
  if L?? < Lo?? then Lo?? = L??
  if H?? > Hi?? then Hi?? = H??
  call MotInt(CCA%(1),R%)
  D$ = string$(Z%,chr$(0))
  call VarStr(CCA%(1),Z%,0%,D$)
  put$ # %UnitFIT, D$
  locate Y%,X%
  print using "###";F%
end if
return
'
'
' SUB-SUBMENUE 9, 1-6 from FITSub label in CCDFSUB1
'============================================================================
'
' Menu 9-1: Editor for FITS-Header
'----------------------------------------------------------------------------
'
IFHD:
'
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
EF$ = BatchI$(N%)
if len(EF$) > 56 then EF$ = right$(EF$,56)
get$ # %UnitAUX, 2880, D$
close %UnitAUX
AOpen% = %False
call FillCards(Card$(),ACrd$(),D$)
print LogOn$(SLText$(6%)+"  "+EF$,%White,%Red)
PCnt% = 1
OSel% = 1
LSel% = 1
LCnt% = 1
call DisPage(PCnt%,ACrd$())
call InsCurs(LSel%,OSel%,ACrd$())
do
  call MovCmd(PCnt%,English%)
  Query$ = KeyIn$
  select case Query$
    case chr$(27)				'ESC=exit
      exit loop
    case chr$(13)				'RET=select
      call EdtCmd(English%)
      locate 18,1
      color %LWhite,%Black
      print Acrd$(LSel%);
      CP% = 1
      OP% = 1
      call EdtCurs(CP%,OP%,Acrd$(LSel%))
      do
        while not instat : wend
        Q$ = inkey$
        select case Q$
          case chr$(0,82)				'--INS=accept
            Card$(LSel%) = Acrd$(LSel%)
            locate 18,1
            call ClrLine
            call InsCurs(LSel%,OSel%,ACrd$())
            exit loop
          case chr$(0,83)				'--DEL=reject
            Acrd$(LSel%) = Card$(LSel%)
            locate 18,1
            call ClrLine
            exit loop
          case chr$(0,75)				'--LeftArrow
            decr CP%
            if CP% < 1 then CP% = 80
            call EdtCurs(CP%,OP%,Acrd$(LSel%))
            OP% = CP%
          case chr$(0,77)				'--RightArrow
            incr CP%
            if CP% > 80 then CP% = 1
            call EdtCurs(CP%,OP%,Acrd$(LSel%))
            OP% = CP%
          case else					'--character
            if (Q$ > chr$(31)) and (Q$ < chr$(127)) then
              Z$ = left$(Q$,1)
              if OP% < 9 then Z$ = ucase$(Z$)
              mid$(Acrd$(LSel%),OP%,1) = Z$
              incr CP%
              if CP% > 80 then CP% = 1
              call EdtCurs(CP%,OP%,Acrd$(LSel%))
              OP% = CP%
            else
              beep
            end if
        end select
      loop
    case chr$(9)				'TAB Card+1
      incr LSel%
      incr LCnt%
      if LCnt% > 12 then
        LCnt% = 1
        LSel% = LSel% - 12
      end if
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
    case chr$(0,71)				'HOME=page 1, Card 1
      if PCnt% > 1 then OSel% = 1
      PCnt% = 1
      LSel% = 1
      LCnt% = 1
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
    case chr$(0,72)				'UpArrow=Card-1
      decr LSel%
      decr LCnt%
      if LCnt% < 1 then
        LCnt% = 12
        LSel% = LSel% + 12
      end if
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
    case chr$(0,73)				'PgUp=Card-12, page-1
      decr PCnt%
      if PCnt% < 1 then PCnt% = 1
      LCnt% = 1
      LSel% = (PCnt%-1) * 12 + 1
      OSel% = LSel%
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
    case chr$(0,79)				'END=card 36, page 3
      if PCnt% < 3 then OSel% = 25
      PCnt% = 3
      LSel% = 36
      LCnt% = 12
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
    case chr$(0,80)				'DownArrow=Card+1
      incr LSel%
      incr LCnt%
      if LCnt% > 12 then
        LCnt% = 1
        LSel% = LSel% - 12
      end if
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
    case chr$(0,81)				'PgDn=Card+10, page+1
      incr PCnt%
      if PCnt% > 3 then PCnt% = 3
      LCnt% = 1
      LSel% = (PCnt%-1) * 12 + 1
      OSel% = LSel%
      call DisPage(PCnt%,ACrd$())
      call InsCurs(LSel%,OSel%,ACrd$())
      OSel% = LSel%
  end select
loop
call FindEnd(Card$())
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
for F% = 1 to 36
  put$ # %UnitAUX, Card$(F%)
next F%
close %UnitAUX
AOpen% = %False
call ClsVB
return
'
'
' Menu 9-2: Remove gray scale bar at last 12 lines of FITS image
'----------------------------------------------------------------------------
'
RmvBar:
'
EF$ = StripExt$(BatchI$(N%)) + ".$$$"
C%  = 1
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
get$ # %UnitAUX, 2880, D$
call FillCards(Card$(),ACrd$(),D$)
Fatal$ = SLText$(56%) + SLText$(58%) + SLText$(35%)
if isfalse left$(Card$(C%),6) = "SIMPLE" then goto WarnIO
if isfalse mid$(Card$(C%),30,1) = "T" then goto WarnIO
Fatal$ = SLText$(56%) + SLText$(81%) + SLText$(35%)
incr C%
BP?? = CardVal??(Card$(C%))
F% = %True
if BP?? =  8 then F% = %False
if BP?? = 16 then F% = %False
if istrue F% then goto WarnIO
incr C%
if isfalse CardVal??(Card$(C%)) = 2 then goto WarnIO
incr C%
N1?? = CardVal??(Card$(C%))
incr C%
N2?? = CardVal??(Card$(C%))
RC% = C%
F% = %True
B% = 1
while not lof(%UnitAUX)
  I% = CardNdx%(Card$(),"END     ")
  if istrue I% then
    F% = %False
    exit loop
  end if
  get$ # %UnitAUX, 2880, D$
  incr B%
wend
B??? = loc(%UnitAUX)		'start of image data
close %UnitAUX
AOpen% = %False
if istrue F% then goto WarnIO
N0% = 2
N1% = N1??
N2% = N2?? - 12
BP% = BP??
A??? = N1% * N2% * (BP%\8)	'raster data without bar
call InsNaxCmt(Card$(),N2%,82%)
Handle% = WrFitH(EF$,Card$(),FOpen%)
FOpen% = %True
if B% > 1 then					'>36 cards
  open BatchI$(N%) for binary as # %UnitAUX
  AOpen% = %True
  get$ # %UnitAUX, 2880, D$
  for F% = 1 to B%
    get$ # %UnitAUX, 2880, D$
    put$ # %UnitFIT, D$
  next F%
  close %UnitAUX
  AOpen% = %False
end if
open BatchI$(N%) for binary as %UnitAUX
Handla% = fileattr(%UnitAUX,2)
AOpen% = %True
seek %UnitAUX, B???
A% =  N1% * (BP% \ 8)		'--bytes per line
L% =  %LMN \ A%			'--lines per block
B% =  L% * A%			'--bytes per block
T% =  N2% \ L%			'--number of blocks (turns)
R% =  N2% - (L% * T%)		'--rest, number of lines not yet done
SF% = 0
color %Cyan,%Black
print SLText$(13%);
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
if T% > 0 then
  for F% = 1 to T%
    Fatal$ = SLText$(56%) + SLText$(65%) + SLText$(35%)
    if istrue RdFit%(Handla%,B%,CCA%(1)) then goto WarnIO
    Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
    if istrue  WrFits%(B%,CCA%(1),Handle%,SF%) then goto WarnIO
    locate Y%,X%
    print using "###";F%
  next F%
end if
if R% > 0 then
  B% = R% * A%			'--rest block length
  Fatal$ = SLText$(56%) + SLText$(65%) + SLText$(35%)
  if istrue RdFit%(Handla%,B%,CCA%(1)) then goto WarnIO
  Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
  if istrue WrFits%(B%,CCA%(1),Handle%,SF%) then goto WarnIO
  locate Y%,X%
  print using "###";F%
end if
call FillFits(N1%,N2%,BP%)
close
AOpen% = %False
FOpen% = %False
kill BatchI$(N%)
name EF$ as BatchI$(N%)
call ClsLC
return
'
'
' Menu 9,3-6: Input FIT. Converts to TIFF. Ignores cards beyond card 36
'----------------------------------------------------------------------------
'
IFTI:
'
N3?? =     0
C%   =     1		'card counter
Lo?? = 65535
Hi?? =     0
Txt269$ = "Void" + chr$(0)
Txt271$ = "Void" + chr$(0)
Txt272$ = "Void" + chr$(0)
Txt315$ = "Void" + chr$(0)
Txt316$ = "Void" + chr$(0)
open BatchI$(N%) for binary as # %UnitAUX
AOpen% = %True
get$ # %UnitAUX, 2880, D$
call FillCards(Card$(),ACrd$(),D$)
Fatal$ = SLText$(56%) + SLText$(58%) + SLText$(35%)
if isfalse left$(Card$(C%),6) = "SIMPLE" then goto WarnIO
if isfalse mid$(Card$(C%),30,1) = "T" then goto WarnIO
Fatal$ = SLText$(56%) + SLText$(81%) + SLText$(35%)
incr C%
BP?? = CardVal??(Card$(C%))
incr C%
N0?? = CardVal??(Card$(C%))
incr C%
N1?? = CardVal??(Card$(C%))
incr C%
N2?? = CardVal??(Card$(C%))
if N0?? = 3 then
  incr C%
  N3?? = CardVal??(Card$(C%))
  if isfalse N3?? = 3 then goto WarnIO
end if
if (N0?? < 2) or (N0?? > 3) then goto WarnIO
Fatal$ = SLText$(56%) + SLText$(80%) + SLText$(35%)
if (N1?? = 0) or (N2?? = 0) then goto WarnIO
F% = %True
if BP?? =  8 then F% = %False
if BP?? = 16 then F% = %False
if istrue F% then goto WarnIO
I% = CardNdx%(Card$(),"DATAMIN ")
if istrue I% then Lo?? = CardVal??(Card$(I%))
I% = CardNdx%(Card$(),"DATAMAX ")
if istrue I% then Hi?? = CardVal??(Card$(I%))
I% = CardNdx%(Card$(),"OBJECT  ")
if istrue I% then Txt269$ = CardAscZ$(Card$(I%))
Txt270$ = "Original BitsPerPixel:" + using$("###",BP??) + chr$(0)
I% = CardNdx%(Card$(),"TELESCOP")
if istrue I% then Txt271$ = CardAscZ$(Card$(I%))
I% = CardNdx%(Card$(),"HISTORY ")
if istrue I% then Txt272$ = CardAscZ$(Card$(I%))
I% = CardNdx%(Card$(),"OBSERVER")
if istrue I% then Txt315$ = CardAscZ$(Card$(I%))
I% = CardNdx%(Card$(),"INSTRUME")
if istrue I% then Txt316$ = CardAscZ$(Card$(I%))
Txt305$ = VN$ + chr$(0)
Txt306$ = DTAscZ$
F% = %True
while not lof(%UnitAUX)
  I% = CardNdx%(Card$(),"END     ")
  if istrue I% then
    F% = %False
    exit loop
  end if
  get$ # %UnitAUX, 2880, D$
wend
B??? = loc(%UnitAUX)		'start of image data
close %UnitAUX
AOpen% = %False
if istrue F% then goto WarnIO
CCD%(2,1) = len(Txt269$)	'1=start, 2=len
CCD%(2,2) = len(Txt270$)
CCD%(2,3) = len(Txt271$)
CCD%(2,4) = len(Txt272$)
CCD%(2,5) = len(Txt305$)
CCD%(2,6) = len(Txt306$)
CCD%(2,7) = len(Txt315$)
CCD%(2,8) = len(Txt316$)
CCD%(1,1) = 8
for F% = 1 to 8
  CCD%(1,F%+1) = CCD%(1,F%) + CCD%(2,F%)
next F%
A??? = CCD%(1,9)			'start of IFD
CCD%(1,9) = CCD%(1,9) + 22 * 12	+ 4	'end of IFD for 282/283
CCD%(2,9) = CCD%(1,9) + 8		'start of raster data
if N3?? = 3 then X% = 3 else X% = 1
SN??? = Stripses???(X%,N1??,N2??,SL???,SB???,RL???,RB???)
B$ = "II" + Single$(42??) + Double$(A???) + Txt269$ + Txt270$ + Txt271$
C$ = Txt272$ + Txt305$ + Txt306$ + Txt315$ + Txt316$ + Single$(22???)
D$ = TiffH$(N1??,N2??,X%,CCD%(),SN???,SL???,SB???,RL???,RB???)
open BatchO$(N%) for binary as %UnitFIT		'actually TIFF
Handle% = fileattr(%UnitFIT,2)
FOpen% = %True
put$# %UnitFIT, B$
put$# %UnitFIT, C$
put$# %UnitFIT, D$
B$ = Nill$
C$ = Nill$
D$ = Nill$
S??? = N1?? * N2?? * (BP?? \ 8) * X%
N1% = N1??
BP% = BP??
B% = %LMN
call BlockLen(B%,R%,T%,BP%,N1%,S???)
H% = B% \ 2
open BatchI$(N%) for binary as # %UnitAUX
Handla% = fileattr(%UnitAUX,2)
AOpen% = %True
seek# %UnitAUX, B???
color %Cyan,%Black
print SLText$(13%);" (analysis)  ";
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
C??? = 0
A??? = 0
Fatal$ = SLText$(56%) + SLText$(65%) + SLText$(35%)
if T% > 0 then
  for F% = 1 to T%
    if istrue RdFit%(Handla%,B%,CCA%(1)) then goto WarnIO
    if BP% = 16 then
      call MotInt(CCA%(1),H%)
      call AndMWA(CCA%(1),32767??,H%)
      L?? = MinWrd??(CCA%(1),H%)
      H?? = MaxWrd??(CCA%(1),H%)
      if L?? < Lo?? then Lo?? = L??
      if H?? > Hi?? then Hi?? = H??
      C??? = C??? + CntWrd??(CCA%(1),H??,H%)
      A??? = A??? + CntWrd??(CCA%(1),H??\2,H%)
    else
      L?? = MinByt??(CCA%(1),B%)
      H?? = MaxByt??(CCA%(1),B%)
      if L?? < Lo?? then Lo?? = L??
      if H?? > Hi?? then Hi?? = H??
    end if
    locate Y%,X%
    print using "###";F%
  next F%
end if
if R% > 0 then
  H% = R% \ 2
  if istrue RdFit%(Handla%,R%,CCA%(1)) then goto WarnIO
  if BP% = 16 then
    call MotInt(CCA%(1),H%)
    call AndMWA(CCA%(1),32767??,H%)
    L?? = MinWrd??(CCA%(1),H%)
    H?? = MaxWrd??(CCA%(1),H%)
    if L?? < Lo?? then Lo?? = L??
    if H?? > Hi?? then Hi?? = H??
    C??? = C??? + CntWrd??(CCA%(1),H??,H%)
    A??? = A??? + CntWrd??(CCA%(1),H??\2,H%)
  else
    L?? = MinByt??(CCA%(1),R%)
    H?? = MaxByt??(CCA%(1),R%)
    if L?? < Lo?? then Lo?? = L??
    if H?? > Hi?? then Hi?? = H??
  end if
  locate Y%,X%
  print using "###";F%
end if
B% = %LMN
call BlockLen(B%,R%,T%,BP%,N1%,S???)
close %UnitAUX
AOpen% = %False
select case SubOpt%
  case 3						'slight
    if C??? < S??? / 200 then Hi?? = Hi?? / 2		'<1%
  case 4						'medium
    if C??? < S??? / 200 then Hi?? = Hi?? / 2		'<1%
    if A??? < S??? / 100 then Hi?? = Hi?? / 1.5		'<2%
  case 5						'strong
    if C??? < S??? / 100 then Hi?? = Hi?? / 2		'<2%
    if A??? < S??? / 100 then Hi?? = Hi?? / 2		'<2%
end select
D%  = Hi?? - Lo??
M%  = D% \ 255 + 1
SF% = 0
open BatchI$(N%) for binary as # %UnitAUX
Handla% = fileattr(%UnitAUX,2)
AOpen% = %True
seek# %UnitAUX, B???
color %Cyan,%Black
print SLText$(13%);" (conversion)";
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
if T% > 0 then
  for F% = 1 to T%
    Fatal$ = SLText$(56%) + SLText$(65%) + SLText$(35%)
    if istrue RdFit%(Handla%,B%,CCA%(1)) then goto WarnIO
    if BP% = 16 then
      H%  = B% \ 2
      call MotInt(CCA%(1),H%)
      call LmtHWC(CCA%(1),Hi??,H%)
      if Lo?? > 0 then call SubCWL(CCA%(1),Lo??,0%,H%)
      call DivAry(CCQ%(1,1),CCA%(1),M%,H%)
    else
      H% = B%
      call CpyB2B(CCQ%(1,1),CCA%(1),H%)
    end if
    Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
    if istrue WrFits%(H%,CCQ%(1,1),Handle%,SF%) then goto WarnIO
    locate Y%,X%
    print using "###";F%
  next F%
end if
if R% > 0 then
  Fatal$ = SLText$(56%) + SLText$(65%) + SLText$(35%)
  if istrue RdFit%(Handla%,R%,CCA%(1)) then goto WarnIO
  if BP% = 16 then
    H% = R% \ 2
    call MotInt(CCA%(1),H%)
    call LmtHWC(CCA%(1),Hi??,H%)
    if Lo?? > 0 then call SubCWL(CCA%(1),Lo??,0%,H%)
    call DivAry(CCQ%(1,1),CCA%(1),M%,H%)
  else
    H% = R%
    call CpyB2B(CCQ%(1,1),CCA%(1),H%)
  end if
  Fatal$ = SLText$(56%) + SLText$(74%) + SLText$(35%)
  if istrue WrFits%(H%,CCQ%(1,1),Handle%,SF%) then goto WarnIO
  locate Y%,X%
  print using "###";F%
end if
close
AOpen% = %False
FOpen% = %False
call ClsCL
return
'
'
CCDFSub2:
'
'===================================-<960311>-=========-<HoroSoft>-==========

