'960412 1429
'****************************************************************************
'* PROGRAM NAME: CCDGALRY.BAS   DATE: 26. 1.1994   INCLUDE IN: is Main!     *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: CCD-Gallery Utility for CCD-Image archiving purposes.           *
'* INCLUDE FILES: ERROR3  .INC  Fatal error handler                         *
'*                IOTEXT  .INC  Set of Text and File functions              *
'*                CCDGFUNC.INC  Collection of functions                     *
'*                CCDGPROC.INC  Collection of procedures                    *
'*                CCDGSUB .INC  Collection of subroutines                   *
'*                CCDGDAT .INC  Data and text definitions                   *
'* OBJECT FILES:  PBSTACK .OBJ  Power BASIC 2 & 3 Stack handler for objects *
'*                ARRAYEXT.PBL  Byte, word and integer array functions.     *
'*                CLRSCRN .PBL  Cute screen sweeper                         *
'*                CCDGG   .OBJ  Assembly Routines with external procedures  *
'*                RLCEGEN .OBJ  Run Length Count Encoding Generator         *
'* UNIT FILES:    PB3GPUSE.PBU  General Purpose Functions and Procedures    *
'* INPUT FILES:   filename.CGE  CCD Gallery Encoded files.                  *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.44    8-APR-96 Added cute screen sweepers                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.43   10-FEB-96 Definitely FreeWare, updated Copyright to 1996 *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.42    2-SEP-95 Recompiled from PB3.10 to PB3.20               *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.41   28-APR-95 Added Edit function for Text                   *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.31   17-FEB-95 Recompiled with PB3.1. Is freeware             *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.23    2-JUN-94 Added Version CCDGalryV% = 123                 *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.13   6-May-94: Works                                          *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03  26-JAN-94: Start                                          *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
' COMPILER DIRECTIVES
'----------------------------------------------------------------------------
'
'$alias data as "DSEG"	'or data segment name as used in .OBJ
'$code seg "CODE"	'or code segment name as used in .OBJ
'$huge			'for arrays > 64K
$cpu 8086		'8086/80286/80386
$debug map off		'on/off
$debug path off		'on/off
$debug unit off		'on/off
$debug pbdebug off	'on/off
$dim array		'all/array/none
$dynamic		'$static
$error all off		'bounds/numeric/overflow/stack/all on/off
$event off		'on/off
$float procedure	'emulate/npx/procedure
$lib com-,lpt-,graph+,cga+,ega+,vga+,herc-,fullfloat-,iprint-
$optimize speed		'size/speed
$option cntlbreak off	'cntlbreak/gosub on/off
$stack 2048		'1536...32767
$com 0			'0...32767
$sound 1		'1...4096
$string 32		'1/2/4/8/16/32
$compile exe		'memory/exe/chain/unit
'
'
' LANGUAGE SELECTION AND VERSION NUMBER
'----------------------------------------------------------------------------
'
VN$      = "CCDGALRY V.1.44"
CCDGalryV% = 144
on error goto ErrorHandling
%True   = -1
%False  =  0
Chroma% = %True
shared Idiom%()
dim Idiom%(0:2)			'0:E=true/D=false 1:SL-text-, 2:ML text-offs
C$ = command$
InpDir$ = DefPath$(C$)
English% = ComLinLan%(command$,"CCDTOOLS: "+VN$)
if English% then
  Idiom%(0) = %True		'English
  Idiom%(1) = 0			'SL offset
  Idiom%(2) = 0			'ML offset
  Version$ = "CCD Image Gallery Tool " + VN$
else
  Idiom%(0) = %False		'Deutsch
  Idiom%(1) =  50               'SL offset
  Idiom%(2) =  10		'ML offset
  Version$ = "CCD Bild Gallerie Werkzeug " + VN$
end if
'
'
' VARIABLES SETUP and VIDEO TEST - SHARED VARIABLES AS WELL
' -----------------------------------------------------------------------------
'
%VBIOS = &h10
%DOS   = &h21
'
on error goto ErrorHandling
'
'
' CONSTANTS CPU-REGISTERS AND COLORS
'-----------------------------------------------------------------------------
'
%FLAGS      = 0        'CPU registers
%AX         = 1
%BX         = 2
%CX         = 3
%DX         = 4
%SI         = 5
%DI         = 6
%BP         = 7
%DS         = 8
%ES         = 9
'
%Black     =  0        'COLORS, dark
%Blue      =  1
%Green     =  2
%Cyan      =  3
%Red       =  4
%Pink      =  5
%Brown     =  6
%White     =  7
%Gray      =  8        'COLORS, light
%LBlue     =  9
%LGreen    = 10
%LCyan     = 11
%LRed      = 12
%LPink     = 13
%Yellow    = 14
%LWhite    = 15
'
%LMN       = 3520	'eLeMeNts in arrays
%UnitAUX   =    1		'Input file
'
'
' Function and Procedure Declaration in external object: ARRAYEXT.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function ArrayExtV%()
declare sub CpyB2B(byte,byte,integer)
declare sub SwapBA(byte,byte,integer)
'
'
' Function and Procedure Declaration in external units: CLRSCRN.PBL
'----------------------------------------------------------------------------
'
declare function ClrScrnV%()
declare sub ClsLC()
declare sub HoroSoftLogo()
'
'
' Function and Procedure Declaration in external units: PB3GPUSE.INC/PBU
'----------------------------------------------------------------------------
'
declare function PB3GPUseV%()
declare function PBVer%(string)
declare function EscRet%()
declare function AddSlash$(string)
declare function Center$(string,integer)
declare function LogOn$(string,integer,integer)
declare function DateNorm$(integer)
declare function KeyIn$()
declare function ComLinLan%(string,string)
declare function IOPath$(string,string,string)
declare function IOFile$(integer,integer,string)
declare function Confirm%(string)
declare function Redo%(string)
declare function FileHere%(string)
declare function SizeOk%(string,long)
declare function ByteBin$(integer)
declare function Outch$(string)
declare sub ClrLine()
declare sub Illegal(string,string)
'
'
' Function and Procedure Declaration in external units: CCDGG.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function CCDGGV%()
declare sub NiByte(byte,byte)
declare sub ColCvt(byte,byte)
declare sub Pictur(byte,integer,integer)
'
'
' Function and Procedure Declaration in external units: RLCEGEN.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function RlceGenV%()
declare function DecBie%(byte,byte)
declare function RdBie%(byte,integer,word)
'
'
' FILES TO BE LINKED IN
'-----------------------------------------------------------------------------
'
$link "PBSTACK.OBJ"
$link "ARRAYEXT.PBL"
$link "CLRSCRN.PBL"
$link "CCDGG.OBJ"
$link "RLCEGEN.OBJ"
$link "PB3GPUSE.PBU"
'
'
' FILES TO BE INCLUDED
'-----------------------------------------------------------------------------
'
$include "IOTEXT.INC"
$include "CCDGFUNC.INC"
$include "CCDGPROC.INC"
$include "CCDGSUB.INC"
$include "CCDGDAT.INC"
$include "ERROR3.INC"
$segment
'
'
' ARRAY SETUP
'----------------------------------------------------------------------------
'
Z% = fix(fre(-1)/1024)
Fatal$ = SLText$(37%) + str$(32-Z%) + "Kb"
if Z% < 32 then goto NoJob			'Needs about 172Kb
'
dim CCA?(1:3530)		'10 bytes spare
dim CCB?(1:3530)		'10 bytes spare
'
MaxFiles% = 2725		'Maximum number of files to read from Dir
dim FilesInDir$(MaxFiles%)	'Holds unformatted filenames
dim ImgFlax%(MaxFiles%)		'if true, image is of no use
dim Inverted%(MaxFiles%)	'if true, image is inverted
dim Edi%(1:20,1:4)		'Editor counter
restore EdiData			'initialize
for F% = 1 to 20
  for N% = 1 to 4
    read Edi%(F%,N%)
  next N%
next F%
'
'
' VARIABLES SETUP
'-----------------------------------------------------------------------------
'
GPCR$ = "(c) 1994-96 by H.-R.H. Wernli, CH-3952 Susten, Switzerland"
STCR$ = "Processed with " + VN$ + "; " + GPCR$
'
'
'
' START
'============================================================================
'
' Get Video Mode, Log On and if neither EGA, MCGA or VGA, quit on error
'
screen 0
A% = BestVideo%
select case A%
  case 9
    EGAHere% = %True
    VMode%   = 9
  case 12
    EGAHere% = %True
    VGAHere% = %True
    VMode%   = 9
  case else
    EGAHere% = %False
    VGAHere% = %False
    VMode%   = 0
end select
on error goto ErrorHandling
print LogOn$(Version$,%White,%Blue)
print Describe$
if VMode% = 0 then
  color %LWhite,%Red
  print SLText$(9%)
  Fatal$ = SLText$(7%)
  goto NoJob
end if
'
' Look for files. If there are none, quit on error
'
Many%  = AnyDir%(InpDir$+"*.CGE",FilesInDir$(),MaxFiles%)	'get files
if Many% = 0 then
  Fatal$ = SLText$(1%)
  goto NoJob
end if
call Intro1
call Intro2
color %Cyan,%Black
print SLText$(8%);" ";
color %LCyan,%Black
'
' Show best video mode found
'
if istrue VGAHere% then
  print "VGA"
else
  if istrue EGAHere% then print "EGA 256K RAM"
end if
'
' Do some calculations and sort filenames
'
SA% = Many% \ 32			'-- screen all
SR% = Many% mod 32			'-- screen rest
RA% = 4					'-- rows all
RR% = SR% \ 8				'-- rows rest
CA% = 8					'-- columns all
CR% = SR% mod 8				'-- columns rest
color %Cyan,%Black
print SLText$(21%);
color %LCyan,%Black
print Many%
'
' Set to Video and draw first screen full of images
'
if istrue VGAHere% then
  if Confirm%(SLText$(34%)) then call VGAMoCoTog(%True)
else
  A% = Confirm%(SLText$(20%))
end if
screen VMode%
Last% = 1
Z% = 1
Inverted%(This%) = %False
This% = Update%(Last%,Many%,"I",Z%)
'
'.................... MAIN LOOP START .......................................
'
do
  Q$ = KeyIn$
  select case Q$
    case chr$(27)				'ESC - End
      exit loop
    case chr$(0,71)				'HOME - first
      This% = Update%(Last%,Many%,"H",Z%)
    case chr$(0,79)				'END - last
      This% = Update%(Last%,Many%,"E",Z%)
    case chr$(0,73)				'PgUP - previous screen
      This% = Update%(Last%,Many%,"P",Z%)
    case chr$(0,81)				'PgDN - next screen
      This% = Update%(Last%,Many%,"N",Z%)
    case chr$(0,75)				'Left
      This% = Update%(Last%,Many%,"L",Z%)
    case chr$(0,77)				'Right
      This% = Update%(Last%,Many%,"R",Z%)
    case chr$(0,72)				'Up
      This% = Update%(Last%,Many%,"U",Z%)
    case chr$(0,80)				'Down
      This% = Update%(Last%,Many%,"D",Z%)
    case " "					'Blank - Invert
      if not ImgFlax%(This%) then
        if GetOneImg%(InpDir$+FilesInDir$(This%),CCA?(),CCB?()) then
          if isfalse Inverted%(This%) then
            call SwapBA(CCA?(1),CCB?(1),%LMN)
            Inverted%(This%) = %True
          else
            Inverted%(This%) = %False
          end if
          call Image(This%,CCB?())
          call Mark(This%,Inverted%(This%))
        else
          ImgFlax%(This%) = %True
          call ErrImg(This%)
        end if
      end if
    case chr$(13)				'RET - Select
      call PntHead(InpDir$,FilesInDir$(This%),T$,ImgFlax%(This%))
      if right$(T$,1) = chr$(26) then
        V$ = KeyIn$
        if V$ = chr$(0,82) then			'INS
          call EditIt(T$,Z$,Edi%())
          if right$(T$,1) = chr$(26) then
            open InpDir$+FilesInDir$(This%) for binary as # %UnitAUX
            put$ # %UnitAUX, T$
            close %UnitAUX
          end if
          call DoBar(Z%,Z%)
        else
          locate 25,73
          color %White,%Black
          print "[RET]";
        end if
      end if
  end select
loop
'
'................... MAIN LOOP END ..........................................
'
' That's it - we're going to log off
'
if istrue VGAHere% then call VGAMoCoTog(%False)
screen 0
print LogOn$(Version$,%White,%Blue);
print Describe$
color %LWhite,%Green
A$ = VN$ + SLText$(2%)
print
print Center$(A$,80)
print
color %LWhite,%Red
A$ = VN$ + "; " + GPCR$
print Center$(A$,80)
color %White,%Black
locate 22,1
goto About
'
'
' Should an unrecoverable error occur, we exit program here
'
NoJob:
'
Y% = csrlin
if Y% < 6 then Y% = 18
locate Y%,1
color %Yellow,%Red
print Center$(SLText$(3%) + Fatal$,80);
color %LWhite,%Red
print Center$(SLText$(4%) + VN$ + SLText$(5%),80);
color %LCyan,%Blue
print Center$(SLText$(6%),80)
color %White,%Black
locate 22,1
A$ = KeyIn$
goto About
'
'
About:
'
print "Info = F1 (2 sec)"
delay 2
if inkey$ = chr$(0,59) then
  print
  color %LWhite,%Black
  print "CCDGALRY.BAS Version";CCDGalryV%
  color %White,%Black
  print "CCDGFUNC.INC Version";CCDGFuncV%
  print "CCDGPROC.INC Version";CCDGProcV%
  print "CCDGSUB .INC Version";CCDGSubV%
  print "CCDGDAT .INC Version";CCDGDatV%
  print "CCDGG   .OBJ Version";CCDGGV%
  print "IOTEXT  .INC Version";IOTextV%
  print "ERROR3  .INC Version";Error3V%
  print "PB3GPUSE.PBU Version";PB3GPUseV%
  print "ARRAYEXT.PBL Version";ArrayExtV%
  print "CLRSCRN. PBL Version";ClrScrnV%
  print "RLCEGEN .OBJ Version";RlceGenV%
  print "PBSTACK .OBJ Version 100"
  print "PowerBASIC  Revision";PBVer%(SV$);SV$
  print
  color %LWhite,%Blue
  call HoroSoftLogo
  color %White,%Black
  while not instat : wend
  Q$ = inkey$
  call ClsLC
end if
cls
system
'
'============================-<940126>-================-<HoroSoft>-===========
