'960210 1459
'****************************************************************************
'* PROGRAM NAME: CCDGFUNC.INC   DATE:  5. 2.1994   INCLUDE IN: CCDGALRY.BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE:                                                                 *
'* INCLUDE FILES:                                                           *
'* OBJECT FILES:                                                            *
'* INPUT FILES:                                                             *
'* OUTPUT FILES:                                                            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03 - 10-FEB-96 Recompileds with PB 3.20                       *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02 - 30-APR-95 Added editting function                        *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01 -  2-JUN-94 Introduced Version CCDGFuncV% = 101            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00 -  5-FEB-94 Extracted from CCDGALRY.BAS                    *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDGFuncV% = 103
'
'
' FUNCTION scans any directory and returns all files up to M% in string
'          array FilesInDir$(). This array must be dimmed as (1:M%).
'          The search is made for the Mask M$, which may contain a full
'          path description, e.g. "B:\CCD\LUNA\????????.BYT". The
'          filenames returned in the array are of variable length, e.g.
'          "ALPES.BYT" or "TESTPICT.BYT". The integer returned from the
'          function itself is the number of files found.
'----------------------------------------------------------------------------
'
function AnyDir%(M$,FilesInDir$(),M%)
  local C%,F%,N%,Z%,DTASeg??,DTAOfs??,DTA$
  M$ = M$ + chr$(0)
  C% = 0
  DTA$ = string$(128,chr$(0))
  reg (%AX), &h2F00
  call interrupt %DOS
  DTASeg?? = reg (%ES)
  DTAOfs?? = reg (%BX)
  reg (%DS), strseg(DTA$)
  reg (%DX), strptr(DTA$)
  reg (%AX), &h1A00
  call interrupt %DOS
  reg (%DS), strseg(M$)
  reg (%DX), strptr(M$)
  reg (%CX), 0
  reg (%AX), &h4E00
  call interrupt %DOS
  Z% = reg (%FLAGS)
  F% = bit(Z%,0)
  if isfalse F% then
    incr C%
    Z% = instr(31,DTA$,chr$(0))
    FilesInDir$(C%) = mid$(DTA$,31,Z%-31)
    for N% = 2 to M%
      reg (%AX), &h4F00
      call interrupt %DOS
      Z% = reg (%FLAGS)
      F% = bit(Z%,0)
      if istrue F% then exit for
      incr C%
      Z% = instr(31,DTA$,chr$(0))
      FilesInDir$(C%) = mid$(DTA$,31,Z%-31)
    next N%
  end if
  reg (%DS), DTASeg??
  reg (%DX), DTAOfs??
  reg (%AX), &h1A00
  call interrupt %DOS
  AnyDir% = C%
end function
'
'
' FUNCTION returns path specifications from C$
'----------------------------------------------------------------------------
'
function DefPath$(C$)
  local A%,B%,C%,A$,D$
  D$ = ""
  B% = len(C$)
  A% = instr(C$,"@")
  if A% > 0 and B% > 0 then
    C% = B% - A%
    if istrue C% then
      A$ = ltrim$(right$(C$,C%))
      A% = instr(A$," ")
      if istrue A% then
        B$ = left$(A$,A%-1)
        A$ = B$
      end if
      B$ = remove$(C$,A$)
      C$ = B$
      D$ = AddSlash$(A$)
    end if
  end if
  DefPath$ = D$
end function
'
'
' FUNCTION returns highest possible supported video mode.
'          Supported are VGA (12), MCGA (11), EGA-256K (9) or none (0).
'----------------------------------------------------------------------------
'
function BestVideo%
  local V%,BL%,BH%
  V% = 0
  reg (%AX), &h1A00
  call interrupt &h10
  BL% = reg(%BX) mod 256
  if (BL% = 7) or (BL% = 11) then V% = 11
  if (BL% = 8) or (BL% = 12) then V% = 12
  if V% = 0 then
    reg (%AX), &h1200
    reg (%BX), &h0010
    call interrupt &h10
    BL% = reg(%BX) mod 256
    BH% = fix(reg(%BX) \ 256)
    if BH% = 0 and BL% = 3 then V% = 9 else V% = 0
  end if
  BestVideo% = V%
end function
'
'
' FUNCTION returns True if there is an image, else false
'----------------------------------------------------------------------------
'
function GetOneImg%(F$,CCA?(),CCB?())
  local A%,Z%,Handle%,I?,ICI?,D$,L&&,L??,D??
  Z% = %False
  ICI? =  0
  I?   = 16
  open F$ for binary as # %UnitAUX
  seek # %UnitAUX, 256
  get$ # %UnitAUX, 4, D$
  L&& = lof(%UnitAUX) - 256
  close %UnitAUX
  L?? = asc(mid$(D$,2,1)) * 256 + asc(left$(D$,1))
  D?? = asc(right$(D$,1)) * 256 + asc(mid$(D$,3,1))
  if (L&& = L??) and (D?? = 1760) then
    open F$ for binary as # %UnitAUX
    Handle% = fileattr(%UnitAUX,2)
    seek # %UnitAUX, 256
    A% = RdBie%(CCB?(1),Handle%,%LMN)
    close %UnitAUX
    if isfalse A% then
      A% = DecBie%(CCA?(1),CCB?(1))
      if isfalse A% then
        call NiByte(CCB?(1),CCA?(1))
        call CpyB2B(CCA?(1),CCB?(1),%LMN)
        call ColCvt(CCB?(1),ICI?)
        call ColCvt(CCA?(1),I?)
        Z% = %True
      end if
    end if
  end if
  GetOneImg% = Z%
end function
'
'
' FUNCTION returns Text from Image with Flag at start, without EOF at end
'          If last byte 1A, then file not R/O, else R/O
'----------------------------------------------------------------------------
'
function GetOneTxt$(F$)
  local X%,D$,Q$
  open F$ for binary as # %UnitAUX
  get$ # %UnitAUX, 256, D$
  close %UnitAUX
  X% = attrib(F$) and 1
  if X% = 0 then Q$ = chr$(26) else Q$ = "!"
  GetOneTxt$ = rtrim$(left$(D$,255)) + Q$
end function
'
'
' FUNCTION updates image number from P% according to A$. M% is max.,
'          B$ bottom bar
'----------------------------------------------------------------------------
'
function Update%(P%,M%,A$,Z%)
  local A%,B%,I%,F%
  B% = fix((P%-1) \ 32)
  I% = P% mod 32
  if I% = 0 then I% = 32
  Z% = P%
  F% = %False
  call ClrTxt
  select case A$
    case "L"				'Left
      if I% > 1 then
        decr Z%
        F% = %True
      end if
    case "R"				'Right
      if (I% < 32) and (P% < M%) then
        incr Z%
        F% = %True
      end if
    case "U"				'Up
      if I% > 8 then
        Z% = Z% - 8
        F% = %True
      end if
    case "D"				'Down
      if (I% < 25) and (P%+7 < M%) then
        Z% = Z% + 8
        F% = %True
      end if
    case "P"				'Previous page
      if B% > 0 then
        Z% = (B%-1) * 32 + 1
        gosub NewScreen
        F% = %True
      end if
    case "N"				'Next page
      A% = (B%+1) * 32
      if A% < M% then
        Z% = A% + 1
        gosub NewScreen
        F% = %True
      end if
    case "H"				'Home
      Z% = 1
      if P% > 32 then gosub NewScreen
      F% = %True
    case "E"				'End
      B% = fix((M%-1) \ 32)
      Z% = B% * 32 + 1
      if P% < Z% then gosub NewScreen
      F% = %True
    case "I"				'Initial
      Z% = 1
      gosub NewScreen
      F% = %True
  end select
  if F% then				'Only if a change occured
    call Cursor(P%,Z%)
    P% = Z%
    call DoBar(Z%,M%)
  end if
  Update% = Z%
end function
'
'
'============================-<940126>-================-<HoroSoft>-===========
'