;940602 0705
;****************************************************************************
;* PROGRAM NAME: CCDGG   .ASM   DATE: 26. 1.1994    LINK INTO: CCDGALRY.BAS *
;* LANGUAGE: Turbo Assembler TASM 2.0                                       *
;* PURPOSE:  Procedures and functions for CCDGALRY                          *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.02  2-JUN-94 Added Version CCDGGV% = 102                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01 10-MAR-94 Changed PICTUR procedure from normal BIOS calls *
;*           to assembly procedure with SetDot subroutine. VIOS calls were, *
;*           funny enough, not suported by IBM PS/2 systems.                *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00 26-JAN-94                                                 *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.00c                 *
;*            = declare function CCDGGV%()                                  *
;*            = declare sub NiByte(byte,byte)                               *
;*            = declare sub ColCvt(byte,byte)                               *
;*            = declare Pictur(byte,integer,integer)                        *
;*            = $link "CCDGG.OBJ"    and PBSTACK.OBJ !!                     *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDGG                                                 *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
dos	equ	 33			;DOS Function Interrupt 21h
readf	equ	 63			;DOS Function 3Fh Read
writef	equ	 64			;DOS Function 40h Write
vbios	equ	 16			;EGA/VGA Bios
;
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;PB3, alternate for PB2: Get$Loc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDGGV%
;----------------------------------------------------------------------------
;
CCDGGV		proc	far
		public	CCDGGV
;
                call	pbastk
		mov	ax,102		;V.1.02
		xor	bl,bl
                jmp	bakbas
;
CCDGGV	endp
;
;
; VARIABLES AND TABLES DEFINITIONS - Do NOT alter sequence!
;============================================================================
;
; ICI color List for 4 Colors and for 16-Colors
;----------------------------------------------------------------------------
;
collst	db	 0, 1, 4, 5, 8, 2, 6, 9, 3,12,13, 7,10,11,14,15	;16 colors
        db	15,14,11,10, 7,13,12, 3, 9, 6, 2, 8, 5, 4, 1, 0	;16 invert
;
;
; PROCEDURES
;============================================================================
;
; PROCEDURE  expands nibbles into bytes
;    call NiByte(CCB?(1),CCA?(1))
;----------------------------------------------------------------------------
;
NIBYTE	proc	far
	public	NIBYTE
;
	call	pbastk			;(DS:SI) = (CCA%(1))
        les	di,[bp+10]		;(ES:DI) = (CCB%(1))
        mov	cx,1760			;elements / 2
        mov	bl,15			;odd nibble mask
nibyt0:	lodsb				;get two nibbles
	mov	ah,al			;copy
        and	al,bl			;low nibble is odd pixel
        shr	ah,1
        shr	ah,1
        shr	ah,1
        shr	ah,1			;move high nibble to low nibble
        stosw				;high byte is even pixel
        loop	nibyt0			;do all
        mov	bl,2			;two parameters
        jmp	bakbas
;
NIBYTE	endp
;
;
; PROCEDURE converts bytes in image to ICI colors. If C? is 0, 16 color
;           scale is used. Add 16 to C? for inverse image.
;    call ColCvt(CCB?(1),C?)
;----------------------------------------------------------------------------
;
COLCVT	proc	far
	public	COLCVT
;
	call	pbastk			;CX = C%
        les	di,[bp+10]		;(ES:DI) = (CCB%(1))
        lea	dx,collst
        add	dx,cx			;offset 0 or 16
        mov	cx,3520			;elements to convert
        xor	ah,ah			;clear AH
colcv0:	mov	bx,dx			;get pointer start
	mov	al,es:[di]		;get pixel value
        add	bx,ax			;point to color
        mov	al,cs:[bx]		;get color
        stosb				;store it
        loop	colcv0			;repeat
        mov	bl,2			;2 parameters
        jmp	bakbas
;
COLCVT	endp
;
;
; PROCEDURE paints one image at row R%, column C% from CCB?().
;    call DrwImg(CCB?(1),R%,C%)
;----------------------------------------------------------------------------
;
PICTUR	proc	far
	public	PICTUR
;
	call	pbastk			;CX = column C%
        mov	bx,cx			;BX = column
        mov	di,cx			;save column
        lds	si,[bp+10]		;(DS:SI) = (R%)
        mov	ax,ds:[si]		;AX = row
        lds	si,[bp+14]		;(DS:SI) = (CCB?(1))
        mov	dh,55			;55 lines
pictu1:	mov	dl,64			;64 columns
pictu2:	mov	ch,ds:[si]		;get color
        call	setdot			;write dot
        inc	si			;point to next color
        inc	bx			;point to next column
        dec	dl			;one column done
        jnz	pictu2			;repeat for all column
	mov	bx,di			;start column
        inc	ax			;next row
        dec	dh			;one row done
        jnz	pictu1			;do all rows
        mov	bl,3			;3 parameters
        jmp	bakbas
;
PICTUR	endp
;
;
;============================================================================
; LOCAL SUBROUTINES AREA - Subroutines are Public and may be accessed by any
; of the above procedures.
;============================================================================
;
; SUBROUTINE - Set a dot. AX=line, BX=column, CH=color. No Reg destroyed!
; Derived from PIXPTR and SETPIX from PC-Intern 2.0, pp 679-680 by Michael
; Tischer. ISBN 3-89011-331-1.    New version does not destroy any register.
;----------------------------------------------------------------------------
;
SETDOT	proc	near			;define procedure near
	public	SETDOT
;
; Part-1: Save environment and calculate proper dot position within EGA-RAM
;
	push	es			;save ES
	push	dx			;save DX anyway
	push	cx			;CH=primary, CL=secondary color
	push	ax			;save Y
	push	bx			;save X
	mov	cl,bl			;save LO-byte of column
	mov	dx,80			;line length in characters
	mul	dx			;AX=line*80
	shr	bx,1
	shr	bx,1
	shr	bx,1			;columns / 8
	add	bx,ax			;+line offset
	mov	ax,40960		;video-RAM segment A000h
	mov	es,ax			;ES=segment of video-RAM
	and	cl,7			;clear bits 8...4 of column
	xor	cl,7			;swap bits 0..3 = 7-CL
	mov	ah,1			;keep bit 0 only
;
; Part-2: Draw actual dot directly into appropriate bit-plane
;
	mov	dx,974			;port 3CEh of EGA-controller
	shl	ah,cl			;mask for bit to change
	mov	al,8			;bit-mask register
	out	dx,ax			;write to EGA Bit-Mask-register
	mov	ax,5 + (2 shl 8)	;register and mode value
	out	dx,ax			;write to EGA Mode-register
	mov	ax,3 + (0 shl 8)	;register number
	out	dx,ax			;write to EGA Function-register
	mov	al,es:[bx]		;load latches
	mov	es:[bx],ch		;load color into bit-planes
;
; Part-3: Restore environment for EGA-Controller and CCTINY
;
	mov	ax,8 + (255 shl 8)	;reset old bit mask
	out	dx,ax			;write old value into Bit-Mask
	mov	ax,5			;old value for Mode
	out	dx,ax			;reset Mode-register
	mov	ah,3			;old value for Function Select AH=0
	out	dx,ax			;reset Function-Select register
	pop	bx			;restore X
	pop	ax			;restore Y
	pop	cx			;restore colors
	pop	dx			;restore DX
	pop	es			;restore ES
	ret
;
SETDOT	endp
;
;
code	ends
	end
;
;=======================-<940126 HoroSoft, CH-3952 Susten>-==================
;
