'960210 1458
'****************************************************************************
'* PROGRAM NAME: CCDGPROC.INC   DATE:  5. 2.1994   INCLUDE IN: CCDGALRY.BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE:                                                                 *
'* INCLUDE FILES:                                                           *
'* OBJECT FILES:                                                            *
'* INPUT FILES:                                                             *
'* OUTPUT FILES:                                                            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03 10-FEB-96 Recompiled with PB 3.20                          *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02 29-APR-95 Introduced Text Edit Function                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01  2-JUN-94 Introduced Version CCDGProcV% = 101              *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  5-FEB-94 Extracted from CCDGALRY.BAS                      *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDGProcV% = 103
'
'
' PROCEDURE sets VGA mode if available and sets DAC to grayscale (T%=False)
'           or to color (T%=True).
'----------------------------------------------------------------------------
'
sub VGAMoCoTog(T%)
  screen 0
  if T% then reg %AX, &h1200 else reg (%AX), &h1201
  reg %BX, &h0033
  call interrupt %VBIOS
  screen 12
end sub
'
'
' PROCEDURE prints introduction
'----------------------------------------------------------------------------
'
sub Intro1
  local Y?,N?
  locate 8,1
  call ClrLine
  Y? = 8
  color %LWhite,%Black
  print Center$(SLText$(22%),80);
  print space$(17);"[ESC]"
  print space$(16);"[HOME]"
  print space$(17);"[END]"
  print space$(14);"[PageUP]"
  print space$(12);"[PageDOWN]"
  print space$(19);"[";chr$(17);"]"
  print space$(19);"[";chr$(16);"]"
  print space$(19);"[";chr$(30);"]"
  print space$(19);"[";chr$(31);"]"
  print space$(19);"[ ]"
  print space$(17);"[RET]"
  color %White,%Black
  for N? = 1 to 11
    locate Y?+N?,24
    print SLText$(22%+N?);
  next N?
  print
  print
  A% = Confirm%(SLText$(20%))
  for N? = 8 to 24
    locate N?,1
    call ClrLine
  next N?
end sub
'
'
' PROCEDURE prints intro for editting mode
'----------------------------------------------------------------------------
'
sub Intro2
  local A%,Y?,N?
  locate 8,1
  call ClrLine
  Y? = 8
  color %LWhite,%Black
  print Center$(SLText$(38%),80);
  print space$(25);"[ESC]"
  print space$(24);"[HOME]"
  print space$(25);"[END]"
  print space$(25);"[TAB]"
  print space$(26);"[BS]"
  print space$(27);"[";chr$(17);"]"
  print space$(27);"[";chr$(16);"]"
  print space$(17);"[A...z/0...9]"
  color %White,%Black
  locate Y?+1,32
  print SLText$(39);
  for N? = 2 to 8
    locate Y?+N?,32
    print SLText$(37%+N?);
  next N?
  print
  print
  call MLText(2%,4%,"tf")
  print
end sub
'
'


' PROCEDURE clears text part
'----------------------------------------------------------------------------
'
sub ClrTxt
  local Y%,N%
  Y% = csrlin
  for N% = 19 to 24
    locate N%,1
    call ClrLine
  next N%
  locate Y%,1
end sub
'
'
' PROCEDURE prints unformatted Text from T$ at lines 19 to 24. If there are
'           more than 6 CR/LF, a key must be pressed to continue text output
'           ( )
'----------------------------------------------------------------------------
'
sub UnfInf(T$,C1%,C2%)
  local A%,N%,A$,Q$
  call ClrTxt
  locate 19,1
  A% = 19
  color C2%,%Black
  for N% = 1 to len(T$)
    A$ = mid$(T$,N%,1)
    if A$ = chr$(13) then
      incr N%
      incr A%
      if A% > 24 then
        A% = 19
        Q$ = KeyIn$
        call ClrTxt
      end if
      locate A%,1
    else
      print A$;
    end if
  next N%
  color %White,%Black
  locate 1,1
end sub
'
'
' PROCEDURE prints formatted data base text at lines 21 to 24. Masktext is
'           in green, database text in light green (:)
'----------------------------------------------------------------------------
'
sub DbfInf(T$,C1%,C2%)
  call ClrTxt
  locate 21,1
  color C1%,%Black
  print SLText$(10%);
  color C2%,%Black
  print " ";mid$(T$,  2,11);"  ";
  color C1%,%Black
  print SLText$(11%);
  color C2%,%Black
  print " ";mid$(T$, 15,12);"  ";
  color C1%,%Black
  print SLText$(12%);
  color C2%,%Black
  print " ";mid$(T$, 29,21);
  locate 22,1
  color C1%,%Black
  print SLText$(13%);
  color C2%,%Black
  print " ";mid$(T$, 52,46);"  ";
  color C1%,%Black
  print SLText$(14%);
  color C2%,%Black
  print " ";mid$(T$,100, 8);"  ";
  color C1%,%Black
  print SLText$(15%);
  color C2%,%Black
  print " ";mid$(T$,110, 5);
  locate 23,1
  color C1%,%Black
  print SLText$(16%);
  color C2%,%Black
  print " ";mid$(T$,117,46);"   ";
  color C1%,%Black
  print SLText$(17%);
  color C2%,%Black
  print " ";mid$(T$,165, 4);"   ";
  color C1%,%Black
  print SLText$(18%);
  color C2%,%Black
  print " ";mid$(T$,171, 5);
  locate 24,1
  color C1%,%Black
  print SLText$(19%);"em";
  color C2%,%Black
  print " ";mid$(T$,178,76);
  color %White,%Black
  locate 1,1
end sub
'
'
' PROCEDURE prints formatted data base text from Mac (;) - 4 Lines
'----------------------------------------------------------------------------
'
sub MacInf(T$,C1%,C2%)
  local A$,N%,R%,O%
  call ClrTxt
  locate 19,1
  color C1%,%Black
  print SLText$(36%);" ";
  color C2%,%Black
  print mid$(T$,2,60)
  for N% = 1 to 3
    O% = (N%-1) * 64 + 64
    A$ = using$("#",N%)
    color C1%,%Black
    print "    Text-";A$;": ";
    color C2%,%Black
    print mid$(T$,O%,62)
  next N%
  color %White,%Black
  locate 1,1
end sub
'
'
' PROCEDURE prints formatted data base text from Dos (.) - 6 Lines
'----------------------------------------------------------------------------
'
sub DosInf(T$,C1%,C2%)
  local A$,N%,R%,O%
  call ClrTxt
  locate 19,1
  color C1%,%Black
  print SLText$(36%);" ";
  color C2%,%Black
  print mid$(T$,2,42)
  for N% = 1 to 5
    O% = (N%-1) * 42 + 46
    A$ = using$("#",N%)
    color C1%,%Black
    print "    Text-";A$;": ";
    color C2%,%Black
    print mid$(T$,O%,40)
  next N%
  color %White,%Black
  locate 1,1
end sub
'
'
' PROCEDURE prints text in file F$, Path D$. F% is flag. If true, illegal
'           CGE file.
'----------------------------------------------------------------------------
'
sub PntHead(D$,F$,T$,F%)
  local C1%,C2%,Q$
  if F% then
    call ClrTxt
    locate 23,1
    color %LRed,%Black
    print Center$(F$+SLText$(35%),80);
    locate 1,1
  else
    T$ = GetOneTxt$(D$+F$)
    Q$ = left$(T$,1)
    if (right$(T$,1)=chr$(26)) and (Q$=":" or Q$=";" or Q$=".") then
      locate 25,73
      color %LWhite,%Black
      print "[INS]";
    else
      mid$(T$,256,1) = " "
    end if
    C1% = %White
    C2% = %LWhite
    select case Q$
      case " "
        call UnfInf(T$,C1%,C2%)
      case ":"
        call DbfInf(T$,C1%,C2%)
      case ";"
        call MacInf(T$,C1%,C2%)
      case "."
        call DosInf(T$,C1%,C2%)
    end select
  end if
end sub
'
'
' PROCEDURE Text Edit entry. Only for DBF, Mac and Dos format
'----------------------------------------------------------------------------
'
sub EditIt(T$,Z$,Edi%(2))
  local Q$
  mid$(T$,256,1) = " "
  Q$ = left$(T$,1)
  Z$ = T$
  locate 25,1
  color %White,%Black
  print "[HOME][ESC]=undo[END]=done[TAB]=next field[BS]";
  print "[";chr$(17);"][";chr$(16);"]ı";
  locate 19,1
  select case Q$
    case ":"
      call EditDbf(T$,Z$,Edi%())
    case ";"
      call EditMac(T$,Z$,Edi%())
    case "."
      call EditDos(T$,Z$,Edi%())
  end select
end sub
'
'
' PROCEDURE handles Edit of DBF-type data Edi%(1...10)
'----------------------------------------------------------------------------
'
sub EditDbf(T$,Z$,Edi%(2))
  local C1%,C2%,F%
  C1% = %Cyan
  C2% = %White
  call DbfInf(Z$,C1%,C2%)
  F% = 1
  call DoEdit(T$,Z$,F%,Edi%())
  C1% = %White
  C2% = %LWhite
  call DbfInf(T$,C1%,C2%)
end sub
'
'
' PROCEDURE handles Edit of Mac-type data Edi%(11...14)
'----------------------------------------------------------------------------
'
sub EditMac(T$,Z$,Edi%(2))
  local C1%,C2%,F%,N%,I%,L%,C%,R%
  C1% = %Cyan
  C2% = %White
  call MacInf(Z$,C1%,C2%)
  F% = 11
  call DoEdit(T$,Z$,F%,Edi%())
  call MacInf(T$,C1%,C2%)
end sub
'
'
' PROCEDURE handles Edit of Dos-type data Edi%(15...20)
'----------------------------------------------------------------------------
'
sub EditDos(T$,Z$,Edi%(2))
  local C1%,C2%,F%,N%,I%,L%,C%,R%
  C1% = %Cyan
  C2% = %White
  call DosInf(Z$,C1%,C2%)
  F% = 15
  call DoEdit(T$,Z$,F%,Edi%())
  C1% = %White
  C2% = %LWhite
  call DosInf(T$,C1%,C2%)
end sub
'
'
' PROCEDURE does actual editting - T$=Z$ on entry
'----------------------------------------------------------------------------
'
sub DoEdit(T$,Z$,F%,Edi%(2))
  local I%,L%,R%,C%,F1%,F2%,Q$
  I%  = Edi%(F%,1)
  L%  = Edi%(F%,2)
  R%  = Edi%(F%,3)
  C%  = Edi%(F%,4)
  Z1% = F%
  select case F%
    case  1
      Z2% = 10
    case 11
      Z2% = 14
    case 15
      Z2% = 20
  end select
  locate R%,C%
  color %LWhite,%Black
  print mid$(Z$,I%,1);
  do
    while not instat : wend
    Q$ = inkey$
    select case Q$
      case chr$(9)						'TAB
        color %White,%Black
        locate R%,C%
        print mid$(Z$,I%,1);
        if F% < Z2% then incr F% else F% = Z1%
        I% = Edi%(F%,1)
        L% = Edi%(F%,2)
        R% = Edi%(F%,3)
        C% = Edi%(F%,4)
        color %LWhite,%Black
        locate R%,C%
        Q$ = mid$(Z$,I%,1)
        if Q$ = " " then print "_"; else print Q$;
      case chr$(0,75),chr$(8)					'<
        if Q$ = chr$(8) then mid$(Z$,I%,1) = " "
        if I% > Edi%(F%,1) then
          color %White,%Black
          locate R%,C%
          print mid$(Z$,I%,1);
          decr I%
          decr C%
          color %LWhite,%Black
          locate R%,C%
          Q$ = mid$(Z$,I%,1)
          if Q$ = " " then print "_"; else print Q$;
        end if
      case chr$(0,77)						'>
        if I% < Edi%(F%,1) + Edi%(F%,2) - 1 then
          color %White,%Black
          locate R%,C%
          print mid$(Z$,I%,1);
          incr I%
          incr C%
          color %LWhite,%Black
          locate R%,C%
          Q$ = mid$(Z$,I%,1)
          if Q$ = " " then print "_"; else print Q$;
        end if
      case chr$(0,71),chr$(27)					'HOME & ESC
        exit loop
      case chr$(0,79)						'END
        T$ = Z$
        mid$(T$,256,1) = chr$(26)
        exit loop
      case > chr$(31)						'character
        mid$(Z$,I%,1) = Q$
        color %White,%Black
        locate R%,C%
        print mid$(Z$,I%,1);
        if I% < Edi%(F%,1) + Edi%(F%,2) - 1 then
          incr I%
          incr C%
        end if
        color %LWhite,%Black
        locate R%,C%
        Q$ = mid$(Z$,I%,1)
        if Q$ = " " then print "_"; else print Q$;
    end select
  loop
  C1% = %White
  C2% = %LWhite
end sub
'
'
' PROCEDURE draws a box in a row in green - Expexts image number
'----------------------------------------------------------------------------
'
sub OneBox(P%)
  local I%,X%,Y%
  I% = P% mod 32
  if I% = 0 then I% = 32
  Y% = fix((I%-1)  \  8) * 64
  X% = ((I%-1) mod 8) * 80
  line (X%,Y%) - (X%+63,Y%+54),%Green,B
end sub
'
'
' PROCEDURE draws P% boxes
'----------------------------------------------------------------------------
'
sub ScrBox(P%)
  local N%
  line (0,0) - (639,260),%Black,BF
  locate 25,1
  color %White,Black
  print "";string$(78,"");"";
  locate 1,1
  call ClrTxt
  for N% = 1 to P%
    call OneBox(N%)
  next N%
end sub
'
'
' PROCEDURE inserts image cursor and clears old one.
'----------------------------------------------------------------------------
'
sub Cursor(OI%,NI%)
  local O%,N%,X%,Y%
  O% = OI% mod 32
  N% = NI% mod 32
  if O% = 0 then O% = 32
  if N% = 0 then N% = 32
  Y% = fix((O%-1)  \  8) * 64 + 37
  X% = ((O%-1) mod 8) * 80 + 65
  line (X%,Y%) - (X%+8,Y%+16),%Black,BF
  Y% = fix((N%-1)  \  8) * 64 + 37
  X% = ((N%-1) mod 8) * 80 + 65
  line (X%,Y%) - (X%+8,Y%+16),%LCyan,BF
end sub
'
'
' PROCEDURE inserts image inverse-cursor or clears it
'----------------------------------------------------------------------------
'
sub Mark(P%,F%)
  local C%,I%,X%,Y%
  if istrue F% then C% = %LRed else C% = %Black
  I% = P% mod 32
  if I% = 0 then I% = 32
  Y% = fix((I%-1)  \  8) * 64 + 1
  X% = ((I%-1) mod 8) * 80 + 65
  line (X%,Y%) - (X%+8,Y%+8),C%,BF
end sub
'
'
' PROCEDURE inserts image
'----------------------------------------------------------------------------
'
sub Image(P%,CCB?())
  local A%,B%,F%,I%,J%,N%,X%,Y%
  J% = P% mod 32
  if J% = 0 then J% = 32
  A% = fix((J%-1)  \  8) * 64
  B% = ((J%-1) mod 8) * 80
  call Pictur(CCB?(1),A%,B%)
end sub
'
'
' PROCEDURE inserts error image P%
'----------------------------------------------------------------------------
'
sub ErrImg(P%)
  local I%,X%,Y%
  I% = P% mod 32
  if I% = 0 then I% = 32
  Y% = fix((I%-1)  \  8) * 64
  X% = ((I%-1) mod 8) * 80
  line (X%,Y%) - (X%+63,Y%+54),%Red,BF
  line (X%,Y%) - (X%+63,Y%+54),%LWhite,B
  line (X%,Y%) - (X%+63,Y%+54),%LWhite
  line (X%+63,Y%) - (X%,Y%+54),%LWhite
end sub
'
'
' PROCEDURE updates Bar at bottom line
'----------------------------------------------------------------------------
'
sub DoBar(P%,M%)
  local I%,Bar$
  Bar$ = "[ESC][HOME][END]" + string$(44,"") + "[ ][RET]ͱ"
  I% = P% mod 32
  if I% = 0 then I% = 32
  locate 25,1
  color %White,%Black
  print Bar$;
  if P% > 32 then				'PgUP
    locate 25,26
    print "[PageUP]";
  end if
  if P%-I%+32 < M% then				'PgDN
    locate 25,36
    print "[PageDOWN]";
  end if
  if I% > 1 then				'Left
    locate 25,48
    print "[";chr$(17);"]";
  end if
  if (I% < 32) and (P% < M%) then		'Right
    locate 25,53
    print "[";chr$(16);"]";
  end if
  if I% > 8 then				'Up
    locate 25,58
    print "[";chr$(30);"]";
  end if
  if (I% < 25) and (P%+7 < M%) then		'Down
    locate 25,63
    print "[";chr$(31);"]";
  end if
  color %White,%Black
  locate 1,1
end sub
'
'
'============================-<940126>-================-<HoroSoft>-===========
'