;931205 1714
;****************************************************************************
;* PROGRAM NAME: CCDLL   .ASM   DATE:  5.12.1993    LINK INTO: CCDLSCVT.BAS *
;* LANGUAGE: Turbo Assembler TASM 2.01                                      *
;* PURPOSE:  Procedures and functions for CCDLSCVT                          *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01  1-JUN-94 Introduced Version CCDLLV% = 101                *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00  5-DEC-92 (17-OCT-92 extracted from CCDRTNS.ASM)          *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.00c                 *
;*            = declare function CCDLLV%()                                  *
;*            = declare sub DecLnx(integer,integer)                         *
;*            = declare sub EncLnx(integer,integer,integer)                 *
;*            = declare sub EDCST4(integer,string,integer,integer)          *
;*            = declare sub FLIPXY(integer,integer)                         *
;*            = declare sub MltPly(integer,integer)                         *
;*            = $link "CCDLL.OBJ"    and PBSTACK.OBJ !!                     *
;*             call FLIPXY(CCD%(1,1),Mode%)                                *
;*                                    Mode% = 1: Y-axis flip                *
;*                                    Mode% = 2: X-axis flip                *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDLL                                                 *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
rows	equ	165			;165 rows
cols	equ	192			;192 columns
hrows	equ	 82			;half rows, 82 = fix(165/2)
hcols	equ	 96			;half columns, 96 = 192/2
dos	equ	 33			;DOS Function Interrupt 21h
readf	equ	 63			;DOS Function 3Fh Read
writef	equ	 64			;DOS Function 40h Write
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;PB3, alternate for PB2: Get$Loc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDLLV%
;----------------------------------------------------------------------------
;
CCDLLV		proc	far
		public	CCDLLV
;
                call	pbastk
		mov	ax,105		;V.1.05
		xor	bl,bl
                jmp	bakbas
;
CCDLLV	endp
;
;
; PROCEDURES
;============================================================================
;
; PROCEDURE  reads 12 bit Lynx file into CCD% and converts it to 16 bits
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call DecLnx(Handle%,CCD%(1,1))
;============================================================================
;
DECLNX	proc	far
	public	DECLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = DOS File-Handle
	mov	ah,readf		;AH = function read
	mov	cx,47520		;CX = number of bytes to read
	push	cx			;save bytes
	int	dos			;read whole file
	pop	cx			;restore bytes
	jc	decly1			;error
	cmp	ax,cx			;check all read
	jnz	decly1			;error
	lds	si,[bp+6]		;(DS:SI) = (CCD%(1,1))
	les	di,[bp+6]		;(ES:DI) = (CCD%(1,1))
	add	si,47519		;point to last byte loaded
	add	di,63359		;point to last byte in CCD%
	std				;set direction flag to descending
	mov	cx,23760		;23760 x 2 = 47520
	rep	movsw			;copy to last element
	inc	si			;point to first element
	inc	di			;point to first dest element at 15840
	xchg	si,di			;swap source and dest pointers
	push	es
	push	ds
	pop	es
	pop	ds			;swap source and dest segments
	mov	cx,15840		;15840 x 3 = 47520
	cld				;clear direction flag to ascending
decly0:	movsb				;copy low byte-1
	lodsb				;AL = byte-2H Byte-1H
	mov	ah,al			;AH copy of Byte-1H
	and	al,15			;remove high nibble
	stosb				;store Byte-1H
	movsb				;copy low byte-2
	mov	al,ah			;get Byte-2H
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1			;Byte-2H high- to low nibble
	stosb				;store Byte-2H
	loop	decly0			;repeat
	mov	ax,-1			;true flag
	jmp	short decly2		;store flag and return
decly1:	xor	ax,ax			;flag false
decly2:	les	di,[bp+10]		;point to Handle%
	stosw				;return flag
	mov	bl,2			;2 parameters
	jmp	bakbas
;
DECLNX	endp
;
;
; PROCEDURE  writes 12 bit Lynx file from 16-bit CCD% and multiplies by 16
;            if SyLyFlg% is true.
;            Byte-1: Pixel-1 low byte
;            Byte-2: Pixel-1 high byte at low nibble position
;            Byte-2: Pixel-2 high byte at high nibble position
;            Byte-3: Pixel-2 low byte
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EncLnx(Handle%,SyLyFlg%,CCD%(1,1))
;============================================================================
;
ENCLNX	proc	far
	public	ENCLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = SyLyFlg%
	mov	di,si			;copy start pointer or array
	push	ds
	pop	es
	cmp	bx,0			;is SyLyFlg% reset?
	jz	encly1			;skip multiplication
	mov	cx,31680		;CX = elements to multiply
encly0:	mov	ax,es:[di]		;get value
	shl	ax,1			;AX x  2
	shl	ax,1			;AX x  4
	shl	ax,1			;AX x  8
	shl	ax,1			;AX x 16
	stosw				;save multiplied word
	loop	encly0
encly1:	mov	di,si			;get start of array
	mov	dx,si			;start of buffer
	mov	cx,15840		;15840 x 3 = 47520
encly2:	movsb				;copy byte-1L
	lodsb				;get byte-1H
	and	al,15			;clear high nibble
	mov	ah,al			;save byte-1H
	lodsb				;get byte-2L
	mov	bl,al			;put byte-2L aside
	lodsb				;get byte-2H
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1			;byte-2H to high nibble
	or	al,ah			;combine byte-2H and byte-1H
	stosb				;store both nibbles
	mov	al,bl			;get byte-2L
	stosb				;store byte-2L
	loop	encly2			;repeat
	mov	ah,writef		;function 40h write to file
	les	di,[bp+14]
	mov	bx,es:[di]		;BX = handle
	mov	cx,47520		;CX = number of bytes to write
	push	cx			;save byte counter
	int	dos			;write it
	pop	cx			;restore byte count
	xor	dx,dx			;assume error
	jc	encly3			;error
	cmp	ax,cx			;test wether all bytes are written
	jnz	encly3			;jump if not
	dec	dx			;DX = -1 = True
encly3:	lds	si,[bp+14]
	mov	ds:[si],dx		;save flag
	mov	bl,3			;3 parameters
	jmp	bakbas
;
ENCLNX	endp
;
;
; PROCEDURE  either reads or writes ST4 File into/from CCB% and the 166th
;            line into/from R$. F% has 63 or 64 respectively.
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EDCST4(F%,R$,Handle%,CCB%(1))
;============================================================================
;
EDCST4	proc	far
	public	EDCST4
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 31680 bytes
	mov	cx,31680		;165 x 192
	push	cx			;save it for compare later on
	int	dos
	pop	cx			;restore counter
	mov	dx,0			;assume error
	jc	edcst0			;error
	cmp	ax,cx
	jnz	edcst0			;error
	lds	si,[bp+14]		;(DS:SI) = (R$)
	mov	cx,ds:[si]
	push	cx
	call	GetStrLoc		;locate R$
	mov	ds,dx			;segment
	mov	dx,ax			;offset
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	mov	cx,192			;1 x 192
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 192 bytes
	int	dos
	jc	edcst0			;error
	cmp	ax,192
	jnz	edcst0			;error
	mov	dx,-1			;no error flag
edcst0:	lds	si,[bp+10]		;(ES:DI) = (Handle%)
	mov	ds:[si],dx		;save flag
	mov	bl,4			;4 parameters
	jmp	bakbas
;
EDCST4	endp
;
;
; PROCEDURE  flips image along either X- or Y axis.
;----------------------------------------------------------------------------
;
FLIPXY	proc	far
	public	FLIPXY                  ;whatever name
;
; First, we get the start address of CCD%(1,1) and the Flip%-Mode
;
	call	pbastk			;save environment
	mov	ax,cx			;AX=Flag
	lds	si,[bp+10]		;(DS:SI) = (CCD%(1,1))
	dec	al			;if Y-axis (1), AL is now 0
	jnz	noty			;if not Y, test next
	jmp	yaxis			;if Y, handle it
noty:	dec	al			;if X-axis (2), AL is now 0
	jnz	notx			;if not X, test next
	jmp	xaxis			;if X, handle it
notx:	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
; The Y-Axis flip is performed here. The flip is along the Y-axis and this
; flips left/right. The generalized procedure is:
;
;   for Rx = 1 to fix(X/2)         where X:  max. columns (192)
;     for Cy = 1 to Y                    Y:  max. rows (165)
;       Pa = (Rx-1) * Y + Cy-1           Rx: actual X-position
;       Pb = (X-Rx) * Y + Cy-1           Cy: actual Y-position
;     next Cy                            Pa: position of dot-A
;   next Rx                              Pb: position of dot-B
;
yaxis:	xor	bx,bx			;clear Rx
yaxis1:	inc	bx			;next Rx
	xor	cx,cx			;reset Cy
yaxis2:	inc	cx			;next Cy
	mov	ax,bx			;get Rx
	dec	ax			;calculate (Rx-1)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (Rx-1)*Y
	add	ax,cx			;calculate (Rx-1)*Y+Cy
	dec	ax			;calculate (Rx-1)*Y+Cy-1
	shl	ax,1			;calculate ((Rx-1)*Y+Cy-1)*2
	add	ax,si			;AX=offset to element-A
	push	ax			;save offset to element-A
	mov	ax,cols			;get columns
	sub	ax,bx			;calculate (X-Rx)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (X-Rx)*Y
	add	ax,cx			;calculate (X-Rx)*Y+Cy
	dec	ax			;calculate (X-Rx)*Y+Cy-1
	shl	ax,1			;calculate ((X-Rx)*Y+Cy-1)*2
	add	ax,si			;AX=offset to element-B
	pop	dx			;DX=offset to element-A
	push	si			;save offset to CCD%(1,1)
	mov	si,ax			;SI=address of element-B
	mov	di,dx			;DI=address of element-A
	mov	ax,[si]			;get element-B
	mov	dx,[di]			;get element-A
	mov	[si],dx			;store element-A at element-B
	mov	[di],ax			;store element-B at element-A
	pop	si			;restore offset to CCD%(1,1)
	cmp	cx,rows			;check if thru
	jc	yaxis2			;do all Cy
	cmp	bx,hcols		;check if thru
	jc	yaxis1			;do half of Rx
	jmp	flipex			;exit
;
; The X-Axis flip is performed here. The flip is along the X-axis and this
; flips up/down. The generalized procedure is:
;
;   for Cy = 1 to fix(Y/2)         where X:  max. columns (192)
;     for Rx = 1 to X                    Y:  max. rows (165)
;       Pa = (Rx-1) * Y + Cy-1           Rx: actual X-position
;       Pb = (Rx-1) * Y + Y-Cy           Cy: actual Y-position
;     next Rx                            Pa: position of dot-A
;   next Cy                              Pb: position of dot-B
;
xaxis:	xor	cx,cx			;clear Cy
xaxis1:	inc	cx			;next Cy
	xor	bx,bx			;reset Rx
xaxis2:	inc	bx			;next Rx
	mov	ax,bx			;get Rx
	dec	ax			;calculate (Rx-1)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (Rx-1)*Y
	mov	dx,ax			;save this one in DX
	add	ax,cx			;calculate (Rx-1)*Y+Cy
	dec	ax			;calculate (Rx-1)*Y+Cy-1
	shl	ax,1			;calculate ((Rx-1)*Y+Cy-1)*2
	add	ax,si			;AX=offset to element-A
	push	ax			;save address of element-A
	push	dx			;save (Rx-1)*Y
	mov	dx,rows			;get rows
	sub	dx,cx			;calculate (Y-Cy)
	pop	ax			;get (Rx-1)*Y
	add	dx,ax			;calculate (Rx-1)*Y + Y - Cy
	shl	dx,1			;calculate ((Rx-1)*Y+Y-Cy)*2
	add	dx,si			;DX=offset to element-B
	pop	ax			;restore offset to element-A
	push	si			;save offset to CCD%(1,1)
	mov	si,ax			;SI=address of element-A
	mov	di,dx			;DI=address of element-B
	mov	ax,[si]			;get element-A
	mov	dx,[di]			;get element-B
	mov	[si],dx			;store element-B at element-A
	mov	[di],ax			;store element-A at element-B
	pop	si			;restore offset to CCD%(1,1)
	cmp	bx,cols			;check if 192
	jc	xaxis2			;do all Rx
	cmp	cx,hrows		;check if 82
	jc	xaxis1			;do half of Cy
	jmp	flipex  		;exit
;
;
; Common exit for both flippers
;
flipex:	mov	bl,2			;2 parameters
	jmp	bakbas
;
FLIPXY	endp
;
;
; PROCEDURE  Multiplies all word elements by integer multiplicand supplied
;    call MltPly(CCD%(1,1),M%)
;============================================================================
;
MLTPLY	proc	far
	public	MLTPLY
;
	call	pbastk			;(DS:SI) = (M%)
	mov	bl,cl			;BL = multiplicand
	les	di,[bp+10]
	mov	cx,31680		;CX = number of elements
mltpl0:	mov	ax,es:[di]		;get element
	mul	bl			;AX = AL * BL
        stosw				;store result, incr pointer
        loop	mltpl0			;repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
MLTPLY	endp
;
;
code	ends
	end
;
;=======================-<931206 HoroSoft, CH-3952 Susten>-==================
;
