'960411 1805
'****************************************************************************
'* PROGRAM NAME: CCDLSUB .INC   DATE:  5.12.1993   INCLUDE IN: CCDLSCVT.BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Subroutines for CCDLSCVT                                        *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.06 11-APR-96 Corrected exposure time in ST4 from ms to s/100  *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.04 10-FEB-96 Added Setup for HoroSoft Logo                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03  1-JUN-94 Introduced Version CCDLSubV% = 103               *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02 31-DEC-93 Removed BYT / BIE conversion BYT always RLCE     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01 27-DEC-93 Added RLCE option for BYT <--> BIE conversion    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  6-DEC-93 Extracted from CCDCONVT.BAS.                     *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDLSubV% = 106
'
'
goto CCDLSUB
'
'
' SUBROUTINE returns in A% a true flag if no Path/Drive error occured.
'----------------------------------------------------------------------------
'
ValidatePath:
'
E% = 0
D$ = curdir$
on error goto VPERR
if len(UsePath$) < 4 then
  chdir UsePath$
else
  chdir left$(UsePath$,len(UsePath$)-1)
end if
chdir D$
VPRES:
if E% = 0 then A% = %True else A% = %False
on error goto ErrorHandling
return
VPERR:
E% = err
resume VPRES
'
'
' SUBROUTINE returns validated path. I% = 1 for Input, 2 for output
'----------------------------------------------------------------------------
'
GetDirPath:
'
do
  if I% then
    UsePath$ = IOPath$(SLText$(1%),InpPath$,SLText$(36%))
  else
    UsePath$ = IOPath$(SLText$(10%),OutPath$,SLText$(36%))
  end if
  gosub ValidatePath
  if A% then exit loop
  if not Redo%(SLText$(37%)) then
    Fatal$ = SLText$(38%)
    return NoJob
  end if
  locate csrlin-1,1
loop
return
'
'
' Input-Lynxx - Image is read into CCQ, dimensions adjusted and flipped.
'-----------------------------------------------------------------------------
'
ILNX:
'
open BatchI$(N%) for binary as # %UnitAUX
print BatchI$(N%);SLText$(12%)
Handle% = fileattr(%UnitAUX,2)
call DecLnx(Handle%,CCQ%(1,1))
call XDimWA(CCD%(1,1),CCQ%(1,1),192%,165%)
close %UnitAUX
Fatal$ = SLText$(25%)
if not Handle% then goto WarnIO
call FlipIt(CCD%(),CCQ%())
mid$(ST4Info$,2,11) = "Lynxx Img. "
gosub OST4
return
'
'
' Input-ST-4 - If no processing is required, the file is just copied using DOS
'   COPY-command, otherwise, it is read, converted to 16 bits and procedure
'   FlipIt will test for the processing requred. The routine continues at the
'   appropriate output routine from where it returns.
'-----------------------------------------------------------------------------
'
IST4:
'
open BatchI$(N%) for binary as # %UnitAUX
print BatchI$(N%);SLText$(12%)
R$ = space$(192)
Handle% = fileattr(%UnitAUX,2)
call EDCST4(%DOSRead,R$,Handle%,CCA%(1))
close %UnitAUX
Fatal$ = SLText$(26%)
if not Handle% then goto WarnIO
call CpyB2W(CCQ%(1,1),CCA%(1),%LMN)
call CpyW2W(CCD%(1,1),CCQ%(1,1),%LMN)
color %LGreen,%Black
print mid$(R$,2,78)
color %Green,%Black
print "Exposure time (s/100): ";
color %LGreen,%Black
print mid$(R$,80,10)
color %Green,%Black
print "Focal length (inch): ";
color %LGreen,%Black
print mid$(R$,90,10)
color %Green,%Black
print "Apperture (inch):    ";
color %LGreen,%Black
print mid$(R$,100,10)
color %Green,%Black
print "Calibration factor (1): ";
color %LGreen,%Black
print mid$(R$,110,10)
color %LGreen,%Black
print mid$(R$,120,72)
A$ = left$(R$,119) + STCR$
ST4Info$ = A$
call FlipIt(CCD%(),CCQ%())
color %White,%Black
gosub OLNX
return
'
'
' Output-Lynx - The values are all shifted down, then are stretched over a
'   range of 4096. Then the 12-bit file is synthesized. Optimizer!
'-----------------------------------------------------------------------------
'
OLNX:
'
A$ = MaxMin$(CCD%(),MinV%,MaxV%)
if MinV% > 0 then call SubCWL(CCD%(1,1),MinV%,0%,%LMN)
A% = fix(4096 / (MaxV%-MinV%))
if A% > 1 then call MltPly(CCD%(1,1),A%)
open BatchO$(N%) for output as # %UnitAUX
print BatchO$(N%);SLText$(13%)
Handle% = fileattr(%UnitAUX,2)
call EncLnx(Handle%,%False,CCD%(1,1))
close %UnitAUX
Fatal$ = SLText$(23%)
if not Handle% then goto WarnIO
return
'
'
' Output-ST-4 - An ST-4 image is synthesized/generated from the data. The
'   input subroutine concludes here.
'-----------------------------------------------------------------------------
'
OST4:
'
A$ = MaxMin$(CCD%(),MinV%,MaxV%)
call C16T8(CCD%(),MaxV%)
call XDimWA(CCQ%(1,1),CCD%(1,1),165%,192%)
call CpyW2B(CCA%(1),CCQ%(1,1),%LMN)
open BatchO$(N%) for output as # %UnitAUX
print BatchO$(N%);SLText$(13%)
mid$(ST4Info$,120,72) = STCR$
mid$(ST4Info$,120,72) = STCR$
Handle% = fileattr(%UnitAUX,2)
call EDCST4(%DOSWrite,ST4Info$,Handle%,CCA%(1))
close %UnitAUX
Fatal$ = SLText$(24%)
if not Handle% then goto WarnIO
return
'
'
' Lynxx and ST4 direct DOS read or write error handler
'----------------------------------------------------------------------------
'
WarnIO:
'
beep
color %Yellow,%Red
print Center$(Fatal$,79)
color %White,%Black
A$ = KeyIn$
return
'
'
CCDLSUB:
'
'===================================-<931206>-=========-<HoroSoft>-==========
'
