'960412 1432
'****************************************************************************
'* PROGRAM NAME: CCDOTOV .BAS   DATE: 12. 9.1992   INCLUDE IN: is main      *
'* LANGUAGE: Power BASIC 3.20  (Robert S.Zale)                              *
'* PURPOSE: Shows DotoGrams.                                                *
'* INCLUDE FILES: ERROR3  .INC  Fatal error handler                         *
'*                IOTEXT  .INC  Set of text and file functions              *
'* OBJECT FILES:  PB3GPUSE.PBU  Advanced array manipulating function.       *
'*                CLRSCRN .PBL  Hypercool screen washers                    *
'*                PBSTACK. OBJ  Power BASIC 2 & 3 Stack handler for objects *
'*                RLCEGEN .OBJ  Run Length Count Encoding Generator         *
'* INPUT FILES:   filename.DOT  DotoGram and/or Profil files monochrome     *
'*                              (from CCDUTIL)                              *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.44  8-APR-96: Added Megacool screen washers                   *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.43 10-FEB-96: Definitely FreeWare, updated Copyright to 1996  *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.42  2-SEP-95: Recompiled with PB3.20.                         *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.41 17-FEB-95: Recompiled with PB3.10. Is freeware.            *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.34  5-JUN-94: Decode Dotograms directly into EGA-RAM          *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.33  1-JUN-94: Introduced Version CCDotovV% = 233              *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.23 30-DEC-93: Using RLCE compression for DotoFiles            *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.13 26-APR-93: Removed Catch and redid it for PB3.             *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03 22-FEB-93: Accepts EGA+256K only.                          *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02 24-JAN-93: Can be used as Profil viewer as well.           *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01  7-NOV-92: Changed name to CCDOTOV from DOTOVIEW and made  *
'*                it bilingual.                                             *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00 12-SEP-92: First working version, including CATCH-shell.   *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
' COMPILER DIRECTIVES
'----------------------------------------------------------------------------
'
'$alias data as "DSEG"	'or data segment name as used in .OBJ
'$code seg "CODE"	'or code segment name as used in .OBJ
'$huge			'for arrays > 64K
$cpu 8086		'8086/80286/80386
$debug map off		'on/off
$debug path off		'on/off
$debug unit off		'on/off
$debug pbdebug off	'on/off
$dim array		'all/array/none
$dynamic		'$static
$error all off		'bounds/numeric/overflow/stack/all on/off
$event off		'on/off
$float procedure	'emulate/npx/procedure
$lib com-,lpt-,graph+,cga+,ega+,vga-,herc-,fullfloat-,iprint-
$optimize speed		'size/speed
$option cntlbreak off	'cntlbreak/gosub on/off
$stack 4096		'1536...32767
$com 0			'0...32767
$sound 1		'1...4096
$string 4		'1/2/4/8/16/32
$compile exe		'memory/exe/chain/unit
'
'
' LANGUAGE SELECTION AND VERSION NUMBER
'----------------------------------------------------------------------------
'
VN$       = "CCDOTOV V.2.44"
CCDotovV% = 244
on error goto ErrorHandling
%True   = -1
%False  =  0
Chroma% = %True
shared Idiom%()
dim Idiom%(0:2)			'0:E=true/D=false 1:SL-text-, 2:ML text-offs
English% = ComLinLan%(command$,"CCDTOOLS: "+VN$)
if English% then
  Idiom%(0) = %True		'English
  Idiom%(1) = 0			'SL offset
  Idiom%(2) = 0			'ML offset
  Version$ = "CCDUTIL DotoGram, Profil & Isophotes Viewer " + VN$
else
  Idiom%(0) = %False		'Deutsch
  Idiom%(1) = 30		'SL offset
  Idiom%(2) = 10		'ML offset
  Version$ = "CCDUTIL DotoGramm, Profil & Isophoten Betrachter " + VN$
end if
'
'
' VARIABLES SETUP and VIDEO TEST - SHARED VARIABLES AS WELL
' -----------------------------------------------------------------------------
'
%VBIOS = 16
%EGA   =  9
%VGA   = 12
%AX    =  1
%BX    =  2
screen 0
A% = BestVideo%
select case A%
  case 9
    EGAHere% = %True
    ScrMode% = 9
  case 12
    EGAHere% = %True
    VGAHere% = %True
    ScrMode% = 9
  case else
    EGAHere% = %False
    VGAHere% = %False
    ScrMode% = 0
end select
Chroma%  = %True
on error goto ErrorHandling
Fatal$ = SLText$(14%)
if ScrMode% = 0 then goto NoJob
Nill$ = ""
OldPath$ = curdir$
'
Z% = fix(fre(-1)/1024)
Fatal$ = SLText$(23%) + str$(142-Z%) + "Kb"
if Z% < 142 then goto NoJob	'Needs about 230Kb
'
dim Batch$(1:16)
dim Batch%(1:16)
dim BUse%(1:16)
dim CCA%(1:28006)			'to convert doto files
dim CCB%(1:28006)			'to read doto files into
'
'
' CONSTANTS COLORS
' -----------------------------------------------------------------------------
'
%Black     =  0        'COLORS, dark
%Blue      =  1
%Green     =  2
%Cyan      =  3
%Red       =  4
%Pink      =  5
%Brown     =  6
%White     =  7
%Gray      =  8        'COLORS, light
%LBlue     =  9
%LGreen    = 10
%LCyan     = 11
%LRed      = 12
%LPink     = 13
%Yellow    = 14
%LWhite    = 15
'
'
' Function and Procedure Declaration in external units: CLRSCRN.PBL
'----------------------------------------------------------------------------
'
declare function ClrScrnV%()
declare sub ClsTB()
declare sub HoroSoftLogo()
'
'
' Function and Procedure Declaration in external units: PB3GPUSE.INC/PBU
'----------------------------------------------------------------------------
'
declare function PB3GPUseV%()
declare function PBVer%(string)
declare function EscRet%()
declare function AddSlash$(string)
declare function Center$(string,integer)
declare function LogOn$(string,integer,integer)
declare function DateNorm$(integer)
declare function KeyIn$()
declare function ComLinLan%(string,string)
declare function IOPath$(string,string,string)
declare function IOFile$(integer,integer,string)
declare function Confirm%(string)
declare function Redo%(string)
declare function FileHere%(string)
declare function SizeOk%(string,long)
declare function ByteBin$(integer)
declare sub ClrLine()
declare sub Illegal(string,string)
'
'
' Function and Procedure Declaration in external units: RLCEGEN.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function RlceGenV%()
declare function AryVid??(integer,integer)
declare function DecBie%(integer,integer)
declare function RdBie%(integer,integer,word)
'
'
' FILES TO BE LINKED IN
'-----------------------------------------------------------------------------
'
$link "PBSTACK.OBJ"
$link "RLCEGEN.OBJ"
$link "PB3GPUSE.PBU"
$link "CLRSCRN.PBL"
'
'
' INCLUDE FILES
'-----------------------------------------------------------------------------
'
$include "IOTEXT.INC"
$include "ERROR3.INC"
'
'
' FUNCTIONS AND PROCEDURES
'============================================================================
'
' FUNCTION returns highest possible supported video mode.
'          Supported are VGA (12), MCGA (11), EGA-256K (9) or none (0).
'----------------------------------------------------------------------------
'
function BestVideo%
  local V%,BL%,BH%
  V% = 0
  reg (%AX), &h1A00
  call interrupt %VBIOS
  BL% = reg(%BX) mod 256
  if (BL% = 7) or (BL% = 11) then V% = 11
  if (BL% = 8) or (BL% = 12) then V% = 12
  if V% = 0 then
    reg (%AX), &h1200
    reg (%BX), &h0010
    call interrupt &h10
    BL% = reg(%BX) mod 256
    BH% = fix(reg(%BX) \ 256)
    if BH% = 0 and BL% = 3 then V% = 9 else V% = 0
  end if
  BestVideo% = V%
end function
'
'
' FUNCTION returns true if full filespecs are feasible, else false
'----------------------------------------------------------------------------
'
function FileFlag%(A$)
  local A%,B%
  A% = instr(1,A$," .")
  B% = instr(1,A$,"\.") + A%
  if B% = 0 then FileFlag% = %True else FileFlag% = %False
end function
'
'
' START OF PROGRAM
'=============================================================================
'
' Logon
'
GPCR$ = "(c) 1993-96 by H.-R.H. Wernli, CH-3952 Susten, Switzerland"
print LogOn$(Version$,%White,%Blue);
print Describe$
color %Cyan,%Black
'
' Setup of Filespec string-array, flags array and use sequence array
'
'------------------------------<Start of other Pictures Loop>-----------------
do
  for N% = 1 to 16
    Batch$(N%) = Nill$
    Batch%(N%) = %False
    BUse%(N%) = N%
  next N%
'
' File path and filenames entry.
'
'----------------------------------<Start of File Input Loop>-----------------
  do
    print LogOn$(Version$,%Cyan,%Black);
    print Describe$
    gosub GetDirPath
    OldPath$ = UsePath$
    DOTFlag% = Confirm%(SLText$(20%))
    if DOTFlag% then
      A% = ListFiles%(UsePath$,"DOT",English%)
    else
      A% = ListFiles%(UsePath$,"D??",English%)
    end if
    if A% then
      Y? = csrlin
      if Y? > 21 then
	for N% = 1 to 10
	  print
	next N%
      end if
      locate 21,1
      color %Black,%Cyan
      print Center$(SLText$(2%),80)
      color %Cyan,%Black
      Y? = csrlin
      for N% = 1 to 16
	locate Y?,1
	print space$(80);
	locate Y?,1
	if DOTFlag% then
	  A$ = IOFile$(English%,%False,SLText$(10%))
	else
	  A$ = IOFile$(English%,%True,SLText$(10%))
	end if
	if instr(A$,"END") then exit for
	if DOTFlag% then
	  Batch$(N%) = UsePath$ + StripExt$(A$) + ".DOT"
	else
	  Batch$(N%) = UsePath$ + A$
	end if
      next N%
      exit loop
    else
      Fatal$ = SLText$(9%)
      if not Redo%(SLText$(3%)) then goto NoJob
    end if
  loop
'-----------------------------------<End of File Input Loop>-----------------
'
' Filespec and filesize validification
'
  NoFiles% = N% - 1
  print Logon$(Version$,%Cyan,%Blue);
  color %LCyan,%Black
  print Center$(SLText$(4%),80)
  for N% = 1 to NoFiles%
    Z% = FileFlag%(Batch$(N%))
    Batch%(N%) = Z%
    if Z% then
      color %White,%Black
      print "[";
      print using "##";N%;
      print "] ";
      color %Green,%Black
      print Batch$(N%);" ";
      if not dir$(Batch$(N%)) = "" then
        open Batch$(N%) for binary as # 1
        get$ # 1, 5,D$
        Z?? = asc(mid$(D$,4,1)) * 256 + asc(mid$(D$,3,1))
        if Z?? = 28000 then
	  color %LGreen,%Black
	  print ""
	else
	  color %LRed,%Black
	  print SLText$(15%);Z??
	end if
	close 1
      else
	color %LRed,%Black
	print SLText$(16%)
	Batch%(N%) = %False
      end if
    end if
  next N%
'
' Moving filespecs such that invalid ones are skipped
'
  Cnt% = 0
  for N% = 1 to NoFiles%
    if Batch%(N%) then
      incr Cnt%
      Batch$(Cnt%) = Batch$(N%)
    end if
  next N%
  NoFiles% = Cnt%
'
' If there is more than one file to view, the list is displayed and the order
' can be changed, if the user desires
'
'----------------------------------------<Start of Review Loop>---------------
  do
    if NoFiles% > 1 then
      if not Confirm%(SLText$(5%)) then
	print LogOn$(Version$,%White,%Pink);
	Y% = csrlin
	for N% = 1 to NoFiles%
	  color %LWhite,%Black
	  print "[";
	  print using "##";N%;
	  print "] ";Batch$(N%);
	  color %LCyan,%Black
	  locate csrlin,76
	  print "[  ]"
	next N%
'
' Aquisition of new sequence and verification of valid numbers
'
	for N% = 1 to NoFiles%
	  do
	    color %Yellow,%Black
	    locate Y%+N%-1,77
	    print "  ";
	    locate Y%+N%-1,77
	    line input Q$
	    Q% = val(Q$)
	    if (Q% = 0) or (Q% > NoFiles%) then
	      color %Yellow,%Red
	      locate Y%+N%-1,77
	      print using "##";Q%
	      beep
	      delay 1
	    else
	      color %LCyan,%Black
	      locate Y%+N%-1,77
	      print using "##";Q%
	      BUse%(Q%) = N%
	      exit loop
	    end if
	  loop
	next N%
      else
	for N% = 1 to NoFiles%
	  BUse%(N%) = N%
	next N%
      end if
    end if
'
' This very simple part of the program actually does the job for what it was
' designed for. The whole rest is just the aquisition gadged and for making
' everythin shiny.
'
    screen ScrMode%
    for N% = 1 to NoFiles%
      open Batch$(BUse%(N%)) for binary as # 1
      Handle% = fileattr(1,2)
      Z% = RdBie%(CCB%(1),Handle%,28005??)
      close 1
      if not Z% then
        if istrue AryVid??(X%,CCB%(1)) then
          print SLText$(22%);Batch$(BUse%(N%))
        end if
      else
        print SLText$(21%);Batch$(BUse%(N%))
      end if
      while not instat : wend
      Q$ = inkey$
    next N%
    screen 0
'
' The displayed files are listed one more time
'
    print LogOn$(Version$,%White,%Blue);
    color %LCyan,%Black
    print Center$(SLText$(6%),80)
    color %White,%Black
    for N% = 1 to NoFiles%
      print Batch$(BUse%(N%))
    next N%
'
' Review query
'
    locate 23,1
    if not Confirm%(SLText$(7%)) then exit loop
  loop
'----------------------------------------<End of Review Loop>-----------------
'
' Redo all with different pictures query
'
  locate 23,1
  if not Confirm%(SLText$(8%)) then exit loop
loop
'-------------------------------<End of other Pictures Loop>------------------
'
' That's it - we're going to log off
'
print LogOn$(Version$,%White,%Blue);
print Describe$
color %LWhite,%Green
A$ = VN$ + SLText$(11%)
print
print Center$(A$,80)
print
color %LWhite,%Red
A$ = VN$ + "; " + GPCR$
print Center$(A$,80)
color %White,%Black
locate 22,1
goto About
'
'
' Should an unrecoverable error occur, we exit program here
'
NoJob:
'
Y% = csrlin
if Y% < 5 then Y% = 15
locate Y%,1
color %Yellow,%Red
print Center$(SLText$(17%) + Fatal$,80);
color %LWhite,%Red
print Center$(SLText$(18%) + VN$ + SLText$(19%),80);
color %LCyan,%Blue
print Center$(SLText$(13%),80)
color %White,%Black
locate 22,1
A$ = KeyIn$
goto About
'
'
About:
'
print "Info = F1 (2 sec)"
delay 2
if inkey$ = chr$(0,59) then
  print
  color %LWhite,%Black
  print "CCDOTOV .BAS Version";CCDotovV%
  color %White,%Black
  print "IOTEXT  .INC Version";IOTextV%
  print "ERROR3  .INC Version";Error3V%
  print "CLRSCRN .PBL Version";ClrScrnV%
  print "PB3GPUSE.PBU Version";PB3GPUseV%
  print "RLCEGEN .OBJ Version";RlceGenV%
  print "PBSTACK .OBJ Version 100"
  print "PowerBASIC  Revision";PBVer%(SV$);SV$
  print
  color %LWhite,%Blue
  call HoroSoftLogo
  color %White,%Black
  while not instat : wend
  Q$ = inkey$
  call ClsTB
end if
cls
system
stop
'
'
' SUBROUTINE AREA
'=============================================================================
'
' SUBROUTINE returns in A% a true flag if no Path/Drive error occured.
'----------------------------------------------------------------------------
'
ValidatePath:
'
E% = 0
D$ = curdir$
on error goto VPERR
if len(UsePath$) < 4 then
  chdir UsePath$
else
  chdir left$(UsePath$,len(UsePath$)-1)
end if
chdir D$
VPRES:
if E% = 0 then A% = %True else A% = %False
on error goto ErrorHandling
return
VPERR:
E% = err
resume VPRES
'
'
' SUBROUTINE returns validated path. I% = 1 for Input, 2 for output
'----------------------------------------------------------------------------
'
GetDirPath:
'
do
  UsePath$ = IOPath$(SLText$(1%),OldPath$,SLText$(10%))
  gosub ValidatePath
  if A% then exit loop
  if not Redo%(SLText$(12%)) then
    Fatal$ = SLText$(9%)
    return NoJob
  end if
  locate csrlin-1,1
loop
return
'
'
' DATA AREA
'=============================================================================
'
MLTxtDat:
'	       1         2         3         4         5        6          7         8
'     12345678901234567890123456789012345678901234567890123456789012345678901234567890
'
data 1,3
data "This viewer permits to view up to 16 DotoGrams, Profils and Isophotes"
data "filename.DOT or filename.Dxx. DotoGram, Profil and Isophotes files"
data "must have a size of exactly 28,008 bytes. They are created by CCDUTIL."
'
' German Texts, set with Idiom%(2) = 10
'
data 11,3
data "Dieser Betrachter erlaubt das Anzeigen von bis zu 16 DotoGramm-, Profil-"
data "und Isophoten-Dateien dateiname.DOT oder dateiname.Dxx. Die Dateigre mu"
data "genau 28'008 Byte betragen. Solche Dateien werden von CCDUTIL erzeugt.
data 0,0
'
'
SLTxtDat:
'
data  1,"Dirspecs for input file(s) or [RET] for current?"
data  2,"Type END when done"
data  3,"No files available  [RET] = enter new Dirspect  -  [ESC] = Abort"
data  4,"* * *  SELECTED FILES  * * *"
data  5,"Rearrange this sequence  [ESC] = Yes  -  [RET] = No, no need, really"
data  6,"* * *  FILES DISPLAYED  * * *"
data  7,"Review these pictures  [RET] = Yes  -  [ESC] = No"
data  8,"View other pictures  [RET] = Yes, please  -  [ESC] = No, we call it a day"
data  9,"No input files available! Abort on user request."
data 10,"Ok or Redo?  [RET] = Ok  -  [ESC] = Redo"
data 11," quits after a job well done. Have a nice day."
data 12,"No files!  [RET] = Enter another Path  -  [ESC] = No, exit"
data 13,"Sorry for the inconvenience caused."
data 14,"You need EGA with 256K RAM videocard!"
data 15,"WRONG DATASIZE, NOT 28,000 BYTES: "
data 16,"NON-EXISTENT"
data 17,"* ERROR - "
data 18,"You have to restart "
data 19," in order to get results."
data 20,"Filetype?  [RET] = .DOT  -  [ESC] = .Dxx (D00, D01, ..., D99)"
data 21,"Sorry skipped, cannot read "
data 22,"Sorry skipped, cannot decode "
data 23,"Memory shortage. CCDOTOV needs  230Kb to run. Missing"
'
' German texts. Set with Idiom%(1) = 30
'
data 31,"Eingabedatei: Verzeichnis?"
data 32,"Eingabe beenden mit 'END'"
data 33,"Keine Datei verfgbar  [RET] = anderes Verzeichnis  -  [ESC] = Abbruch"
data 34,"* * *   GEWHLTE DATEIEN   * * *"
data 35,"Sequenz neu ordnen  [ESC] = Ja  -  [RET] = Nein, nicht ntig, Danke."
data 36,"* * *   ANGEZEIGTE  DATEIEN   * * *"
data 37,"Bilder nochmals ansehen  [RET] = Ja  -  [ESC] = Nein, das wr's dann."
data 38,"Andere Bilder ansehen  [RET] = Ja, gerne  -  [ESC] = Nein, danke."
data 39,"Keine Eingabedateien verfgbar. Vom Benutzer verlangter Abbruch"
data 40,"I.O. oder wiederholen?  [RET] = i.O.  -  [ESC] = erneut eingeben"
data 41," endet nach getaner Arbeit. Schnen Tag noch."
data 42,"Keine Dateien!  [RET] = Anderen Pfad eingeben  -  [ESC] = Abbruch"
data 43,"Ich bedaure die verursachten Unannehmlichkeiten"
data 44,"Bentigte Videokarte: EGA mit 256K RAM."
data 45,"FALSCHE DATENLNGE, NICHT 28'000 BYTES: "
data 46,"EXISTIERT NICHT"
data 47,"* FEHLER - "
data 48,"Sie mssen "
data 49," neu starten, um etwas zu erreichen.
data 50,"Dateierweiterung?  [RET] = .DOT  -  [ESC] = .Dxx (D00, D01, ..., D99)"
data 51,"Bedaure, bersprungen; nicht lesbar "
data 52,"Bedaure, bersprungen; nicht dekodierbar "
data 53,"Zuwenig Speicher. CCDOTOV bentigt  230Kb. Es fehlen"
'
data 0
'
end
'
'===================================-<920912>-=========-<HoroSoft>-===========
