'960210 1503
'****************************************************************************
'* PROGRAM NAME: CCDPFUNC.INC   DATE: 13. 2.1993   INCLUDE IN: CCDPRINT.BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Dedicated functions.                                            *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.04  10-FEB-96,  Recompiled with PB 3.20                       *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03   5-JUL-94,  Corrected Photometric Interpretation          *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02   2-JUN-94,  Introduced Version CCDPFuncV% = 102           *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01  10-FEB-94,  Added TIFF                                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  13-FEB-93,  1-JUN-92,  31-DEC-93                          *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDPFuncV% = 104
'
'
' FUNCTION returns highest possible supported video mode.
'          Supported are VGA (12), MCGA (11), EGA-256K (9) or none (0).
'----------------------------------------------------------------------------
'
function BestVideo%
  local V%,BL%,BH%
  V% = 0
  reg (%AX), &h1A00
  call interrupt %VBIOS
  BL% = reg(%BX) mod 256
  if (BL% = 7) or (BL% = 11) then V% = 11
  if (BL% = 8) or (BL% = 12) then V% = 12
  if V% = 0 then
    reg (%AX), &h1200
    reg (%BX), &h0010
    call interrupt &h10
    BL% = reg(%BX) mod 256
    BH% = fix(reg(%BX) \ 256)
    if BH% = 0 and BL% = 3 then V% = 9 else V% = 0
  end if
  BestVideo% = V%
end function
'
'
' TRUE-FUNCTION reads RLCE compressed files into CCB%
'               Returns false if ok, 1 if wrong filesize or read error
'               number from DOS
'----------------------------------------------------------------------------
'
function GetBytDot%(CCB%(),F$,S??)
  local H%,Z%,A??,Z??,D$
  open F$ for binary as # %UnitAUX
  A?? = lof(%UnitAUX)
  get$ # %UnitAUX, 5,D$
  close %UnitAUX
  Z?? = asc(mid$(D$,2,1)) * 256 + asc(mid$(D$,1,1))
  if not A?? = Z?? then E% = %True
  Z?? = asc(mid$(D$,4,1)) * 256 + asc(mid$(D$,3,1))
  if not Z?? = S?? then
    GetBytDot% = 1
    exit function
  end if
  open F$ for binary as # %UnitAUX
  H% = fileattr(%UnitAUX,2)
  Z% = RdBie%(CCB%(1),H%,S??+5)
  close %UnitAUX
  GetBytDot% = Z%
end function
'
'
' TRUE-FUNCTION reads RLCE compressed files into CCB%
'               Returns false if ok, 1 if wrong filesize or read error
'               number from DOS
'----------------------------------------------------------------------------
'
function GetCge%(CCB%(),F$)
  local H%,Z%,A??,Z??,D$
  open F$ for binary as # %UnitAUX
  A?? = lof(%UnitAUX) - 256
  seek # %UnitAUX, 256
  get$ # %UnitAUX, 5,D$
  close %UnitAUX
  Z?? = asc(mid$(D$,2,1)) * 256 + asc(mid$(D$,1,1))
  if not A?? = Z?? then E% = %True
  Z?? = asc(mid$(D$,4,1)) * 256 + asc(mid$(D$,3,1))
  if not Z?? = 1760 then
    GetCge% = 1
    exit function
  end if
  open F$ for binary as # %UnitAUX
  H% = fileattr(%UnitAUX,2)
  seek # %UnitAUX, 256
  Z% = RdBie%(CCB%(1),H%,1765??)
  close %UnitAUX
  GetCge% = Z%
end function
'
'
' TRUE-FUNCTION increments file-extension
'----------------------------------------------------------------------------
'
function IncrExt$(E$)
  local A%,A$,B$,C$
  C$ = left$(E$,2)
  A$ = right$(E$,2)
  A% = val(A$)
  incr A%
  A$ = str$(A%)
  B$ = ltrim$(A$)
  A$ = rtrim$(B$)
  B$ = right$("00"+A$,2)
  IncrExt$ = C$ + B$
end function
'
'
' TRUE-FUNCTION returns Dots from value in A$. A is either 25.4 for mm or
'               1 for inches. B holds the upper limit in dots (1632 or 2440)
'               C has to offset, either 0.18 or 0.57.
'-----------------------------------------------------------------------------
'
function ToDot%(A$,A!,B!,C!)
  local D!
  D! = (val(A$) / A! - C!) * 300 + .5
  if D! < 0 then D! = 0
  if D! > B then D! = B
  ToDot% = fix(D!)
end function
'
'
' TRUE-FUNCTION returns from A% value in inch or mm according to A (25.4 or 1)
'               and the offset B (0.18 or 0.57)
'-----------------------------------------------------------------------------
'
function DotTo$(A%,A!,B!)
  local C!,C%,C$,D%
  C! = (A% / 300 + B!) * A!
  if A! = 25.4 then C! = C! + 0.5
  C$ = rtrim$(ltrim$(str$(C!)))
  C% = instr(C$,".")
  if not C% = 0 then
    C$ = C$ + "000"
    C$ = left$(C$,C%+2)
    if A! > 1 then C$ = left$(C$,C%-1)
  end if
  if A! = 1 then C$ = C$ + " inch" else C$ = C$ + " mm"
  DotTo$ = C$
end function
'
'
' TRUE-FUNCTION returns complete Head for a PCX image file, depending on
'               Version V%; 2 = V.2.8 (monochrome), 3 = V.3.0 (color)
'               Special case 4: replaces byte-65, color planes, in V3 to 3
'-----------------------------------------------------------------------------
'
function PCXHead$(V%)
  local A$,A%,N%
  A$ = string$(128,chr$(0))
  select case V%
    case 2
      restore PCXD2Head
    case 3,4
      restore PCXD3Head
    case 5
      restore PCXD4Head
  end select
  for N% = 1 to 72
    read A%
    mid$(A$,N%,1) = chr$(A%)
  next N%
  if V% = 4 then mid$(A$,66,1) = chr$(3)
  PCXHead$ = A$
  A$ = ""
end function
'
'
' TRUE-FUNCTION returns complete Footer for a PCX V.3.0 image file
'-----------------------------------------------------------------------------
'
function PCXFoot$(RGBFlag%)
  local A$,A%,N%
  A$ = string$(769,chr$(0))
  if RGBFlag% then
    restore PCXDFoot
    for N% = 1 to 769
      read A%
      mid$(A$,N%,1) = chr$(A%)
    next N%
  else
    for N% = 0 to 255
      A% = N% * 3 + 2
      mid$(A$,A%,3) = chr$(N%,N%,N%)
    next N%
    mid$(A$,1,1) = chr$(12)
  end if
  PCXFoot$ = A$
end function
'
'
' FUNCTION returns TIFF Head for
'          F% = 0: 192 x 165 24-bit for BYR/BYG/BYB
'          F% = 1: 192 x 165  8-bit for BYT & PCX
'          F% = 2: 192 x 165  4-bit for BYT & PCX, 1 Plane, 4 Bits
'          F% = 3: 192 x 165  4-bit for BYT & PCX, 4 Planes, 1 Bit
'          F% = 4:  64 x  55  4-bit for CGE, 1 Plane, 4 Bits
'          F% = 5:  64 x  55  4-bit for CGE, 4 Planes, 1 Bit
'          F% = 6: 640 x 350  1-bit for DOT
'----------------------------------------------------------------------------
'
function TIFFHead$(V$,F%)
  local T0$,T1$,T2$,T3$,T4$,T5$,T6$,T7$,T8$,T9$,T10$,T11$,T12$,T13$,_
        T14$,T15$,T16$,T17$,T18$,T19$,T20$,T21$
  T0$  = "II*" + chr$(0,60,0,0,0) + left$(V$+space$(15),15) + chr$(0)
  T1$  = chr$(255,0, 3,0, 1,0,0,0,   1,0,0,0)	'SubFile
  T2$  = chr$(  0,1, 3,0, 1,0,0,0)		'ImageWidth (t.b.d)
  T3$  = chr$(  1,1, 3,0, 1,0,0,0)		'ImageLength (t.b.d)
  T4$  = chr$(  2,1, 3,0)			'BitsPerSample (t.b.d)
  T5$  = chr$(  3,1, 3,0, 1,0,0,0,   1,0,0,0)	'Compression
  T6$  = chr$(  6,1, 3,0, 1,0,0,0)		'PhotometricInterpr. (t.b.d)
  T7$  = chr$(  7,1, 3,0, 1,0,0,0,   1,0,0,0)	'Thresholding
  T8$  = chr$( 10,1, 3,0, 1,0,0,0,   1,0,0,0)	'FillOrder
  T9$  = chr$( 17,1, 4,0)			'StripOffset (t.b.d.)
  T10$ = chr$( 18,1, 3,0, 1,0,0,0,   1,0,0,0)	'Orientation
  T11$ = chr$( 21,1, 3,0, 1,0,0,0)		'SamplesPerPixel (t.b.d)
  T12$ = chr$( 22,1, 4,0, 1,0,0,0)		'RowsPerStrip (t.b.d.)
  T13$ = chr$( 23,1, 4,0, 1,0,0,0)		'StripByteCounts (t.b.d.)
  T14$ = chr$( 26,1, 5,0, 1,0,0,0,  24,0,0,0)	'XResolution
  T15$ = chr$( 27,1, 5,0, 1,0,0,0,  32,0,0,0)	'YResolution
  T16$ = chr$( 28,1, 3,0, 1,0,0,0)		'PlanarConfiguration (t.b.d.)
  T17$ = chr$( 49,1, 2,0, 1,0,0,0,   8,0,0,0)	'Software
  T18$ = chr$( 59,1, 2,0, 1,0,0,0,  40,0,0,0)	'Artist
  select case F%
    case 0
      T2$  = T2$  + chr$(192,0,0,0)		'ImageWidth
      T3$  = T3$  + chr$(165,0,0,0)		'ImageLength
      T4$  = T4$  + chr$(3,0,0,0,  54,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(2,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(1,0,0,0, 246,0,0,0)	'StripOffset
      T11$ = T11$ + chr$(3,0,0,0)		'SamplesPerPixel
      T12$ = T12$ + chr$(165,0,0,0)		'RowsPerStrip
      T13$ = T13$ + chr$(64,115,1,0)		'StripByteCounts
      T16$ = T16$ + chr$(1,0,0,0)		'PlanarConfiguration
      T19$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + string$(11,chr$(0)) + chr$(8,0,8,0,8,0)
    case 1
      T2$  = T2$  + chr$(192,0,0,0)		'ImageWidth
      T3$  = T3$  + chr$(165,0,0,0)		'ImageLength
      T4$  = T4$  + chr$(1,0,0,0,   8,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(1,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(1,0,0,0, 246,0,0,0)	'StripOffset
      T12$ = T12$ + chr$(165,0,0,0)		'RowsPerStrip
      T13$ = T13$ + chr$(192,123,0,0)		'StripByteCounts
      T16$ = T16$ + chr$(1,0,0,0)		'PlanarConfiguration
      T19$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + string$(17,chr$(0))
    case 2
      T2$  = T2$  + chr$(192,0,0,0)		'ImageWidth
      T3$  = T3$  + chr$(165,0,0,0)		'ImageLength
      T4$  = T4$  + chr$(1,0,0,0,   4,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(1,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(1,0,0,0, 246,0,0,0)	'StripOffset
      T11$ = T11$ + chr$(4,0,0,0)		'SamplesPerPixel
      T12$ = T12$ + chr$(165,0,0,0)		'RowsPerStrip
      T13$ = T13$ + chr$(224,61,0,0)		'StripByteCounts
      T16$ = T16$ + chr$(1,0,0,0)		'PlanarConfiguration
      T19$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + string$(17,chr$(0))
    case 3
      T2$  = T2$  + chr$(192,0,0,0)		'ImageWidth
      T3$  = T3$  + chr$(165,0,0,0)		'ImageLength
      T4$  = T4$  + chr$(1,0,0,0,   4,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(1,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(4,0,0,0,  44,0,0,0)	'StripOffset
      T11$ = T11$ + chr$(4,0,0,0)		'SamplesPerPixel
      T16$ = T16$ + chr$(2,0,0,0)		'PlanarConfiguration
      T19$ = chr$( 64,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(200,0,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + chr$(0, 246,0,0,0, 110,16,0,0, 230,31,0,0, 94,47,0,0)
    case 4
      T2$  = T2$  + chr$(  64,0,0,0)		'ImageWidth
      T3$  = T3$  + chr$(  55,0,0,0)		'ImageLength
      T4$  = T4$  + chr$(  1,0,0,0,   4,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(  0,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(  1,0,0,0, 246,0,0,0)	'StripOffset
      T11$ = T11$ + chr$(  4,0,0,0)		'SamplesPerPixel
      T12$ = T12$ + chr$( 55,0,0,0)		'RowsPerStrip
      T13$ = T13$ + chr$(224,6,0,0)		'StripByteCounts
      T16$ = T16$ + chr$(  1,0,0,0)		'PlanarConfiguration
      T19$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + string$(17,chr$(0))
    case 5
      T2$  = T2$  + chr$( 64,0,0,0)		'ImageWidth
      T3$  = T3$  + chr$( 55,0,0,0)		'ImageLength
      T4$  = T4$  + chr$(1,0,0,0,   4,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(1,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(4,0,0,0,  44,0,0,0)	'StripOffset
      T11$ = T11$ + chr$(4,0,0,0)		'SamplesPerPixel
      T16$ = T16$ + chr$(2,0,0,0)		'PlanarConfiguration
      T19$ = chr$( 64,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(200,0,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + chr$(0, 246,0,0,0, 174, 2,0,0, 102, 4,0,0, 30, 6,0,0)
    case 6
      T2$  = T2$  + chr$(128,2,0,0)		'ImageWidth
      T3$  = T3$  + chr$( 94,1,0,0)		'ImageLength
      T4$  = T4$  + chr$(1,0,0,0,   1,0,0,0)	'BitsPerSample
      T6$  = T6$  + chr$(1,0,0,0)		'PhotometricInterpretation
      T9$  = T9$  + chr$(1,0,0,0, 246,0,0,0)	'StripOffset
      T12$ = T12$ + chr$(94,  1,0,0)		'RowsPerStrip
      T13$ = T13$ + chr$(96,109,1,0)		'StripByteCounts
      T16$ = T16$ + chr$(1,0,0,0)		'PlanarConfiguration
      T19$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionX
      T20$ = chr$(44,1,0,0,  1,0,0,0)		' ResolutionY
      T21$ = "hrw" + string$(17,chr$(0))
  end select
  T0$ =  T0$ + T19$ + T20$ + T21$ + chr$(15,0) + T1$ + T2$ + T3$ + T4$ + T5$ + T6$
  T1$ =  T9$ + T10$
  T2$ = T14$ + T15$ + T16$ + T17$
  select case F%
    case 0
      T3$ = T1$ + T11$ + T12$ + T13$ +  T2$
    case 1, 2, 4, 6
      T3$ = T8$ + T1$  + T12$ + T13$ +  T2$
    case 3, 5
      T3$ = T7$ + T1$  + T11$ +  T2$ + T18$
  end select
  TIFFHead$ = T0$ + T3$ + chr$(0,0,0,0)
end function
'
'
' TRUE-FUNCTION returns integer from string. 1st position in string
'-----------------------------------------------------------------------------
'
function StrInt%(A$,A%)
  local L%,H%
  L% = asc(mid$(A$,A%))
  H% = asc(mid$(A$,A%+1))
  StrInt% = BytWrd%(L%,H%)
end function
'
'
' FUNCTION returns from raw string a string of 192 bytes
'----------------------------------------------------------------------------
'
function Str192$(A$)
  local B$
  B$ = A$ + string$(192,chr$(0))
  Str192$ = left$(B$,192)
end function
'
'
' FUNCTION returns false if all planes were successfully written to opened
'          TIFF file, else the error code from the first unsuccessfully
'          written one.
'----------------------------------------------------------------------------
'
function Write4Planes%(CCA%(),CCP%(),CCD%(),CCI%(),H%,D%)
  local A%
  A% = WrTiff%(CCA%(1),H%,D%)
  if isfalse A% then
    A% = WrTiff%(CCP%(1),H%,D%)
    if isfalse A% then
      A% = WrTiff%(CCD%(1),H%,D%)
      if isfalse A% then A% = WrTiff%(CCI%(1),H%,D%)
    end if
  end if
  Write4Planes% = A%
end function
'
'
' FUNCTION checks wether file Z$ exists and warns on overwriting. If
'          overwriting is ok, kills file and returns false. If file
'          may not be overwritten, returns true
'----------------------------------------------------------------------------
'
function Existing%(Z$,F$)
  color %Cyan,%Black
  print SLText$(26%);
  print " ";Z$;" ";
  if FileHere%(Z$) then
    color %LWhite,%Red
    print SLText$(83%)
    if Confirm%(SLText$(84%)) then
      kill Z$
      Existing% = %False
    else
      F$ = SLText$(84%)
      Existing% = %True
    end if
  else
    Existing% = %False
  end if
end function
'
'
' PROCEDURE
'============================================================================
'
' PROCEDURE fills Color, grayscale and convolution arrays
'----------------------------------------------------------------------------
'
sub ArraySetUp(ColScale%(),GrayScale%())
  ColScale%(0) = BytWrd%(%Black, %Blue)		'--16-color image, Grayscale
  ColScale%(1) = BytWrd%(%Red,   %Pink)
  ColScale%(2) = BytWrd%(%Gray,  %Green)
  ColScale%(3) = BytWrd%(%Brown, %LBlue)
  ColScale%(4) = BytWrd%(%Cyan,  %LRed)
  ColScale%(5) = BytWrd%(%LPink, %White)
  ColScale%(6) = BytWrd%(%LGreen,%LCyan)
  ColScale%(7) = BytWrd%(%Yellow,%LWhite)
  GrayScale%( 0) = NibWrd%(%Black, %Black, %Black, %Black)	'--  0
  GrayScale%( 1) = NibWrd%(%Black, %Gray,  %Black, %Black)	'--  1
  GrayScale%( 2) = NibWrd%(%Gray,  %Gray,  %Black, %Black)	'--  2
  GrayScale%( 3) = NibWrd%(%Gray,  %Gray,  %Black, %Gray)	'--  3
  GrayScale%( 4) = NibWrd%(%Gray,  %Gray,  %Gray,  %Gray)	'--  4
  GrayScale%( 5) = NibWrd%(%Gray,  %White, %Black, %Black)	'--  5
  GrayScale%( 6) = NibWrd%(%Gray,  %White, %Black, %Gray)	'--  6
  GrayScale%( 7) = NibWrd%(%White, %White, %Black, %Gray)	'--  7
  GrayScale%( 8) = NibWrd%(%Black, %LWhite,%Black, %White)	'--  8
  GrayScale%( 9) = NibWrd%(%Gray,  %LWhite,%Black, %White)	'--  9
  GrayScale%(10) = NibWrd%(%White, %White, %Gray,  %White)	'-- 10
  GrayScale%(11) = NibWrd%(%White, %White, %White, %White)	'-- 11
  GrayScale%(12) = NibWrd%(%White, %LWhite,%Gray,  %White)	'-- 12
  GrayScale%(13) = NibWrd%(%LWhite,%LWhite,%Gray,  %White)	'-- 13
  GrayScale%(14) = NibWrd%(%LWhite,%LWhite,%White, %LWhite)	'-- 14
  GrayScale%(15) = NibWrd%(%LWhite,%LWhite,%LWhite,%LWhite)	'-- 15
end sub
'
'
'=============================-<930213>-=============-<HoroSoft>-=============
'
