;940708 1738
;****************************************************************************
;* PROGRAM NAME: CCDPP   .ASM   DATE:  6. 2.1993    LINK INTO: CCDPRINT.BAS *
;* LANGUAGE: Turbo Assembler TASM 2.0                                       *
;* PURPOSE:  Collection of Procedures for CCDPRINT                          *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.02  7-JUL-94 Added RdFits for Fits files                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01  2-JUN-94 Introduced Version CCDPPV% = 101                *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00  6-FEB-93 Start                                           *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.00c:                *
;*            = declare function CCDPPV%()
;*            = declare sub VarPP(integer)                                  *
;*            = declare sub LitPCL(integer,integer,string,integer)          *
;*            = declare sub LitScn(string,integer,integer)                  *
;*            = declare sub LitLin(string,integer,integer)                  *
;*            = declare sub DotPCL(string,integer)                          *
;*            = declare sub DotScn(string,integer)                          *
;*            = declare sub DotRLE(string,integer)                          *
;*            = declare sub ProPCL(string,integer,integer)                  *
;*            = declare sub IsoPCL(string,integer,integer)                  *
;*            = declare sub IsoIso(string,integer)                          *
;*            = declare sub ToRLLE(string,integer,integer)                  *
;*            = declare sub PcxAdj(integer,integer)                         *
;*            = declare sub PCXPal(integer,integer)                         *
;*            = declare sub InsByt(integer,integer,integer,string)          *
;*            = declare sub FreAry(integer,integer)                         *
;*            = declare sub BitByt(integer,integer,integer)                 *
;*            = declare sub E1Gray(integer,string)                          *
;*            = declare sub S1Gray(integer,string)                          *
;*            = declare sub Raster(integer,integer)                         *
;*            = declare sub VGACol(integer,integer)                         *
;*            = declare sub StuffV(integer)                                 *
;*            = declare sub ColAss(integer,integer,integer,integer)         *
;*            = declare sub BytStr(string,integer,integer)                  *
;*            = declare sub Third(integer,integer)                          *
;*            = declare sub Sixth(integer,integer,integer)                  *
;*            = declare sub Promo(integer,integer,string)                   *
;*            = declare sub Make4B(integer,integer,integer)                 *
;*            = declare sub NiByte(integer,integer)                         *
;*            = declare sub ByteNi(integer,integer)                         *
;*            = declare sub CgeReo(integer,integer)                         *
;*            = declare function BitAnd%(integer,integer)                   *
;*            = declare function RdFits%(integer,integer)                   *
;*            = declare function WrTiff%(integer,integer,integer)           *
;*            = declare function TiffWr%(string,int,int,int,int,integer)    *
;*            = $link "CCDPP.OBJ                                            *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDPP                                                 *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
getcon	equ	 11			;int 21h function get console status
dos	equ	 33			;int 21h DOS interrupt
readf	equ	 63			;DOS Function 3Fh Read
writef	equ	 64			;DOS Function 40h Write
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;GetStrLoc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDPPV%
;----------------------------------------------------------------------------
;
CCDPPV		proc	far
		public	CCDPPV
;
                call	pbastk
		mov	ax,102		;V.1.02
		xor	bl,bl
                jmp	bakbas
;
CCDPPV	endp
;
;
; VARIABLES AND TABLES DEFINITIONS
;============================================================================
;
; These variables are set and reset by VarPP procedre for CGE files.
;   The procedure sets it to alternate values for CGE and then resets them.
;----------------------------------------------------------------------------
;
col1pp	dw	  96			; 32 for CGE
col2pp	dw	 384			;128 for CGE
col3pp	dw	3960			;440 for CGE used in Make4B
;
;
; Raster and Dither data 4 X 4 for LitPCL
;----------------------------------------------------------------------------
;
pcllr:  db       0, 0, 0, 0, 0, 4, 0, 0, 0, 6, 0, 0, 0, 6, 2, 0
        db       2, 6, 2, 0, 2, 7, 2, 0, 2, 7, 6, 0, 6, 7, 6, 0
        db       6,15, 6, 0, 6,15, 6, 4, 6,15,14, 4, 6,15,14, 6
        db       6,15,15, 6, 7,15,15, 6, 7,15,15,14,15,15,15,15
;
pclld:  db       0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 4, 0, 5, 0, 4, 0
        db       5, 0, 5, 0, 5, 2, 5, 0, 5, 2, 5, 8, 5,10, 5, 8
        db       5,10, 5,10, 7,10, 5,10, 7,10,13,10,15,10,13,10
        db      15,10,15,10,15,11,15,10,15,11,15,14,15,15,15,15
;
;
; PROCEDURE  If Flag is false, the variables col1pp, col2pp and col3pp are
;            set for use in a CGE file. If Flag ist true, resets the
;            variables back to BYT file use.
;    call VarPP(Flag%)
;----------------------------------------------------------------------------
;
VARPP	proc	far
	public	VARPP
;
	call	pbastk			;CX = Flag%
        inc	cx			;if True, now 0, if False, now 1
        jnz	varpp1			;was false, set to CGE values
        mov	ax,96			;for true
        mov	dx,384			;for true
        mov	bx,3960			;for true
        jz	varpp2			;still 0, jump
varpp1:	mov	ax,32			;for false
	mov	dx,128			;for false
        mov	bx,440			;for false
varpp2:	mov	col1pp,ax		;change value
	mov	col2pp,dx		;change value
        mov	col3pp,bx		;change value
        mov	bl,1			;1 parameter
        jmp	bakbas
;
VARPP	endp
;
;
; PROCEDURE  creates a 4 X 4 dot raster or dither pattern for one pixel row.
;            A% has offset into CCx%, which has the image data, P$ will take
;            the pattern and PRes% has a flag (high order byte) for Raster/
;            Dither and the bit-mask (low order byte) according to
;            resolution desired.
;    call LitPCL(CCx%(1),A%,P$,PRes%)
;============================================================================
;
LITPCL	proc	far
	public	LITPCL
;
	call	pbastk			;save environment
	push	cx			;save Dither/Raster flag
	lds	si,[bp+10]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	pop	dx			;get Dither/Raster flag in DH
	lds	si,[bp+14]		;get pointer to F%*192
	mov	ax,ds:[si]		;AX=offset
	lds	si,[bp+18]		;DS:SI = CCB%(1)
	add	si,ax			;point to CCB%(F%*96)
	mov	cx,col1pp		;one row
litpc0:	push	di			;save offset pointer to P$
	mov	ax,ds:[si]		;AL=1st, AH=2nd
	xor	ax,1111111111111111b	;invert both bytes
	shr	ax,1                    ;/2
	shr	ax,1                    ;/4 = [0;63]
	and	ax,0011110000111100b	;mask to 0,4,8,..56,60
	xchg	al,ah			;swap 1st and 2nd byte
	push	ax			;save both bytes
	xor	ah,ah			;clear ah
	lea	bx,pcllr		;assume raster table
	and	dh,dh			;check Dither flag
	jz	litpc1			;if reset, skip
	lea	bx,pclld		;use dither table
litpc1: add	bx,ax			;BX points to table for 2nd byte
	pop	ax			;restore both bytes
	push	bx			;save table start for 2nd byte
	xchg	ah,al			;swap 2nd and 1st byte
	xor	ah,ah			;clear AH
	lea	bx,pcllr		;assume raster table
	and	dh,dh			;check dither flag
	jz	litpc2			;if reset, skip
	lea	bx,pclld		;use dither table
litpc2:	add	bx,ax			;BX points to table for 1st byte
	pop	ax			;AX points to table for 2nd byte
	push	ds			;save source segment
	push	cs			;get code segment
	pop	ds			;set ds to cs
	push	ax			;store table start for 2nd byte
	push	di			;save storing address
	mov	ch,4			;use temporarily as counter
litpc3:	mov	al,ds:[bx]		;get one decoded row
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1			;move 1st byte at high nibble
	mov	es:[di],al		;store decoded row
	inc	bx			;point to next decode row
	add	di,col1pp		;point to next dest row
	dec	ch			;one row decoded
	jnz	litpc3			;repeat 4 times
	pop	di			;restore storing address
	pop	bx			;restore table start for 2nd byte
	mov	ch,4			;use temporarily as counter
litpc4:	mov	al,ds:[bx]
	or	es:[di],al		;or 1st and 2nd nibble together
	inc	bx                      ;point to next decode row
	add	di,col1pp		;point to next dest row
	dec	ch			;one row decoded
	jnz	litpc4			;repeat 4 times
	pop	ds			;restore source segment
	pop	di			;restore old pointer
	inc	di			;point to next dest pixel
	inc	si			;point to next srce pixel
	inc	si			;point to next srce pixel
	xor	ch,ch			;be sure, ch is 0
	loop	litpc0			;repeat for full row
	mov	bl,4			;4 parameters to remove
	jmp	bakbas
;
LITPCL	endp
;
;
; PROCEDURE compresses line using RLE
;           Get pointer into P$, offset in P$ (N%) and add it to point at
;           the start of one of 4 lines. Get position of string
;           length-counter to be returned. The line of 96 bytes is
;           compressed by using Run-Length-Encoding. There are always two
;           bytes per data byte: the 1st is the counter (0-255 = 1-256)
;           followed by the data byte thus repeated. See the "Technical
;           Reference Manual for the DeskJet 500/500C" by Hewlett Packard,
;           Manual Part Number C2114-90008, Chapter 8: Graphics Control,
;           Page 8-24, Run-length Encoding. LITSCN should be used first to
;           check that compression will not become expansion.
;    call LitLin(P$,D%,C%)
;=============================================================================
;
LITLIN	proc	far
	public	LITLIN
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of P$
	mov	si,ax			;DS:SI = P$ location
	les	di,[bp+10]		;position of Pos
	add	si,es:[di]		;add offset into P$ for start
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	add	di,col2pp		;last 96 bytes for RLE data
	mov	cx,col1pp		;191 + 1 bytes per line
        dec	cx
	xor	bx,bx			;clear string length
	xor	dl,dl			;clear similiar byte counter
	lodsb				;get 1st byte
	mov	ah,al			;copy into ah
litli1:	lodsb				;get 2nd byte
	cmp	ah,al			;are they the same?
	jz	litli2			;skip if same
	mov	dh,al			;save first unmatching byte
	mov	al,dl			;get equal byte counter
	stosw				;save cntr-byte, inc di twice
	inc	bx
	inc	bx			;len(P$) + 2
	xor	dl,dl			;reset equal byte counter
	dec	dl			;compensate upcomming increment
	mov	ah,dh			;get next reference byte
litli2:	inc	dl			;increment equal bytes counter
	loop	litli1			;for 96 bytes
	mov	al,dl			;get equal bytes counter
	stosw				;store last counter & byte
	inc	bx
	inc	bx			;len(P$) + 2
	les	di,[bp+6]		;ES:DI = position of string length
	mov	es:[di],bx		;return string length
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
LITLIN	endp
;
;
; PROCEDURE returns number of non-consecutive bytes in a line
;           Get pointer into P$, offset in P$ (N%) and add it to point at
;           the start of one of 4 lines. Get position of difference-counter.
;           Return number of non-consecutive similiar bytes in C%.
;     call LitScn(P$,D%,C%)
;=============================================================================
;
LITSCN	proc	far
	public	LITSCN
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of P$
	mov	si,ax			;DS:SI = P$ location
	les	di,[bp+10]		;position of Pos
	add	si,es:[di]		;add offset into P$
	les	di,[bp+6]		;ES:DI = position of counter
	mov	cx,col1pp		;95 bytes to scan
        dec	cx
	xor	bx,bx			;clear counter
	mov	ah,ds:[si]		;get first byte
	inc	si			;point to 2nd byte
litsc1:	lodsb				;get next byte into AL, SI=SI+1
	cmp	ah,al			;is it equal?
	jz	litsc2			;jump if equal
	mov	ah,al			;this to compare
	inc	bl			;if different, count as different
litsc2:	loop	litsc1			;do 191 bytes
	mov	es:[di],bx		;return counter value
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
LITSCN	endp
;
;
; PROCEDURE adds white bits
;    call DotPCL(P$,CCD%(F%*40+1))
;=============================================================================
;
DOTPCL	proc	far
	public	DOTPCL
;
; Get pointer into P$ and CCD%(F%*40+1). Shift bits in such a way to add
; two unset dots to the already unset one in a line: 1010 --> 10001000.
; 8 bits thus become 16 bits.
;
	call	pbastk			;save environment
	lds	si,[bp+10]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	lds	si,[bp+6]		;position of CCD%(F%*40+1)
	mov	cx,12290		;CH=48 * 8 * = 384, CL=2
dotpc1:	lodsb				;mov ax,ds:[si] - inc si
	xor	dh,dh			;clear accu
	mov	dl,al			;DX: 00000000 10101010
	shl	dx,cl			;DX: 00000010 10101000
	shl	dh,cl			;DX: 00001000 10101000
	shl	dx,cl			;DX: 00100010 10100000
	shl	dh,cl			;DX: 10001000 10100000
	mov	ah,dh			;AH: 10001000
	xor	dh,dh			;DX: 00000000 10100000
	shl	dx,cl			;DX: 00000010 10000000
	shl	dh,cl			;DX: 00001000 10000000
	shl	dx,cl			;DX: 00100010 00000000
	shl	dh,cl			;DX: 10001000 00000000
	mov	al,ah			;AL: 10001000
	mov	ah,dh			;mem 10001000 10001000
	stosw				;mov es:[di], ax - inc di - inc di
	dec	ch			;1 byte done
	jnz	dotpc1			;repeat
	mov	dl,ds:[si]		;get remaining 2 bits
	xor	dh,dh			;DX: 00000000 10101010
	shl	dx,cl			;DX: 00000010 10101000
	shl	dh,cl			;DX: 00001000 10101000
	shl	dx,cl			;DX: 00100010 10100000
	shl	dh,cl			;DX: 10001000 10100000
	mov	es:[di],dh		;store it
	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
DOTPCL	endp
;
;
; PROCEDURE returns number of non-consecutive bytes
;     call DotScn(P$,C%)
;=============================================================================
;
DOTSCN	proc	far
	public	DOTSCN
;
; Get pointer into P$ and C%, how many bytes to scan.
; Return number of non-consecutive similiar bytes in C% as well.
;
	call	pbastk			;save environment
	lds	si,[bp+10]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of P$
	mov	si,ax			;DS:SI = P$ location
	les	di,[bp+6]		;position of C%
	mov	cx,es:[di]		;get counter
	dec	cx			;one less
	xor	bx,bx			;clear counter
	mov	ah,ds:[si]		;get first byte
	inc	si			;point to 2nd byte
dotsc1:	lodsb				;get next byte into AL, SI=SI+1
	cmp	ah,al			;is it equal?
	jz	dotsc2			;jump if equal
	mov	ah,al			;this to compare
	inc	bl			;if different, count as different
dotsc2:	loop	dotsc1			;do 191 bytes
	mov	es:[di],bx		;return counter value
	mov	bl,2			;3 parameters to remove
	jmp	bakbas
;
DOTSCN	endp
;
;
; PROCEDURE compresses line using RLE
;     call DotRLE(P$,C%)
;=============================================================================
;
DOTRLE	proc	far
	public	DOTRLE
;
; Get pointer into P$, offset in P$ is always 200 and number of bytes in C%
; to handle. At the end, C% also returns the string length.
; The line of C% bytes is compressed by using Run-Length-Encoding. There
; are always 2 bytes per data byte: the 1st is the counter (0-255 = 1-256)
; followed by the data byte thus repeated. See the "Technical Reference
; Manual for the DeskJet 500/500C" by Hewlett Packard, Manual Part Number
; C2114-90008, Chapter 8: Graphics Control, Page 8-24, Run-length Encoding.
; DOTSCN should be used first to check that compression will not become
; expansion.
;
	call	pbastk			;save environment
	lds	si,[bp+10]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of P$
	mov	si,ax			;DS:SI = P$ location
	les	di,[bp+6]		;position of C%
	mov	cx,es:[di]		;counter
	dec	cx			;one less
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	add	di,200			;ES:DI = P$(81) loaction
	xor	bx,bx			;clear string length
	xor	dl,dl			;clear similiar byte counter
	lodsb				;get 1st byte
	mov	ah,al			;copy into ah
dotrl1:	lodsb				;get 2nd byte
	cmp	ah,al			;are they the same?
	jz	dotrl2			;skip if same
	mov	dh,al			;save first unmatching byte
	mov	al,dl			;get equal byte counter
	stosw				;save cntr-byte, inc di twice
	inc	bx
	inc	bx			;len(P$) + 2
	xor	dl,dl			;reset equal byte counter
	dec	dl			;compensate upcomming increment
	mov	ah,dh			;get next reference byte
dotrl2:	inc	dl			;increment equal bytes counter
	loop	dotrl1			;for all bytes
	mov	al,dl			;get equal bytes counter
	stosw				;store last counter & byte
	inc	bx
	inc	bx			;len(P$) + 2
	les	di,[bp+6]		;ES:DI = position of string length
	mov	es:[di],bx		;return string length
	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
DOTRLE	endp
;
;
; PROCEDURE prepares Profil for PCL
;     call ProPCL(P$,CCD%(F%*40+1),TnyFlg%)
;=============================================================================
;
PROPCL	proc	far
	public	PROPCL
;
; Get pointer into P$, CCD%(F%*40+1) and TnyFlg%. If not TnyFlg% then double
; every bit set and any reset. Otherwise just copy data.
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	lds	si,[bp+6]		;position of TnyFlg%
	mov	bx,ds:[si]		;get TnyFlg%
	lds	si,[bp+10]		;DS:SI = CCD%(F%*40+1) location
	and	bh,bl			;check 0
	jz	propc0			;double bits
	mov	cx,37			;37 * 2 * 8 = 592 dots
	rep	movsw
	jmp	short propc1
propc0:	mov	cx,18946		;CH=74 bytes, CL=2 shift counter
	call	isopro			;convert
propc1:	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
PROPCL	endp
;
;
; PROCEDURE prepares Isophotes from the small image for PCL
;     call IsoPCL(P$,CCD%(F%*40+1),TnyFlg%)
;=============================================================================
;
ISOPCL	proc	far
	public	ISOPCL
;
; Get pointer into P$, CCD%(F%*40+1) and TnyFlg%. Copy 196 bits by 6 times
; right shifting into P$(201) and then recopy them into P$(1). If TnyFlg% is
; set, that will be all, otherwise double bits in row. This is used for
; the small Isophotes image.
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	lds	si,[bp+6]		;position of TnyFlg%
	mov	bx,ds:[si]		;get TnyFlg%
	push	bx			;save TnyFlg%
	lds	si,[bp+10]		;DS:SI = CCD%(F%*40+1) location
	push	di			;save ES:DI = P$ start location
	push	es
	add	di,200			;ES:DI = P$(201)
	add	si,55			;offset to start: 55 * 8 = 440
	mov	dh,252			;DH: 11111100 mask
	mov	cx,6406			;CH=25*8-6=194, CL=6
isopcc:	lodsw				;AH: mem+1, AL: mem+0
	xchg	ah,al			;AH: mem+0, AL: mem+1
	shl	ax,cl			;AL bits 5-0 = 0
	mov	dl,ds:[si]		;DL: mem+2
	and	dl,dh			;DL: bits 7-2
	shr	dl,1
	shr	dl,1			;DL: bits 5-0
	or	al,dl			;add together
	xchg	al,ah			;AL: mem+0/mem+1, AH: mem+1/mem+2
	stosw
	dec	ch			;repeat 25 times
	jnz	isopcc
	pop	bx			;ES
	pop	dx			;DI
	mov	es,bx
	mov	ds,bx
	mov	di,dx			;ES:DI = P$(1)
	mov	si,dx
	add	si,200			;DS:SI = P$(201)
	mov	bx,si			;save source
	mov	cx,12			;24 bytes to xfer
	rep	movsw			;P$(201) -> P$(1)
	lodsw				;get last byte
	and	ax,192			;keep last 2 bytes only
	stosw				;and clear 14 bits
	mov	di,dx			;P$(201) = srce
	mov	si,bx			;P$(1) = dest
	pop	bx			;restore TnyFlg%
	and	bh,bl			;check 0
	jz	isopc0			;double bits
	jmp	short isopc1
isopc0:	mov	cx,6402			;CH=25 bytes, CL=2 shift counter
	call	isopro			;convert
	and	word ptr es:[di-2],240	;clear all bits exept the first 4
isopc1:	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
ISOPCL	endp
;
;
; PROCEDURE prepares Isophotes from the large image for PCL
;     call IsoIso(P$,CCD%(F%*40+1))
;=============================================================================
;
ISOISO	proc	far
	public	ISOISO
;
; Get pointer into P$, CCD%(F%*40+1). Copy all 48 bytes. This copies Isophotes
; from the large image.
;
	call	pbastk			;save environment
	lds	si,[bp+10]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	lds	si,[bp+6]		;DS:SI = CCD%(F%*40+1) location
	mov	cx,24			;24 * 2 * 8 = 384 dots
	rep	movsw			;move'em over
	mov     bl,2			;2 parameters to remove
	jmp	bakbas
;
ISOISO	endp
;
;
; PROCEDURE compresses using RLLE
;     call ToRLLE(P$,CCP%(F%*192),C%) C%=returned string length
;=============================================================================
;
TORLLE	proc	far
	public	TORLLE
;
; Get pointer into P$, CCP%(F%*96+1) and get position of string length-counter
; to be returned. The line of 192 bytes is compressed by using Run-Length-
; Limitation-Encoding. If the databyte has bits 7 and 6 not set and it is a
; single occurance, it is stored as one data byte. If its value surmounts 63,
; i.e. bit 7 and 6 are set, a counter byte preceeding this data byte is
; mandatory, since set bits 7 and 6 indicate a counter byte.
; "Die wunderbare Welt der Grafikformate" by M.Pohl & H.Eriksdottar
; ISBN 3-925328-05x Wolfram's Fachverlag 1991, p.p141-146, 3.2.2 ZSoft PCX.
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	lds	si,[bp+6]		;get counter - len(P$) is stored at end
	mov	cx,ds:[si]		;get counter 192 or 80
	dec	cx			;191+1 or 79+1 bytes per line
	lds	si,[bp+10]		;point to CCP%(F%*96+1)
	xor	bx,bx			;clear string length
	mov	dl,1			;set similiar byte counter to 1
	lodsb				;get 1st byte
	mov	ah,al			;copy into ah
rlle1:	lodsb				;get 2nd byte
	cmp	dl,63			;only up to 63
	jz	rlle2			;if full, save it
	cmp	ah,al			;are they the same?
	jz	rlle5 			;skip if same
rlle2:	mov	dh,al			;save first unmatching byte
	cmp	dl,1			;check counter > 1
	jnz	rlle3			;if > 0, handle as 2 bytes
	cmp	ah,192			;bits 7 and 6 set?
	jnc	rlle3			;handle as 2 bytes
	mov	al,ah			;counter=1, data < 64
	stosb				;store one byte
	jmp	rlle4			;string length + 1
rlle3:	mov	al,dl			;get equal byte counter
	or	al,192			;set bits 7 an d 6
	stosw				;save cntr-byte, inc di twice
	inc	bx
rlle4:	inc	bx			;len(P$) + 2
	xor	dl,dl			;equal byte counter to 1 (incr later)
	mov	ah,dh			;get next reference byte
rlle5:	inc	dl			;increment equal bytes counter
	loop	rlle1			;for 192 bytes
	cmp	dl,1			;counter = 1 at end
	jnz	rlle6			;no, greater, store two bytes
	cmp	ah,192			;data byte bits 7 and 6 set?
	jnc	rlle6			;if yes, store 2 bytes
	mov	al,ah			;if no, store only one byte
	stosb
	jmp	rlle7			;string length +1
rlle6:	mov	al,dl			;get equal bytes counter
	or	al,192			;set bits 7 an d 6
	stosw				;store last counter & byte
	inc	bx
rlle7:	inc	bx			;len(P$) + 2
	les	di,[bp+6]		;ES:DI = position of string length
	mov	es:[di],bx		;return string length
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
TORLLE	endp
;
;
; PROCEDURE makes from 256 gray scales 64
;     call PcxAdj(CCI%(1),CCP%(1))
;=============================================================================
;
PCXADJ	proc	far
	public	PCXADJ
;
; Copy all bytes from CCP% to CCI% and dividing each byte by 4
;
	call	pbastk			;save environment
	lds	si,[bp+6]		;DS:SI = CCP%(1)
	les	di,[bp+10]		;ES:DI = CCI%(1)
	mov	cx,15840		;192 * 165 bytes = 15840 Words
pcxad1:	lodsw				;mov ax,ds:[si] - inc si - inc si
	shr	ax,1			;/2
	shr	ax,1			;/4
	and	al,63			;mask 00111111
	stosw				;mov es:[di],ax - inc di - inc di
	loop	pcxad1			;do all elements
	mov     bl,2			;2 parameters to remove
	jmp	bakbas
;
PCXADJ	endp
;
;
; PROCEDURE adds 192 to 64 grayscales
;     call PcxPal(CCI%(1),Pal%)
;=============================================================================
;
PCXPAL	proc	far
	public	PCXPAL
;
; Add Pal% to each byte in CCI%
;
	call	pbastk			;save environment
	lds	si,[bp+6]		;DS:SI = Pal%
	mov	bl,ds:[si]		;get Pal% Palette offset
	lds	si,[bp+10]		;DS:SI = CCI%(1)
	les	di,[bp+10]		;ES:DI = CCI%(1)
	mov	cx,15840		;192 * 165 bytes = 15840 Words
pcxpa1:	lodsw				;mov ax,ds:[si] - inc si - inc si
	add	al,bl			;add Palette offset
	add	ah,bl			;add Palette offset
	stosw				;mov es:[di],ax - inc di - inc di
	loop	pcxpa1			;do all elements
	mov     bl,2			;2 parameters to remove
	jmp	bakbas
;
PCXPAL	endp
;
;
; PROCEDURE inserts C% bytes from R$ into CCI%() at byte position CP%.
;           If C% > 192 then C% = 192. If C% < 192, rest is filled with zero
;     call InsByt(CCI%(1),CP%,C%,R$)
;----------------------------------------------------------------------------
;
INSBYT	proc	far
	public	INSBYT
;
	call	pbastk			;(DS:SI) = (R$-Head)
	push	ds:[si]			;onto stack
	call	GetStrLoc		;locate R$
	mov	ds,dx
	mov	si,ax			;(DS:SI) = (R$)
	les	di,[bp+10]
	mov	cx,es:[di]		;CX = C%
	cmp	cx,193			;check > 192
	jc	insby0			;ok if [0;192]
	mov	cx,192			;else set to 192
insby0:	les	di,[bp+14]
	mov	bx,es:[di]		;BX = CP%
	les	di,[bp+18]		;(ES:DI) = (CCI%(1))
	add	di,bx			;point to position
	mov	dx,192			;filler counter
	sub	dx,cx			;establish bytes to fill
	jnc	insby1			;if CX < 192, DX filler counter
	xor	dx,dx			;else, nothing to fill
	cmp	cx,192			;check wider lines
	jnc	insby1			;if <=192 ok
	mov	cx,192			;else set to max
insby1:	rep	movsb			;copy bytes into CCI%
	mov	cx,dx			;get filler counter
	jcxz	insby2			;if 0, all done
	xor	al,al			;set to zero
	rep	stosb			;otherwise fill
insby2:	mov	bl,4			;4 parameters
	jmp	bakbas
;
INSBYT	endp
;
;
; PROCEDURE copies 80 bytes by 165 bytes to temporary array to free other
;     call FreAry(CCB%(1),CCA%(1)
;----------------------------------------------------------------------------
;
FREARY	proc	far
	public	FREARY
;
	call	pbastk			;(DS:SI) = (CCA%())
	les	di,[bp+10]		;(ES:DI) = (CCB%())
	mov	bl,165			;165 lines
frear0:	mov	cx,12			;12 words, 24*8=192pixels
	rep	movsw
	add	si,168			;total 192 bytes
	dec	bl			;one line done
	jnz	frear0			;repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
FREARY	endp
;
;
; PROCEDURE converts Bits to Bytes and places bit accordingly to Mask S%
;      call BitByt(CCA%(1),CCB%(1),S%)
;----------------------------------------------------------------------------
;
BITBYT	proc	far
	public	BITBYT
;
	call	pbastk			;CX = Mask
	mov	bl,cl			;BL = Mask 128/64/32/16
	lds	si,[bp+10]		;(DS:SI) = (CCB%())
	les	di,[bp+14]		;(ES:DI) = (CCA%())
	mov	cx,3960			;BX = 24 bytes * 165 lines
bitby0:	mov	dl,8			;8 bits to shift through
	lodsb				;AL = CCB%, SI+1
	mov	ah,al			;copy
bitby1:	xor	al,al			;assume zero
	rcl	ah,1			;rotate through carry
	jnc	bitby2			;if no carry, AL = zero
	mov	al,bl			;insert mask
bitby2:	stosb				;save byte
	dec	dl			;1 bit done
	jnz	bitby1			;repeat 8 times
	loop	bitby0			;repeat
	mov	bl,3			;3 parameters
	jmp	bakbas
;
BITBYT	endp
;
;
; PROCEDURE converts a color picture into a gray scale picture. Each color
;           pixel is trice gray weighted, once for red (30%), once for green
;           (59%) and once for blue (11%). These three values are added and
;           make up a gray weighted pixel (100%). Extended Color Map.
;      call E1Gray(CCA%(1),FulPal$)
;----------------------------------------------------------------------------
;
E1GRAY	proc	far
	public	E1GRAY
;
	call	pbastk			;CX = string ident
	push	cx			;string ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of FulPal$
	mov	si,ax			;DS:SI = FulPal$ location
	les	di,[bp+10]		;(ES:DI) = (CCA%())
	mov	cx,31680		;number of pixels
e1gra0:	mov	bl,es:[di]		;get byte
	xor	bh,bh			;BX = color byte
	mov	ax,bx			;AX = color byte
	add	bx,bx			;BX = BX * 2
	add	bx,ax			;BX = BX * 3 - 3 bytes per pal-entry
	mov	al,ds:[si+bx]		;get red palette value
	mov	dh,77			;Red:   n *  77 / 256 = n * 0.3008
	mul	dh			;AH = AL * 77 / 256
	mov	dl,ah			;DL = red
	inc	bx			;point to green palette value
	mov	al,ds:[si+bx]		;get green palette value
	mov	dh,151			;Green: n * 151 / 256 = n * 0.5898
	mul	dh      		;AH = AL * 151 / 256
	add	dl,ah			;DL = red + green
	inc	bx			;point to blue palette value
	mov	al,ds:[si+bx]		;get blue palette value
	mov	dh,229			;Blue: n * 225 / 2048 = n * 0.1099
	mul	dh			;AH = AL * 225 / 256
	shr	ah,1			;/ 512
	shr	ah,1			;/1024
	shr	ah,1			;/2048
	add	dl,ah			;DL = red + green + blue
	mov	al,dl			;AL = result
	stosb				;save it
	loop	e1gra0			;repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
E1GRAY	endp
;
;
; PROCEDURE converts a color picture into a gray scale picture. Each color
;           pixel is trice gray weighted, once for red (30%), once for green
;           (59%) and once for blue (11%). These three values are added and
;           make up a gray weighted pixel (100%). Standard Color Map.
;      call S1Gray(CCA%(1),StdPal$)
;----------------------------------------------------------------------------
;
S1GRAY	proc	far
	public	S1GRAY
;
	call	pbastk			;CX = string ident
	push	cx			;string ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of StdPal$
	mov	si,ax			;DS:SI = StdPal$ location
	les	di,[bp+10]		;(ES:DI) = (CCA%())
	mov	cx,31680		;number of pixels
s1gra0:	mov	bl,es:[di]		;get byte
	shr	bl,1
	shr	bl,1
	shr	bl,1
	shr	bl,1			;from XPand in high nibble
	xor	bh,bh			;BX = color byte
	mov	ax,bx			;AX = color byte
	add	bx,bx			;BX = BX * 2
	add	bx,ax			;BX = BX * 3 - 3 bytes per pal-entry
	mov	al,ds:[si+bx]		;get red palette value
	mov	dh,77			;Red:   n *  77 / 256 = n * 0.3008
	mul	dh			;AH = AL * 77 / 256
	mov	dl,ah			;DL = red
	inc	bx			;point to green palette value
	mov	al,ds:[si+bx]		;get green palette value
	mov	dh,151			;Green: n * 151 / 256 = n * 0.5898
	mul	dh      		;AH = AL * 151 / 256
	add	dl,ah			;DL = red + green
	inc	bx			;point to blue palette value
	mov	al,ds:[si+bx]		;get blue palette value
	mov	dh,225			;Blue: n * 225 / 2048 = n * 0.1099
	mul	dh			;AH = AL * 225 / 256
	shr	ah,1			;/ 512
	shr	ah,1			;/1024
	shr	ah,1			;/2048
	add	dl,ah			;DL = red + green + blue
	mov	al,dl			;AL = result
	stosb				;save it
	loop	s1gra0			;repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
S1GRAY	endp
;
;
; PROCEDURE draws rastered image if only EGA present. Derived from CCDUTIL,
;           but direction of drawing is vertical, not horizontal.
;     call Raster(CCA%(1),GrayScale%(0))
;----------------------------------------------------------------------------
;
RASTER	proc	far
	public	RASTER
;
	call	pbastk			;(DS:SI) = GrayScale%(0))
	mov	cx,ds
	mov	es,cx
	mov	di,si			;(ES:DI) = (GrayScale%(0))
	lds	si,[bp+10]		;(DS:SI) = (CCA%(f,n))
	xor	ax,ax			;AX = Y
raste1:	push	ax			;save Y
	mov	bx,128			;BX = X
raste2:	push	bx			;save X
	lodsb				;AL = CCA%(ax,bx) - inc si
	xor	ah,ah			;AX = CCA%(ax,bx)
	mov	cl,4			;divisor 255/16 = 16 [0;15]
	shr	al,cl			;AL = GrayScale number
	add	al,al			;2 bytes or 4 nibbles
	add	di,ax			;calculate offset into GrayScale
	mov	dx,es:[di]		;get all four colors
	sub	di,ax			;reset GrayScale pointer
	mov	bx,dx			;BX = col 1, 2, 3 & 4
	shr	dx,cl			;DX=col 3 & 4 move high to low nibble
	mov	cx,bx			;CX = col 1, 2, 3 & 4
	mov	bx,0f0fh		;BX = nibble mask
	and	dx,bx			;DX = colors 3 & 4
	and	cx,bx			;CX = colors 1 & 2
	pop	bx			;get X
	pop	ax			;get Y
	push	ax			;save Y again
	call	setdot			;pset (bx,ax),ch
	mov	ch,cl			;get color 2
	inc	ax			;Y+1
	call	setdot			;pset (bx,ax+1),ch
	mov	ch,dl			;get color 3
	inc	bx			;X+1
	call	setdot			;pset (bx+1,ax+1),ch
	mov	ch,dh			;get color 4
	dec	ax			;Y
	call	setdot			;pset (bx+1,ax),ch
	inc	bx			;X+2 = next sprite X-start
	cmp	bx,512			;128+384 reached?
	jc	raste2			;no, repeat
	pop	ax			;get X
	inc	ax
	inc	ax			;Y+2 = next sprite Y-start
	cmp	ax,330			;330 reached?
	jc	raste1			;no, repeat
raste5:	mov	bl,2			;2 parameters
	jmp	bakbas
;
RASTER	endp
;
;
; PROCEDURE draws 16 grayscales if VGA is present. Derived from CCDUTIL,
;           but direction of drawing is vertical, not horizontal.
;    call VGACol(ColScale%(7),CCA%(1))
;----------------------------------------------------------------------------
;
VGACOL	proc	far
	public	VGACOL
;
	call	pbastk			;(DS;SI) = (CCA%(1))
	mov	cl,4			;CL = 4 divisor
	les	di,[bp+10]		;(ES:DI) = (ColScale%(7))
	xor	ax,ax			;AX = Y
vgaco0:	mov	dx,128			;X column 128 - 512 (BX)
vgaco1: push	ax			;save Y
	lodsb				;AL = value
	mov	bl,al
	shr	bl,cl			;div by 16 or 32
	xor	bh,bh
	pop	ax			;get line number
	mov	ch,es:[di+bx]		;get color
	mov	bx,dx			;BX = column number
	call	setdot			;set dot at quadrant 2
	inc	ax
	call	setdot			;set dot at quadrant 1
	inc	bx
	call	setdot			;set dot at quadrant 4
	dec	ax
	call	setdot			;set dot at quadrant 3
	inc	bx			;point to next line
	mov	dx,bx			;save X
	cmp	bx,512			;all done?
	jc	vgaco1			;repeat for 192 columns
	inc	ax
	inc	ax			;point to next row
	cmp	ax,330			;check all done
	jc	vgaco0			;repeat 330 times
	mov	bl,2			;2 parameters
	jmp	bakbas
;
VGACOL	endp
;
;
; PROCEDURE draws stuffs array into video memory. Screen %EGA set is
;           assumed.
;    call StuffV(CCD%(1))
;----------------------------------------------------------------------------
;
STUFFV	proc	far
	public	STUFFV
;
	call	pbastk			;(DS:SI) = (CCD%(1))
	mov	ax,40960		;video segment A000h
	mov	es,ax
	xor	ax,ax
	mov	di,ax			;(ES:DI) = Video RAM
	mov	cx,14000		;80 * 350 / 2
	rep	movsw
	mov	bl,1			;1 parameter
	jmp	bakbas
;
STUFFV	endp
;
;
; PROCEDURE  assembles into CCA% 30% of red frame from CCD%, 59% of green
;            frame from CCP% and 11% of blue frame from CCI%
;    call ColAsm(CCA%(1),CCD%(1),CCP%(1),CCI%))
;----------------------------------------------------------------------------
;
COLASS	proc	far
	public	COLASS
;
	call	pbastk			;(DS:SI) = (CCI%(1)) : blue
	mov	bx,997			;Blue = n * 229 / 2048 (BH=3 shifts)
	call	percnt			;adjust data
	lds	si,[bp+10]		;(DS:SI) = (CCP%(1)) : green
	mov	bx,152			;Green = n * 152 / 256 (BH=0 shifts)
	call	percnt			;adjust data
	lds	si,[bp+14]		;(DS:SI) = (CCD%(1)) : red
	mov	bx,77			;Red = n * 77 / 256 (BH=0 shifts)
	call	percnt			;adjust data
	lds	si,[bp+6]		;(DS:SI) = (CCI%(1))
	les	di,[bp+10]		;(ES:DI) = (CCP%(1))
	call	addtwo			;Blue + Green
	lds	si,[bp+10]		;(DS:SI) = (CCP%(1))
	les	di,[bp+14]		;(ES:DI) = (CCD%(1))
	call	addtwo			;Red + (Blue+Green)
	lds	si,[bp+14]		;(DS:SI) = (CCD%(1))
	les	di,[bp+18]		;(ES:DI) = (CCA%(1))
	mov	cx,15840		;number of words
	rep	movsw			;copy result
	mov	bl,4			;4 parameters
	jmp	bakbas
;
COLASS	endp
;
;
; PROCEDURE copies one line of 192 bytes from integer to string. L% is line
;           number, option base 1. String is in 3-digit ascii with leading 0
;      call BytStr(A$,CCP%(1),L%)
;----------------------------------------------------------------------------
;
BYTSTR	proc	far
	public	BYTSTR
;
	call	pbastk			;CX = L%
	dec	cx
	mov	bx,192			;192 bytes per line
	mov	al,bl
	mul	cl			;AX = offset into CCP%
	lds	si,[bp+10]		;(DS:SI) = (CCP%(1))
	add	si,ax			;(DS:SI) = (CCP%(L%/2)
	les	di,[bp+14]		;(ES:DI) = (A$ identifier)
	mov	dx,es:[di]		;DX = A$ identifier
	push	dx			;A$ ident onto stack
	call	GetStrLoc		;DX:AX = string location
	mov	es,dx			;ES = segment of A$
	mov	di,ax			;ES:DI = A$ location
	mov	cx,bx			;number of pixels
bytst0:	lodsb				;get byte
	mov	ah,'0'			;hundredth, ascii offset
	mov	dh,ah			;tenth
	mov	dl,ah			;units
	mov	bl,100			;div 100
bytst1:	inc	dh			;assume > 99
	sub	al,bl
	jnc	bytst1			;> 99
	add	al,bl			;underflow
	dec	dh			;DH=hundredth in ascii
	mov	bl,10
bytst2:	inc	ah			;assume > 9
	sub	al,bl
	jnc	bytst2			;> 9
	add	al,bl			;underflow
	dec	ah			;AH=tenth in ascii
	add	dl,al			;DL=units in ascii
	mov	al,dh			;AX= L:hundredth H:tenth
	stosw				;save 2 bytes
	mov	al,dl			;get units
	stosb				;save it
	loop	bytst0			;repeat 192 times
	mov	bl,3			;3 parameters
	jmp	bakbas
;
BYTSTR	endp
;
;
; PROCEDURE divides each byte in array by 3 and adds it to other array
;      call Third(CCA%(1),CCB%(1))
;----------------------------------------------------------------------------
;
THIRD	proc	far
	public	THIRD
;
	call	pbastk			;(DS:SI) = (CCB%())
	les	di,[bp+10]		;(ES:DI) = (CCA%())
	mov	cx,31680		;elements
	mov	bl,3			;divisor
third0:	lodsb				;get element
	xor	ah,ah			;clear high byte
	div	bl			;divide
	mov	ah,es:[di]		;get destination byte
	add	al,ah			;add them
	stosb				;save byte
	loop	third0			;repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
THIRD	endp
;
;
; PROCEDURE divides each element of CCA% by 51, multiplies it with A% and
;           adds it to CCB%.
;      call Sixth(CCB%(1),CCA%(1),A%)
;----------------------------------------------------------------------------
;
SIXTH	proc	far
	public	SIXTH
;
	call	pbastk			;CL = multiplicator
	mov	bl,cl			;BL = multiplicator
	mov	bh,51			;BH = divisor
        lds	si,[bp+10]		;(DS:SI) = (CCA%())
	les	di,[bp+14]		;(ES:DI) = (CCB%())
	mov	cx,31680		;elements
sixth0:	lodsb				;get element
	mul	bl			;multiply
	div	bh			;divide by 51
        mov	ah,es:[di]		;get dest-byte
        add	al,ah			;add together
	stosb    			;store it
	loop	sixth0
	mov	bl,3			;3 Parameters
	jmp	bakbas
;
SIXTH	endp
;
;
; PROCEDURE Assumes an 8-bit PCX image in CCA% and creates from it either a
;           red (B=0), green (B=1) or blue (B=2) array
;      call Promot(CCD%(1),B%,FulPal$)
;----------------------------------------------------------------------------
;
PROMOT	proc	far
	public	PROMOT
;
	call	pbastk			;CL = multiplicator
	push	cx			;string ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of FulPal$
	mov	si,ax			;DS:SI = FulPal$ location
	les	di,[bp+10]		;access B%
	mov	dx,es:[di]		;offset in palette: 0, 1 or 2
	les	di,[bp+14]		;(ES:DI) = (CCD%())
	mov	cx,31680		;number of pixels
promo0:	mov	al,es:[di]		;get element
	xor	ah,ah			;clear high byte
	mov	bx,ax			;get byte
	add	bx,bx			;* 2
	add	bx,ax			;* 3
	add	bx,dx			;add offset
	mov	al,ds:[si+bx]		;get value from palette
	stosb				;save it
	loop	promo0			;repeat
	mov	bl,3			;3 Parameters
	jmp	bakbas
;
PROMOT	endp
;
;
; PROCEDURE Masks bit 4, 5, 6 or 7 and rolls 8 into array. This is to
;           reduce a 256-color image to a 16 color image. Variable col3pp
;           is 3960 for BYT and 440 for CGE files.
;      call Make4B(CCA%(1),CCB%(1),M%)
;----------------------------------------------------------------------------
;
MAKE4B	proc	far
	public	MAKE4B
;
	call	pbastk			;CL = 16, 32, 64 or 128
	mov	bl,cl			;BL = Mask
	lds	si,[bp+10]		;(DS:SI) = (CCB%())
	les	di,[bp+14]		;(ES:DI) = (CCA%())
	mov	cx,col3pp		;elements / 8
	xor	dx,dx			;DH = zero, DL = bit accumulator
make40:	mov	bh,8			;8 bit counter
make41:	lodsb				;get element
	and	al,bl			;mask out bit to keep
	cmp	dh,al			;set carry if AL > 0
	rcl	dl,1			;rotate carry into DL
	dec	bh			;1 bit done
	jnz	make41			;repeat 8 times
	mov	al,dl			;get 8 bits
	stosb				;save it
	loop	make40			;do whole array
	mov	bl,3			;3 Parameters
	jmp	bakbas
;
MAKE4B	endp
;
;
; PROCEDURE  expands nibbles into bytes
;    call NiByte(CCB%(1),CCP%(1))
;----------------------------------------------------------------------------
;
NIBYTE	proc	far
	public	NIBYTE
;
	call	pbastk			;(DS:SI) = (CCA%(1))
        les	di,[bp+10]		;(ES:DI) = (CCB%(1))
        mov	cx,1760			;elements / 2
        mov	bl,240			;even nibble mask
nibyt0:	lodsb				;get two nibbles
	mov	ah,al			;copy
        shl	al,1
        shl	al,1
        shl	al,1
        shl	al,1			;move low nibble to high nible
        and	ah,bl			;high nibble is even pixel
        stosw				;high byte is even pixel
        loop	nibyt0			;do all
        mov	bl,2			;two parameters
        jmp	bakbas
;
NIBYTE	endp
;
;
; PROCEDURE compresses Bytes into Nibbles for C% Bytes
;    call ByteNi(CCG%(1),C%)
;----------------------------------------------------------------------------
;
BYTENI	proc	far
	public	BYTENI
;
	call	pbastk			;CX = C%
        lds	si,[bp+10]		;(DS:SI) = (CCG%(1))
	les	di,[bp+10]		;(ES:DI) = (CCG%(1))
        mov	bl,240			;odd nibble mask
byten0:	lodsw				;get 2 bytes
        and	al,bl
        shr	ah,1
        shr	ah,1
        shr	ah,1
        shr	ah,1			;move even byte to low nibble
        or	al,ah			;add even byte
        stosb				;save it
        loop	byten0			;repeat
        mov	bl,2			;2 parameters
        jmp	bakbas
;
BYTENI	endp
;
;
; PROCEDURE reorganizes CGE file in such a way that it is a printable
;           Byte-file in CCP%
;    call CgaReo(CCP%(1),CCB%(1))
;----------------------------------------------------------------------------
;
CGEREO	proc	far
	public	CGEREO
;
	call	pbastk			;(DS:SI) = (CCB%(1))
        les	di,[bp+10]		;(ES:DI) = (CCP%(1))
        mov	bl,55			;BL = row counter: 55 rows
        mov	dx,128			;64 + 128 = 192
cgere0:	mov	cx,32			;32 words
	rep	movsw			;copy a row
        add	di,dx			;jump over rest
        dec	bl			;ready for next row
        jnz	cgere0			;repeat for all rows
	mov	bl,2			;2 parameters
        jmp	bakbas
;
CGEREO	endp
;
;
; FUNCTION is derived from PB2EXT to be able to compile CCDPRINT for
;          PB 2.10e with PB 3.00c.
;============================================================================
;
; FUNCTION performs bitwise AND of two integers
;    A% = BitAnd%(B%,C%)
;----------------------------------------------------------------------------
;
BITAND	proc	far
	public	BITAND
;
	call	pbastk			;CX = C%
	lds	si,[bp+10]
	mov	ax,ds:[si]		;AX = B%
	and	ax,cx			;bitwise and
	mov	bl,2			;2 parameters
	jmp	bakbas
;
BITAND	endp
;
;
; FUNCTION dumps file to array. It is assumed as open. Handle% has the DOS
;          handle, Data is written to CCA% for 31680 bytes.
;          RdFits% returns zero if ok, else DOS error code
;    if not RdFits%(CCA%(1),Handle%) then ok
;----------------------------------------------------------------------------
;
RDFITS	proc	far
	public	RDFITS
;
	call	pbastk			;CX = DOS Handle
        mov	bx,cx			;BX = DOS Handle
        lds	si,[bp+10]		;(DS:SI) = (CCA%(1))
        mov	dx,si			;DS:DX = buffer start
        mov	ah,readf		;DOS Function 21h, 3Fh
        mov	cx,31680		;number of bytes
        int	dos			;read it
        jc	rdfit1			;carry, not ok, AX = error code
        xor	ax,ax			;no carry, AX = 0
rdfit1:	mov	bl,2			;2 parameters
	jmp	bakbas
;
RDFITS	endp
;
;
; FUNCTION dumps array to file. It is assumed as open. Handle% has the DOS
;          handle, CCA% the data to be written and C% the number of bytes.
;          WrTiff% returns zero if ok, else DOS error code
;    if not WrTiff%(CCA%(1),Handle%,C%) then ok
;----------------------------------------------------------------------------
;
WRTIFF	proc	far
	public	WRTIFF
;
	call	pbastk			;CX = Bytes to write
        lds	si,[bp+10]		;(DS:SI) = (Handle%)
        mov	bx,ds:[si]		;BX = DOS Handle
        lds	si,[bp+14]		;(DS:SI) = (CCA%(1))
        mov	dx,si			;DS:DX = buffer start
        mov	ah,writef		;DOS Function 21h, 40h
        int	dos			;write it
        jc	wrtif1			;carry, not ok, AX = error code
        xor	ax,ax			;no carry, AX = 0
wrtif1:	mov	bl,3			;3 parameters
	jmp	bakbas
;
WRTIFF	endp
;
;
; FUNCTION returns false if write is ok. Assemples from CCD%, CCP% and CCI%
;          to Q$ one forth of 24-bit image contiguous and writes that batch
;          Start in all sources is Z% (0, 7920, 15840, 23760)
;    call TiffWr(Q$,Handle%,CCI%(1),CCP%(1),CCD%(1),Z%)
;----------------------------------------------------------------------------
;
TIFFWR	proc	far
	public	TIFFWR
;
	call	pbastk			;CX = Z%
        push	cx
        lds	si,[bp+26]		;point to Q$
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of Q$
	mov	di,ax			;ES:DI = Q$ location
        mov	dx,ax			;DX = start of Q$
        pop	bx			;BX = Z%
        lds	si,[bp+10]		;access RED in CCD%
        add	si,bx			;point to (new) start in CCD%
        mov	cx,7920			;31680 / 4 = 7920
tiffw1:	movsb				;copy RED pixel
	inc	di			;skip place for green
        inc	di			;skip place for blue
        loop	tiffw1			;do RED pixels
        mov	di,dx			;get start of Q$
        inc	di			;skip RED, point to GREEN
        lds	si,[bp+14]		;access GREEN in CCP%
        add	si,bx			;point to (new) start in CCP%
        mov	cx,7920			;31680 / 4 = 7920
tiffw2:	movsb				;copy GREEN pixel
	inc	di			;skip place for blue
        inc	di			;skip place for red
        loop	tiffw2			;do GREEN pixels
        mov	di,dx			;get start of Q$
        inc	di			;skip RED
        inc	di			;skip GREEN, point to BLUE
        lds	si,[bp+18]		;access BLUE in CCI%
        add	si,bx			;point to (new) start in CCI%
        mov	cx,7920			;31680 / 4 = 7920
tiffw3:	movsb				;copy BLUE pixel
	inc	di			;skip place for red
        inc	di			;skip place for green
        loop	tiffw3			;do BLUE pixels
	lds	si,[bp+22]		;(DS:SI) = Handle%
        mov	bx,ds:[si]		;BX = Handle%
        push	es
        pop	ds			;DS:DX = Buffer start (Q$)
        mov	cx,23760		;31680 / 4 * 3 = 23760
        mov	ah,writef		;write a fourth
        int	dos
        jc	tiffw4			;carry, not ok, AX = error code
        xor	ax,ax			;no carry, AX = 0
tiffw4:	mov	bl,6			;6 parameters
        jmp	bakbas
;
TIFFWR	endp
;
;
;============================================================================
; LOCAL SUBROUTINES AREA - Subroutines are Public and may be accessed by any
; of the above procedures.
;============================================================================
;
; SUBROUTINE - Set a dot. AX=line, BX=column, CH=color. No Reg destroyed!
; Derived from PIXPTR and SETPIX from PC-Intern 2.0, pp 679-680 by Michael
; Tischer. ISBN 3-89011-331-1.    New version does not destroy any register.
;----------------------------------------------------------------------------
;
SETDOT	proc	near			;define procedure near
	public	SETDOT
;
; Part-1: Save environment and calculate proper dot position within EGA-RAM
;
	push	es			;save ES
	push	dx			;save DX anyway
	push	cx			;CH=primary, CL=secondary color
	push	ax			;save Y
	push	bx			;save X
	mov	cl,bl			;save LO-byte of column
	mov	dx,80			;line length in characters
	mul	dx			;AX=line*80
	shr	bx,1
	shr	bx,1
	shr	bx,1			;columns / 8
	add	bx,ax			;+line offset
	mov	ax,40960		;video-RAM segment A000h
	mov	es,ax			;ES=segment of video-RAM
	and	cl,7			;clear bits 8...4 of column
	xor	cl,7			;swap bits 0..3 = 7-CL
	mov	ah,1			;keep bit 0 only
;
; Part-2: Draw actual dot directly into appropriate bit-plane
;
	mov	dx,974			;port 3CEh of EGA-controller
	shl	ah,cl			;mask for bit to change
	mov	al,8			;bit-mask register
	out	dx,ax			;write to EGA Bit-Mask-register
	mov	ax,5 + (2 shl 8)	;register and mode value
	out	dx,ax			;write to EGA Mode-register
	mov	ax,3 + (0 shl 8)	;register number
	out	dx,ax			;write to EGA Function-register
	mov	al,es:[bx]		;load latches
	mov	es:[bx],ch		;load color into bit-planes
;
; Part-3: Restore environment for EGA-Controller and CCTINY
;
	mov	ax,8 + (255 shl 8)	;reset old bit mask
	out	dx,ax			;write old value into Bit-Mask
	mov	ax,5			;old value for Mode
	out	dx,ax			;reset Mode-register
	mov	ah,3			;old value for Function Select AH=0
	out	dx,ax			;reset Function-Select register
	pop	bx			;restore X
	pop	ax			;restore Y
	pop	cx			;restore colors
	pop	dx			;restore DX
	pop	es			;restore ES
	ret
;
SETDOT	endp
;
;
; SUBROUTINE  adds for each bit set in a row a second one and adds a 0 for
;             each bit unset.
;-----------------------------------------------------------------------------
;
ISOPRO	proc	near
;
	mov	bl,3			;bit mask 00000011
isopr0:	lodsb				;AL e.g.: 11001011
	mov	dl,al			;DX: xxxxxxxx 11001011
	sal	dl,1			;Cy: 1
	jnc	isopr1
	or	dh,bl			;DX: xxxxxx11 10010110
isopr1:	shl	dh,cl			;DX: xxxx1100 10010110
	sal	dl,1			;Cy: 1
	jnc	isopr2
	or	dh,bl			;DX: xxxx1111 00101100
isopr2:	shl	dh,cl			;DX: xx111100 00101100
	sal	dl,1			;Cy: 0
	jnc	isopr3
	or	dh,bl
isopr3:	shl	dh,cl			;DX: 11110000 01011000
	sal	dl,1			;Cy: 0
	jnc	isopr4
	or	dh,bl
isopr4:	mov	al,dh			;AL: 11110000
	sal	dl,1			;Cy: 1
	jnc	isopr5
	or	dh,bl			;DX: 11110011 01100000
isopr5:	shl	dh,cl			;DX: 11001100 01100000
	sal	dl,1			;Cy: 0
	jnc	isopr6
	or	dh,bl
isopr6:	shl	dh,cl			;DX: 00110000 11000000
	sal	dl,1			;Cy: 1
	jnc	isopr7
	or	dh,bl			;DX: 00110011 10000000
isopr7:	shl	dh,cl			;DX: 11001100 10000000
	sal	dl,1			;Cy: 1
	jnc	isopr8
	or	dh,bl			;DX: 11001111 00000000
isopr8:	mov	ah,dh			;11001011 --> 1111000011001111
	stosw				;mov es:[di],ax - inc di - inc di
	dec	ch			;8 bits to 16 bits
	jnz	isopr0			;repeat
	ret
;
ISOPRO	endp
;
;
; SUBROUTINE  weights values in array pointed to by (DS:SI) by multiplying
;             by BL and dividing by BH right shifts
;----------------------------------------------------------------------------
;
PERCNT	proc	near
;
	mov	ax,ds
	mov	es,ax			;copy segment address of array
	mov	di,si			;copy offset address of array
	mov	cx,31680		;number of elements
;
percn0:	lodsb				;AL = value
	mul	bl			;AX = AL * BL
	and	bh,bh			;test zero
	jz	percn1			;jump if zero (red or green)
	shr	ah,1
	shr	ah,1
	shr	ah,1			;blue, divide by 8 (2048)
percn1:	mov	al,ah			;get result
	stosb				;store	it
	loop	percn0			;repeat for all elements
	ret				;done
;
PERCNT	endp
;
;
; SUBROUTINE  adds values of two arrays: (ES:DI) = (ES:DI) + (DS:SI)
;----------------------------------------------------------------------------
;
ADDTWO	proc	near
;
	mov	cx,31680		;number of elements
addtw0:	lodsb				;AL = (DS:SI)
	mov	ah,es:[di]		;AH = (ES:DI)
	add	al,ah			;AL = sum
	stosb				;save it
	loop	addtw0			;repeat
	ret
;
ADDTWO	endp
;
;
code	ends
	end
;
;=======================-<930206 HoroSoft, CH-3952 Susten>-==================
;
;
