'960210 1502
'****************************************************************************
'* PROGRAM NAME: CCDPPROC.INC   DATE: 12. 2.1993   INCLUDE IN: CCDPRINT.BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Procedures Collection for CCDTOOL                               *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.04  10-FEB-96 Recompiled with PB 3.20                         *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03   7-JUL-94 Introduced FITS 6-Plane from BYR/BYG/BYB        *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02   2-JUN-94 Introduced Version CCDPProcV% = 102             *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01  12-FEB-94 Just a year! Added CGE and TIFF formats.        *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  12-FEB-93,  1-JUN-93, 30-DEC-93                           *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDPProcV% = 104
'
'
' PROCEDURE Illegal Option issues warning if option is used with wrong
'           input file type A=61(Opt2), 62=(Opt3&4), 63=(Opt1,3&4)
'           Cursor position is retained, color is white on black
'----------------------------------------------------------------------------
'
sub IllOpt(A%)
  local X%,Y%
  Y% = csrlin
  X% = pos(Y%)
  locate Y%+1,1
  color %LWhite,%Red
  beep
  print Center$(SLText$(A%),80)
  delay 2
  locate Y%+1,1
  call ClrLine
  color %White,%Black
  locate Y%,X%
end sub
'
'
' PROCEDURE Large_Round_Buttons draws a large button in color C
'----------------------------------------------------------------------------
'
sub LRB(X%,Y%,C%)
  local A%
  A% = C% + 8
  circle(X%,Y%),12,A%
  circle(X%,Y%),11,A%
  circle(X%,Y%),10,A%
  paint (X%,Y%),C%,A%
end sub
'
'
' PROCEDURE Gets multiple inputs from user for small images
'-----------------------------------------------------------------------------
'
sub GetSmal(FilExt$(),PCLFil$,Z$,MI!,Txt1%,Txt2%,RD%,X%,Y%,PRes%)
  local N%,A%,Z%,V%,A$,Q$
  Z$ = FilExt$(%UnitP00)
  locate csrlin-1,1
  color %White,%Black
  call MLText(Txt1%,80%,"cs")
  print
  color %Cyan,%Black
  call MLText(Txt2%,80%,"cs")
  print
  if RD% then if Confirm%(SLText$(2%)) then PRes% = 256 else PRes% = 0
  if Confirm%(SLText$(29%)) then MI! = 25.4 else MI! = 1
  if MI! = 1 then W$ = " inches: " else W$ = " mm: "
  color %Cyan,%Black
  print SLText$(30%);W$;
  Z% = csrlin
  V% = pos(Z%)
  color %Yellow,%Black
  line input Q$
  locate Z%,V%+10
  color %Cyan,%Black
  X% = ToDot%(Q$,MI!,1632!,0.18!)
  print "Dots: ";X%
  print SLText$(31%);W$;
  Z% = csrlin
  V% = pos(Z%)
  color %Yellow,%Black
  line input Q$
  locate Z%,V%+10
  color %Cyan,%Black
  Y% = ToDot%(Q$,MI!,2440!,0.57!)
  print "Dots: ";Y%
  open PCLFil$ + Z$ for output as # %UnitPCL
end sub
'
'
' PROCEDURE informs user about a few things of the small image
'-----------------------------------------------------------------------------
'
sub PutSmal(FilExt$(),PCLFil$,Z$,MI!,X%,Y%,XO%,YO%)
  local A$,W$
  close %UnitPCL
  color %Cyan,%Black
  print SLText$(4%);PCLFil$;Z$
  if MI! = 1 then A$ = "inch): " else A$ = "mm):"
  print SLText$(32%);A$
  A$ = DotTo$(X%,MI!,0.18!) + "/" + DotTo$(Y%,MI!,0.57!) + ", "
  W$ = DotTo$(X%+XO%,MI!,0.18!) + "/" + DotTo$(Y%+YO%,MI!,0.57!)
  print A$;W$
end sub
'
'
' PROCEDURE Gets multiple inputs from user for large images
'-----------------------------------------------------------------------------
'
sub GetLarg(FilExt$(),PCLFil$,Z$,W$,PRes%,X%,Y%,FPFlg%)
  Z$ = FilExt$(%UnitPCL)
  if FPFlg% then FPFlg% = Confirm%(SLText$(41%)) else FPFlg% = %True
  if FPFlg% then
    X% = %True
    PRes% = 150
    if Confirm%(SLText$(3%)) then
      Y% = %False
      W$ = SLText$(17%)
    else
      Y% = %True
      W$ = SLText$(25%)
    end if
  else
    X% = %False
    Y% = %False
    PRes% = 100
    W$ = SLText$(52%)
  end if
  open PCLFil$ + Z$ for output as # %UnitPCL
end sub
'
'
' PROCEDURE informs user about a few things of the large image
'-----------------------------------------------------------------------------
'
sub PutLarg(FilExt$(),PCLFil$,Z$,W$)
  close %UnitPCL
  color %Cyan,%Black
  print SLText$(4%);PCLFil$;Z$;W$
  print
end sub
'
'
' PROCEDURE askes whether image shall be printed now and if so, queries to
'           purge PCL file afterwards.
'-----------------------------------------------------------------------------
'
sub HCNow(FilExt$(),PCLFil$,Z$)
  local A%,W%
  A% = csrlin-1
  W% = %True
  if not Confirm%(SLText$(33%)) then
    Q$ = "COPY " + PCLFil$ + Z$ + " PRN /B"
    shell Q$
    locate A%,1
    if not Confirm%(SLText$(39%)) then
      W% = %False
      kill PCLFil$ + Z$
      color %Yellow,%White
      print Center$(SLText$(40%) + PCLFil$ + Z$,80);
      delay 1
    end if
  end if
  if W% then FilExt$(%UnitP00) = IncrExt$(Z$)
  color %White,%Black
end sub
'
'
' PROCEDURE writes data to PCL-file. The file is assumed to be open.
'           Each data line (165 times 192 data bytes) are converted to either
'           a raster or a dither pattern with 8 X 8 dots. These 8 point rows
'           are scanned to check how many different bytes there are. If there
'           less than half a line, the line is run-length encoded. The lines
'           are than written as printer data in HP PCL Level III language.
'-----------------------------------------------------------------------------
'
sub LinPCL(CCP%(),PRes%,X$)
  local F%,N%,Y%,X%,A%,B%,C%,D%,K%,P$,Z$
  print# %UnitPCL, chr$(27);"E";chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p419x";X$;"Y";chr$(27);"*t300R";
  print# %UnitPCL, chr$(27);"*r1536S";chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(37%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Y% = csrlin
  X% = pos(Y%)
  P$ = space$(1728)
  for F% = 0 to 164
    locate Y%,X%
    print using "####";F%+1;
    A% = F% * 192
    call OnePCL(CCP%(1),A%,P$,PRes%)
    for N% = 0 to 7
      D% = N% * 192
      call RLEscn(P$,D%,C%)
      if K% and (C% < 96) then
	call RLElin(P$,D%,C%)
	Z$ = ltrim$(rtrim$(str$(C%)))
	print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,1537,C%);
      else
	print# %UnitPCL, chr$(27);"*b0m192W";mid$(P$,D%+1,192);
      end if
    next N%
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  color %Cyan,%Black
  locate Y%,X%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE writes data to PCL-file. The file is assumed to be open.
'           Each data line (165 times 192 data bytes) are converted to either
'           a raster or a dither pattern with 4 X 4 dots. These 4 point rows
'           are scanned to check how many different bytes there are. If there
'           less than half a line, the line is run-length encoded. The lines
'           are than written as printer data in HP PCL Level III language.
'-----------------------------------------------------------------------------
'
sub SmlPCL(CCP%(),PRes%,X%,Y%)
  local F%,N%,Z%,V%,A%,B%,C%,D%,K%,P$,X$,Y$,Z$
  X$ = rtrim$(ltrim$(str$(X%)))
  Y$ = rtrim$(ltrim$(str$(Y%)))
  print# %UnitPCL, chr$(27);"E";chr$(27);"&l26A";      'Select A4!
  print# %UnitPCL, chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p";X$;"x";Y$;"Y";chr$(27);"*t300R";
  print# %UnitPCL, chr$(27);"*r768S";chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(38%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Z% = csrlin
  V% = pos(Z%)
  P$ = space$(576)
  for F% = 0 to 164
    locate Z%,V%
    print using "####";F%+1;
    A% = F% * 192
    call LitPCL(CCP%(1),A%,P$,PRes%)
    for N% = 0 to 3
      D% = N% * 96
      call LitScn(P$,D%,C%)
      if K% and (C% < 48) then
	call LitLin(P$,D%,C%)
	Z$ = ltrim$(rtrim$(str$(C%)))
	print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,385,C%);
      else
	print# %UnitPCL, chr$(27);"*b0m96W";mid$(P$,D%+1,96);
      end if
    next N%
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  color %Cyan,%Black
  locate Z%,V%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE writes data to PCL-file. The file is assumed to be open.
'           Each data line (55 times 64 data bytes) are converted to either
'           a raster or a dither pattern with 8 X 8 dots. These 8 point rows
'           are scanned to check how many different bytes there are. If there
'           less than half a line, the line is run-length encoded. The lines
'           are than written as printer data in HP PCL Level III language.
'-----------------------------------------------------------------------------
'
sub LinCGE(CCG%(),PRes%,X$,X1%,Y1%)
  local F%,N%,Y%,X%,A%,B%,C%,D%,K%,P$,Z$
  X$ = rtrim$(ltrim$(str$(X1%)))
  Y$ = rtrim$(ltrim$(str$(Y1%)))
  print# %UnitPCL, chr$(27);"E";chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p";X$;"x";Y$;"Y";chr$(27);"*t300R";
  print# %UnitPCL, chr$(27);"*r512S";chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(37%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Y% = csrlin
  X% = pos(Y%)
  P$ = space$(576)
  call VarUP(%False)
  for F% = 0 to 54
    locate Y%,X%
    print using "####";F%+1;
    A% = F% * 64
    call OnePCL(CCG%(1),A%,P$,PRes%)
    for N% = 0 to 7
      D% = N% * 64
      call RLEscn(P$,D%,C%)
      if K% and (C% < 32) then
	call RLElin(P$,D%,C%)
	Z$ = ltrim$(rtrim$(str$(C%)))
	print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,513,C%);
      else
	print# %UnitPCL, chr$(27);"*b0m64W";mid$(P$,D%+1,64);
      end if
    next N%
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  call VarUP(%True)
  color %Cyan,%Black
  locate Y%,X%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE writes data to PCL-file. The file is assumed to be open.
'           Each data line (55 times 64 data bytes) are converted to either
'           a raster or a dither pattern with 4 X 4 dots. These 4 point rows
'           are scanned to check how many different bytes there are. If there
'           less than half a line, the line is run-length encoded. The lines
'           are than written as printer data in HP PCL Level III language.
'-----------------------------------------------------------------------------
'
sub SmlCGE(CCG%(),PRes%,X%,Y%)
  local F%,N%,Z%,V%,A%,B%,C%,D%,K%,P$,X$,Y$,Z$
  X$ = rtrim$(ltrim$(str$(X%)))
  Y$ = rtrim$(ltrim$(str$(Y%)))
  print# %UnitPCL, chr$(27);"E";chr$(27);"&l26A";      'Select A4!
  print# %UnitPCL, chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p";X$;"x";Y$;"Y";chr$(27);"*t300R";
  print# %UnitPCL, chr$(27);"*r256S";chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(38%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Z% = csrlin
  V% = pos(Z%)
  P$ = space$(192)
  call VarPP(%False)
  for F% = 0 to 54
    locate Z%,V%
    print using "####";F%+1;
    A% = F% * 64
    call LitPCL(CCG%(1),A%,P$,PRes%)
    for N% = 0 to 3
      D% = N% * 32
      call LitScn(P$,D%,C%)
      if K% and (C% < 16) then
	call LitLin(P$,D%,C%)
	Z$ = ltrim$(rtrim$(str$(C%)))
	print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,129,C%);
      else
	print# %UnitPCL, chr$(27);"*b0m32W";mid$(P$,D%+1,32);
      end if
    next N%
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  call VarPP(%True)
  color %Cyan,%Black
  locate Z%,V%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE writes DotoGram to PCL file at position X, Y with resolution R=300
'-----------------------------------------------------------------------------
'
sub PCLDot(CCD%(),X%,Y%,R%)
  local F%,Z%,V%,C%,K%,P$,X$,Y$,Z$,R$
  X$ = rtrim$(ltrim$(str$(X%)))
  Y$ = rtrim$(ltrim$(str$(Y%)))
  R$ = rtrim$(ltrim$(str$(R%)))
  print# %UnitPCL, chr$(27);"E";chr$(27);"&l26A";      'Select A4!
  print# %UnitPCL, chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p";X$;"x";Y$;"Y";chr$(27);"*t";R$;"R";
  print# %UnitPCL, chr$(27);"*r776S";chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(38%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Z% = csrlin
  V% = pos(Z%)
  P$ = string$(400,chr$(0))
  if K% then
    print# %UnitPCL, chr$(27);"*b1m4W";chr$(95,255,0,248);
  else
    print# %UnitPCL, chr$(27);"*b0m97W";string$(96,chr$(255));chr$(248);
  end if
  for F% = 1 to 348
    locate Z%,V%
    print using "####";F%+1;
    C% = F% * 40 + 1
    call DotPCL(P$,CCD%(C%))
    C% = 97
    call DotScn(P$,C%)
    if K% and (C% < 48) then
      C% = 97
      call DotRLE(P$,C%)
      Z$ = ltrim$(rtrim$(str$(C%)))
      print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,201,C%);
    else
      print# %UnitPCL, chr$(27);"*b0m97W";left$(P$,97);
    end if
    if K% then
      print# %UnitPCL, chr$(27);"*b1m6W";chr$(0,128,94,0,0,8);
    else
      print# %UnitPCL, chr$(27);"*b0m97W";
      print# %UnitPCL, chr$(128);string$(95,chr$(0));chr$(8);
    end if
  next F%
  P$ = ""
  if K% then
    print# %UnitPCL, chr$(27);"*b1m4W";chr$(95,255,0,248);
  else
    print# %UnitPCL, chr$(27);"*b0m97W";string$(96,chr$(255));chr$(248);
  end if
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  color %Cyan,%Black
  locate Z%,V%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE writes Profil to PCL file at position X, Y with resolution R=300
'           If TnyFlg% = True, image is 5 X 3 cm, otherwise it is doubled.
'-----------------------------------------------------------------------------
'
sub PCLPro(CCD%(),X%,Y%,R%,TnyFlg%)
  local A%,F%,Z%,V%,C%,K%,A$,P$,X$,Y$,Z$,R$
  X$ = rtrim$(ltrim$(str$(X%)))
  Y$ = rtrim$(ltrim$(str$(Y%)))
  R$ = rtrim$(ltrim$(str$(R%)))
  print# %UnitPCL, chr$(27);"E";chr$(27);"&l26A";      'Select A4!
  print# %UnitPCL, chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p";X$;"x";Y$;"Y";chr$(27);"*t";R$;"R";
  print# %UnitPCL, chr$(27);"*";
  if TnyFlg% then
    print# %UnitPCL, "592S";
    A% =  74
    A$ = "74"
  else
    print# %UnitPCL, "1184S";
    A% =  148
    A$ = "148"
  end if
  print# %UnitPCL, chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(38%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Z% = csrlin
  V% = pos(Z%)
  P$ = string$(400,chr$(0))
  for F% = 0 to 349
    locate Z%,V%
    print using "####";F%+1;
    C% = F% * 40 + 1
    call ProPCL(P$,CCD%(C%),TnyFlg%)
    C% = A%
    call DotScn(P$,C%)
    if K% and (C% < A%) then
      C% = A%
      call DotRLE(P$,C%)
      Z$ = ltrim$(rtrim$(str$(C%)))
      print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,201,C%);
    else
      print# %UnitPCL, chr$(27);"*b0m";A$;"W";left$(P$,A%);
    end if
    if not TnyFlg% then
      if K% then
	print# %UnitPCL, chr$(27);"*b1m6W";chr$(0,128,145,0,0,8);
      else
	print# %UnitPCL, chr$(27);"*b0m148W";
	print# %UnitPCL, chr$(128);string$(146,chr$(0));chr$(8);
      end if
    end if
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  color %Cyan,%Black
  locate Z%,V%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE writes Isophotes to PCL file at position X, Y with resolution R=300
'           If TnyFlg% = True, image is 5 X 3 cm, otherwise it is doubled.
'-----------------------------------------------------------------------------
'
sub PCLIso(CCD%(),X%,Y%,R%,TnyFlg%,ILFlg%)
  local A%,F%,Z%,V%,C%,K%,A$,P$,X$,Y$,Z$,R$
  X$ = rtrim$(ltrim$(str$(X%)))
  Y$ = rtrim$(ltrim$(str$(Y%)))
  R$ = rtrim$(ltrim$(str$(R%)))
  print# %UnitPCL, chr$(27);"E";chr$(27);"&l26A";      'Select A4!
  print# %UnitPCL, chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p";X$;"x";Y$;"Y";chr$(27);"*t";R$;"R";
  print# %UnitPCL, chr$(27);"*";
  if TnyFlg% then
    print# %UnitPCL, "200S";
    A% =  25
    A$ = "25"
    B% = 166
  else
    print# %UnitPCL, "400S";
    A% =  50
    A$ = "50"
    B% = 166
  end if
  if ILFlg% then
    A% =  48
    A$ = "48"
    B% = 329
  end if
  print# %UnitPCL, chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(38%))
  color %Cyan,%Black
  print SLText$(5%);
  color %LCyan,%Black
  Z% = csrlin
  V% = pos(Z%)
  P$ = string$(400,chr$(0))
  for F% = 0 to B%
    locate Z%,V%
    print using "####";F%+1;
    C% = F% * 40 + 1
    if not ILFlg% then
      call IsoPCL(P$,CCD%(C%),TnyFlg%)
    else
      call IsoIso(P$,CCD%(C%))
    end if
    C% = A%
    call DotScn(P$,C%)
    if K% and (C% < A%) then
      C% = A%
      call DotRLE(P$,C%)
      Z$ = ltrim$(rtrim$(str$(C%)))
      print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,201,C%);
    else
      print# %UnitPCL, chr$(27);"*b0m";A$;"W";left$(P$,A%);
    end if
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  color %Cyan,%Black
  locate Z%,V%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE converts a BYT image into the body of a PCX image
'-----------------------------------------------------------------------------
'
sub BytPcx(CCP%())
  local A%,Y%,X%,F%,C%,P$
  color %Cyan,%Black
  print SLText$(48%);
  color %LCyan,%Black
  Y% = csrlin
  X% = pos(Y%)
  P$ = string$(384,chr$(0))
  for F% = 0 to 164
    locate Y%,X%
    print using "####";F%+1;
    A% = F% * 96 + 1
    C% = 192
    call ToRLLE(P$,CCP%(A%),C%)
    print# %UnitI00, left$(P$,C%);
  next F%
  P$ = ""
  color %Cyan,%Black
  locate Y%,X%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE converts three BYT images into the body of a color PCX image
'-----------------------------------------------------------------------------
'
sub RGBPCX(CCD%(),CCP%(),CCI%())
  local A%,Y%,X%,F%,C%,P$
  color %Cyan,%Black
  print SLText$(48%);
  color %LCyan,%Black
  Y% = csrlin
  X% = pos(Y%)
  P$ = string$(384,chr$(0))
  for F% = 0 to 164
    A% = F% * 96 + 1
    locate Y%,X%
    print using "####";F%+1;
    C% = 192
    call ToRLLE(P$,CCD%(A%),C%)
    print# %UnitI00, left$(P$,C%);
    C% = 192
    call ToRLLE(P$,CCP%(A%),C%)
    print# %UnitI00, left$(P$,C%);
    C% = 192
    call ToRLLE(P$,CCI%(A%),C%)
    print# %UnitI00, left$(P$,C%);
  next F%
  P$ = ""
  color %Cyan,%Black
  locate Y%,X%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE Arranges byte planes for 24-bit PCX and TIFF images
'----------------------------------------------------------------------------
'
sub MakeRGB(CCB%(),CCD%(),CCI%(),CCP%(),Z$,F$)
  print
  color %Cyan,%Black
  print SLText$(26%);
  print " ";Z$;" ";
  call XDimBA(CCB%(1),CCD%(1),165%,192%)
  call CpyW2W(CCD%(1),CCB%(1),%LMN/2)
  call XDimBA(CCB%(1),CCP%(1),165%,192%)
  call CpyW2W(CCP%(1),CCB%(1),%LMN/2)
  call XDimBA(CCB%(1),CCI%(1),165%,192%)
  call CpyW2W(CCI%(1),CCB%(1),%LMN/2)
  F$ = SLText$(46%) + Z$
end sub
'
'
' PROCEDURE converts a DOT image into the body of a PCX image
'-----------------------------------------------------------------------------
'
sub DotPcx(CCD%())
  local A%,Y%,X%,F%,C%,P$
  color %Cyan,%Black
  print SLText$(48%);
  color %LCyan,%Black
  Y% = csrlin
  X% = pos(Y%)
  P$ = string$(160,chr$(0))
  for F% = 0 to 349
    locate Y%,X%
    print using "####";F%+1;
    A% = F% * 40 + 1
    C% = 80
    call ToRLLE(P$,CCD%(A%),C%)
    print# %UnitI00, left$(P$,C%);
  next F%
  P$ = ""
  color %Cyan,%Black
  locate Y%,X%
  print using "####";F%;
  print " "
  color %White,%Black
end sub
'
'
' PROCEDURE converts an image into 4 bit planes. If F% false then CGE file
'----------------------------------------------------------------------------
'
sub Make4Planes(CCA%(),CCB%(),CCD%(),CCG%(),CCI%(),CCP%(),F%)
  local X%,Y%
  color %Cyan,%Black
  print SLText$(65%);
  Y% = csrlin
  X% = pos(Y%)
  color %LCyan,%Black
  if istrue F% then call CpyW2W(CCB%(1),CCP%(1),%LMN/2)
  locate Y%,X%
  print " 1";
  if istrue F% then
    call Make4B(CCA%(1),CCB%(1), 16%)
  else
    call VarPP(%False)
    call Make4B(CCA%(1),CCG%(1), 16%)
  end if
  locate Y%,X%
  print " 2";
  if istrue F% then
    call Make4B(CCP%(1),CCB%(1), 32%)
  else
    call Make4B(CCP%(1),CCG%(1), 32%)
  end if
  locate Y%,X%
  print " 3";
  if istrue F% then
    call Make4B(CCD%(1),CCB%(1), 64%)
  else
    call Make4B(CCD%(1),CCG%(1), 64%)
  end if
  locate Y%,X%
  print " 4";
  if istrue F% then
    call Make4B(CCI%(1),CCB%(1),128%)
  else
    call Make4B(CCI%(1),CCG%(1),128%)
    call VarPP(%True)
  end if
  color %Cyan,%Black
  locate Y%,X%
  print " 4";
  color %LCyan,%Black
  print " "
end sub
'
'
' PROCEDURE expects PCX-file open and reads head of 128 bytes and returns:
'           PXH%( 0) = Identifier for ZSoft PCX: 10
'               ( 1) = V.2.5 = 0, V2.8 = 2 or 3, V.3.00 = 5
'               ( 2) = RLLE-Flag; 0 = no compression, 1 = RLLE
'               ( 3) = Bits per Pixel (or per plane)
'               ( 4) = XMin
'               ( 5) = YMin
'               ( 6) = XMax
'               ( 7) = YMax
'               ( 8) = Dots/Inch Horizontal
'               ( 9) = Dots/Inch Vertical
'               (10) = Color Planes
'               (11) = Bytes/Line (must be even!)
'               (12) = Palette; 1 = Color & BW, 2 = Grayscales
'-----------------------------------------------------------------------------
'
sub AnaHead(PXH%(),R$,P$)
  local X%,Y%
  PXH%( 0) = asc(left$(R$,1))	'ZSoft Ident
  PXH%( 1) = asc(mid$(R$,2,1))	'Version
  PXH%( 2) = asc(mid$(R$,3,1))	'RLLE-Flag
  PXH%( 3) = asc(mid$(R$,4,1))	'Bits/Pixel
  PXH%( 4) = StrInt%(R$, 5%)	'XMin
  PXH%( 5) = StrInt%(R$, 7%)	'YMin
  PXH%( 6) = StrInt%(R$, 9%)	'XMax
  PXH%( 7) = StrInt%(R$,11%)	'YMax
  PXH%( 8) = StrInt%(R$,13%)	'dots per inch horizontal
  PXH%( 9) = StrInt%(R$,15%)	'dots per inch vertical
  PXH%(10) = asc(mid$(R$,66,1))	'number of planes
  PXH%(11) = StrInt%(R$,67%)	'Bytes per line
  PXH%(12) = StrInt%(R$,69%)	'palette data
  P$ = mid$(R$,17,48)		'standard palette map
end sub
'
'
' PROCEDURE displays PCX head
'-----------------------------------------------------------------------------
'
sub DispHead(PXH%(),A$,V$)
  local N%,X%,Y%,R$
  X% = 19
  print LogOn$(V$,%White,%Red)
  if len(A$) > 60 then A$ = right$(A$,60)
  color %Green,%Black
  Y% = csrlin
  call MLText(16%,0,"tf")
  color %LGreen,%Black
  locate Y%,X%
  print A$
  locate Y%+1,X%
  if PXH%(0) = 10 then
    print "Format PCX ZSoft"
  else
    print "(?) ";PXH%(0)
  end if
  locate Y%+2,X%
  select case PXH%(1)
    case 0
      print "2.5"
    case 2
      print "2.8 ";SLText$(53%);" ";SLText$(7%)
    case 3
      print "2.8 ";SLText$(54%);" ";SLText$(7%)
    case 5
      print "3.0"
    case else
      print "?"
  end select
  locate Y%+3,X%
  N% = 53
  if PXH%(2) = 0 then incr N%
  print SLText$(N%)
  locate Y%+4,X%
  print using "###";PXH%(3)
  for N% = 4 to 11
    locate Y%+N%+1,X%
    print using "###";PXH%(N%)
  next N%
  locate Y%+13,X%
  select case PXH%(12)
    case 1
      print SLText$(55%)
    case 2
      print SLText$(56%)
    case else
      print "?"
  end select
  print
end sub
'
'
' PROCEDURE reads and converts PCX data. Result is in
'           CCA% for plane 1 (red)
'           CCP% for plane 2 (green)
'           CCD% for plane 3 (blue)
'           CCI% for plane 4 (intensity)
'----------------------------------------------------------------------------
'
sub ConvtPCX(CCA%(),CCP%(),CCD%(),CCI%(),PXH%(),PLF&)
  local CP%,C%,N%,F%,V%,W%,X%,Y%,Z%,R$
  color %Cyan,%Black
  CP% = 0
  F% = PXH%(7) - PXH%(5) + 1
  if F% > 165 then F% = 165
  if PXH%(2) = 0 then			'-- not RLLE
    print SLText$(57%);
    Y% = csrlin
    X% = pos(Y%)
    color %LCyan,%Black
    for N% = 1 to F%
      locate Y%,X%
      print using "####";N%
      get$ # %UnitAUX, PXH%(11), R$
      D$ = Str192$(R$)
      call InsByt(CCA%(1),CP%,PXH%(11),D$)
      if PXH%(10) > 1 then
	get$ # %UnitAUX, PXH%(11), R$
	D$ = Str192$(R$)
	call InsByt(CCP%(1),CP%,PXH%(11),D$)
	if PXH%(10) > 2 then
	  get$ # %UnitAUX, PXH%(11), R$
	  D$ = Str192$(R$)
	  call InsByt(CCD%(1),CP%,PXH%(11),D$)
	  if PXH%(10) > 3 then
	    get$ # %UnitAUX, PXH%(11), R$
	    D$ = Str192$(R$)
	    call InsByt(CCI%(1),CP%,PXH%(11),D$)
	  end if
	end if
      end if
      CP% = CP% + 192
    next N%
  else					'-- RLLE
    print SLText$(58%);
    Y% = csrlin
    X% = pos(Y%)
    color %LCyan,%Black
    for N% = 1 to F%
      locate Y%,X%
      print using "####";N%
      call DeRLLE(PXH%(),D$)
      call InsByt(CCA%(1),CP%,PXH%(11),D$)
      if PXH%(10) > 1 then
	call DeRLLE(PXH%(),D$)
	call InsByt(CCP%(1),CP%,PXH%(11),D$)
	if PXH%(10) > 2 then
	  call DeRLLE(PXH%(),D$)
	  call InsByt(CCD%(1),CP%,PXH%(11),D$)
	  if PXH%(10) > 3 then
	    call DeRLLE(PXH%(),D$)
	    call InsByt(CCI%(1),CP%,PXH%(11),D$)
	  end if
	end if
      end if
      CP% = CP% + 192
    next N%
  end if
end sub
'
'
' PROCEDURE checks for PCX 3 and valid Palette data. If any, gets it.
'           Assumes PCX-File to be open
'----------------------------------------------------------------------------
'
sub ExtPalDat(FulPal$,FPF%)
  local A$
  FPF% = %False				'-- full palette flag
  seek# %UnitAUX, lof(%UnitAUX) - 769
  get$# %UnitAUX, 1, A$
  if asc(A$) = 12 then
    get$# %UnitAUX, 768, FulPal$
    FPF% = %True
  end if
end sub
'
'
' PROCEDURE expands/decodes one PCX line from RLLE compression
'----------------------------------------------------------------------------
'
sub DeRLLE(PXH%(),D$)
  local A%,Z%,V%,W%,A$,R$
  D$ = ""
  W% = 0
  do
    get$ # %UnitAux, 1, R$
    A% = asc(R$)
    Z% = BitAnd%(A%,192%)
    V% = BitAnd%(A%, 63%)
    if Z% = 192 then
      get$ # %UnitAUX, 1, R$
      W% = W% + V%
      A$ = A$ + string$(V%,R$)
    else
      incr W%
      A$ = A$ + R$
    end if
    if W% = PXH%(11) then exit loop
  loop
  D$ = Str192$(A$)
end sub
'
'
' PROCEDURE expands picture data with 1 bit per pixel
'----------------------------------------------------------------------------
'
sub Xpand(CCB%(),CCA%(),CCP%(),CCD%(),CCI%())
  call FreAry(CCB%(1),CCA%(1))
  call BitByt(CCA%(1),CCB%(1),16%)
  call FreAry(CCB%(1),CCP%(1))
  call BitByt(CCP%(1),CCB%(1),32%)
  call FreAry(CCB%(1),CCD%(1))
  call BitByt(CCD%(1),CCB%(1),64%)
  call FreAry(CCB%(1),CCI%(1))
  call BitByt(CCI%(1),CCB%(1),128%)
  call ORWAS(CCA%(1),CCP%(1),%LMN/2)
  call ORWAS(CCA%(1),CCD%(1),%LMN/2)
  call ORWAS(CCA%(1),CCI%(1),%LMN/2)
end sub
'
'
' PROCEDURE gets coordinates for table files. X1/Y1 top-left, X2/Y2 bottom-
'           right, X0 and Y0 size. Not possible on DOT-files.
'-----------------------------------------------------------------------------
'
sub GetCoords(X1%,Y1%,X2%,Y2%,X0%,Y0%,A%)
  local V$,T$
  if A% = 2 then
    call IllOpt(1%)
    call IllOpt(3%)
    call IllOpt(4%)
    X0% = 0
    Y0% = 0
    exit sub
  end if
  V$ = " {vector} (1...192): "
  T$ = " {tuple}  (1...165): "
  X1% = IntLmt%(1%,192%,SelOpt%(SLText$(66%) + V$))
  Y1% = IntLmt%(1%,165%,SelOpt%(SLText$(67%) + T$))
  X2% = IntLmt%(1%,192%,SelOpt%(SLText$(68%) + V$))
  Y2% = IntLmt%(1%,165%,SelOpt%(SLText$(69%) + T$))
  X0% = IntLmt%(1%,192%,X2%-X1%+1)
  Y0% = IntLmt%(1%,165%,Y2%-Y1%+1)
end sub
'
'
' PROCEDURE writes head of DIF and SDI files. C$ has version for DIF, X0%
'           vector counter and Y0% tuples counter
'-----------------------------------------------------------------------------
'
sub DSHead(C$,X0%,Y0%)
  local V$,T$,A$
  A$ = chr$(34,34)
  V$ = ltrim$(rtrim$(str$(X0%)))
  T$ = ltrim$(rtrim$(str$(Y0%)))
  print# %UnitI00, "TABLE"
  print# %UnitI00, "0,1"
  print# %UnitI00, C$
  print# %UnitI00, "VECTORS"
  print# %UnitI00, "0,";V$
  print# %UnitI00, A$
  print# %UnitI00, "TUPLES"
  print# %UnitI00, "0,";T$
  print# %UnitI00, A$
  if C$ = A$ then
    print# %UnitI00, "GDISP-FORMAT"
    print# %UnitI00, "3,0"
    print# %UnitI00,"IR"
  end if
  print# %UnitI00, "DATA"
  print# %UnitI00, "0,0"
  print# %UnitI00, A$
end sub
'
'
' PROCEDURE writes head of SYLK file. C$ has version, X0% vector counter and
'           Y0% tuples counter
'-----------------------------------------------------------------------------
'
sub SYHead(C$,X0%,Y0%)
  local V$,T$,A$
  A$ = chr$(34,34)
  V$ = ltrim$(rtrim$(str$(X0%)))
  T$ = ltrim$(rtrim$(str$(Y0%)))
  print# %UnitI00, "ID;P";C$
  print# %UnitI00, "B;Y";T$;";X";V$
  print# %UnitI00, "F;W1 ";V$;" 3"
  print# %UnitI00, "NN;NDataBase;ER1C1:R";T$;"C";V$
end sub
'
'
' PROCEDURE writes head of CAL file.
'-----------------------------------------------------------------------------
'
sub CALHead
  local A$
  A$ = string$(768,chr$(0))
  mid$(A$,1,22) = "SuperCalc ver.  1.07" + chr$(13,10)
  mid$(A$,103,1) = chr$(26)
  mid$(A$,488,1) = chr$(1)
  mid$(A$,494,4) = chr$(1,1,21,80)
  mid$(A$,515,3) = chr$(9,1,4)
  mid$(A$,545,2) = chr$(2,1)
  print# %UnitI00, A$;
end sub
'
'
' PROCEDURE assembles and writes FITS head, assuming file open
'----------------------------------------------------------------------------
'
sub FitsHead(FH$())
  local N%,C$,D$
  C$ = ""
  for N% = 1 to 8
    C$ = C$ + left$(FH$(N%)+space$(80),80)
  next N%
  C$ = C$ + left$(FH$(9)+SLText$(82%)+" BYR/BYG/BYB'"+space$(80),80)
  for N% = 11 to 16
    C$ = C$ + left$(FH$(10)+FH$(N%)+space$(80),80)
  next N%
  D$ = left$(C$+"END"+space$(2880),2880)
  C$ = ""
  put$ # %UnitI00, D$
  D$ = ""
end sub
'
'
'================================-<930212>-===========-<HoroSoft>-============
'
