'960408 1458
'****************************************************************************
'* PROGRAM NAME: CCDPSUB .INC   DATE: 12. 2.1993   INCLUDE IN: CCDPRINT.BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Option Subroutines - Main-Program Extensions.                   *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.04   8-APR-96, removed Logo, now in CLRSCRN.PBL               *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03  10-FEB-96, Added Setup for HoroSoft Logo                  *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02   1-JUN-94, Added compression efficiency for Byte-save     *
'*                and introduced Version CCDPSubV% = 102                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01  10-FEB-94, Added TIFF write                               *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  12-FEB-93, 1-JUN-93, 31-DEC-93                            *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDPSubV% = 104
'
'
goto CCDPSUB            'Include file - skip over this
'
' SUBROUTINES
'============================================================================
'
' Option-A: Writing as 8 X 8 PCL file, either on top or on bottom of page.
'----------------------------------------------------------------------------
'
OptA:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
Z$ = FilExt$(%UnitP00)
do
  PRes% = %False
  print LogOn$(Version$,%White,%Red)
  color %LCyan,%Black
  print Center$(SLText$(28%),80)
  color %Cyan,%Black
  call MLText(4%,12%,"tf")
  A% = Prompt%(64%,Q$)
  select case Q$
    case "1"
      PRes% = 252
    case "2"
      PRes% = 248
    case "3"
      PRes% = 240
    case "4"
      PRes% = 224
    case chr$(13)
      color %LCyan,%Black
      print "2"
      PRes% = 248
    case else
      print Outch$(Q$)
  end select
loop while PRes% = %False
print
color %Cyan,%Black
if Confirm%(SLText$(2%)) then PRes% = PRes% + 256
if Confirm%(SLText$(3%)) then X$ = "70" else X$ = "1618"
if FileHere%(PCLFil$ + Z$) then
  Fatal$ = SLText$(84%)
  color %LWhite,%Red
  print SLText$(83%)
  if Confirm%(SLText$(84%)) then kill PCLFil$+Z$ else return NoJob
end if
open PCLFil$ + Z$ for output as # %UnitPCL
call LinPCL(CCP%(),PRes%,X$)
close %UnitPCL
color %Cyan,%Black
W$ = SLText$(17%)
if X$ = "1618" then W$ = SLText$(25%)
color %Cyan,%Black
print SLText$(4%);PCLFil$;Z$;W$
print
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Option-B: Writing as 4 X 4 PCL file, either on top or on bottom of page.
'----------------------------------------------------------------------------
'
OptB:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
print LogOn$(Version$,%White,%Red)
call GetSmal(FilExt$(),PCLFil$,Z$,MI!,5%,6%,%True,X%,Y%,PRes%)
call SmlPCL(CCP%(),PRes%,X%,Y%)
call PutSmal(FilExt$(),PCLFil$,Z$,MI!,X%,Y%,768%,660%)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Option-C  Checks for valid DOT-Typ and deviates to D - I or P Large
'-----------------------------------------------------------------------------
'
OptC:
'
if not Menu1% = 2 then
  call IllOpt(61%)
  return
end if
print LogOn$(Version$,%White,%Brown)
print Describe$
select case DotoTyp$
  case "D"
    goto OptCD
  case "I"
    goto OptCI
  case "P"
    goto OptCP
end select
call Illegal(DotoTyp$,SLText$(1%))
return
'
'
' Sub Option-CD  handles large Dotogramms
'-----------------------------------------------------------------------------
'
OptCD:
'
call GetLarg(FilExt$(),PCLFil$,Z$,W$,PRes%,X%,Y%,%True)
if X% then X% =  420 else X% = 30
if Y% then Y% = 1540 else Y% =  0
call PCLDot(CCD%(),X%,Y%,PRes%)
call PutLarg(FilExt$(),PCLFil$,Z$,W$)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Sub Option-CI  handles large Isophotes
'-----------------------------------------------------------------------------
'
OptCI:
'
call GetLarg(FilExt$(),PCLFil$,Z$,W$,PRes%,X%,Y%,%False)
PRes% = 75
if X% then X% =  420 else X% = 30
if Y% then Y% = 1540 else Y% =  0
call PCLIso(CCD%(),X%,Y%,PRes%,%False,%True)
call PutLarg(FilExt$(),PCLFil$,Z$,W$)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Sub Option-CP  handles large Profil
'-----------------------------------------------------------------------------
'
OptCP:
'
print
TnyFlg% = Confirm%(SLText$(42%))
call GetLarg(FilExt$(),PCLFil$,Z$,W$,PRes%,X%,Y%,%False)
if TnyFlg% then
  PRes% = 100
  X%    = 300
else
  PRes% = 150
  X%    =   0
end if
if Y% then Y% = 1530 else Y% = 0
call PCLPro(CCD%(),X%,Y%,PRes%,TnyFlg%)
call PutLarg(FilExt$(),PCLFil$,Z$,W$)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Option-D  Checks for valid DOT-Typ and deviates to D - I or P for Small
'-----------------------------------------------------------------------------
'
OptD:
'
if not Menu1% = 2 then
  call IllOpt(61%)
  return
end if
select case DotoTyp$
  case "D"
    goto OptDD
  case "I"
    goto OptDI
  case "P"
    goto OptDP
end select
beep
W% = Confirm%(SLText$(1%))
return
'
'
' Sub Option-DD  handles small Dotogramms
'-----------------------------------------------------------------------------
'
OptDD:
'
print LogOn$(Version$,%White,%Brown)
call GetSmal(FilExt$(),PCLFil$,Z$,MI!,5%,7%,%False,X%,Y%,PRes%)
call PCLDot(CCD%(),X%,Y%,300%)
call PutSmal(FilExt$(),PCLFil$,Z$,MI!,X%,Y%,786%,696%)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Sub Option-DI  handles small Isophotes
'-----------------------------------------------------------------------------
'
OptDI:
'
do
  Print LogOn$(Version$,%White,%Brown)
  print Describe$
  color %LCyan,%Black
  print Center$(SLText$(43%),80)
  color %Cyan,%Black
  call MLText(15%,23%,"tf")
  Y% = csrlin - 1
  Z% = Prompt%(56%,Q$)
  A% = %False
  select case Z%
    case 1
      TnyFlg% = %True
      ILFlg%  = %False
      PRes%   = 300
      A% =   10
      B% =  194
      C% =  167
      X% = 2206
      Y% = 3106
    case 2
      TnyFlg% = %False
      ILFlg%  = %True
      PRes%   = 300
      A% =   11
      B% =  388
      C% =  334
      X% = 2012
      Y% = 2866
    case 3
      TnyFlg% = %True
      ILFlg%  = %False
      PRes%   = 100
      A% =   12
      B% =  582
      C% =  498
      X% = 1902
      Y% = 2702
    case 4
      TnyFlg% = %True
      ILFlg%  = %True
      PRes%   = 150
      A% =   13
      B% =  776
      C% =  656
      X% = 1624
      Y% = 2544
    case 5
      TnyFlg% = %True
      ILFlg%  = %True
      PRes%   = 100
      A% =   14
      B% = 1157
      C% =  986
      X% = 1243
      Y% = 2214
    case else
      print Outch$(Q$)
  end select
loop while A% = %False
print LogOn$(Version$,%White,%Brown)
color %Cyan,%Black
call GetSmal(FilExt$(),PCLFil$,Z$,MI!,5%,A%,%False,X%,Y%,PRes%)
call PCLIso(CCD%(),X%,Y%,PRes%,TnyFlg%,ILFlg%)
call PutSmal(FilExt$(),PCLFil$,Z$,MI!,X%,Y%,B%,C%)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Sub Option-DP  handles small Profil
'-----------------------------------------------------------------------------
'
OptDP:
'
print LogOn$(Version$,%White,%Brown)
TnyFlg% = Confirm%(SLText$(42%))
if TnyFlg% then
  A% =    8
  B% =  592
  C% =  350
  X% = 2102
  Y% = 2917
else
  A% =    9
  B% = 1184
  C% =  700
  X% = 1276
  Y% = 2575
end if
call GetSmal(FilExt$(),PCLFil$,Z$,MI!,5%,A%,%False,X%,Y%,PRes%)
call PCLPro(CCD%(),X%,Y%,300%,TnyFlg%)
call PutSmal(FilExt$(),PCLFil$,Z$,MI!,X%,Y%,B%,C%)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Option-E creates an 8 x 8 PCL file from a CGE image (EF%=19)
' Option-F creates a  4 x 4 PCL file from a CGE image (EF%=18)
'----------------------------------------------------------------------------
'
OptEF:
'
if not Menu1% = 5 then
  call IllOpt(78%)
  return
end if
print LogOn$(Version$,%White,%Red)
call GetSmal(FilExt$(),PCLFil$,Z$,MI!,5%,EF%,%True,X%,Y%,PRes%)
if EF% = 19 then
  PRes% = PRes% + 240
  call LinCGE(CCG%(),PRes%,X$,X%,Y%)
else
  call SmlCGE(CCG%(),PRes%,X%,Y%)
end if
call PutSmal(FilExt$(),PCLFil$,Z$,MI!,X%,Y%,256%,220%)
call HCNow(FilExt$(),PCLFil$,Z$)
return
'
'
' Option-G converts a PCX file to a BYT file (BYP=PCX, BYC=Composite-PCX)
'-----------------------------------------------------------------------------
'
OptG:
'
if Menu1% < 3 then
  call IllOpt(62%)
  return
end if
print
A$ = Z$
print SLText$(59%);" ";A$;
A% = EncBie%(CCB%(1),CCA%(1),31680??)
Z! = A% * 100 / 31680
if FileHere%(A$) then
  Fatal$ = SLText$(84%)
  color %LWhite,%Red
  print SLText$(83%)
  if Confirm%(SLText$(84%)) then kill Z$ else return NoJob
end if
open A$ for binary as # %UnitRGB
Handle% = fileattr(%UnitRGB,2)
A% = WrBie(CCB%(1),Handle%)
close %UnitRGB
if not A% then
  print " (";ltrim$(rtrim$(str$(fix(Z!))));"%) "
else
  print "??";A%
end if
return
'
'
' Option-H creates from BYT file a 16 color PCX file
'-----------------------------------------------------------------------------
'
OptH:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
print
Z$ = PCXFil$ + FilExt$(%UnitI00)
color %Cyan,%Black
A% = Confirm%(SLText$(64%))
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
H1$ = PCXHead$(5)
if A% then
  H2$ = PCXHead$(3)
  mid$(H1$,17,48) = mid$(H2$,17,48)
  H2$ = ""
end if
print# %UnitI00, H1$;
color %LCyan,%Black
print " "
call Make4Planes(CCA%(),CCB%(),CCD%(),CCG%(),CCI%(),CCP%(),%True)
color %Cyan,%Black
print SLText$(48%);
Y% = csrlin
X% = pos(Y%)
P$ = string$(48,chr$(0))
for F% = 0 to 164
  locate Y%,X%
  print using "####";F%+1;
  A% = F% * 12 + 1
  C% = 24
  call ToRLLE(P$,CCA%(A%),C%)
  print# %UnitI00, left$(P$,C%);
  C% = 24
  call ToRLLE(P$,CCP%(A%),C%)
  print# %UnitI00, left$(P$,C%);
  C% = 24
  call ToRLLE(P$,CCD%(A%),C%)
  print# %UnitI00, left$(P$,C%);
  C% = 24
  call ToRLLE(P$,CCI%(A%),C%)
  print# %UnitI00, left$(P$,C%);
next F%
close %UnitI00
P$ = ""
color %Cyan,%Black
locate Y%,X%
print using "####";F%;
print " "
call CpyW2W(CCP%(1),CCB%(1),%LMN/2)
color %Cyan,%Black
print SLText$(47%);
color %LCyan,%Black
print PCXFil$;Z$
FilExt$(%UnitI00) = IncrExt$(FilExt$(%UnitI00))
delay 1
return
'
'
' Option-I creates from BYT file a PCX file
' Option-K creates from DOT file a PCX file
'-----------------------------------------------------------------------------
'
OptIK:
'
print
if Menu1% = 5 then
  call IllOpt(79%)
  return
end if
Z$ = PCXFil$ + FilExt$(%UnitI00)
Fatal$ = SLText$(46%) + Z$
color %Cyan,%Black
if HT% = 2 then
  if not Menu1% = 2 then
    call IllOpt(61%)
    return
  end if
  if istrue Existing%(Z$,Fatal$) then return NoJob
  open Z$ for output as # %UnitI00
  print# %UnitI00, PCXHead$(HT%);
  color %LCyan,%Black
  print " "
  call DotPcx(CCD%())
else
  if Menu1% = 2 then
    call IllOpt(63%)
    return
  end if
  if istrue Existing%(Z$,Fatal$) then return NoJob
  open Z$ for output as # %UnitI00
  print# %UnitI00, PCXHead$(HT%);
  color %LCyan,%Black
  print " "
  call BytPcx(CCP%())
  print# %UnitI00, PCXFoot$(RGBFlag%);
end if
close %UnitI00
color %Cyan,%Black
print SLText$(47%);
color %LCyan,%Black
print PCXFil$;Z$
delay 1
FilExt$(%UnitI00) = IncrExt$(FilExt$(%UnitI00))
return
'
'
' Option-J creates a 16 color PCX from a CGE file
'----------------------------------------------------------------------------
'
OptJ:
'
if not Menu1% = 5 then
  call IllOpt(78%)
  return
end if
print
Z$ = PCXFil$ + FilExt$(%UnitI00)
color %Cyan,%Black
A% = Confirm%(SLText$(64%))
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
H1$ = PCXHead$(5)
if A% then
  H2$ = PCXHead$(3)
  mid$(H1$,17,48) = mid$(H2$,17,48)
  H2$ = ""
end if
mid$(H1$, 9,3) = chr$(63,0,54)
mid$(H1$,67,1) = chr$(8)
print# %UnitI00, H1$;
color %LCyan,%Black
print " "
call Make4Planes(CCA%(),CCB%(),CCD%(),CCG%(),CCI%(),CCP%(),%False)
print SLText$(48%);
Y% = csrlin
X% = pos(Y%)
P$ = string$(16,chr$(0))
for F% = 0 to 54
  locate Y%,X%
  print using "####";F%+1;
  A% = F% * 4 + 1
  C% = 8
  call ToRLLE(P$,CCA%(A%),C%)
  print# %UnitI00, left$(P$,C%);
  C% = 8
  call ToRLLE(P$,CCP%(A%),C%)
  print# %UnitI00, left$(P$,C%);
  C% = 8
  call ToRLLE(P$,CCD%(A%),C%)
  print# %UnitI00, left$(P$,C%);
  C% = 8
  call ToRLLE(P$,CCI%(A%),C%)
  print# %UnitI00, left$(P$,C%);
next F%
P$ = ""
color %Cyan,%Black
locate Y%,X%
print using "####";F%;
print " "
close %UnitI00
color %Cyan,%Black
print SLText$(47%);
color %LCyan,%Black
print PCXFil$;Z$
delay 1
FilExt$(%UnitI00) = IncrExt$(FilExt$(%UnitI00))
return
'
'
' Option-L creates 4-bit TIFF file from a BYT file
' Option-M creates 8-bit TIFF file from a BYT file
' Option-N creates 4-bit TIFF file from a CGE file
' Option-O creates 8-bit TIFF file from a PCX file
' Option-P creates 1-bit TIFF file from a DOT file
'----------------------------------------------------------------------------
'
OptLMNOP:
'
select case L%
  case 1					'-- 8-bit BYT & PCX
    if (Menu1% = 2) or (Menu1% = 5) then
      call IllOpt(63%)
      return
    end if
    DS% = 31680
  case 2					'-- 4 and 8-bit BYT & PCX
    if (Menu1% = 2) or (Menu1% = 5) then
      call IllOpt(63%)
      return
    end if
    DS% = 15840
  case 3					'-- 4 and 8-bit BYT & PCX
    if (Menu1% = 2) or (Menu1% = 5) then
      call IllOpt(63%)
      return
    end if
    DS% = 3960
  case 4					'-- 4-bit CGE
    if not Menu1% = 5 then
      call IllOpt(78%)
      return
    end if
    DS% = 1760
  case 5					'-- 4-bit CGE
    if not Menu1% = 5 then
      call IllOpt(78%)
      return
    end if
    DS% = 440
  case 6					'-- 1-bit DOT
    if not Menu1% = 2 then
      call IllOpt(61%)
      return
    end if
    DS% = 28000
end select
print
Z$ = TIFFil$ + FilExt$(%UnitT00)
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for binary as # %UnitT00
Handle% = fileattr(%UnitT00,2)
select case L%
  case 1
    put$# %UnitT00, TIFFHead$(VN$,L%)		'1: 192 x 165 BYT & PCX
    A% = WrTiff%(CCP%(1),Handle%,DS%)
  case 2
    put$# %UnitT00, TIFFHead$(VN$,L%)		'2: 192 x 165 BYT & PCX
    call ByteNi(CCP%(1),DS%)
    A% = WrTiff%(CCP%(1),Handle%,DS%)
  case 3
    put$# %UnitT00, TIFFHead$(VN$,L%)		'3: 192 x 165 BYT & PCX
    print
    call Make4Planes(CCA%(),CCB%(),CCD%(),CCG%(),CCI%(),CCP%(),%True)
    A% = Write4Planes%(CCA%(),CCP%(),CCD%(),CCI%(),Handle%,DS%)
  case 4
    put$# %UnitT00, TIFFHead$(VN$,L%)		'4:  64 x  55 CGE
    A% = WrTiff%(CCA%(1),Handle%,DS%)
  case 5
    put$# %UnitT00, TIFFHead$(VN$,L%)		'5:  64 x  55 CGE
    print
    call Make4Planes(CCA%(),CCB%(),CCD%(),CCG%(),CCI%(),CCP%(),%False)
    A% = Write4Planes%(CCA%(),CCP%(),CCD%(),CCI%(),Handle%,DS%)
  case 6					'6: 640 x 350 DOT
    put$# %UnitT00, TIFFHead$(VN$,L%)
    A% = WrTiff%(CCD%(1),Handle%,DS%)
end select
close %UnitT00
if not A% then print " " else print "??";A%
color %Cyan,%Black
print SLText$(75%);
color %LCyan,%Black
print TIFFil$;Z$
FilExt$(%UnitT00) = IncrExt$(FilExt$(%UnitT00))
delay 1
return
'
'
' Option-Q converts a BYT or PCX file into a Comma Separated Value file
' Option-R converts a BYT or PCX file into a System Data Format file
' Option-S converts a BYT or PCX file into a FiXeD file
'----------------------------------------------------------------------------
'
OptQRS:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
call GetCoords(X1%,Y1%,X2%,Y2%,X0%,Y0%,Menu1%)
if X0%+Y0% = 0 then return
select case Q$
  case "I"
    Z$ = PCXFil$ + ".CSV"
    A% = X0% * 4 - 1		'-- Size of line string
  case "J"
    Z$ = PCXFil$ + ".SDF"
    A% = X0% * 3		'-- Size of line string
  case "K"
    Z$ = PCXFil$ + ".FXD"
    A% = X0% * 3		'-- Size of line string
end select
print
color %Cyan,%Black
print SLText$(26%);
print " ";Z$;" ";
if FileHere%(Z$) then
  Fatal$ = SLText$(84%)
  color %LWhite,%Red
  print SLText$(83%)
  if Confirm%(SLText$(84%)) then kill Z$ else return NoJob
end if
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
color %LCyan,%Black
print " "
P% = (X1%-1) * 3 + 1
A$ = string$(A%,chr$(0))
B$ = string$(576,chr$(0))
color %Cyan,%Black
print SLText$(70%);using$("####",X0%);" x";using$("####",Y0%)
print SLText$(57%);
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
for F% = Y1% to Y2%
  locate Y%,X%
  print using("####");F%;
  call BytStr(B$,CCP%(1),F%)
  PB% = P%
  PA% = 1
  if Q$ = "I" then				'-- "H"=CSV
    for N% = 2 to X0%
      mid$(A$,PA%,4) = mid$(B$,PB%,3) + ","
      PA% = PA% + 4
      PB% = PB% + 3
    next N%
    mid$(A$,PA%,3) = mid$(B$,PB%,3)
    print# %UnitI00, A$
  else
    for N% = 1 to X0%				'-- "I"=SDF & "J"=FXD
      mid$(A$,PA%,3) = mid$(B$,PB%,3)
      PA% = PA% + 3
      PB% = PB% + 3
    next N%
    if Q$ = "J" then print# %UnitI00, A$ else print# %UnitI00, A$;
  end if
next F%
close %UnitI00
return
'
'
' Option-T converts a BYT or PCX file into a Standard Interface Format file
'----------------------------------------------------------------------------
'
OptT:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
call GetCoords(X1%,Y1%,X2%,Y2%,X0%,Y0%,Menu1%)
if X0%+Y0% = 0 then return
Z$ = PCXFil$ + ".SIF"
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
color %LCyan,%Black
print " "
print# %UnitI00, ltrim$(rtrim$(str$(Y0%)))
P% = (X1%-1) * 3 + 1
B$ = string$(576,chr$(0))
color %Cyan,%Black
print SLText$(70%);using$("####",X0%);" x";using$("####",Y0%)
print SLText$(57%);
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
for F% = Y1% to Y2%
  locate Y%,X%
  print using("####");F%;
  call BytStr(B$,CCP%(1),F%)
  PB% = P%
  for N% = 2 to X0%
    A$ = mid$(B$,PB%,3) + ","
    PB% = PB% + 3
    print# %UnitI00, A$
  next N%
  A$ = mid$(B$,PB%,3) + ";"
  print# %UnitI00, A$
next F%
close %UnitI00
return
'
'
' Option-U converts a BYT or PCX file into a Data Interchange Format file
' Option-V converts a BYT or PCX file into a Super Data Interchange file
'----------------------------------------------------------------------------
'
OptUV:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
call GetCoords(X1%,Y1%,X2%,Y2%,X0%,Y0%,Menu1%)
if X0%+Y0% = 0 then return
select case Q$
  case "M"
    Z$ = PCXFil$ + ".DIF"
    C$ = chr$(34) + Version$ + chr$(34)
  case "N"
    Z$ = PCXFil$ + ".SDI"
    C$ = chr$(34,34)
end select
print
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
color %LCyan,%Black
print " "
call DSHead(C$,X0%,Y0%)
P% = (X1%-1) * 3 + 1
B$ = string$(576,chr$(0))
color %Cyan,%Black
print SLText$(70%);using$("####",X0%);" x";using$("####",Y0%)
print SLText$(57%);
Y% = csrlin
X% = pos(Y%)
color %LCyan,%Black
for F% = Y1% to Y2%
  locate Y%,X%
  print using("####");F%;
  call BytStr(B$,CCP%(1),F%)
  PB% = P%
  print# %UnitI00, "-1,0"
  print# %UnitI00, "BOT"
  for N% = 1 to X0%
    A$ = "0," + mid$(B$,PB%,3)
    PB% = PB% + 3
    print# %UnitI00, A$
    print# %UnitI00, "V"
  next N%
next F%
print# %UnitI00, "-1,0"
print# %UnitI00, "EOD"
close %UnitI00
return
'
'
' Option-W converts a BYT or PCX file into a CALculation SuperCalc file
'----------------------------------------------------------------------------
'
OptW:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
call GetCoords(X1%,Y1%,X2%,Y2%,X0%,Y0%,Menu1%)
if X0%+Y0% = 0 then return
Z$ = PCXFil$ + ".CAL"
print
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
color %LCyan,%Black
print " "
call CALHead
P% = (X1%-1) * 3 + 1
B$ = string$(576,chr$(0))
color %Cyan,%Black
print SLText$(70%);using$("####",X0%);" x";using$("####",Y0%)
print SLText$(57%);
Y% = csrlin
X% = pos(Y%)
T% = 0
color %LCyan,%Black
for F% = Y1% to Y2%
  locate Y%,X%
  print using("####");F%;
  call BytStr(B$,CCP%(1),F%)
  PB% = P%
  V% = 0
  for N% = 1 to X0%
    A$ = chr$(V%,T%,80,0) + mid$(B$,PB%,3) + chr$(0,0,0)
    print# %UnitI00, A$;
    PB% = PB% + 3
    incr V%
  next N%
  incr T%
next F%
A$ = string$(128,chr$(26))
print# %UnitI00, A$;
close %UnitI00
return
'
'
' Option-X converts a BYT or PCX file into a SYmbolic LinK format file
'----------------------------------------------------------------------------
'
OptX:
'
if (Menu1% = 2) or (Menu1% = 5) then
  call IllOpt(63%)
  return
end if
call GetCoords(X1%,Y1%,X2%,Y2%,X0%,Y0%,Menu1%)
if X0%+Y0% = 0 then return
Z$ = PCXFil$ + ".SLK"
C$ = Version$
print
if istrue Existing%(Z$,Fatal$) then return NoJob
Fatal$ = SLText$(46%) + Z$
open Z$ for output as # %UnitI00
color %LCyan,%Black
print " "
call SYHead(C$,X0%,Y0%)
P% = (X1%-1) * 3 + 1
B$ = string$(576,chr$(0))
color %Cyan,%Black
print SLText$(70%);using$("####",X0%);" x";using$("####",Y0%)
print SLText$(57%);
Y% = csrlin
X% = pos(Y%)
R% = 0
color %LCyan,%Black
for F% = Y1% to Y2%
  locate Y%,X%
  print using("####");F%;
  call BytStr(B$,CCP%(1),F%)
  PB% = P%
  incr R%
  T$ = ltrim$(rtrim$(str$(R%)))
  print# %UnitI00, "C;Y";T$
  for N% = 1 to X0%
    V$ = ltrim$(rtrim$(str$(N%)))
    A$ = "C;X" + V$ + ";K" + mid$(B$,PB%,3)
    PB% = PB% + 3
    print# %UnitI00, A$
  next N%
next F%
print# %UnitI00, "E"
close %UnitI00
return
'
'
' GENERAL SUBROUTINES
'============================================================================
'
' SUBROUTINE returns in A% a true flag if no Path/Drive error occured.
'----------------------------------------------------------------------------
'
ValidatePath:
'
E% = 0
D$ = curdir$
on error goto VPERR
if len(UsePath$) < 4 then
  chdir UsePath$
else
  chdir left$(UsePath$,len(UsePath$)-1)
end if
chdir D$
VPRES:
if E% = 0 then A% = %True else A% = %False
on error goto ErrorHandling
return
VPERR:
E% = err
resume VPRES
'
'
' SUBROUTINE returns validated path. I% = 1 for Input, 2 for output
'----------------------------------------------------------------------------
'
GetDirPath:
'
do
  if I% then
    UsePath$ = IOPath$(SLText$(8%),InpPath$,SLText$(49%))
  else
    UsePath$ = IOPath$(SLText$(9%),OutPath$,SLText$(49%))
  end if
  gosub ValidatePath
  if A% then exit loop
  if not Redo%(SLText$(50%)) then
    Fatal$ = SLText$(51%)
    return NoJob
  end if
  locate csrlin-1,1
loop
return
'
'
' SUBROUTINE  for previewing image either in 16 EGA-Grayscales or in
'             64 VGA Grayscales
'----------------------------------------------------------------------------
'
PreView:
'
if ScrMode% = 0 then return
G% = %False
if VGAHere% then
  G% = %True
  reg %AX, &h1200
  reg %BX, &h0033
  call interrupt %VBIOS
  screen ScrMode%
  call LRB(15%,15%,%Red)
  call VGACol(ColScale%(0),CCB%(1))
else
  screen ScrMode%
  call LRB(15%,15%,%Red)
  call Raster(CCB%(1),GrayScale%(0))
end if
call LRB(15%,15%,%Green)
if G% then
  reg %AX, &h1201
  reg %BX, &h0033
  call interrupt %VBIOS
end if
Q$ = KeyIn$
screen 0
return
'
'
' SUBROUTINE creates a 3-color-plane PCX 3 iamge
'----------------------------------------------------------------------------
'
MakeRGBPcx:
'
F$ = ""
call MakeRGB(CCB%(),CCD%(),CCI%(),CCP%(),Z$,F$)
if FileHere%(Z$) then
  Fatal$ = SLText$(84%)
  color %LWhite,%Red
  print SLText$(83%)
  if Confirm%(SLText$(84%)) then kill Z$ else return NoJob
end if
Fatal$ = F$
open Z$ for output as # %UnitI00
print# %UnitI00, PCXHead$(4%);
color %LCyan,%Black
print " "
call RGBPCX(CCD%(),CCP%(),CCI%())
close %UnitI00
color %Cyan,%Black
print SLText$(47%);
color %LCyan,%Black
print Z$
delay 1
return
'
'
' SUBROUTINE creates a 3-color-plane TIFF iamge
'----------------------------------------------------------------------------
'
MakeRGBTiff:
'
F$ = ""
call MakeRGB(CCB%(),CCD%(),CCI%(),CCP%(),Z$,F$)
Fatal$ = F$
if FileHere%(Z$) then
  Fatal$ = SLText$(84%)
  color %LWhite,%Red
  print SLText$(83%)
  if Confirm%(SLText$(84%)) then kill Z$ else return NoJob
end if
open Z$ for binary as # %UnitT00
Handle% = fileattr(%UnitT00,2)
put$# %UnitT00, TIFFHead$(VN$,0%)		'0: 192 x 165 BYT & PCX
for N% = 0 to 3
  A% = TiffWr%(TiffQ$,Handle%,CCI%(1),CCP%(1),CCD%(1),N%*7920)
  if istrue A% then exit for
next N%
close %UnitT00
print
color %Cyan,%Black
print SLText$(75%);" ";
if isfalse A% then
  color %LCyan,%Black
  print Z$
else
  color %LWhite,%Red
  print " ";SLText$(13%);" "
end if
color %White,%Black
delay 1
return
'
'
' SUBROUTINE creates from 8-bit color image three Byte RGB Images
'----------------------------------------------------------------------------
'
RGBF8:
'
call CpyW2W(CCD%(1),CCA%(1),%LMN/2)	'red
call CpyW2W(CCP%(1),CCA%(1),%LMN/2)	'green
call CpyW2W(CCI%(1),CCA%(1),%LMN/2)	'blue
call CpyW2W(CCB%(1),CCA%(1),%LMN/2)	'copy
call Promot(CCD%(1),0%,FulPal$)
call Promot(CCP%(1),1%,FulPal$)
call Promot(CCI%(1),2%,FulPal$)
Z$ = OutPath$ + StripExt$(InpFile$) + ".BYR"
call XDimBA(CCA%(1),CCD%(1),192%,165%)
gosub OptG
Z$ = OutPath$ + StripExt$(InpFile$) + ".BYG"
call XDimBA(CCA%(1),CCP%(1),192%,165%)
gosub OptG
Z$ = OutPath$ + StripExt$(InpFile$) + ".BYB"
call XDimBA(CCA%(1),CCI%(1),192%,165%)
gosub OptG
call XDimBA(CCB%(1),CCA%(1),165%,192)
call CpyW2W(CCA%(1),CCB%(1),%LMN/2)
return
'
'
' SUBROUTINE creates from 24-bit color image three Byte RGB Images
'----------------------------------------------------------------------------
'
RGBF24:
'
call CpyW2W(CCB%(1),CCA%(1),%LMN/2)
Z$ = OutPath$ + StripExt$(InpFile$) + ".BYR"
call XDimBA(CCA%(1),CCB%(1),192%,165%)
gosub OptG
Z$ = OutPath$ + StripExt$(InpFile$) + ".BYG"
call XDimBA(CCA%(1),CCP%(1),192%,165%)
gosub OptG
Z$ = OutPath$ + StripExt$(InpFile$) + ".BYB"
call XDimBA(CCA%(1),CCD%(1),192%,165%)
gosub OptG
call CpyW2W(CCA%(1),CCB%(1),%LMN/2)
return
'
'
CCDPSUB:
'
' ============================-<930212>-================-<HoroSoft>-===========
'
