;940602 0746
;****************************************************************************
;* PROGRAM NAME: CCDUP   .ASM   DATE:  6. 2.1993    LINK INTO: CCDUTIL .BAS *
;*                                                             CCDPRINT.BAS *
;* LANGUAGE: Turbo Assembler TASM 2.0                                       *
;* PURPOSE:  Procedures and Functions for CCDUTIL and CCDPRINT              *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01  2-JUN-94 Introduced Version CCDUPV% = 101                *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00  6-FEB-93 Start                                           *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.00c:                *
;*            = declare function CCDUPV%()                                  *
;*            = declare sub VarUP(integer)  {CCDPRINT only}                 *
;*            = declare sub OnePCL(integer,integer,string,integer)          *
;*            = declare sub RLEscn(string,integer,integer)                  *
;*            = declare sub RLElin(string,integer,integer)                  *
;*            = declare function BytWrd%(integer,integer)                   *
;*            = declare function NibWrd%(integer,integer,integer,integer)   *
;*            = $link "CCDUP.OBJ"                                           *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDUP                                                 *
;* NOTE: Needs PB2STACK.OBJ to be linked in as well!                        *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;GetStrLoc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDUPV%
;----------------------------------------------------------------------------
;
CCDUPV		proc	far
		public	CCDUPV
;
                call	pbastk
		mov	ax,101		;V.1.01
		xor	bl,bl
                jmp	bakbas
;
CCDUPV	endp
;
;
; VARIABLES AND TABLES DEFINITIONS
;============================================================================
;
; These variables are set and reset by VarUP procedre for CGE files.
;   The procedure sets it to alternate values for CGE and then resets them.
;----------------------------------------------------------------------------
;
col1up	dw	 192			; 64 for CGE
col2up	dw	1536			;512 for CGE
;
;
; Raster and Dither data 8 X 8 for CCDUTIL & CCDPRINT
;----------------------------------------------------------------------------
;
pclras: db          0,  0,  0,  0,  0,  0,  0,  0	;---- Raster
        db          0,  0,  0,  8,  0,  0,  0,  0
        db          0,  0,  0,  8,  8,  0,  0,  0
        db          0,  0,  0,  8, 24,  0,  0,  0
        db          0,  0,  0,  8, 24,  8,  0,  0
        db          0,  0,  0,  8, 24, 24,  0,  0
        db          0,  0,  0,  8, 24, 28,  0,  0
        db          0,  0,  0,  8, 24, 28,  8,  0
        db          0,  0,  0,  8, 28, 28,  8,  0
        db          0,  0,  0, 24, 28, 28,  8,  0
        db          0,  0,  8, 24, 28, 28,  8,  0
        db          0,  0,  8, 28, 28, 28,  8,  0
        db          0,  0,  8, 28, 60, 28,  8,  0
        db          0,  0,  8, 60, 60, 28,  8,  0
        db          0,  0, 24, 60, 60, 28,  8,  0
        db          0,  0, 24, 60, 62, 28,  8,  0
        db          0,  0, 24, 60, 62, 30,  8,  0
        db          0,  0, 24, 60, 62, 30, 12,  0
        db          0,  0, 28, 60, 62, 30, 12,  0
        db          0,  8, 28, 60, 62, 30, 12,  0
        db          0,  8, 28, 62, 62, 30, 12,  0
        db          0, 12, 28, 62, 62, 30, 12,  0
        db          0, 12, 30, 62, 62, 30, 12,  0
        db          0, 12, 30, 63, 62, 30, 12,  0
        db          0, 12, 30, 63, 63, 30, 12,  0
        db          0, 12, 62, 63, 63, 30, 12,  0
        db          0, 28, 62, 63, 63, 30, 12,  0
        db          8, 28, 62, 63, 63, 30, 12,  0
        db          8, 28, 62,127, 63, 30, 12,  0
        db          8, 60, 62,127, 63, 30, 12,  0
        db         24, 60, 62,127, 63, 30, 12,  0
        db         24, 60, 62,127,127, 30, 12,  0
        db         24, 60, 62,127,127, 62, 12,  0
        db         24, 60, 62,127,127, 62, 28,  0
        db         24, 60, 63,127,127, 62, 28,  0
        db         24, 60, 63,127,127, 63, 28,  0
        db         24, 62, 63,127,127, 63, 28,  0
        db         24, 62, 63,127,127, 63, 30,  0
        db         24, 62, 63,127,127, 63, 30,  4
        db         24, 62, 63,127,255, 63, 30,  4
        db         24, 62, 63,127,255,127, 30,  4
        db         24, 62, 63,127,255,127, 62,  4
        db         24, 62, 63,127,255,127, 62, 12
        db         24, 62, 63,255,255,127, 62, 12
        db         24, 62,127,255,255,127, 62, 12
        db         28, 62,127,255,255,127, 62, 12
        db         28, 62,127,255,255,127, 62, 28
        db         30, 62,127,255,255,127, 62, 28
        db         30, 62,127,255,255,127, 63, 28
        db         30, 62,127,255,255,127, 63, 30
        db         30,126,127,255,255,127, 63, 30
        db         30,126,127,255,255,127,127, 30
        db         30,126,255,255,255,127,127, 30
        db         62,126,255,255,255,127,127, 30
        db         62,126,255,255,255,127,127, 62
        db         62,126,255,255,255,255,127, 62
        db         62,127,255,255,255,255,127, 62
        db         63,127,255,255,255,255,127, 62
        db         63,127,255,255,255,255,127, 63
        db        127,127,255,255,255,255,127, 63
        db        127,255,255,255,255,255,127, 63
        db        127,255,255,255,255,255,255, 63
        db        255,255,255,255,255,255,255, 63
        db        255,255,255,255,255,255,255,255
;
pcldit  db          0,  0,  0,  0,  0,  0,  0,  0	;---- Dither
        db          8,  0,  0,  0,  0,  0,  0,  0
        db          8,  0,  0,  0,128,  0,  0,  0
        db        136,  0,  0,  0,128,  0,  0,  0
        db        136,  0,  0,  0,136,  0,  0,  0
        db        136,  0,  0,  1,136,  0,  0,  0
        db        136,  0,  0,  1,136,  0,  0, 16
        db        136,  0,  0, 17,136,  0,  0, 16
        db        136,  0,  0, 17,136,  0,  0, 17
        db        136,  4,  0, 17,136,  0,  0, 17
        db        136,  4,  0, 17,136, 64,  0, 17
        db        136, 68,  0, 17,136, 64,  0, 17
        db        136, 68,  0, 17,136, 68,  0, 17
        db        136, 68,  2, 17,136, 68,  0, 17
        db        136, 68,  2, 17,136, 68, 32, 17
        db        136, 68, 34, 17,136, 68, 32, 17
        db        136, 68, 34, 17,136, 68, 34, 17
        db        137, 68, 34, 17,136, 68, 34, 17
        db        137, 68, 34, 17,152, 68, 34, 17
        db        153, 68, 34, 17,152, 68, 34, 17
        db        153, 68, 34, 17,153, 68, 34, 17
        db        153, 68, 34, 25,153, 68, 34, 17
        db        153, 68, 34, 25,153, 68, 34,145
        db        153, 68, 34,153,153, 68, 34,145
        db        153, 68, 34,153,153, 68, 34,153
        db        153, 70, 34,153,153, 68, 34,153
        db        153, 70, 34,153,153,100, 34,153
        db        153,102, 34,153,153,100, 34,153
        db        153,102, 34,153,153,102, 34,153
        db        153,102, 38,153,153,102, 34,153
        db        153,102, 38,153,153,102, 98,153
        db        153,102,102,153,153,102, 98,153
        db        153,102,102,153,153,102,102,153
        db        157,102,102,153,153,102,102,153
        db        157,102,102,153,217,102,102,153
        db        221,102,102,153,217,102,102,153
        db        221,102,102,153,221,102,102,153
        db        221,102,102,155,221,102,102,153
        db        221,102,102,155,221,102,102,185
        db        221,102,102,187,221,102,102,185
        db        221,102,102,187,221,102,102,187
        db        221,110,102,187,221,102,102,187
        db        221,110,102,187,221,230,102,187
        db        221,238,102,187,221,230,102,187
        db        221,238,102,187,221,238,102,187
        db        221,238,103,187,221,238,102,187
        db        221,238,103,187,221,238,118,187
        db        221,238,119,187,221,238,118,187
        db        221,238,119,187,221,238,119,187
        db        223,238,119,187,221,238,119,187
        db        223,238,119,187,253,238,119,187
        db        255,238,119,187,253,238,119,187
        db        255,238,119,187,255,238,119,187
        db        255,238,119,191,255,238,119,187
        db        255,238,119,191,255,238,119,251
        db        255,238,119,255,255,238,119,251
        db        255,238,119,255,255,238,119,255
        db        255,238,127,255,255,238,119,255
        db        255,238,127,255,255,238,247,255
        db        255,238,255,255,255,238,247,255
        db        255,239,255,255,255,238,247,255
        db        255,255,255,255,255,238,247,255
        db        255,255,255,255,255,239,247,255
        db        255,255,255,255,255,255,255,255
;
;
; PROCEDURE  If Flag is false, the variables col1up and col2up are set for
;            use in a CGE file. If Flag ist true, resets the variables
;            back to BYT file use. Only used from CCDPRINT.
;    call VarUP(Flag%)
;----------------------------------------------------------------------------
;
VARUP	proc	far
	public	VARUP
;
	call	pbastk			;CX = Flag%
        inc	cx			;if True, now 0, if False, now 1
        jnz	varup1			;was false, set to CGE values
        mov	ax,192			;for true
        mov	dx,1536			;for true
        jz	varup2			;still 0, jump
varup1:	mov	ax,64			;for false
	mov	dx,512			;for false
varup2:	mov	col1up,ax		;change value
	mov	col2up,dx		;change value
        mov	bl,1			;1 parameter
        jmp	bakbas
;
VARUP	endp
;
;
; PROCEDURE  creates a 8 X 8 dot raster or dither pattern for one pixel
;            Variable col1up is updated by CCDPRINT procedure OneCge and
;            reset afterwards.
;     call OnePCL(CCB%(1),F%*192,P$,PRes%)
;============================================================================
;
ONEPCL	proc	far
	public	ONEPCL
;
; Get pointer into CCB%(1), F%*192, P$ (ident) and PRes%. Generate either one
; rastered or one dithered line compromising 192 X 8 bits, 8 times
;
	call	pbastk			;CX = PRes% Mask
	push	cx			;save PRes% & Dither Flag
	lds	si,[bp+10]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	pop	dx			;PRes% Mask
	lds	si,[bp+14]		;get pointer to F%*192
	mov	ax,ds:[si]		;AX=offset
	lds	si,[bp+18]		;DS:SI = CCB%(1)
	add	si,ax			;point to CCB%(F%*192)
	mov	cx,col1up		;one row
onepc1:	push	di			;save offset pointer to P$
	mov	al,ds:[si]		;get byte
	xor	al,255			;invert
	and	al,dl			;Mask 1111ab00
	xor	ah,ah			;clear ah
	shl	ax,1			;value times 8 (together with mask)
	lea	bx,pclras		;get start of table
	and	dh,dh			;check Dither flag
	jz	onepc0			;if reset, skip
	lea	bx,pcldit		;use dither data
onepc0:	add	bx,ax			;BX points to table
	mov	ch,8			;use temporarily as counter
	push	ds			;save source segment
	push	cs			;get code segment
	pop	ds			;set ds to cs
onepc2:	mov	al,ds:[bx]		;get one decoded row
	mov	es:[di],al		;store decoded row
	inc	bx			;point to next decode row
	add	di,col1up		;point to next dest row
	dec	ch			;one row decoded
	jnz	onepc2			;repeat 8 times
	pop	ds			;restore source segment
	pop	di			;restore old pointer
	inc	di			;point to next dest pixel
	inc	si			;point to next srce pixel
	xor	ch,ch			;be sure, ch is 0
	loop	onepc1			;repeat for full row
	mov	bl,4			;4 parameters to remove
	jmp	bakbas
;
ONEPCL	endp
;
;
; PROCEDURE returns number of non-consecutive bytes in a row.
;     call RLEscn(P$,N%*192,C%) C%=returned number of non-equal
;=============================================================================
;
RLESCN	proc	far
	public	RLESCN
;
; Get pointer into P$, offset in P$ (N%) and add it to point at the start
; of one of 8 lines. Get position of difference-counter. Return number
; of non-consecutive similiar bytes.
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of P$
	mov	si,ax			;DS:SI = P$ location
	les	di,[bp+10]		;position of Pos
	add	si,es:[di]		;add offset into P$
	les	di,[bp+6]		;ES:DI = position of counter
	mov	cx,col1up		;191 or 63 bytes to scan
        dec	cx
	xor	bx,bx			;clear counter
	mov	ah,ds:[si]		;get first byte
	inc	si			;point to 2nd byte
rlesc1:	lodsb				;get next byte into AL, SI=SI+1
	cmp	ah,al			;is it equal?
	jz	rlesc2			;jump if equal
	mov	ah,al			;this to compare
	inc	bl			;if different, count as different
rlesc2:	loop	rlesc1			;do 191 bytes
	mov	es:[di],bx		;return counter value
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
RLESCN	endp
;
;
; PROCEDURE compresses one line into Run-length Encoding format
;     call RLElin(P$,N%*192,C%) C%=returned string length
;=============================================================================
;
RLELIN	proc	far
	public	RLELIN
;
; Get pointer into P$, offset in P$ (N%) and add it to point at the start
; of one of 8 lines. Get position of string length-counter to be returned.
; The line of 192 bytes is compressed by using Run-Length-Encoding. There
; are always 2 bytes per data byte: the 1st is the counter (0-255 = 1-256)
; followed by the data byte thus repeated. See the "Technical Reference
; Manual for the DeskJet 500/500C" by Hewlett Packard, Manual Part Number
; C2114-90008, Chapter 8: Graphics Control, Page 8-24, Run-length Encoding.
; RLESCN should be used first to check that compression will not become
; expansion.
;
	call	pbastk			;save environment
	lds	si,[bp+14]		;P$ ident
	push	ds:[si]			;put ident onto stack
	call	GetStrLoc		;get string location
	mov	ds,dx			;DS=segment of P$
	mov	si,ax			;DS:SI = P$ location
	les	di,[bp+10]		;position of Pos
	add	si,es:[di]		;add offset into P$ for start
	mov	es,dx			;ES=segment of P$
	mov	di,ax			;ES:DI = P$ location
	add	di,col2up		;last 192/64 bytes for RLE data
	mov	cx,col1up		;191/63 + 1 bytes per line
        dec	cx
	xor	bx,bx			;clear string length
	xor	dl,dl			;clear similiar byte counter
	lodsb				;get 1st byte
	mov	ah,al			;copy into ah
rleli1:	lodsb				;get 2nd byte
	cmp	ah,al			;are they the same?
	jz	rleli2			;skip if same
	mov	dh,al			;save first unmatching byte
	mov	al,dl			;get equal byte counter
	stosw				;save cntr-byte, inc di twice
	inc	bx
	inc	bx			;len(P$) + 2
	xor	dl,dl			;reset equal byte counter
	dec	dl			;compensate upcomming increment
	mov	ah,dh			;get next reference byte
rleli2:	inc	dl			;increment equal bytes counter
	loop	rleli1			;for 192 bytes
	mov	al,dl			;get equal bytes counter
	stosw				;store last counter & byte
	inc	bx
	inc	bx			;len(P$) + 2
	les	di,[bp+6]		;ES:DI = position of string length
	mov	es:[di],bx		;return string length
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
RLELIN	endp
;
;
; FUNCTIONS are derived from PB2EXT to be able to compile CCDPRINT for
;           PB 2.10e with PB 3.00c.
;============================================================================
;
; FUNCTION returns HiByte%*256+LoByte% as an integer word without overflow
;    A% = BytWrd%(LoByte%,HiByte%)
;----------------------------------------------------------------------------
;
BYTWRD	proc	far
	public	BYTWRD
;
	call	pbastk			;CX = HiByte%
	mov	ah,cl			;HiByte% * 256
	lds	si,[bp+10]		;(LoByte%)
	mov	al,ds:[si]		;AX = HiByte% * 256 + LoByte%
	mov	bl,2			;2 parameters
	jmp	bakbas			;exit
;
BYTWRD	endp
;
;
; FUNCTION returns an integer word without overflow from 4 nibbles.
;          LBLN% = Low Byte Low  Nibble  -  HBLN% = High Byte Low  Nibble
;          LBHN% = Low Byte High Nibble  -  HBHN% = High Byte High Nibble
;    A% = NibWrd%(LBLN%,LBHN%,HBLN%,HBHN%)
;----------------------------------------------------------------------------
;
NIBWRD	proc	far
	public	NIBWRD
;
	call	pbastk			;CX = HBHN%
	mov	ah,cl			;AH = HBHN% * 256
	mov	cl,4			;CL = shift counter
	shl	ah,cl			;AH = HBHN% * 256 * 16
	lds	si,[bp+10]		;(HBLN%)
	or	ah,ds:[si]		;AH = (HBHN%*16+HBLN%)*256
	lds	si,[bp+14]		;(LBHN%)
	mov	al,ds:[si]		;AL = LBHN%
	shl	al,cl			;AL = LBHN% * 16
	lds	si,[bp+18]		;(LBLN%)
	or	al,ds:[si]		;AL = LBHN% * 16 + LBLN%
	mov	bl,4			;4 parameters
	jmp	bakbas			;exit
;
NIBWRD	endp
;
;
code	ends
	end
;
; =======================-<930206 HoroSoft, CH-3952 Susten>-==================
;
