'960412 1417
'****************************************************************************
'* PROGRAM NAME: CCDUPROC.INC   DATE: 13. 8.1992   INCLUDE IN: CCDUTIL .BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Collection of procedures used in CCDUTIL.BAS                    *
'* INCLUDE FILES: none - though they must be included/linked by main        *
'* INPUT FILES: none - files accessed must be opened by main                *
'* OUTPUT FILES: none - files written to must be opened by main             *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.07:  12-APR-96 Bugfix in sound                                *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.06:  10-FEB-96 Recompiled with PB 3.20                        *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.05:  11-FEB-95 Added brightness calculculations               *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.04:  17-SEP-94 Redid unsharp masking and Optimizer            *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.03:   2-JUN-94 Introduced Version CCDUProcV% = 203            *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.02:  30-JAN-94 Additions to support CGE files.                *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.01:  24-DEC-93 Retry with PB 3 - added RLCE                   *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.00:  25-MAR-93 Ported to PB 3.00a and back to PB2             *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02: 13-AUG-92 First time it run.                              *
'* ------------------------------------------------------------------------ *
'* COMMENTS: The procedures are grouped according to their purposes.        *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDUProcV% = 207
'
'
' >>> FILE  READ <<<
'============================================================================
'
' >>> CONVERTERS <<<
'============================================================================
'
' PROCEDURE generates a test image.
'            1) Fill whole image with white
'            2) Set horizontal bar on top and bottom
'            3) Set vertical bar at left and right edge
'            4) Set vertical bars to show left/right/centered squarred
'            5) Create a square at top left corner
'            6) Draw vertical bars for HoroSoft
'            7) Draw horizontal bars for H O R O S O F
'            8) Draw top bar for S and T
'            9) Draw lower bar for S
'           10) Draw angled line for R
'           11) Draw color block
'-----------------------------------------------------------------------------
'
sub GenTestImg(CCD%(2))
  local A%,B%,C%,I%,J%,N%,F%,X%,Y%,Z%
  for N% = 1 to 192			'-- 1
    for F% = 1 to 165
      CCD%(F%,N%) = 255
    next F%
  next N%
  for N% = 2 to 191			'-- 2
    CCD%(  2,N%) = 16
    CCD%(164,N%) = 16
  next N%
  for F% = 2 to 164			'-- 3
    CCD%(F%,  2) = 256
    CCD%(F%,191) = 256
    CCD%(F%,  2) = 16
    CCD%(F%,191) = 16
  next F%
  for F% = 4 to 162			'-- 4
    CCD%(F%, 14) =  32
    CCD%(F%, 28) = 128
    CCD%(F%,164) =  64
    CCD%(F%,178) =  32
  next F%
  for N% = 4 to 10			'-- 5
    for F% = 4 to 10
      CCD%(F%,N%) = 8
    next F%
  next N%
  restore VertDat			'-- 6
  for N% = 1 to 14
    read A%,B%,C%
    for F% = B% to C%
      CCD%(F%,A%) = 96
    next F%
  next N%
  for N% = 1 to 12			'-- 7
    read A%,B%
    for F% = A% to A% + 5
      CCD%(B%,F%) = 96
    next F%
  next N%
  for N% = 85 to 120			'-- 8
    CCD%(8,N%) = 96
  next N%
  for N% = 45 to 90			'-- 9
    CCD%(22,N%) = 96
  next N%
for F% = 16 to 20			'-- 10
  CCD%(F%,F%+50) = 96
next F%
  for I% = 0 to 15			'-- 11
    for J% = 0 to 15
      for F% = 0 to 4
	Y% = I% * 5 + F% + 45
	for N% = 0 to 4
	  X% = J% * 5 + N% + 45
	  Z% = I% * 16 + J%
	  CCD%(Y%,X%) = Z%
	next N%
      next F%
    next J%
  next I%
end sub
'
'
' PROCEDURE Convert_16bits_To_8 converts 16-bit integers into 8-bit integers.
'           Experience showed for Lynxx that low bits should be removed, the
'           high bits are more important. The 16-bit values will be lost!
'----------------------------------------------------------------------------
'
sub C16T8(CCD%(2),Hi%)
  local Z%
  color %Cyan,%Black
  if Hi% > 255 then
    select case Hi%
      case < 512
	Z% = 1
      case < 1024
	Z% = 2
      case < 2048
	Z% = 3
      case else
	Z% = 4
    end select
    print SLText$(29%);
    for N% = 1 to Z%
      call ShrWrd(CCD%(1,1),%LMN)
    next N%
    print ""
  else
    print SLText$(30%)
  end if
  color %White,%Black
end sub
'
'
' PROCEDURE ReaD_BYTe copies from file .BYT data into array.
'----------------------------------------------------------------------------
'
'sub RDBYT(CCA%(),B$)
'  color %Cyan,%Black
'  print SLText$(9%);B$;
'  def seg = varseg(CCA%(1))
'  bload B$
'  def seg
'  print " "
'  color %White,%Black
'end sub
'
'
'
' >>> DISPLAY  HANDLING <<<
'============================================================================
'
'---- General Use
'
' PROCEDURE resets Pointer into CCA% and the Step sizes
'----------------------------------------------------------------------------
'
sub ResetXY0S(X0%,Y0%,XS%,YS%)
  X0% = 96		'-- initial X-pos in CCA% [1;192]
  Y0% = 83		'-- initial Y-pos in CCA% [1;165]
  XS% =  1		'-- initial X-step
  YS% =  1		'-- initial Y-step
end sub
'
'
' PROCEDURE centers X/Y position for menues G, H, I, J and N-1
'----------------------------------------------------------------------------
'
sub CentXY(X0%,Y0%,X1%,Y1%)
  X1% = X0%
  Y1% = Y0%
  X0% = 96
  Y0% = 83
end sub
'
'
' PROCEDURE inserts Step value A at X/Y position with color Z
'----------------------------------------------------------------------------
'
sub InStep(A%,Y%,X%,Z%)
  locate Y%,X%
  color Z%,%Black
  print using "##";A%;
  color %White,%Black
end sub
'
'
' PROCEDURE checks and executes cursor movements
'----------------------------------------------------------------------------
'
sub StepAdj(CCA%(),U%,V%,W%,YS%,XS%,Y0%,X0%,Y1%,X1%,A$)
  select case A$
    case "*"
      YS% = StepInc%(YS%,%True)
      call InStep(YS%,U%,V%,%LRed)
    case "/"
      YS% = StepInc%(YS%,%False)
      call InStep(YS%,U%,V%,%LRed)
    case "+"
      XS% = StepInc%(XS%,%True)
      call InStep(XS%,U%,W%,%LGreen)
    case "-"
      XS% = StepInc%(XS%,%False)
      call InStep(XS%,U%,W%,%LGreen)
  end select
end sub
'
'
' PROCEDURE Large_Round_Buttons draws a large button in color C
'----------------------------------------------------------------------------
'
sub LRB(X%,Y%,C%)
  local A%
  A% = C% + 8
  circle(X%,Y%),12,A%
  circle(X%,Y%),11,A%
  circle(X%,Y%),10,A%
  paint (X%,Y%),C%,A%
end sub
'
'
' PROCEDURE Small_Round_Button draws small button in color C
'----------------------------------------------------------------------------
'
sub SRB(X%,Y%,C%)
  local A%
  A% = C% + 8
  circle(X%,Y%),6,A%
  paint (X%,Y%),C%,A%
end sub
'
'
' PROCEDURE SQuare_Button  draws a text button without destroying cursor
'           position, but color is destroyed!
'----------------------------------------------------------------------------
'
sub SQB(X%,Y%,C%)
  local X1%,Y1%,A%
  Y1% = csrlin
  X1% = pos(Y%)
  A%  = C% + 8
  locate Y%,X%
  color A%,%Black
  print chr$(222);
  color C%,%Black
  print chr$(219);
  color A%,%Black
  print chr$(221);
  locate Y1%,X1%
end sub
'
'
'---- Graphics Display use
'
' PROCEDURE False_Color_Multi_Image is just the loop controller for OneOfSix
'----------------------------------------------------------------------------
'
sub FCMI(CCA%(),ColScale%(),R%,V%)
  local N%
  call SRB(207%,174%,%Red)
  call SRB(429%,174%,%Red)
  for N% = 1 to 6
    call OneOfSix(CCA%(),ColScale%(),N%,R%,V%)
  next N%
  call SRB(207%,174%,%Green)
  call SRB(429%,174%,%Green)
end sub
'
'
' PROCEDURE ONE_OF_SIX prints one image in false color at the screen position
'           determined by the loop controller FCMI.
'----------------------------------------------------------------------------
'
sub OneOfSix(CCA%(),ColScale%(),I%,R%,V%)
  local A!,F%,N%,C%,E%,J%,X%,Y%,S%,L%,B%,Z%,Q$
    C% = 14				'-- assume ICI/IBK
    L% = 29
  if not R% and V% then                 '-- Grayweighted or Grayscale
    C% = 30				'-- C%: Start index of color scale
    L% = 45				'-- L%: End index of color scale
  end if
  Y% = 183				'-- Y%: Frame top position
  S% = 176				'-- S%: Col. scale top position
  Z% =   0				'-- Z%: Col. scale repeater
  select case I%			'-- I%: Image Number
    case 1				'-- Image top left (2 colors)
      C% =   0
      X% =   0				'-- X%: Frame left position
      Y% =   0
      S% = 167
      L% =   1
      B% =  96				'-- B%: One color X-size (dots)
    case 2				'-- Image top center (4 colors)
      C% =   2
      X% = 222
      Y% =   0
      S% = 167
      L% =   5
      B% =  48
    case 3				'-- Image top right (8 colors)
      C% =   6
      X% = 445
      Y% =   0
      S% = 167
      L% =  13
      B% =  24
    case 4				'-- Image lower left (16 colors)
      X% =   0
      B% =  12
    case 5				'-- Image low-center (32 colors)
      X% = 222
      B% =   6
      Z% =   1
    case 6				'-- Image lower right (64 colors)
      X% = 445
      B% =   3
      Z% =   3
  end select
  for F% = C% to L%				'-- Number of colors
    E% = UseColor%(ColScale%(),F%)
    for N% = 0 to Z%				'-- Number of repetitions
      J% = (F%-C%)*B%+N%*B%*16+X%		'-- J%: One color left pos.
      line (J%,S%)-(J%+B%,S%+5),E%,BF
    next N%
  next F%
  line(X%,S%)-(X%+193,S%+6),%Green,B		'-- Color scale box
  line(X%+1,Y%+1)-(X%+192,Y%+165),%Red,B	'-- Frame box
  call SetSix(CCA%(1),ColScale%(C%/2),I%)
  if instat then Q$ = inkey$			'-- Clear in-buffer
end sub
'
'
' PROCEDURE sets or removes crosshair for zoomed image
'----------------------------------------------------------------------------
'
sub CrossLine(Y0%,X0%,A%)
  local X%,Y%,C1%,C2%
  if A% then
    C1% = %LGreen
    C2% = %LRed
  else
    C1% = %Black
    C2% = %Black
  end if
  X%  = X0% * 2
  Y%  = Y0% * 2
  line (X%,331)-(X%,346),C1%
  line (X%+1,331)-(X%+1,346),C1%
  line (385,Y%)-(400,Y%),C2%
  line (385,Y%+1)-(400,Y%+1),C2%
end sub
'
'
' PROCEDURE highlights quart of image for Zoom Option B
'----------------------------------------------------------------------------
'
sub CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
  call LRB(413%,BO%,%Red)
  call CrossLine(Y1%,X1%,%False)
  call ZoomC(YU%,XL%)
  pset (413,BO%+20)				'-- Reset EGA
  XL% = LowX0%(X0%,%False)
  YU% = LowY0%(Y0%,%False)
  call CrossLine(Y0%,X0%,%True)
  color %LGreen,%Black
  locate 5,63
  print using "###";X0%;
  color %LRed,%Black
  locate 5,75
  print using "###";Y0%;
  call ZoomB(CCA%(1),ColScale%(0),YU%,XL%,S%)
  pset (413,BO%+20),%Black			'-- Reset EGA
  call LRB(413%,BO%,%Green)
end sub
'
'
' PROCEDURE Gray_Scale_ZOOM displays the false-color-gray-scale-zoomed image.
'           ͻ  There are 2 colors out of 16 and each of those two
'            2  1   colors can be set in any of the 4 quadrants making up
'           Ķ  dither-sprite. This results in 64 colors. In case of
'            3  4   true grayscales (VGA), there are only 61 grayscales.
'           ͼ  Black and white both make up 1.5 grayscales.
'-----------------------------------------------------------------------------
'
sub GSZoom(CCA%(),ColScale%(),D%,R%)
  local A%,B%,C%,N%,M%,S%,CO%,CS%,Q$
  call LRB(106%,313%,%Red)
  call LRB(533%,313%,%Red)
  line(128,  0)-(511,329),%Red,  B
  select case D%
    case 2				'-- 16 colors ICI
      CS% =   1				'-- CS%: step
      CO% =  30				'-- C0%: Offset into ColScale%
      S%  =   4				'-- S%:  Rotate number to divide
    case 3				'-- 32 colors ICI
      CC% =   8
      CO% =   0
      M%  = 248
    case 4				'-- 64 colors ICI
      CC% =   4
      CO% =   0
      M%  = 252
    case 5				'-- 8 colors grayweighted
      CS% =   2
      CO% =   6
      S%  =   5
    case 6				'-- 16 cols gray. also for opt. D
      CS% =   1
      CO% =  14
      S%  =   4
    case 7				'-- 32 colors grayweighted
      CC% =   8
      CO% = 128
      M%  = 248
    case 8				'-- 64 colors grayweighted
      CC% =   4
      CO% = 128
      M%  = 252
  end select
  select case D%
    case 2, 5, 6			'-- 16 ICI, 8 & 16 grayweighted
      for N% = 0 to 15
	B% = fix(N%/CS%) + CO%
	A% = UseColor%(ColScale%(),B%)
	C% = 32 * N% + 64
	line (C%,333) - (C%+32,348),A%,BF
      next N%
      line( 63,332)-(577,349),%Green,B
      call LRB(106%,313%,%Green)
      call VGACol(ColScale%(CO%/2),S%,CCA%(1))
    case 3, 4, 7, 8				'-- 32 & 64 ICI & grayw.
      call DScale(S%,M%,CO%)
      line( 63,332)-(577,349),%Green,B
      call LRB(106%,313%,%Green)
      call Dither (CCA%(1),M%,CO%)
    end select
  call LRB(533%,313%,%Green)
  if instat then Q$ = inkey$
end sub
'
'
' PROCEDURE Gray_ZOOM displays the true-gray-scale-zoomed image in a Raster.
' ͻ  ͻ  ͻ  ͻ  ͻ  Raster-Sprite, where
'  +  +    *  +    *  +    *  *    *  *   + and * may be any of
' Ķ  Ķ  Ķ  Ķ  Ķ  Black, Gray, White or
'  +  +    +  +    +  *    *  +    *  *   Light White, forming
' ͼ  ͼ  ͼ  ͼ  ͼ  total of 16 scales.
'-----------------------------------------------------------------------------
'
sub GrayZoom(CCA%(),GrayScale%())
  local Q$
  call LRB(106%,313%,%Red)
  call LRB(533%,313%,%Red)
  line(128,  0)-(511,329),%Red,  B
  call RScale(GrayScale%(0))
  line( 63,332)-(576,349),%Green,B
  call LRB(106%,313%,%Green)
  call Raster(CCA%(1),GrayScale%(0))
  call LRB(533%,313%,%Green)
  if instat then Q$ = inkey$
end sub
'
'
' PROCEDURE plots red histogram of brightness distribution X-cut
'----------------------------------------------------------------------------
'
sub RedXHist(CCA%(),Y0%,Y1%,SF%)
  local A%,Z%,N%,V&,W%
  call LRB(230%,12%,%Red)
  color %LRed,%Black
  locate 18,49
  print using "###";Y0%;
  Z% = Y1% + 9
  line (624,Z%)-(638,Z%),%Black
  line (415,Z%)-(429,Z%),%Black
  line (275,Z%)-(282,Z%),%Black
  Z% = Y0% + 9
  line (624,Z%)-(638,Z%),%LRed
  line (415,Z%)-(429,Z%),%LRed
  line (275,Z%)-(282,Z%),%LRed
  paint(431,191),%Black,%Yellow
  V& = 0
  for N% = 1 to 192
    W% = UseByte%(CCA%(),N%,Y0%)
    V& = V& + W%
    A% = N% + 430
    Z% = W% / 2
    if SF% then
      if N% = 1 then
	X1% = 431
	Y1% = 318-Z%
      end if
	X2% = A%
	Y2% = 318-Z%
	line (X1%,Y1%)-(X2%,Y2%),%LRed
	X1% = X2%
	Y1% = Y2%
    else
      line (A%,318)-(A%,318-Z%),%Red
    end if
  next N%
  A% = V& / 384
  Z% = 318 - A%
  line (431,Z%)-(622,Z%),%LRed
  color %LRed,%Black
  locate 19,49
  print using "###";V&/192;
end sub
'
'
' PROCEDURE plots green histogram of brightness distribution Y-cut
'----------------------------------------------------------------------------
'
sub GrnYHist(CCA%(),X0%,X1%,SF%)
  local A%,Z%,N%,V&,W%
  call LRB(230%,12%,%Red)
  color %LGreen,%Black
  locate 18,37
  print using "###";X0%;
  Z% = X1% + 430
  line (Z%,  1)-(Z%,  8),%Black
  line (Z%,176)-(Z%,187),%Black
  line (Z%,320)-(Z%,325),%Black
  Z% = X0% + 430
  line (Z%,  1)-(Z%,  8),%LGreen
  line (Z%,176)-(Z%,187),%LGreen
  line (Z%,320)-(Z%,325),%LGreen
  paint(285,10),%Black,%Yellow
  V& = 0
  for N% = 1 to 165
    W% = UseByte%(CCA%(),X0%,N%)
    V& = V& + W%
    A% = N% + 9
    Z% = W% / 2
    if SF% then
      if N% = 1 then
	X1% = 284+Z%
	Y1% =  10
      end if
	X2% = 284+Z%
	Y2% = A%
	line (X1%,Y1%)-(X2%,Y2%),%LGreen
	X1% = X2%
	Y1% = Y2%
    else
      line (284,A%)-(284+Z%,A%),%Green
    end if
  next N%
  A% = V& / 330
  Z% = 284 + A%
  line (Z%,10)-(Z%,174),%LGreen
  color %LGreen,%Black
  locate 19,37
  print using "###";V&/165;
end sub
'
'
' PROCEDURE prints small, zoomed cutting of active image
'----------------------------------------------------------------------------
'
sub CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
  local C%
  if R% then C% = 7 else C% = 15
  XL% = LowX0%(X0%,%True)
  YU% = LowY0%(Y0%,%True)
  call Tiny(CCA%(1),ColScale%(C%),YU%,XL%)
  pset (230,32),%Black				'-- Reset EGA
  line (193,183)-(202,166),%LBlue
end sub
'
'
' PROCEDURE prints picture information (caption) right of Dotogram (r)
'           and plots Luminance Histogram. Assumes Screen 9 set.
'           BO% has Y-offset for buttons.
'----------------------------------------------------------------------------
'
sub LumPlot(CCA%(),LAV%,HAV%,D%,ActFil$,WRTFile$,Z$,VN$,BO%,CCB%())
  local Z%,V%,A$,N%,A%
  line (386,0) - (386,350),%White
  line (0,0) - (639,349),%White,B
  if HAV% < LAV% then swap HAV%,LAV%
  V% = D%
  if D% = 0 then
    Z% = fix((HAV% - LAV%) / 22)
    if Z% = 0 then D% = 1 else D% = Z%
    if D% > 127 then D% = 127
    V% = D%
  end if
  if D% < 0 then
    Z% = abs(D%) and 127
    if Z% = 0 then D% = 129 else D% = Z% + 128
    V% = D% - 128
  end if
  color %White,%Black
  locate 2,60
  print "";string$(16,"");"";
  locate 3,60
  print "   ";SLText$(157%);"   ";
  locate 4,60
  print SLText$(164%)
  locate 5,60
  print " ";right$(space$(14)+ActFil$,14);" ";
  locate 6,60
  print "";string$(16,"");"";
  locate 7,60
  print " ";SLText$(158%);":";space$(5);
  print using "###";LAV%;
  print " ";
  locate 8,60
  print " ";SLText$(159%);space$(4);
  print using "###";HAV%;
  print " ";
  locate 9,60
  print " ";
  if D% > 128 then print "Expansion: "; else print SLText$(165%);
  print using "###";V%;
  print " ";
  locate 10,60
  print " ";SLText$(160%);space$(4);"165 ";
  locate 11,60
  print " ";SLText$(161%);space$(3);"192 ";
  locate 12,60
  print "";string$(16,"");"";
  locate 13,60
  print " ";VN$;" ";
  locate 14,60
  print " (c) 1992-96 by ";
  locate 15,60
  print " H.-R.H. Wernli ";
  locate 16,60
  print " CH-3952 Susten ";
  locate 17,60
  print "";string$(16,"");"";
  call LRB(528,BO%,%Red)
  color %LGreen,%Black
  locate 23,61
  print SLText$(162%);
  color %Yellow,%Black
  locate 24,61
  print SLText$(163%);
  call Doto(CCA%(1),LAV%,HAV%,D%)
  call LRB(528%,BO%,%Green)
  color %White,%Black
  if EscRet% then
    line (390,250) - (630,340),%Black,BF
    pset (636,348),%LWhite		'Dotogram Identifier for CCDPRINT
    A$ = WRTFile$ + Z$
    A% = WrtDoto%(CCB%(),A$,Z$)
  end if
end sub
'
'
' PROCEDURE prints profil of image, depending on HorizontalResolution (1,2,3,4)
'           VerticalResolution (1,3,5). If HR% is negative, no horizontal
'           averaging is done, if VR% is negative, no vertical averaging is
'           performed. If SF% is negative, the image values will be multiplied,
'           else divided. If Slant% is true, format wil be // - else \\.
'           This works by creating a frame in gray, drawing one line in gray
'           and connecting the line to the frame. Everything within that poly-
'           gone is overpainted in black up to the limiting color gray. The
'           line is redrawn in white, making it subject to erase. The gray
'           frame is removed when the whole profil is finished.
'-----------------------------------------------------------------------------
'
sub Profil(CCA%(),CCX%(2),HR%,VR%,SF%,Slant%,AF%)
  local X0%,X1%,X2%,X3%,X4%,X5,Y0%,Y1%,Y2%,Y3%,F%,N%,R%,S%,HF%,VF%,MD%
  AF% = %False
  HF% = %True
  VF% = %True
  MD% = %False
  if SF% < 0 then
    MD% = %True
    SF% = abs(SF%)
  end if
  if HR% < 0 then
    HR% = abs(HR%)
    HF% = %False
  end if
  if VR% < 0 then
    VR% = abs(VR%)
    VF% = %False
  end if
  if HR% = 1 then HF% = %False
  if VR% = 1 then VF% = %False
  line (0,0) - (590,349),%Gray,B
  for F% = 1 to 165 step VR%
    if instat then
      Q$ = inkey$
      AF% = %True
      exit sub
    end if
    Y0% = (F% - 1) * 2 + 20
    Y1% = Y0%
    Y3% = Y0% + 2
    X0% = 1
    call Copy5X(CCA%(1),CCX%(0,1),VR%,F%)
    if HF% then call HAvrg(CCX%(0,1),HR%,VR%)
    if VF% then call VAvrg(CCX%(0,1),VR%)
    if SF% > 1 then call ScaleX(CCX%(0,1),SF%,MD%)
    call VertY(CCX%(0,1),Y0%)
    if Slant% then X1% = 166 - F% + 20 else X1% = F% + 20
    X3% = 589
    X4% = X1%
    line (X0%,Y0%) - (X1%,Y0%), %Gray
    for N% = 1 to 192 step HR%
      Y2% = CCX%(0,N%)
      X2% = HR% * 2 + X1%
      line (X1%,Y1%) - (X2%,Y2%), %Gray
      Y1% = Y2%
      X1% = X2%
    next N%
    line (X2%,Y2%) - (X2%,Y0%), %Gray
    line (X2%,Y0%) - (X3%,Y0%), %Gray
    line (X0%,Y3%) - (X3%,Y3%), %Gray
    paint (X3%,Y3%-1), %Black, %Gray
    line (X2%,Y2%) - (X2%,Y0%), %White
    line (X2%,Y0%) - (589,Y0%), %Black
    line (X0%,Y3%) - (X3%,Y3%), %Black
    line (X2%,Y0%) - (X2%+20,Y0%), %White
    Y1% = Y0%
    X1% = X4%
    line (X0%,Y0%) - (X1%,Y0%), %Black
    line (X4%,Y0%) - (X1%-20,Y0%), %White
    for N% = 1 to 192 step HR%
      Y2% = CCX%(0,N%)
      X2% = HR% * 2 + X1%
      line (X1%,Y1%) - (X2%,Y2%), %White
      Y1% = Y2%
      X1% = X2%
    next N%
  next F%
  line (0,0) - (590,349),%Black,B
end sub
'
'
' PROCEDURE prints screen without data and Grid for option F
'----------------------------------------------------------------------------
'
sub DrawAnaly(CCA%(),ColScale%(),R%)
  local C%,N%,S%,Y%,A$
  call LRB(416%,337%,%Red)
  line (446,  0)-(639,166),%Red,B
  line (446,183)-(639,349),%Red,B
  call SetSix(CCA%(1),ColScale%(3%),19%)
  if instat then Q$ = inkey$
  if R% then C% = 7 else C% = 15
  call SetSix(CCA%(1),ColScale%(C%),14%)
  C% = C% + C%
  if instat then Q$ = inkey$
  call LRB(416%,337%,%Red)
  color %LCyan,%Black
  locate 1,1,0
  print SLText$(120%);
  color %Cyan,%Black
  locate 24,12
  print "[ ]/[ ]/[ ] & [0-9]";
  locate 1,48
  print "[ ] [.]"
  locate 3,1
  print SLText$(121%)
  locate 24,34
  print "P O S I T I O N";
  A$ = "M A G N I T U D E"
  for N% = 1 to 17
    locate N%+4,54
    print mid$(A$,N%,1);
  next N%
  for N% = 0 to 7			'-- Color scale 8
    Y% = 300 - (N%*32)
    S% = UseColor%(ColScale%(),6%+N%)
    line (417,Y%)-(421,Y%-32),S%,BF
  next N%
  line (416,44)-(422,301),%Cyan,B
  for N% = 0 to 15			'-- Color scale 16
    Y% = 300 - (N%*16)
    S% = UseColor%(ColScale%(),C%+N%)
    line (433,Y%)-(437,Y%-16),S%,BF
  next N%
  line (432,44)-(438,301),%Cyan,B
  locate 2,2
  print "X-Step: ..  Y-Step: ..  Move: . . . .  Step:"
  color %LRed,%Black
  locate 2,36
  print chr$(30,32,31)
  locate 2,51
  print "* /"
  locate 23,31
  print "Row";
  locate 23,43
  print "Zeile";
  locate 24,13
  print "H";
  color %LGreen,%Black
  locate 2,32
  print chr$(17,32,16)
  locate 2,47
  print "+ -"
  locate 23,4
  print "Column";
  locate 23,17
  print "Spalte"
  locate 24,17
  print "V";
  color %LCyan,%Black
  locate 24,21
  print "$";
  color %Cyan,%Black
  locate 24,1
  print ":";
  locate 4,50
  print "250"
  locate 8,50
  print "200"
  locate 11,50
  print "150"
  locate 15,50
  print "100"
  locate 18,51
  print "50"
  locate 22,52
  print "0"
  locate 23,1
  print "0"
  locate 23,13
  print "50"
  locate 23,25
  print "100"
  locate 23,37
  print "150"
end sub
'
'
' PROCEDURE draws grid for option F
'----------------------------------------------------------------------------
'
sub DrawGrid
  local N%
  line (439,0)-(445,349),%Black,BF	'-- clear markers
  line (447,167)-(639,182),%Black,BF
  line (0,44)-(384,301),%Cyan,B		'-- clear scale
  for N% = 1 to 381 step 20		'-- X
    line (N%,46)-(N%,300),%Cyan,,&hAAAA
  next N%
  for N% = 1 to 381 step 100
    line (N%,45)-(N%,306),%Cyan
  next N%
  for N% = 300 to 45 step -10		'-- Y 300-Y
    line (1,N%)-(384,N%),%Cyan,,&hAAAA
  next N%
  for N% = 300 to 50 step -50
    line (1,N%)-(390,N%),%Cyan
  next N%
end sub
'
'
' PROCEDURE draws Horizontal Cut through Image for option F
'----------------------------------------------------------------------------
'
sub HoriCut(CCA%(),Y0%,X0%)
  local V&,N%,W%,XA%,XB%,YA%,YB%
  call LRB(416%,337%,%Red)
  W%  = UseByte%(CCA%(),1%,Y0%)
  V&  = W%
  XA% = 1
  YA% = 300 - W%
  for N% = 2 to 192
    W%  = UseByte%(CCA%(),N%,Y0%)
    V&  = V& + W%
    XB% = (N%-1) * 2 + 1
    YB% = 300 - W%
    line (XA%,YA%)-(XB%,YB%),%LRed
    XA% = XB%
    YA% = YB%
  next N%
  W%  = V& / 192
  YB% = 300 - W%
  line (1,YB%)-(384,YB%),%LRed,,&HAAAA		'-- average
  line (439,Y0%)-(445,Y0%),%LRed		'-- upper marker
  line (439,Y0%+183)-(445,Y0%+183),%LRed	'-- lower marker
  color %LCyan,%Black
  locate 24,6
  print using "###";UseByte%(CCA%(),X0%,Y0%);
  color %LRed,%Black
  locate 3,21
  print using "###";Y0%
  locate 3,45
  print using "###";W%
  call LRB(416%,337%,%Green)
end sub
'
'
' PROCEDURE draws Vertical Cut through Image for option F
'----------------------------------------------------------------------------
'
sub VertCut(CCA%(),X0%,Y0%)
  local V&,N%,W%,XA%,XB%,YA%,YB%
  call LRB(416%,337%,%Red)
  W%  = UseByte%(CCA%(),X0%,1%)
  V&  = W%
  XA% = 1
  YA% = 300 - W%
  for N% = 2 to 165
    W%  = UseByte%(CCA%(),X0%,N%)
    V&  = V& + W%
    XB% = (N%-1) * 2 + 1
    YB% = 300 - W%
    line (XA%,YA%)-(XB%,YB%),%LGreen
    XA% = XB%
    YA% = YB%
  next N%
  W%  = V& / 165
  YB% = 300 - W%
  line (1,YB%)-(331,YB%),%LGreen,,&hAAAA	'-- average
  line (X0%+446,167)-(X0%+446,182),%LGreen	'-- marker
  color %LCyan,%Black
  locate 24,6
  print using "###";UseByte%(CCA%(),X0%,Y0%);
  color %LGreen,%Black
  locate 3,9
  print using "###";X0%
  locate 3,40
  print using "###";W%
  call LRB(416%,337%,%Green)
end sub
'
'
'---- Character & Number Graphics
'
' PROCEDURE draws small template for menues I (A%=True) and N
'----------------------------------------------------------------------------
'
sub IBox(VN$,YS%,XS%,A%)
  local Y%,X%,Z%,A$
  color %Cyan,%Black
  if A% then
    Y% = 14
    X% = 26
    Z% = 57
    locate 5,28
    print "ASCII"
    locate 6,27
    print SLText$(186%)
    locate 7,28
    print "17x17"
  else
    Y% =  1
    X% = 52
    Z% = 65
  end if
  A$ = "" + string$(26,"") + ""
  locate Y%,X%
  print "";string$(26,"");"";
  locate Y%+1,X%
  if A% then
    print " [HOME] [END] ";
    color %Yellow,%Black
    print "d=........";chr$(34);
    color %Cyan,%Black
    print " ";
  else
    print " ";VN$;"  HoroSoft ";
  end if
  locate Y%+2,X%
  print A$;
  locate Y%+3,X%
  print SLText$(55%);
  locate Y%+4,X%
  print SLText$(56%);
  locate Y%+5,X%
  print SLText$(Z%);
  locate Y%+6,X%
  print A$;
  locate Y%+7,X%
  print SLText$(58%);
  locate Y%+8,X%
  print " ";
  color %LGreen,%Black
  print chr$(17,32,16,32);
  color %LRed,%Black
  print chr$(30,32,31);
  color %Cyan,%Black
  A$ = SLText$(59%)
  if not A% then replace "[ ] [.]" with "  [.]  " in A$
  print A$;
  locate Y%+9,X%
  print " ";
  color %LGreen,%Black
  print "+ - ";
  color %LRed,%Black
  print "* / ";
  color %Cyan,%Black
  print SLText$(60%);
  locate Y%+10,X%
  print SLText$(61%);
  locate Y%+11,X%
  print "";string$(26,"");"";
  color %LGreen,%Black
  locate Y%+10,X%+19
  print using "##";XS%;
  color %LRed,%Black
  locate Y%+10,X%+24
  print using "##";YS%;
end sub
'
'
' PROCEDURE prints template for table Option G
'----------------------------------------------------------------------------
'
sub Template
  local N%,A$,B$,C$
  A$ = string$(5,"")
  B$ = string$(3,"")
  C$ = string$(3,"")
  cls
  color %Cyan,%Black
  print space$(2);"";A$;"";string$(67,"");""
  print space$(2);"[INS]";
  color %LGreen,%Black
  call TempHead(%True)
  print space$(1);""
  print space$(2);"";repeat$(16,C$+"");C$;""
  print space$(2);"";
  color %LRed,%Black
  print SLText$(166%);
  color %Cyan,%Black
  print "";repeat$(16,space$(3)+"");space$(3);""
  print space$(2);"";A$;"";repeat$(16,B$+"");B$;""
  for N% = 1 to 17
    print space$(2);"";space$(5);"";repeat$(16,space$(3)+"");space$(3);""
  next N%
  print space$(2);"";A$;"";repeat$(16,B$+"");B$;""
  locate 24,3
  print SLText$(123%);
end sub
'
'
' PROCEDURE fills in Template head, also used for ascii-representation
'----------------------------------------------------------------------------
'
sub TempHead(Z%)
  Local L%
  if Z% then
    locate 2,11
    L% = 5
  else
    locate 2,5
    L% = 4
  end if
  color %LGreen,%Black
  print SLText$(167%);
  if Z% then print space$(2); else print space$(8);
  color %Cyan,%Black
  print "X-Step:";space$(4);"Y-Step:";space$(L%);"Move";
  color %LGreen,%Black
  print chr$(32,17,32,16);
  color %LRed,%Black
  print chr$(32,30,32,31);
  color %Cyan,%Black
  print space$(2);"Step";
  color %LGreen,%Black
  print " + -";
  color %LRed,%Black
  print " * /";
  color %Cyan,%Black
  print space$(2);"[RET]";
end sub
'
'
' PROCEDURE fills in template table
'----------------------------------------------------------------------------
'
sub FillTemp(CCA%(),Y0%,YU%,X0%,XL%,TR$())
  local N%,F%,W%
  XL% = LowX0%(X0%,%True)
  YU% = LowY0%(Y0%,%True)
  for F% = 0 to 16
    locate F%+6,5
    color %LRed,%Black
    print using "###";YU%+F%
    for N% = 0 to 16
      color %LGreen,%Black
      locate 4,N%*4+10
      print using "###";XL%+N%
      color %White,%Black
      locate F%+6,N%*4+10
      if (F%+YU%=Y0%) and (N%+XL%=X0%) then color %Yellow,%Black
      W% = UseByte%(CCA%(),XL%+N%,YU%+F%)
      print using "###";W%;
      mid$(TR$(F%),N%*4+1,4) = using$("####",W%)
    next N%
  next F%
  call InsCnt(CCA%(),X0%,Y0%)
end sub
'
'
' PROCEDURE counts and inserts number of occurrences of CCA%(X0%,Y0%)
'----------------------------------------------------------------------------
'
sub InsCnt(CCA%(),X0%,Y0%)
  local W%
  W% = UseByte%(CCA%(),X0%,Y0%)
  locate 24,27
  color %Yellow,%Black
  print using "###";W%;
  color %Cyan,%Black
  print ": ";
  color %LCyan,%Black
  print using "#####";CntByt%(CCA%(1),W%,%LMN);
end sub
'
'
' PROCEDURE edits value in center of table
'----------------------------------------------------------------------------
'
sub Edit(CCA%(),X0%,Y0%)
  local N%,Q$,A$,A!,A%,U%,V%,W%,X%,Y%
  A$ = ""
  W% = UseByte%(CCA%(),X0%,Y0%)
  X% = 42
  if X0% <   9 then X% = (X0%+  1)*4+2
  if X0% > 184 then X% = (X0%-174)*4+2
  Y% = 14
  if Y0% <   9 then Y% = Y0%+  5
  if Y0% > 157 then Y% = Y0%-143
  locate Y%,X%
  color %Brown,%Black
  print using "###";W%
  locate Y%,X%
  color %LWhite,%Black
  for N% = 1 to 3
    Q$ = KeyIn$
    if Q$ = chr$(27) then exit sub
    if (Q$<"0") or (Q$>"9") or (Q$=chr$(13)) then exit for
    print Q$;
    A$ = A$ + Q$
  next N%
  N% = val(A$)
  N% = IntLmt%(0%,255%,N%)
  A! = ((X0%-1)*165+Y0%+1) / 2
  A% = fix(A!)
  U% = CCA%(A%)
  V% = LoBytI%(U%)
  W% = HiBytI%(U%)
  if A% = A! then V% = N% else W% = N%
  CCA%(A%) = BytWrd%(V%,W%)
  locate Y%,X%
  color %Yellow,%Black
  print using "###";N%
  call InsCnt(CCA%(),X0%,Y0%)
end sub
'
'
' PROCEDURE draws frame for ascii-representation
'----------------------------------------------------------------------------
'
sub AscTbl(VN$,ChrDec$)
  local N%
  cls
  color %Cyan,%Black
  print "  ";string$(73,"");""
  print "  ";space$(73);""
  print "  ";string$(34,"");""; string$(34,"");""
  for N% = 1 to 17
    print "  ";space$(34);"   ";space$(34);""
  next N%
  print "  ";string$(34,"");"";string$(34,"");""
  print "  ";
  color %White,%Black
  print " 0-63  ";ChrDec$;" ";
  color %Cyan,%Black
  print ""
  print "  ";
  color %Gray,%Black
  print " 0 ... 63   ";
  color %White,%Black
  print "64 ... 127   ";
  color %LCyan,%Black
  print "128 ... 191   ";
  color %LWhite,%Black
  print "192 ... 255";space$(8);
  color %Cyan,%Black
  print VN$;" "
  print "  ";string$(73,"");"";
  call TempHead(%False)
end sub
'
'
' PROCEDURE fills in ascii-representation
'----------------------------------------------------------------------------
'
sub AscRep(CCA%(),Y0%,YU%,X0%,XL%,ChrDec$,AR$())
  local I%,F%,N%,X%,Y%,Z%
  XL% = LowX0%(X0%,%True)
  YU% = LowY0%(Y0%,%True)
  color %LGreen,%Black
  locate 2,11
  print ": ";
  print using "###";X0%
  color %LRed,%Black
  for F% = 0 to 16
    locate F%+4,39
    print using "###";YU%+F%;
  next F%
  Z% = %False
  for I% = 1 to 2
    for F% = 0 to 16
      for N% = 0 to 16
	A% = UseByte%(CCA%(),XL%+N%,YU%+F%)
	A0% = A% / 4 + 1
	A$ = mid$(ChrDec$,A0%,1)
	if Z% then
	  select case A%
	    case > 191
	      color %LWhite,%Black
	    case > 127
	      color %LCyan,%Black
	    case > 63
	      color %White,%Black
	    case else
	      color %Gray,%Black
	  end select
	  X% = N% * 2 + 43
	else
	  color %White,%Black
	  X% = N% * 2 + 4
	end if
	Y% = F% + 4
	if (YU%+F%=Y0%) and (XL%+N%=X0%) then Color %Yellow,%Black
	locate Y%,X%
	print A$;A$;
	mid$(AR$(F%),N%*2+1,2) = A$ + A$
      next N%
      print
    next F%
    Z% = not Z%
  next I%
end sub
'
'
' PROCEDURE either fills number table or the ascii-representation
'----------------------------------------------------------------------------
'
sub TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,PQFlag%,AR$(),TR$())
  if PQFlag% then
    call SQB(75%,24%,%Red)
    call FillTemp(CCA%(),Y0%,YU%,X0%,XL%,TR$())
    call SQB(75%,24%,%Green)
  else
    call SQB(57%,23%,%Red)
    call AscRep(CCA%(),Y0%,YU%,X0%,XL%,ChrDec$,AR$())
    call SQB(57%,23%,%Green)
  end if
end sub
'
'
' PROCEDURE sets up ASCII and Table representation strings
'----------------------------------------------------------------------------
'
sub AscTab(CCA%(),Y0%,YU%,X0%,XL%,ChrDec$,AR$(),TR$())
  local N%,F%,A%,A0%,A$
  XL% = LowX0%(X0%,%True)
  YU% = LowY0%(Y0%,%True)
  for F% = 0 to 16
    for N% = 0 to 16
      A% = UseByte%(CCA%(),XL%+N%,YU%+F%)
      A0% = A% / 4 + 1
      A$ = mid$(ChrDec$,A0%,1)
      mid$(AR$(F%),N%*2+1,2) = A$ + A$
      mid$(TR$(F%),N%*4+1,4) = using$("####",A%)
    next N%
  next F%
end sub
'
'
' PROCEDURE draws brightness template
'----------------------------------------------------------------------------
'
sub BBox
  local N%,T%
  T% = 7
  color %Cyan,%Black
  print space$(T%);
  print "ͻ"
  print space$(T%);SLText$(249%)
  print space$(T%);
  print "Ͷ"
  for N% = 1 to 17 step 2
    print space$(T%);"  ";
    print using "##";N%;
    print " x ";
    print using "##";N%;
    print "  .../... - .../...  .../...  ...     ...     ... "
  next N%
  print space$(T%);
  print "ͼ"
  color %White,%Black
end sub
'
'
' PROCEDURE fills in first part of Brightnessbox, i.e. X/Y
'----------------------------------------------------------------------------
'
sub FillBox1(Cx%,Cy%,Xl%,Yu%,Xr%,Yl%,Xb%,Yb%)
  locate Cy%,Cx%
  print using "###";Xl%;
  print "/";
  print using "###";Yu%;
  print " - ";
  print using "###";Xr%;
  print "/";
  print using "###";Yl%;
  Cx% = pos(Yc%) + 3
  locate Cy%,Cx%
  print using "###";Xb%;
  print "/";
  print using "###";Yb%;
  Cx% = pos(Yc%) + 3
end sub
'
'
' PROCEDURE fills in second part of Brightnessbox, i.e. value (called trice)
'----------------------------------------------------------------------------
'
sub FillBox2(Cx%,Cy%,M%)
  locate Cy%,Cx%
  print using "###";M%;
  if Cx% < 70 then Cx% = pos(Yc%) + 6
end sub
'
'
' PROCEDURE draws template linear & logarithmic for histogram
'----------------------------------------------------------------------------
'
sub HistBox
  local N%
  color %Cyan,%Black
  locate 20,45
  print "2 3 5"
  color %LCyan,%Black
  print "0    5000 10000 15000  20000 25000 30000  ";
  print "1       10      100     1000   10000"
  line (  0,0) - (329,257),%Cyan,B
  line (336,0) - (639,257),%Cyan,B
  for N% = 16 to 240 step 16
    line (  1,N%) - (328,N%),%Cyan,,&hCCCC
    line (337,N%) - (638,N%),%Cyan,,&hCCCC
  next N%
  for N% = 50 to 300 step 50
    line (N%+ 1,1) - (N%+ 1,280),%Cyan,,&hCCCC
    line (N%-39,1) - (N%-39,256),%Cyan,,&hAAAA	'1
    line (N%-29,1) - (N%-29,256),%Cyan,,&hAAAA	'2
    line (N%-19,1) - (N%-19,256),%Cyan,,&hAAAA	'3
    line (N%- 9,1) - (N%- 9,256),%Cyan,,&hAAAA	'4
  next N%
  line (311,1) - (311,256),%Cyan,,&hAAAA
  line (321,1) - (321,256),%Cyan,,&hAAAA
  for N% = 404 to 602 step 66
    line (N%+ 1,1) - (N%+ 1,280),%Cyan,,&hCCCC
    line (N%-46,1) - (N%-46,256),%Cyan,,&HAAAA	'2
    line (N%-35,1) - (N%-35,256),%Cyan,,&HAAAA	'3
    line (N%-27,1) - (N%-27,256),%Cyan,,&HAAAA	'4
    line (N%-20,1) - (N%-20,256),%Cyan,,&HAAAA	'5
    line (N%-15,1) - (N%-15,256),%Cyan,,&HAAAA	'6
    line (N%-10,1) - (N%-10,256),%Cyan,,&HAAAA	'7
    line (N%- 6,1) - (N%- 6,256),%Cyan,,&HAAAA	'8
    line (N%- 2,1) - (N%- 2,256),%Cyan,,&HAAAA	'9
  next N%
  line (  1,256) - (  0,280),%Cyan,,&hCCCC	'0
  line (338,  1) - (338,280),%Cyan,,&hCCCC	'1
  line (358,  1) - (358,266),%Cyan,,&hAAAA	'2
  line (369,  1) - (369,266),%Cyan,,&hAAAA	'3
  line (384,  1) - (384,266),%Cyan,,&hAAAA	'5
  line (622,  1) - (622,256),%Cyan,,&hAAAA	'20,000
  line (633,  1) - (633,256),%Cyan,,&hAAAA	'30,000
  color %LCyan,%Black
  print
  print Center$(SLText$(254%),79);
end sub
'
'
' >>> MORE TEMPLATES
'============================================================================
'
' PROCEDURE draws template for CGE file database
'----------------------------------------------------------------------------
'
sub CGETemplate
  local Y%
  Y% = csrlin
  color %Cyan,%Black
  call MLText(30%,1%,"tf")
  locate Y%,23
  print "[";string$(11,"_");"]"			'-- volume name
  incr Y%
  locate Y%,23
  print "[";string$(8,"_");".___]"		'-- file name
  incr Y%
  locate Y%,23
  print "[";string$(21,"_");"]"			'-- subdirectories
  incr Y%
  locate Y%,23
  print "[";string$(46,"_");"]"			'-- location
  incr Y%
  locate Y%,23
  print "[__/__/__]"				'-- date
  incr Y%
  locate Y%,23
  print "[__:__]"				'-- time
  incr Y%
  locate Y%,23
  print "[";string$(46,"_");"]"			'-- optical system
  incr Y%
  locate Y%,23
  print "[____] (1 mm = 0.0394 in)"		'-- focal length
  incr Y%
  locate Y%,23
  print "[_____]"				'-- exposure time
  incr Y%
  incr Y%
  locate Y%,3
  print "[";string$(76,"_");"]"			'-- remarks
end sub
'
'
' >>> FILTERING <<<
'============================================================================
'
' PROCEDURE shows masks. If F%=-1 then LPF-1/4, F%=0:HPF-1/4, F%=1: rest
'----------------------------------------------------------------------------
'
sub FewMask(CMasks%(2),CMask$(),I%(),I$,Z%)
  local A%,S%,E%,N%,F%
  call ShowCMask(I%(),I$ + SLText$(184%))
  locate 10,1
  if not Confirm%(SLText$(183%)) then exit sub
  for N% = 1 to 10
    CMasks%(0,N%) = I%(N%)
  next N%
  select case Z%
    case -1
      S% =  1
      E% =  4
    case 0
      S% =  5
      E% =  8
    case 1
      S% =  9
      E% = 15
  end select
  for F% = S% to E%
    for N% = 1 to 10
      I%(N%) = CMasks%(F%,N%)
    next N%
    I$ = CMask$(F%)
    call ShowCMask(I%(),I$)
    locate 10,1
    A% = Confirm%(SLText$(183%))
    if not A% then exit for
  next F%
  for N% = 1 to 10
    I%(N%) = CMasks%(0,N%)
  next N%
  I$ = CMask$(0)
end sub
'
'
' PROCEDURE shows convolving Mask. Values are in CMasks%(0,1...9), sum in
'           CMasks%(0,10)
'-----------------------------------------------------------------------------
'
sub ShowCMask(I%(),I$)
  local A$,B$,C$,N%
  cls
  I%(10) = 0
  for N% = 1 to 9
    I%(10) = I%(10) + I%(N%)
  next N%
  A$ = " ͻ"
  B$ = " Ķ"
  C$ = " ͼ"
  cls
  color %Black,%Cyan
  print "CONVOLVING MASK"
  color %Cyan,%Black
  print A$
  for N% = 1 to 9 step 3
    print " ";
    print using "###";I%(N%);
    print "";
    print using "###";I%(N%+1);
    print "";
    print using "###";I%(N%+2);
    print ""
    if N% < 7 then print B$
  next N%
  print C$
  color %Black,%Cyan
  print "KONVOLVIERMASKE"
  color %Cyan,%Black
  locate 3,17
  print I$
  locate 5,16
  print "Sum/Summe = ";I%(10)
  locate 10,1
  color %White,%Black
end sub
'
'
' PROCEDURE enters Convolving mask into I%(1...9) and sum into I%(10)
'-----------------------------------------------------------------------------
'
sub GetCMask(I%(),I$)
  local X%,Y%,N%,F%,Z%,Q$
  for N% = 1 to 10
    I%(N%) = 0
  next N%
  do
    for F% = 0 to 2
      Y% = F% * 2 + 3
      for N% = 0 to 2
	X% = N% * 4 + 3
	Z% = F% * 3 + N% + 1
	call ShowCMask(I%(),I$)
	color %Yellow,%Black
	locate Y%,X%
	print " ? "
	locate 11,1
	line input Q$
	I%(Z%) = val(Q$)
      next N%
    next F%
    call ShowCMask(I%(),I$)
    locate 11,1
    if (I%(10) > -1) and (I%(10) < 127) then
      if Confirm%(SLText$(18%)) then exit loop
    else
      beep
      Z% = Redo%(SLText$(114%))
    end if
  loop
end sub
'
'
' PROCEDURE fills I%() for Low- and High Pass Filters. F%=%False (0): HPF,
'           F% = %True (-1): LPF,  F% = %True (+1): Unsharp Masking
'---------------------------------------------------------------------------
'
sub HPFLPF(CCA%(),CCB%(),CMasks%(2),CMask$(),I%(),V$,F%)
  local N%,A%,Z%,V%,S%,A$,Z$
  V% = F%
  if F% = 1 then V% = %True
  print LogOn$(V$,%White,%Brown)
  color %LCyan,%Black
  print Center$(SLText$(124%),80)
  color %Cyan,%Black
  call MLText(17%,16%,"tf")
  A% = Prompt%(21%,Q$)
  select case A%
    case 0
      call FewMask(CMasks%(),CMask$(),I%(),I$,V%)
      exit sub
    case 5
      call GetCMask(I%(),SLText$(182%))
      A$ = "Filter" + SLText$(168%) + " " + SLText$(182%) + ":"
      for N% = 1 to 9
	A$ = A$ + using$("##+",I%(N%)) + ","
      next N%
      A$ = A$ + "=" + using$("###+",I%(10))
    case 1, 2, 3, 4
      if F% = 0 then Z% = A% + 4 else Z% = A%
      A$ = CMask$(Z%)
      for N% = 1 to 10
	I%(N%) = CMasks%(Z%,N%)
      next N%
    case else
      print Outch$(Q$)
      exit sub
  end select
  call UniConv(CCA%(),CCB%(),I%(),%True)
  if F% = 1 then				'== unsharp masking
    call SQB(77%,23%,%Red)
    call ShrByt(CCA%(1),%LMN)			'-- compress / 2
    call XORMBA(CCA%(1),255%,%LMN)		'-- negate image
    S% = MinByt%(CCA%(1),%LMN)
    if S% > 0 then call SubCBL(CCA%(1),S%,0%,%LMN)
    A$ = A$ + " (" + SLText$(127%) + ")"
  end if
  print# %UnitRPT, A$
  call SQB(77%,23%,%Green)
end sub
'
'
' PROCEDURE completely processes Universal Convolution Filter
'----------------------------------------------------------------------------
'
sub UniConv(CCA%(),CCB%(),I%(),F%)
  call SQB(77%,23%,%Red)
  call XDimBA(CCB%(1),CCA%(1),165%,192%)	'-- Rearrange {CCD%(F%,N%)}
  if F% then
      call ConvUF(CCA%(1),CCB%(1),I%(1))
  else
    call StatMF(CCA%(1),CCB%(1),I%(1))
  end if
  call XDimBA(CCB%(1),CCA%(1),192%,165%)	'-- Rearrange {CCD%(N%,F%)}
  call CpyW2W(CCA%(1),CCB%(1),%LMN/2)
end sub
'
'
' PROCEDURE fills I%() for Contour Filters.
'---------------------------------------------------------------------------
'
sub Contour(CCA%(),CCB%(),CMasks%(2),CMask$(),I%(),V$)
  local N%,A%,Z%,A$
  print LogOn$(V$,%White,%Brown)
  color %LCyan,%Black
  print Center$(SLText$(125%),80)
  color %Cyan,%Black
  call MLText(18%,16%,"tf")
  A% = Prompt%(21%,Q$)
  select case A%
    case 0
      call FewMask(CMasks%(),CMask$(),I%(),I$,1%)
      exit sub
    case 8
      call GetCMask(I%(),SLText$(182%))
      A$ = "Filter" + SLText$(168%) + " " + SLText$(182%) + ":"
      for N% = 1 to 9
	A$ = A$ + using$("##+",I%(N%)) + ","
      next N%
      A$ = A$ +"=" + using$("###+",I%(10))
    case 1, 2, 3, 4, 5, 6, 7
      Z% = A% + 8
      for N% = 1 to 10
	I%(N%) = CMasks%(Z%,N%)
      next N%
      A$ = CMask$(Z%)
      print
      color %LCyan,%Black
      if not Confirm%(SLText$(31%)) then
	A$ = A$ + ", "
	if Confirm%(SLText$(136%)) then
	  swap I%(1),I%(3)
	  swap I%(4),I%(6)
	  swap I%(7),I%(9)
	  A$ = A$ + SLText$(137%)
	else
	  swap I%(1),I%(7)
	  swap I%(2),I%(8)
	  swap I%(3),I%(9)
	  A$ = A$ + SLText$(138%)
	end if
      end if
      A$ = A$ + "."
    case else
      print Outch$(Q$)
      exit sub
  end select
  call ShrByt(CCB%(1),%LMN)
  call UniConv(CCA%(),CCB%(),I%(),%True)
  print# %UnitRPT, A$
  call SQB(77%,23%,%Green)
end sub
'
'
' PROCEDURE handles statistical minimal, median & maximal filters
'---------------------------------------------------------------------------
'
sub Statist(CCA%(),CCB%(),I%(),V$)
  local N%,A%,Z%,A$,B$
  print LogOn$(V$,%White,%Brown)
  color %LCyan,%Black
  print Center$(SLText$(126%),80)
  color %Cyan,%Black
  call MLText(19%,22%,"tf")
  A% = Prompt%(27%,Q$)
  A$ = "Minimal"
  I%(10) = %False
  if A% > 6 then
    A$ = "Maximal"
    I%(10) = %True
  end if
  if A% > 3 and A% < 7 then
    A$ = "Median"
    I%(10) = 1
  end if
  B$ = ""
  for N% = 1 to 9
    I%(N%) = 1
  next N%
  select case A%
    case < 1, > 9
      print Outch$(Q$);
      exit sub
    case 2, 5, 8
      for N% = 1 to 9 step 2
	I%(N%) = 0
      next N%
      I%(5) = 1
      B$ = "+"
    case 3, 6, 9
      for N% = 2 to 8 step 2
	I%(N%) = 0
      next N%
      B$ = "x"
  end select
  call UniConv(CCA%(),CCB%(),I%(),%False)
  print# %UnitRPT, A$;" statist. Filtertyp: ";B$
  call SQB(77%,23%,%Green)
end sub
'
'
' PROCEDURE smoothes image by cross convolution and error diffusion
'-----------------------------------------------------------------------------
'
sub Smooth(CCA%(),CCB%())
  call VErDif(CCA%(1))
  call XDimBA(CCB%(1),CCA%(1),165%,192%)
  call HErDif(CCB%(1))
  call CErDif(CCB%(1))
  call XDimBA(CCA%(1),CCB%(1),192%,165%)
end sub
'
'
' PROCEDURE applies logical Mask-constant to all elements
'----------------------------------------------------------------------------
'
sub LogMask(CCA%(),MinV%,MaxV%,V$)
  local Y%,Q$,Z%
  print LogOn$(V$,%White,%Brown)
  color %LCyan,%Black
  print Center$(SLText$(78%),80)
  color %Cyan,%Black
  call MLText(20%,26%,"tf")
  A% = Prompt%(31%,Q$)
  if A% < 1 or A% > 3 then exit sub		'-- Do nothing
  print
  print SLText$(40%);
  color %LCyan,%Black
  print ByteBin$(MinV%);" / ";ByteBin$(MaxV%)
  Y% = csrlin
  print SLText$(41%);
  locate Y%,51
  color %Yellow,%Black
  line input Q$
  Z% = val("&b"+Q$)
  call SQB(77%,23%,%Red)
  select case A%
    case 1
      call AndMBA(CCA%(1),Z%,%LMN)
      Q$ = "AND"
    case 2
      call OrMBA(CCA%(1),Z%,%LMN)
      Q$ = "OR"
    case 3
      call XorMBA(CCA%(1),Z%,%LMN)
      Q$ = "XOR"
  end select
  Q$ = Q$ + SLText$(168%)
  print# %UnitRPT, Q$;": ";ByteBin$(Z%)
  print# %UnitRPT, space$(3);MaxMin$(CCA%(),MinV%,MaxV%)
  call SQB(77%,23%,%Green)
end sub
'
'
' PROCEDURE manipulates A- and F- Frames, Primary (1) and Secondary (2)
'----------------------------------------------------------------------------
'
sub FraMani(CCA%(),CCF%(),CCC%(),CCD%(2),V$,P$,S$)
  local Y%,Q$,A$,B$,V%,Z%
  print LogOn$(V$,%White,%Red)
  Y% = csrlin
  locate 22,1
  color %White,%Black
  print SLText$(116%);" ";P$
  print SLText$(117%);" ";S$
  locate Y%,1
  color %LCyan,%Black
  print Center$(SLText$(128%),80)
  color %Cyan,%Black
  call MLText(21%,19%,"tf")
  A% = Prompt%(24%,Q$)
  if A% < 1 or A% > 8 then
    print Outch$(Q$)
    exit sub
  end if
  call SQB(77%,23%,%Red)
  A$ = SLText$(129%)+SLText$(131%) + " = " + SLText$(129%)+SLText$(131%) + " "
  B$ = " " + SLText$(130%)+SLText$(131%)
  select case A%
    case 1
      call AddBAS(CCA%(1),CCF%(1),255%,%LMN)
      Q$ = A$ + "PLUS" + B$
    case 2
      call SubBAS(CCA%(1),CCF%(1),0%,%LMN)
      Q$ = A$ + "MINUS" + B$
    case 3
      call AndBAS(CCA%(1),CCF%(1),%LMN)
      Q$ = A$ + "AND" + B$
    case 4
      call OrBAS(CCA%(1),CCF%(1),%LMN)
      Q$ = A$ + "OR" + B$
    case 5
      call XorBAS(CCA%(1),CCF%(1),%LMN)
      Q$ = A$ + "XOR" + B$
    case 6
      call AvrgBA(CCA%(1),CCF%(1),%LMN)
      Q$ = A$ + SLText$(173%) + B$
    case 7
      call CpyHBA(CCA%(1),CCF%(1),%LMN)
      Q$ = A$ + SLText$(174%) + B$
    case 8
      call CpyLBA(CCA%(1),CCF%(1),%LMN)
      Q$ = A$ + SLText$(175%) + B$
  end select
  print# %UnitRPT, Q$
  call SQB(77%,23%,%Green)
end sub
'
'
' PROCEDURE copies and swaps any frame. D% is dest-frame, S% is source frame.
'           if F% is set, swapping occures. P% is dest quadrant and Q% source
'----------------------------------------------------------------------------
'
sub AllFrames(CCA%(),CCB%(),CCC%(),CCD%(2),CCF%(),CCR%(),CCN$(),D%,S%,F%,P%,Q%)
  local A%,B%,C%
  C% = %False
  if P% = 0 then if S% = D% then exit sub
  if S% < 1 or S% > 6 then C% = %True
  if D% < 1 or D% > 6 then C% = %True
  if C% then
    call Illegal(SLText$(225%)," ! ")
    exit sub
  end if
  call SQB(77%,23%,%Red)
  if not F% then
    CCR%(D%) = CCR%(S%)
    CCN$(D%) = CCN$(S%)
    if P% = 0 then
      print# %UnitRPT, SLText$(84%);":";D%;"<---";S%
    else
      print# %UnitRPT, SLText$(181%);" Quadrant";P%;"<---";Q%;
      print# %UnitRPT, SLText$(187%);D%;"<---";S%
    end if
    select case D%
      case 1
	select case S%
	  case 1
	    if not P% = 0 then call CpyQdr(CCA%(1),CCA%(1),P%,Q%)
	  case 2
	    if P% = 0 then
	      call CpyW2W(CCA%(1),CCF%(1),%LMN/2)
	    else
	      call CpyQdr(CCA%(1),CCF%(1),P%,Q%)
	    end if
	  case 3
	    if P% = 0 then
	      call CpyW2W(CCA%(1),CCC%(1),%LMN/2)
	    else
	      call CpyQdr(CCA%(1),CCC%(1),P%,Q%)
	    end if
	  case 4
	    if P% = 0 then
	      call CpyW2W(CCA%(1),CCD%(1,1),%LMN/2)
	    else
	      call CpyQdr(CCA%(1),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if P% = 0 then
	      call CpyW2W(CCA%(1),CCD%(1,97),%LMN/2)
	    else
	      call CpyQdr(CCA%(1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 2
	select case S%
	  case 1
	    if P% = 0 then
	      call CpyW2W(CCF%(1),CCA%(1),%LMN/2)
	    else
	      call CpyQdr(CCF%(1),CCA%(1),P%,Q%)
	    end if
	  case 2
	    if not P% = 0 then call CpyQdr(CCF%(1),CCF%(1),P%,Q%)
	  case 3
	    if P% = 0 then
	      call CpyW2W(CCF%(1),CCC%(1),%LMN/2)
	    else
	      call CpyQdr(CCF%(1),CCC%(1),P%,Q%)
	    end if
	  case 4
	    if P% = 0 then
	      call CpyW2W(CCF%(1),CCD%(1,1),%LMN/2)
	    else
	      call CpyQdr(CCF%(1),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if P% = 0 then
	      call CpyW2W(CCF%(1),CCD%(1,97),%LMN/2)
	    else
	      call CpyQdr(CCF%(1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 3
	select case S%
	  case 1
	    if P% = 0 then
	      call CpyW2W(CCC%(1),CCA%(1),%LMN/2)
	    else
	      call CpyQdr(CCC%(1),CCA%(1),P%,Q%)
	    end if
	  case 2
	    if P% = 0 then
	      call CpyW2W(CCC%(1),CCF%(1),%LMN/2)
	    else
	      call CpyQdr(CCC%(1),CCF%(1),P%,Q%)
	    end if
	  case 3
	    if not P% = 0 then call CpyQdr(CCC%(1),CCC%(1),P%,Q%)
	  case 4
	    if P% = 0 then
	      call CpyW2W(CCC%(1),CCD%(1,1),%LMN/2)
	    else
	      call CpyQdr(CCC%(1),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if P% = 0 then
	      call CpyW2W(CCC%(1),CCD%(1,97),%LMN/2)
	    else
	      call CpyQdr(CCC%(1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 4
	select case S%
	  case 1
	    if P% = 0 then
	      call CpyW2W(CCD%(1,1),CCA%(1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,1),CCA%(1),P%,Q%)
	    end if
	  case 2
	    if P% = 0 then
	      call CpyW2W(CCD%(1,1),CCF%(1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,1),CCF%(1),P%,Q%)
	    end if
	  case 3
	    if P% = 0 then
	      call CpyW2W(CCD%(1,1),CCC%(1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,1),CCC%(1),P%,Q%)
	    end if
	  case 4
	    if not P% = 0 then call CpyQdr(CCD%(1,1),CCD%(1,1),P%,Q%)
	  case 5
	    if P% = 0 then
	      call CpyW2W(CCD%(1,1),CCD%(1,97),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 5
	select case S%
	  case 1
	    if P% = 0 then
	      call CpyW2W(CCD%(1,97),CCA%(1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,97),CCA%(1),P%,Q%)
	    end if
	  case 2
	    if P% = 0 then
	      call CpyW2W(CCD%(1,97),CCF%(1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,97),CCF%(1),P%,Q%)
	    end if
	  case 3
	    if P% = 0 then
	      call CpyW2W(CCD%(1,97),CCC%(1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,97),CCC%(1),P%,Q%)
	    end if
	  case 4
	    if P% = 0 then
	      call CpyW2W(CCD%(1,97),CCD%(1,1),%LMN/2)
	    else
	      call CpyQdr(CCD%(1,97),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if not P% = 0 then call CpyQdr(CCD%(1,97),CCD%(1,97),P%,Q%)
	end select
    end select
  else
    A% = S%
    B% = D%
    if A% > B% then swap A%,B%
    swap CCR%(D%),CCR%(S%)
    swap CCN$(D%),CCN$(S%)
    if P% = 0 then
      print# %UnitRPT, SLText$(36%);":";D%;"<==>";S%
    else
      print# %UnitRPT, SLText$(188%);" Quadrant";Q%;"<==>";P%;
      print# %UnitRPT, SLText$(187%);S%;"<==>";D%
    end if
    select case A%
      case 1
	if not P% = 0 then call SwpQdr(CCA%(1),CCA%(1),P%,Q%)
	select case B%
	  case 2
	    if P% = 0 then
	      call SwapWA(CCA%(1),CCF%(1),%LMN/2)
	    else
	      call SwpQdr(CCA%(1),CCF%(1),P%,Q%)
	    end if
	  case 3
	    if P% = 0 then
	      call SwapWA(CCA%(1),CCC%(1),%LMN/2)
	    else
	      call SwpQdr(CCA%(1),CCC%(1),P%,Q%)
	    end if
	  case 4
	    if P% = 0 then
	      call SwapWA(CCA%(1),CCD%(1,1),%LMN/2)
	    else
	      call SwpQdr(CCA%(1),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if P% = 0 then
	      call SwapWA(CCA%(1),CCD%(1,97),%LMN/2)
	    else
	      call SwpQdr(CCA%(1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 2
	if not P% = 0 then call SwpQdr(CCF%(1),CCF%(1),P%,Q%)
	select case B%
	  case 3
	    if P% = 0 then
	      call SwapWA(CCF%(1),CCC%(1),%LMN/2)
	    else
	      call SwpQdr(CCF%(1),CCC%(1),P%,Q%)
	    end if
	  case 4
	    if P% = 0 then
	      call SwapWA(CCF%(1),CCD%(1,1),%LMN/2)
	    else
	      call SwpQdr(CCF%(1),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if P% = 0 then
	      call SwapWA(CCF%(1),CCD%(1,97),%LMN/2)
	    else
	      call SwpQdr(CCF%(1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 3
	if not P% = 0 then call SwpQdr(CCC%(1),CCC%(1),P%,Q%)
	select case B%
	  case 4
	    if P% = 0 then
	      call SwapWA(CCC%(1),CCD%(1,1),%LMN/2)
	    else
	      call SwpQdr(CCC%(1),CCD%(1,1),P%,Q%)
	    end if
	  case 5
	    if P% = 0 then
	      call SwapWA(CCC%(1),CCD%(1,97),%LMN/2)
	    else
	      call SwpQdr(CCC%(1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 4
	if not P% = 0 then call SwpQdr(CCD%(1,1),CCD%(1,1),P%,Q%)
	select case B%
	  case 5
	    if P% = 0 then
	      call SwapWA(CCD%(1,1),CCD%(1,97),%LMN/2)
	    else
	      call SwpQdr(CCD%(1,1),CCD%(1,97),P%,Q%)
	    end if
	end select
      case 5
	if not P% = 0 then call SwpQdr(CCD%(1,97),CCD%(1,97),P%,Q%)
    end select
  end if
  call SQB(77%,23%,%Green)
end sub
'
'
' PROCEDURE  optimizes image by automatic stretching.
'----------------------------------------------------------------------------
'
sub Optimizer(CCA%())
  local M%,A%,D%,Z$,L%,H%
  call SQB(77%,23%,%Red)
  L% = MinByt%(CCA%(1),%LMN)
  H% = MaxByt%(CCA%(1),%LMN)
  D% = H% - L%						'-- dynamic
  if L% > 0 then call SubCBL(CCA%(1),L%,0%,%LMN)	'-- shift result down
  M% = 255 \ D%
  if M% > 1 then call MulCBL(CCA%(1),M%,255%,%LMN)		'-- multiply
  if (D% * M%) < 171 then call MD15BA(CCA%(1),%False,%LMN)	'-- * 1.5
  call SQB(77%,23%,%Green)
end sub
'
'
' >>> PRINTER  HANDLING <<<
'============================================================================
'
' PROCEDURE writes data to PCL-file. The file is assumed to be open.
'           Each data line (165 times 192 data bytes) are converted to either
'           a raster or a dither pattern with 8 X 8 dots. These 8 point rows
'           are scanned to check how many different bytes there are. If there
'           less than half a line, the line is run-length encoded. The lines
'           are than written as printer data in HP PCL Level III language.
' -----------------------------------------------------------------------------
'
sub LinPCL(CCB%(),PRes%,X$)
  local F%,N%,Y%,A%,B%,C%,D%,K%,P$,Z$
  print# %UnitPCL, chr$(27);"E";chr$(27);"*l0o0L";chr$(27);"*rbC";
  print# %UnitPCL, chr$(27);"*p419x";X$;"Y";chr$(27);"*t300R";
  print# %UnitPCL, chr$(27);"*r1536S";chr$(27);"*p4N";chr$(27);"*r2q1A";
  K% = Confirm%(SLText$(107%))
  color %Cyan,%Black
  print SLText$(103);
  color %LCyan,%Black
  Y% = csrlin
  P$ = space$(1728)
  for F% = 0 to 164
    locate Y%,50
    print using "###";F%+1;
    A% = F% * 192
    call OnePCL(CCB%(1),A%,P$,PRes%)
    for N% = 0 to 7
      D% = N% * 192
      call RLEscn(P$,D%,C%)
      if K% and (C% < 96) then
	call RLElin(P$,D%,C%)
	Z$ = ltrim$(rtrim$(str$(C%)))
	print# %UnitPCL, chr$(27);"*b1m";Z$;"W";mid$(P$,1537,C%);
      else
	print# %UnitPCL, chr$(27);"*b0m192W";mid$(P$,D%+1,192);
      end if
    next N%
  next F%
  P$ = ""
  print# %UnitPCL, chr$(27);"*rbC";chr$(27);"E";
  locate Y%,54
  print "";
  color %Cyan,%Black
  locate Y%,50
  print using "###";F%
  color %White,%Black
end sub
'
'
' >>> SOUND  HANDLING <<<
'============================================================================
'
' PROCEDURE sounds tone for one line (H), one column (V) or Center (S)
'-----------------------------------------------------------------------------
'
sub ToneOn(CCX%(2),CCA%(),CCB%(),X0%,Y0%,T$)
  local P%,N%,B%,D!,L!,A$
  A$ = ucase$(T$)
  L! = val(KeyIn$)
  if L! < 1 or L! > 9 then L! = 0.5
  D! = 0.2 * L!
  if A$ = "H" then
    B% = 192
    call XDimBA(CCB%(1),CCA%(1),165%,192%)
    P% = (((Y0%-1)*192+1)/2 + 0.5)
    call ToFreq(CCX%(0,1),CCB%(P%),B%)
  else
    if A$ = "V" then
      B% = 165
      P% = (((X0%-1)*165+1)/2 + 0.5)
    else
      B% = 1
      P% = (((X0%-1)*165+Y0%+1)/2 + 0.5)
    end if
    call ToFreq(CCX%(0,1),CCA%(P%),B%)
  end if
  call LRB(416%,337%,%Red)
  for N% = 1 to B%
    sound CCX%(0,N%),D!
  next N%
  call LRB(416%,337%,%Green)
end sub
'
'================================-<920813>-===========-<HoroSoft>-============
'
