'960411 1807
'****************************************************************************
'* PROGRAM NAME: CCDUSUB1.INC   DATE: 27. 3.1993   INCLUDE IN: CCDUTIL .BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Subroutines used in Main program.                               *
'* INCLUDE FILES:                                                           *
'* OBJECT FILES:                                                            *
'* INPUT FILES:                                                             *
'* OUTPUT FILES:                                                            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.05  11-APR-96: Corrected ST4 exposure time from ms to s/100   *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.03  10-FEB-96: Added Setup for HoroSoft Logo                  *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.02   2-JUN-94: Introduced Version CCDUSub1V% = 102            *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.01  30-DEC-93: New BYT and DOT file formats: RLCE             *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  27-MAR-93: Extracted from CCDUTIL 2.01                    *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDUSub1V% = 105
'
'
goto CCDUSUB1
'
'
' SUBROUTINE returns in A% a true flag if no Path/Drive error occured.
'----------------------------------------------------------------------------
'
ValidatePath:
'
E% = 0
D$ = curdir$
on error goto VPERR
if len(UsePath$) < 4 then
  chdir UsePath$
else
  chdir left$(UsePath$,len(UsePath$)-1)
end if
chdir D$
VPRES:
if E% = 0 then A% = %True else A% = %False
on error goto ErrorHandling
return
VPERR:
E% = err
resume VPRES
'
'
' SUBROUTINE returns validated path. I% = 1 for Input, 2 for output
'----------------------------------------------------------------------------
'
GetDirPath:
'
do
  if I% then
    UsePath$ = IOPath$(SLText$(1%),InpPath$,SLText$(50%))
  else
    UsePath$ = IOPath$(SLText$(2%),OutPath$,SLText$(50%))
  end if
  gosub ValidatePath
  if A% then exit loop
  if not Redo%(SLText$(51%)) then
    Fatal$ = SLText$(52%)
    return NoJob
  end if
  locate csrlin-1,1
loop
return
'
'
' SUBROUTINE queries for input option and returns Menu%:
'            1:LNX, 2:ALI, 3:ST4, 4:ASI, 5:BYT, 6:Bxx
'----------------------------------------------------------------------------
'
InputOption:
'
do
  print LogOn$(Version$,%Cyan,%Black)
  print Describe$
  color %LCyan,%Black
  print Center$(SLText$(4%),80)
  color %Cyan,%Black
  call MLText(2%,11%,"tf")
  Menu% = Prompt%(16%,Q$)
  if Q$ = chr$(27) then goto LogOff
  if Q$ = chr$(13) then Menu% = 0
  if (Menu% < 8) and (Menu% > 0) then exit loop
  print Outch$(Q$)
loop
return
'
'
' SUBROUTINE returns InpPath$ with a valid path where at least one file
'            with the appropriate extension can be found. User may Abort.
'----------------------------------------------------------------------------
'
InputPath:
'
do
  print LogOn$(Version$,%Green,%Black)
  I% = %True
  gosub GetDirPath
  InpPath$ = UsePath$
  Ext$ = FileTyp$(Menu%)
  if ListFiles%(InpPath$,Ext$,English%) then exit loop
  beep
  Fatal$ = SLText$(8%)
  if not Redo%(SLText$(12%)) then return NoJob
loop
return
'
'
' SUBROUTINE gets and validates input file: availability and size match.
'            Input may be repeated here or aborted.
'----------------------------------------------------------------------------
'
InputFile:
'
if Ext$ = "B??" then F% = %True else F% = %False
Y% = csrlin
X% = pos(Y%)
do
  locate Y%,X%
  AFile$ = IOFile$(English%,F%,SLText$(50%))
  if AFile$ = "" then iterate loop
  if not Menu% = 6 then AFile$ = AFile$ + "." + FileTyp$(Menu%)
  UseFile$ = InpPath$ + AFile$
  if not FileHere%(UseFile$) then
    if not Redo%(SLText$(13%)) then
      Fatal$ = SLText$(87%) + " " + UseFile$
      return NoJob
    else
      iterate loop
    end if
  end if
  if Menu% = 5 or Menu% = 6 then			'-- RLCE compressed
    open UseFile$ for binary as # %UnitAUX
    A?? = lof(%UnitAUX)
    get$ # %UnitAUX, 5,D$
    close %UnitAUX
    Z?? = asc(mid$(D$,2,1)) * 256 + asc(mid$(D$,1,1))
    if A?? = Z?? then exit loop
    Z?? = asc(mid$(D$,4,1)) * 256 + asc(mid$(D$,3,1))
    if Z?? = 31680 then exit loop
  else
    if SizeOk%(UseFile$,clng(FileSize&(Menu%))) then exit loop
  end if
  if not Redo%(SLText$(14%)) then
    Fatal$=SLText$(85%)+" ."+Ext$+" "+SLText$(86%)+str$(FileSize&(Menu%))
    return NoJob
  end if
loop
return
'
'
' SUBROUTINE asks for full filespecs
'----------------------------------------------------------------------------
'
GetFileSpec:
'
gosub InputOption	'-- Get Option 1-7
gosub InputPath		'-- Get Infile Dirspecs validated
gosub InputFile		'-- Get Inputfile validated
return
'
'
' SUBROUTINE reads a Lynxx LNX or artificial Lynxx ALI file and returns in
'            CCA% and CCD% 8-bit converted image data.
'----------------------------------------------------------------------------
'
GetLNX:
'
open UseFile$ for binary as # %UnitAUX
print UseFile$;" ";SLText$(90%)
Handle% = fileattr(%UnitAUX,2)
call DecLnx(Handle%,CCD%(1,1))
close %UnitAUX
if not Handle% then
  Fatal$ = SLText$(25%)
  return NoJob
end if
mid$(ST4Info$,2,11) = "Lynxx Img. "
MaxV% = MaxWrd%(CCD%(1,1),%LMN)
call C16T8(CCD%(),MaxV%)
color %Cyan,%Black
print SLText$(47%);
call CpyW2B(CCB%(1),CCD%(1,1),%LMN)
call XDimBA(CCA%(1),CCB%(1),192%,165%)
print ""
return
'
'
' SUBROUTINE gets data from ST4 or ASI file into CCA% and ST4Info$
'----------------------------------------------------------------------------
'
GetST4:
'
open UseFile$ for binary as # %UnitAUX
print UseFile$;" ";SLText$(90%)
R$ = space$(192)
Handle% = fileattr(%UnitAUX,2)
call EDCST4(%DOSRead,R$,Handle%,CCB%(1))
close %UnitAUX
if not Handle% then
  Fatal$ = SLText$(28%)
  return NoJob
end if
call XDimBA(CCA%(1),CCB%(1),192%,165%)
color %LGreen,%Black
print mid$(R$,2,78)
color %Green,%Black
print "Exposure time (s/100): ";
color %LGreen,%Black
print mid$(R$,80,10)
color %Green,%Black
print "Focal length (inch): ";
color %LGreen,%Black
print mid$(R$,90,10)
color %Green,%Black
print "Apperture (inch):    ";
color %LGreen,%Black
print mid$(R$,100,10)
color %Green,%Black
print "Calibration factor (1): ";
color %LGreen,%Black
print mid$(R$,110,10)
color %LGreen,%Black
print mid$(R$,120,72)
A$ = left$(R$,119) + STCR$
ST4Info$ = A$
color %White,%Black
return
'
'
' SUBROUTINE reads BYT & Bxx file and decodes it from RLCE into CCA% and CCD%
'----------------------------------------------------------------------------
'
GetByt:
'
color %Cyan,%Black
print SLText$(9%);UseFile$;
Fatal$ = SLText$(227%)
open UseFile$ for binary as # %UnitBYT
Handle% = fileattr(%UnitBYT,2)
Fatal$ = SLText$(74%)
Z% = RdBie%(CCB%(1),Handle%,31685??)
close %UnitBYT
if Z% then return NoJob
S% = DecBie%(CCA%(1),CCB%(1))
if not S% then print " " else print SLText$(228%);31680-S%
call CpyB2W(CCD%(1,1),CCA%(1),%LMN)
color %White,%Black
mid$(ST4Info$,2,11) = "Byte Img. "
return
'
'
' SUBROUTINE asks whether a Lynxx file ALI should be created and does so
'---------------------------------------------------------------------------
'
PutLnx:
'
if not Confirm%(SLText$(7%)) then		'-- Synthesize Lynxx ALI
  SynthFile$ = OutPath$ + LoadFile$ + ".ALI"
  open SynthFile$ for output as # %UnitAUX
  call XDimBA(CCB%(1),CCA%(1),165%,192%)
  call CpyB2W(CCD%(1,1),CCB%(1),%LMN)
  Handle% = fileattr(%UnitAUX,2)
  call EncLnx(Handle%,SyLyFlg%,CCD%(1,1))
  close %UnitAUX
  if not Handle% then print Outch$(SLText$(22%))
end if
return
'
'
' SUBROUTINE  asks whether a ST4 file ASI should be created and does so
'----------------------------------------------------------------------------
'
PutST4:
'
if not Confirm%(SLText$(19%)) then	'-- Synthesize ST4 ASI
  SynthFile$ = OutPath$ + LoadFile$ + ".ASI"
  open SynthFile$ for output as # %UnitAUX
  color %Cyan,%Black
  print SynthFile$;" ";SLText$(91%)
  mid$(ST4Info$,120,72) = STCR$
  Handle% = fileattr(%UnitAUX,2)
  call XDimBA(CCB%(1),CCA%(1),165%,192%)
  call EDCST4(%DOSWrite,ST4Info$,Handle%,CCB%(1))
  close %UnitAUX
  if not Handle% then print Outch$(SLText$(23%))
end if
return
'
'
' SUBROUTINE asks whether a BYT file BYT should be created and does so
'----------------------------------------------------------------------------
'
PutByt:
'
if not Confirm%(SLText$(5%)) then
  SynthFile$ = OutPath$ + LoadFile$ + ".BYT"
  Z% = WrtByt%(CCA%(),CCB%(),SynthFile$)
  if Z% then
    print SLText$(229%);Z%
    delay 1
  end if
end if
return
'
'
' SUBROUTINE gets frames for options O and P
'----------------------------------------------------------------------------
'
OPHead:
'
print LogOn$(Version$,%White,%Red)
Y% = csrlin
locate 21,1
color %White,%Black
print SLText$(116%);" ";CCN$(1)
print SLText$(117%);" ";CCN$(2)
print "Backup: ";CCN$(3)
locate Y%,1
return
'
'
' SUBROUTINE-EXTENSION for non-available Menus. Proper return to main program
'   without stack problems.
'-----------------------------------------------------------------------------
'
NonAv:
Y% = csrlin
X% = pos(Y%)
locate Y%,X%
color %LWhite,%Red
print Center$(SLText$(111%),80);
color %White,%Black
delay 1
locate Y%,X%
print space$(80);
locate Y%,X%
return
'
'
CCDUSUB1:
'
'===================================-<930327>-=========-<HoroSoft>-==========
'
