'960412 1418
'****************************************************************************
'* PROGRAM NAME: CCDUSUB2.INC   DATE:  5. 9.1992   INCLUDE IN: CCDUTIL .BAS *
'* LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
'* PURPOSE: Option Subroutines - Main-Program Extensions.                   *
'* INCLUDE FILES: none.                                                     *
'* OBJECT FILES:  none.                                                     *
'* INPUT FILES:   none.                                                     *
'* OUTPUT FILES:  none.                                                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.13 12-APR-96: Bugfix for sound in OptJ                        *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.12 10-FEB-96: Recompiled with PB 3.20                         *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.11 19-FEB-95: Same color scales for brightness as others      *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.10 11-FEB-95: Added Brightness measurement                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.09 17-SEP-94: Entirely redid unsharp masking                  *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.08 13-SEP-94: Made Screen-Grabber Option available on         *
'*               graphics screens A, B and D (I & J were ok already).       *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.07  1-JUN-94: Adjustments for RLCE-Encoder.                   *
'*               Introduced Version CCDUSub2V% = 207                        *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.06  9-FEB-94: Added CGE file save options.                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.05 25-JAN-94: Added 180 rotate in Menu L (4) and CGE files.  *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.04 31-DEC-93: BYT and DOT files are now RLCE encoded          *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.03 24-DEC-93: Retry with PB 3                                 *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.02 27-NOV-93: Bug fixes in Option K, Cutting and framing.     *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.01 31-MAR-93: Ported to PB 3.00a for CCDUTIL V.2, now PB2     *
'* ------------------------------------------------------------------------ *
'* VERSION: 1.00  5-SEP-92: Extracted from CCDUTIL.BAS                      *
'* ------------------------------------------------------------------------ *
'* COMMENTS:                                                                *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
CCDUSub2V% = 213
'
'
goto CCDUSUB2            'Include file - skip over this
'
'
' Option-A: The 6 images with 2, 4, 8, 16 and 32 false colors are displayed
'----------------------------------------------------------------------------
'
OptA:
'
if ScrMode% = 0 then goto NonAv
color %Green,%Black
print Center$(SLText$(16%),79);
color %White,%Black
VGAGS% = %True
if VGAHere% then VGAGS% = Confirm%(SLText$(198%))
if VGAGS% then R% = not Confirm%(SLText$(37%))
locate 1,1,0
if not VGAGS% then
  reg %AX, &h1200
  reg %BX, &h0033
  call interrupt %VBIOS
end if
screen ScrMode%
call FCMI(CCA%(),ColScale%(),R%,VGAGS%)
A% = EscRet%
if not VGAGS% then
  reg %AX, &h1201
  reg %BX, &h0033
  call interrupt %VBIOS
end if
screen 0
return
'
'
' Option-B: We ask whether the false color gray-scale-zoomed image should be
'           displayed. Then we get the number of colors for dithering.
'----------------------------------------------------------------------------
'
OptB:
'
if ScrMode% = 0 then goto NonAv
print LogOn$(Version$,%White,%Pink)
color %LCyan,%Black
print Center$(SLText$(11%),80)
color %LGreen,%Black
print Center$(SLText$(17%),80)
color %Cyan,%Black
call MLText(4%,7%,"tf")
A% = Prompt%(20%,Q$)
if A% < 1 or A% > 8 then A% = 4			'-- default ICI assumed
if not A% = 1 then
  R% = %False
  if A% > 4 and A% < 9 then			'-- grayweighted
    R% = %True
    G% = %False
    if VGAHere% then
      if Confirm%(SLText$(199%)) then G% = %True
	if G% then
	reg %AX, &h1200
	reg %BX, &h0033
	call interrupt %VBIOS
      end if
    end if
  end if
  screen ScrMode%
  call GSZoom(CCA%(),ColScale%(),A%,R%)
else
  screen ScrMode%
  call GrayZoom(CCA%(),GrayScale%())
end if
A% = EscRet%
if G% then
  reg %AX, &h1201
  reg %BX, &h0033
  call interrupt %VBIOS
end if
screen 0
return
'
'
' Option-C: Isophotes Curves
'----------------------------------------------------------------------------
'
OptC:
'
IsoFlg% = Confirm%(SLText$(194%))
if IsoFlg% and ScrMode% = 0 then goto NonAv
BO% = 175
Z$ = FilExt$(%UnitDOT)
call FillWC(CCB%(1),0%,%LMN/2)
print LogOn$(Version$,%White,%Pink)
color %LCyan,%Black
print Center$(SLText$(63%),80)
color %Cyan,%Black
call MLText(6%,5%,"tf")
S% = Prompt%(40%,Q$)
if Q$ = chr$(27) then return
if S% < 1 or S% > 7 then
  S% = 4
  color %LCyan,%Black
  print "4";
  delay .5
end if
if R% then C% = 7 else C% = 15
color %White,%Black
call EquiBr(CCA%(1),CCB%(1),S%)
if IsoFlg% then
  screen ScrMode%
  call LRB(413%,BO%,%Red)
  select case S%
    case 5
      C% = 3
    case 6
      C% = 1
    case 7
      C% = 0
  end select
  line (0,0)-(383,329),%Red,B
  line (446,0)-(639,166),%Red,BF
  line (446,183)-(639,349),%Red,B
  call SetSix(CCA%(1),ColScale%(C%),18-S%)
  if instat then Q$ = inkey$
  call SetSix(CCB%(1),ColScale%(1%),10%)
  if instat then Q$ = inkey$
  call IsoHug(CCB%(1))
  line (0,0)-(383,329),%Red,B
  if instat then Q$ = inkey$
  call LRB(413%,BO%,%Green)
  locate 10,50
  color %LGreen,%Black
  print "[RET]";
  locate 11,50
  print SLText$(139%);".";
  locate 15,50
  color %Yellow,%Black
  print "[ESC]";
  locate 16,50
  print SLText$(140%);
  color %White,%Black
  if EscRet% then
    line (391,125) - (433,300),%Black,BF
    line (  0,  0) - (383,329),%White,B
    line (446,  0) - (639,166),%White,B
    line (446,183) - (639,349),%Black,BF
    pset (638,348),%White 		    'Isophotes Identifier for CCDPRINT
    A$ = WRTFile$ + Z$
    A% = WrtDoto%(CCB%(),A$,Z$)
    Z$ = Nill$
  end if
  screen 0
  if Z$ = Nill$ then
    Z$ = FilExt$(%UnitDOT)
    color %Cyan,%Black
    locate 23,1
    print SLText$(49%);
    color %LCyan,%Black
    print# %UnitRPT, SLText$(49%);WRTFile$;Z$;" ";SLText$(141%)
    print WRTFile$;Z$;W$
    color %White,%Black
    FilExt$(%UnitDOT) = IncrExt$(Z$)
    delay 1
  end if
  screen 0
else
  M% = 0
  if Confirm%(SLText$(195%)) then
    M% = 2
  else
    if Confirm%(SLText$(196%)) then M% = 1
  end if
  call SupImp(CCA%(1),CCB%(1),M%)
  print# %UnitRPT, SLText$(197%)
end if
return
'
'
' Option-D: Display rasterized 16 gray-scales zoomed image
'----------------------------------------------------------------------------
'
OptD:
'
if ScrMode% = 0 then goto NonAv
if VGAHere% then
  reg %AX, &h1200
  reg %BX, &h0033
  call interrupt %VBIOS
  screen ScrMode%
  call GSZoom(CCA%(),ColScale%(),6%,%True)
  reg %AX, &h1201
  reg %BX, &h0033
  call interrupt %VBIOS
else
  screen ScrMode%
  call GrayZoom(CCA%(),GrayScale%())
end if
A% = EscRet%
screen 0
return
'
'
' Option-E: Luminance Histogram. - DotoGram (R) HoroSoft
'----------------------------------------------------------------------------
'
OptE:
'
if ScrMode% = 0 then goto NonAv
BO%   = 280
SRow% = 1
if Confirm%(SLText$(32%)) then
  LAV% = MinV%
  HAV% = MaxV%
  D% = 0
else
  print
  LAV% = SelOpt%(SLText$(26%) + using$("####",MinV%) + "): ")
  HAV% = SelOpt%(SLText$(27%) + using$("####",MaxV%) + "): ")
  if HAV% = 0 then HAV% = MaxV%
  D% = SelOpt%(SLText$(15%))
end if
screen ScrMode%
Z$ = FilExt$(%UnitDOT)
call LumPlot(CCA%(),LAV%,HAV%,D%,CCN$(1),WRTFile$,Z$,VN$,BO%,CCB%())
screen 0
if Z$ = Nill$ then
  Z$ = FilExt$(%UnitDOT)
  color %Cyan,%Black
  locate 23,1
  print SLText$(49%);
  color %LCyan,%Black
  print# %UnitRPT, SLText$(49%);WRTFile$;Z$;" (Dotogram)"
  print WRTFile$;Z$;" (Dotogram)"
  color %White,%Black
  FilExt$(%UnitDOT) = IncrExt$(Z$)
  delay 1
end if
return
'
'
' Option-F: Draw Profil
'-----------------------------------------------------------------------------
'
OptF:
'
if ScrMode% = 0 then goto NonAv
Z$ = FilExt$(%UnitDOT)
Slant% = Confirm%(SLText$(94%))
print LogOn$(Version$,%White,%Pink)
color %LCyan,%Black
print Center$(SLText$(95%),80)
color %Cyan,%Black
call MLText(8%,12%,"tf")
A% = Prompt%(64%,Q$)
color %LCyan,%Black
select case Q$
  case chr$(27)
    return
  case "1"
    VR% = 1
  case "3"
    VR% = 3
  case "5"
    VR% = 5
  case else
    print "3";
    VR% = 3
end select
print
if VR% > 1 then if not Confirm%(SLText$(97%)) then VR% = -VR%
print
color %LCyan,%Black
print Center$(SLText$(96%),80)
color %Cyan,%Black
call MLText(9%,12%,"tf")
A% = Prompt%(64%,Q$)
color %LCyan,%Black
select case Q$
  case chr$(27)
    return
  case "1"
    HR% = 1
  case "2"
    HR% = 2
  case "3"
    HR% = 3
  case "4"
    HR% = 4
  case else
    print "2";
    HR% = 2
end select
print
if HR% > 1 then if not Confirm%(SLText$(97%)) then HR% = -HR%
SF% = 5
if not Confirm%(SLText$(98%)) then
  SF% = SelOpt%(SLText$(99%))
  if SF% = 0 then SF% = 5
end if
screen ScrMode%
call LRB(624%,12%,%Red)
call Profil(CCA%(),CCX%(),HR%,VR%,SF%,Slant%,AF%)
call LRB(624%,12%,%Green)
if AF% then
  screen 0
else
  if Slant% then X% = 63 else X% = 1
  color %LGreen,%Black
  locate 23,X%
  print SLText$(3%);
  color %Yellow,%Black
  locate 24,X%
  print SLText$(10%);
  color %White,%Black
  if EscRet% then
    line (592,0) - (639,24),%Black,BF
    if X% = 1 then
      line (0,306) - (140,347),%Black,BF
    else
      line (496,306) - (639,347),%Black,BF
    end if
    line (0,0) - (590,349),%White,B
    pset (637,348),%White			'Profil Identifier for CCDPRINT
    A$ = WRTFile$ + Z$
    A% = WrtDoto%(CCB%(),A$,Z$)
    Z$ = Nill$
  end if
  screen 0
  if Z$ = Nill$ then
    Z$ = FilExt$(%UnitDOT)
    color %Cyan,%Black
    locate 23,1
    print SLText$(49%);
    color %LCyan,%Black
    print# %UnitRPT, SLText$(49%);WRTFile$;Z$;" (Profil)"
    print WRTFile$;Z$;" (Profil)"
    color %White,%Black
    FilExt$(%UnitDOT) = IncrExt$(Z$)
    delay 1
  end if
end if
return
'
'
' Option-G1: [RET] Displays Table of Values at crosshair position
' Option-G2: [ESC] Ascii-representation of zoomed-cut image
'----------------------------------------------------------------------------
'
OptG:
'
GHFlag% = Confirm%(SLText$(248%))
locate 1,1,0
if GHFlag% then call Template else call AscTbl(VN$,ChrDec$)
call InStep(XS%,2%,28%,%LGreen)
call InStep(YS%,2%,39%,%LRed)
call TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,GHFlag%,AR$(),TR$())
do
  A$ = KeyIn$
  select case A$
    case chr$(13), chr$(27)		'-- RET
      exit loop
    case chr$(0,82)			'-- INSert Edit
      if GHFlag% then call Edit(CCA%(),X0%,Y0%)
    case chr$(0,72)			'-- UP
      Y1% = Y0%
      Y0% = NewXY0%(Y0%,YS%,"U")
      call TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,GHFlag%,AR$(),TR$())
    case chr$(0,80)			'-- DOWN
      Y1% = Y0%
      Y0% = NewXY0%(Y0%,YS%,"D")
      call TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,GHFlag%,AR$(),TR$())
    case chr$(0,75)			'-- LEFT
      X1% = X0%
      X0% = NewXY0%(X0%,XS%,"L")
      call TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,GHFlag%,AR$(),TR$())
    case chr$(0,77)			'-- RIGHT
      X1% = X0%
      X0% = NewXY0%(X0%,XS%,"R")
      call TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,GHFlag%,AR$(),TR$())
     case "*","/","+","-"
       call StepAdj(CCA%(),2%,39%,28%,YS%,XS%,Y0%,X0%,Y1%,X1%,A$)
     case "."				'-- center
       call CentXY(X0%,Y0%,X1%,Y1%)
       call TempRep(CCA%(),Y0%,X0%,YU%,XL%,ChrDec$,GHFlag%,AR$(),TR$())
  end select
loop
return
'
'
' Option-H: Brightness measurement
'----------------------------------------------------------------------------
'
OptH:
'
Z% = %True
if not ScrMode% = 0 then Z% = Confirm%("Mode:  "+SLText$(253%))
if istrue Z% then
  print LogOn$(Version$,%White,%Red)
  call SQB(75%,24%,%Red)
  locate 5,1
  call BBox
  Cy% =  8
  Xb% = X0%
  Xl% = X0%
  Xr% = X0%
  Yb% = Y0%
  Yu% = Y0%
  Yl% = Y0%
  Z%  = 1
  for N% = 1 to 17 step 2
    if N% > 1 then
      Z%  = fix(N%/2)
      if Xb% <= Z% then Xb% = Z%+1
      if Yb% <= Z% then Yb% = Z%+1
      Xl% = Xb% - Z%						'X-left
      Xr% = Xb% + Z%						'X-right
      Yu% = Yb% - Z%						'Y-upper
      Yl% = Yb% + Z%						'Y-lower
    end if
    Cx% = 21
    call FillBox1(Cx%,Cy%,Xl%,Yu%,Xr%,Yl%,Xb%,Yb%)
    O%  = (Xl%-1) * 165 + Yu% - 1		'top left corner of box
    S%  = N%
    S2% = S% * S%
    call CpyBox(CCG%(1),CCA%(1),O%,S%)
    M% = MinByt%(CCG%(1),S2%)
    call FillBox2(Cx%,Cy%,M%)
    M% = AvgByt%(CCG%(1),S2%)
    call FillBox2(Cx%,Cy%,M%)
    M% = MaxByt%(CCG%(1),S2%)
    call FillBox2(Cx%,Cy%,M%)
    incr Cy%
  next N%
  color %Cyan,%Black
  locate 19,1
  for N% = 250 to 252
    print Center$(SLText$(N%),80);
  next N%
  call SQB(75%,24%,%Green)
  Q$ = KeyIn$
else
  if istrue R% then C% = 7 else C% = 15
  call CpyB2W(CCG%(3000),ColScale%(C%),16%)	'create color scale
  CCG%(3000) = %LWhite				'color
  CCG%(3100) = &hAAAA				'pattern
  for N% = 3101 to 3115
    CCG%(N%) = &hFFFF
  next N%
  locate 1,1,0
  screen ScrMode%
  call HistBox
  call LRB(620%,330%,%Red)
  for N% = 0 to 255
    Gy%  = N%+1
    Gcp% = fix(N%/16) + 3000			'-- CCG color pointer
    Gpp% = fix(N%/16) + 3100			'-- CCG pattern pointer
    CCG%(Gy%) = CntByt%(CCA%(1),N%,%LMN)
    XNR% = int(CCG%(Gy%)/100)+1
    line (  1,Gy%) - (XNR%,Gy%),CCG%(Gcp%),,CCG%(Gpp%)
    if not CCG%(Gy%) = 0 then
      XGR! = log10(CCG%(Gy%)) * 66 + 338.5
      XGR% = fix(XGR!)
      line (338,Gy%) - (XGR%,Gy%),CCG%(Gcp%),,CCG%(Gpp%)
    else
      if C% = 0 then C% = %White
      pset (337,Gy%),CCG%(Gcp%)
    end if
  next N%
  M% = MaxWrd%(CCG%(1),256%)
  if M% < 10894 then
    locate 21,1
    color %LCyan,%Black
    select case M%
      case < 327
        print "0    50    100   150   200     250  300   "
        Z% = 1
      case < 1090
        print "0    167   333   500    667   833   1000  "
        Z% = 3
      case < 3268
        print "0    500   1000  1500  2000   2500  3000  "
        Z% = 10
      case else
        print "0    1667  3333  5000   6667  8333 10000  "
        Z% = 30
    end select
    color %White,%Black
    for N% = 0 to 255
      Gy%  = N%+1
      Gcp% = fix(N%/16) + 3000			'-- CCG color pointer
      Gpp% = fix(N%/16) + 3100			'-- CCG pattern pointer
      XNR% = int(CCG%(Gy%)/Z%)+1
      line (  1,Gy%) - (XNR%,Gy%),CCG%(Gcp%),,CCG%(Gpp%)
    next N%
  end if
  call LRB(620%,330%,%Green)
  Q$ = KeyIn$
  screen 0
end if
return
'
'
' Option-I: Analyze Cut-Histo
'----------------------------------------------------------------------------
'
OptI:
'
if ScrMode% = 0 then goto NonAv
if Scope% then
  Scope% = %False
  PixH! = 0.01375
  PixV! = 0.016
  TelF! = 1000
  print LogOn$(Version$,%White,%Brown)
  color %LCyan,%Black
  print Center$(SLText$(231%),80)
  color %Cyan,%Black
  call MLText(27%,80%,"cs")
  print
  if not Confirm%(SLText$(232%)) then
    print SLText$(233%);" ";
    input PixH!
    print SLText$(234%);" ";
    input PixV!
  end if
  if Confirm%(SLText$(236%)) then
    print SLText$(235%);" ";
    input TelF!
  end if
  Z! = TelF! * 3.14159
  PHS! = PixH! * 648000 / Z!
  PVS! = PixV! * 648000 / Z!
end if
cls
locate 1,1,0
screen ScrMode%
call LRB(230%,12%,%Red)
call IBox(VN$,YS%,XS%,%True)
line (  0,  0)-(193,166),%LPink,B
line (  0,183)-(193,349),%LBlue,B
line (430,  9)-(623,175),%Yellow,B
line (202, 97)-(271,166),%LBlue,B
paint(431,10),%Gray,%Yellow
if R% then C% = 7 else C% = 15
call SetSix(CCA%(1),ColScale%(3%),7%)
if instat then Q$ = inkey$
call SetSix(CCA%(1),ColScale%(C%),8%)
if instat then Q$ = inkey$
call SetSix(CCA%(1),ColScale%(1%),9%)
if instat then Q$ = inkey$
line (430,188)-(623,319),%Yellow,B
line (283,  9)-(414,175),%Yellow,B
X1% = X0% - 1
Y1% = Y0% - 1
call RedXHist(CCA%(),Y0%,Y1%,SpcFlg%)
call GrnYHist(CCA%(),X0%,X1%,SpcFlg%)
call CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
PXH% = X0%
PYH% = Y0%
do
  call LRB(230%,12%,%Green)
  color %LCyan,%Black
  locate 17,45
  print using "###";UseByte%(CCA%(),X0%,Y0%)
  A$ = Flash$(X0%,Y0%,%True)
  select case A$
    case chr$(13)					'-- RET
      exit loop
    case chr$(27)					'-- ESC
      exit loop
    case chr$(0,72)					'-- UP
      Y1% = Y0%
      Y0% = NewXY0%(Y0%,YS%,"U")
      call RedXHist(CCA%(),Y0%,Y1%,SpcFlg%)
      call CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
    case chr$(0,80)					'-- DOWN
      Y1% = Y0%
      Y0% = NewXY0%(Y0%,YS%,"D")
      call RedXHist(CCA%(),Y0%,Y1%,SpcFlg%)
      call CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
    case chr$(0,75)					'-- LEFT
      X1% = X0%
      X0% = NewXY0%(X0%,XS%,"L")
      call GrnYHist(CCA%(),X0%,X1%,SpcFlg%)
      call CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
    case chr$(0,77)					'-- RIGHT
      X1% = X0%
      X0% = NewXY0%(X0%,XS%,"R")
      call GrnYHist(CCA%(),X0%,X1%,SpcFlg%)
      call CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
     case "*","/","+","-"
       call StepAdj(CCA%(),24%,50%,45%,YS%,XS%,Y0%,X0%,Y1%,X1%,A$)
    case " "						'-- Full/Empty curve
      SpcFlg% = not SpcFlg%
      call RedXHist(CCA%(),Y0%,Y1%,SpcFlg%)
      call GrnYHist(CCA%(),X0%,X1%,SpcFlg%)
    case "."						'-- center
      call CentXY(X0%,Y0%,X1%,Y1%)
      call RedXHist(CCA%(),Y0%,Y1%,SpcFlg%)
      call GrnYHist(CCA%(),X0%,X1%,SpcFlg%)
      call CutPic(CCA%(),Y0%,X0%,ColScale%(),R%)
    case chr$(0,71)					'-- HOME: Start
      PXH% = X0%
      PYH% = Y0%
      locate 15,43
      print string$(8,".")
    case chr$(0,79)					'-- END: end
      A% = abs(PXH%-X0%)
      Z% = abs(PYH%-Y0%)
      Pyt! = (A%*A%*PHS!*PHS!) + (Z%*Z%*PVS!*PVS!)
      locate 15,43
      color %Yellow,%Black
      print using "####,.##";sqr(Pyt!)
  end select
loop
screen 0
return
'
'
' Option-J X/Y Analyzing
'----------------------------------------------------------------------------
'
OptJ:
'
if ScrMode% = 0 then goto NonAv
locate 1,1,0
screen ScrMode%
call DrawGrid
call DrawAnaly(CCA%(),ColScale%(),R%)
call InStep(XS%,2%,10%,%LGreen)
call Instep(YS%,2%,22%,%LRed)
call HoriCut(CCA%(),Y0%,X0%)
call VertCut(CCA%(),X0%,Y0%)
call LRB(416%,337%,%Green)
do
  A$ = Flash$(X0%,Y0%,%False)
  select case A$
    case chr$(13)					'-- RET
      exit loop
    case chr$(27)					'-- ESC
      exit loop
    case chr$(0,72)					'-- UP
      Y1% = Y0%
      Y0% = NewXY0%(Y0%,YS%,"U")
      call HoriCut(CCA%(),Y0%,X0%)
    case chr$(0,80)					'-- DOWN
      Y1% = Y0%
      Y0% = NewXY0%(Y0%,YS%,"D")
      call HoriCut(CCA%(),Y0%,X0%)
    case chr$(0,75)					'-- LEFT
      X1% = X0%
      X0% = NewXY0%(X0%,XS%,"L")
      call VertCut(CCA%(),X0%,Y0%)
    case chr$(0,77)					'-- RIGHT
      X1% = X0%
      X0% = NewXY0%(X0%,XS%,"R")
      call VertCut(CCA%(),X0%,Y0%)
     case "*","/","+","-"
       call StepAdj(CCA%(),2%,22%,10%,YS%,XS%,Y0%,X0%,Y1%,X1%,A$)
     case " "						'-- redraw
       line (0,44)-(384,301),%Black,BF
       call DrawGrid
       call HoriCut(CCA%(),Y0%,X0%)
       call VertCut(CCA%(),X0%,Y0%)
     case "."						'-- center
       call CentXY(X0%,Y0%,X1%,Y1%)
       call HoriCut(CCA%(),Y0%,X0%)
       call VertCut(CCA%(),X0%,Y0%)
     case "H","h","V","v","$"
       call ToneOn(CCX%(),CCA%(),CCB%(),X0%,Y0%,A$)
  end select
loop
screen 0
return
'
'
' Option-K: Part Frame Handling
'----------------------------------------------------------------------------
'
OptK:
'
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(206%),80)
color %Cyan,%Black
call MLText(26%,16%,"tf")
A% = Prompt%(21%,Q$)
if A% < 1 or A% > 8 then
  print Outch$(Q$)
  return
end if
print
if A% < 6 then
  XA% = IntLmt%(1%,192%,SelOpt%(SLText$(207%)))
  YA% = IntLmt%(1%,165%,SelOpt%(SLText$(208%)))
  XB% = IntLmt%(XA%,192%,SelOpt%(SLText$(209%) + " " + str$(XA%) + " - 192 "))
  YB% = IntLmt%(YA%,165%,SelOpt%(SLText$(210%) + " " + str$(YA%) + " - 165 "))
  X%  = IntLmt%(1%,192%,XB%-XA%+1)
  Y%  = IntLmt%(1%,165%,YB%-YA%+1)
  print# %UnitRPT, SLText$(214%);XA%;",";YA%;",";XB%;",";YB%
  decr XA%
  decr YA%
  P% = YA% * 192 + XA%
end if
call XDimBA(CCB%(1),CCA%(1),165%,192%)
select case A%
  case 1				'-- fill with value
    C% = IntLmt%(0%,255%,SelOpt%(SLText$(213%)))
    call FilFrm(CCB%(1),C%,X%,Y%,P%)
    print# %UnitRPT, SLText$(134%);C%
  case 2				'-- cut
    C% = IntLmt%(0%,255%,SelOpt%(SLText$(213%)))
    call FillBC(CCA%(1),C%,%LMN)
    call CutFrm(CCA%(1),CCB%(1),X%,Y%,P%)
    call CpyW2W(CCB%(1),CCA%(1),%LMN/2)
    print# %UnitRPT, SLText$(215%);SLText$(134%);C%
  case 3, 4, 5
    select case A%
      case 3
	C% =   0
	A% = 222
      case 4
	C% = 255
	A% = 223
      case 5
	C% = 256
	A% = 224
    end select
    if X% > 2 and Y% > 2 then
      call FrmFrm(CCB%(1),C%,X%,Y%,P%)
    else
      if Y% < 3 then
	for N% = 1 to Y%
	  call FrmHln(CCB%(1),C%,X%,P%)
	  P% = P% + 192
	next N%
      else
	for N% = 1 to X%
	  call FrmVln(CCB%(1),C%,Y%,P%)
	  incr P%
	next N%
      end if
    end if
    print# %UnitRPT, SLText$(216%);SLText$(A%)
  case 6, 7, 8
    select case A%
      case 6
	C% =   0
      case 7
	C% = 255
      case 8
	C% = 256
    end select
    call HVGrid(CCB%(1),C%)
    print# %UnitRPT, SLText$(226%)
end select
call XDimBA(CCA%(1),CCB%(1),192%,165%)
return
'
'
' Option-L: Flip left/right or upside down, rotate 90 CCW
'           Horizontal Y-axis flip. If image is squarred after at least one
'           rotate, it is always moved to the left edge.
'           Vertical X-axis flip
'           Rotate squared image by 90 counterclock wise. The first time,
'           the image will have to be squarred.
'----------------------------------------------------------------------------
'
OptL:
'
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(205%),80)
color %Cyan,%Black
call MLText(25%,16%,"tf")
A% = Prompt%(21%,Q$)
if A% = 5 or A% = 6 then
  print
  B% = IntLmt%(1%,191%,SelOpt%(SLText$(211%)+" (1...191): "))
  C% = IntLmt%(0%,255%,SelOpt%(SLText$(213%)))
end if
if A% = 7 or A% = 8 then
  print
  B% = IntLmt%(1%,164%,SelOpt%(SLText$(212%)+" (1...164): "))
  C% = IntLmt%(0%,255%,SelOpt%(SLText$(213%)))
end if
Z$ = SLText$(217) + str$(B%) + " " + SLText$(214%+A%) + ". "
select case A%
  case 1				'-- Mirror
    call FlipXY(CCA%(1),1%)
    if not CCR%(1) then
      call XDimBA(CCB%(1),CCA%(1),165%,192%)
      call MovLft(CCB%(1),27%)
      call XDimBA(CCA%(1),CCB%(1),192%,165%)
    end if
    print# %UnitRPT, SLText$(72%)
  case 2				'-- Upside down
    call FlipXY(CCA%(1),2%)
    print# %UnitRPT, SLText$(73%)
  case 3				'-- Rotate
    if CCR%(1) then
      CCR%(1) = %False
      A% = SelOpt%(SLText$(38%))
      if A% <  1 then A% = 14
      if A% > 28 then A% = 28
      decr A%
      call XDimBA(CCB%(1),CCA%(1),165%,192%)
      call MovLft(CCB%(1),A%)
      call XDimBA(CCA%(1),CCB%(1),192%,165%)
    end if
    call FlipXY(CCA%(1),3%)
    print# %UnitRPT, SLText$(74%)
  case 4				'-- shift 180
    call XDimBA(CCB%(1),CCA%(1),165%,192%)
    call RoTwic(CCB%(1))
    call XDimBA(CCA%(1),CCB%(1),192%,165%)
    print# %UnitRPT, SLText$(238%)
  case 5				'-- shift left
    call XDimBA(CCB%(1),CCA%(1),165%,192%)
    call SHLUIm(CCB%(1),%True,C%,B%)
    call XDimBA(CCA%(1),CCB%(1),192%,165%)
    print# %UnitRPT, Z$;SLText$(134%);C%
  case 6				'-- shift right
    call XDimBA(CCB%(1),CCA%(1),165%,192%)
    call SHRDIm(CCB%(1),%True,C%,B%)
    call XDimBA(CCA%(1),CCB%(1),192%,165%)
    print# %UnitRPT, Z$;SLText$(134%);C%
  case 7				'-- shift up
    call SHLUIm(CCA%(1),%False,C%,B%)
    print# %UnitRPT, Z$;SLText$(134%);C%
  case 8				'-- shift down
    call SHRDIm(CCA%(1),%False,C%,B%)
    print# %UnitRPT, Z$
    print# %UnitRPT, SLText$(134%);C%
  case else
    print Outch$(Q$)
end select
return
'
'
' Option-M: Insert Label
'----------------------------------------------------------------------------
'
OptM:
'
print LogOn$(Version$,%White,%Red)
A$ = ""
color %Cyan,%Black
print SLText$(201%);" ";
color %Green,%Black
print LblSml$
print
color %LCyan,%Black
print SLText$(200%);
Y% = csrlin
X% = pos(Y%) + 3
print ": [";string$(27,"_");"]"
color %Yellow,%Black
locate Y%,X%
line input B$
if B$ = "" then return					'-- no null-string
if len(B$) > 27 then A$ = left$(B$,27) else A$ = B$
L% = len(A$)
call AConvt(L%,A$)
call ChrLin(CCT%(1),L%,A$)
A% = (27 - L%) * 7 + 3
color %Cyan,%Black
locate 23,26
print " Position X/Y:";
color %LGreen,%Black
print X0%;
color %Cyan,%Black
print "/";
color %LRed,%Black
print Y0%
color %Cyan,%Black
locate Y%+2,1
call MLText(28%,1%,"tf")
Q% = Prompt%(6%,Q$)
select case Q%
  case 1
    X% = A% / 2 + 1
    Y% = SelOpt%("> " + SLText$(203%) + " (1 ... 158) ")
  case 2
    X% = X0%
    Y% = Y0%
  case 3
    X% = X0% - L% * 7 / 2
    Y% = Y0% - 3
  case 4
    X% = SelOpt%("> " + SLText$(202%) + " (1 ... " + str$(A%) + ") ")
    Y% = SelOpt%("> " + SLText$(203%) + " (1 ... 158) ")
  case else
    print Outch$(Q$)
    return				'-- exit, do nothing
end select
decr X%
X% = IntLmt%(0%,A%,X%)
decr Y%
Y% = IntLmt%(0%,158%,Y%)
do
  print LogOn$(Version$,%White,%Pink)
  color %LCyan,%Black
  print Center$(SLText$(204%),80)
  color %Cyan,%Black
  call MLText(24%,16%,"tf")
  M% = Prompt%(21%,Q$)
  if M% = 0 then return			'-- Do not insert text
  if M% > 0 and M% < 5 then exit loop	'-- Valid option
  print Outch$(Q$)			'-- invalid
loop
call XDimBA(CCB%(1),CCA%(1),165%,192%)
if M% = 2 or M% = 4 then call XORMBA(CCT%(1),255%,190%)
P% = Y% * 192 + X%
call InsLbl(CCB%(1),CCT%(1),P%,M%,L%)
call XDimBA(CCA%(1),CCB%(1),192%,165)
return
'
'
' Option-N: Zoom / Shrink Image
'----------------------------------------------------------------------------
'
OptN:
'
Txt$ = SLText$(187%) + " 1"
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(176%),80)
color %Cyan,%Black
call MLText(22%,1%,"tf")
Q% = Prompt%(6%,Q$)
select case Q%
  case 0
    print Outch$(Q$)
  case 1, 2					'== ZOOM
    if ScrMode% = 0 then NonAv
    BO% = 182
    print LogOn$(Version$,%White,%Pink)
    color %LCyan,%Black
    print Center$(SLText$(64%),80)
    color %Cyan,%Black
    call MLText(7%,27%,"tf")
    Z% = Prompt%(32%,Q$)
    if Q$ = chr$(27) then return
    if (Z% < 1) or (Z% > 4) then
      Z% = 4
      color %LCyan,%Black
      print "4";
      delay .5
    end if
    S% = Z%
    if Z% = 4 then
      if R% then
	C% = 14
      else
	incr S%
	C% = 30
      end if
    end if
    select case Z%
      case 1
	C% = 0
      case 2
	C% = 2
      case 3
	C% = 6
    end select
    color %White,%Black
    XL% = LowX0%(X0%,%False)
    YU% = LowY0%(Y0%,%False)
    X1% = X0% - 1
    Y1% = Y0% - 1
    locate 1,1,0
    screen ScrMode%
    call LRB(413%,BO%,%Red)
    line (0,0)-(383,329),%Red,B
    line (446,183)-(639,349),%Red,B
    call IBox(VN$,YS%,XS%,%False)
    call CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
    call LRB(413%,BO%,%Red)
    call SetSix(CCA%(1),ColScale%(C%/2),10+Z%)
    if instat then Q$ = inkey$
    line (0,0)-(383,329),%Black,B
    call ZoomD(CCA%(1),ColScale%(0%),S%)
    call LRB(413%,BO%,%Green)
    do
      color %LCyan,%Black
      locate 4,71
      print using "###";UseByte%(CCA%(),X0%,Y0%);
      A$ = KeyIn$
      select case A$
	case chr$(13)			'-- RET
	  exit loop
	case chr$(27)			'-- ESC
	  exit loop
	case chr$(0,72)			'-- UP
	  Y1% = Y0%
	  Y0% = NewXY0%(Y0%,YS%,"U")
	  call CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
	case chr$(0,80)			'-- DOWN
	  Y1% = Y0%
	  Y0% = NewXY0%(Y0%,YS%,"D")
	  call CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
	case chr$(0,75)			'-- LEFT
	  X1% = X0%
	  X0% = NewXY0%(X0%,XS%,"L")
	  call CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
	case chr$(0,77)			'-- RIGHT
	  X1% = X0%
	  X0% = NewXY0%(X0%,XS%,"R")
	  call CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
	case "*","/","+","-"
	  call StepAdj(CCA%(),11%,76%,71%,YS%,XS%,Y0%,X0%,Y1%,X1%,A$)
	case "."			'-- center
	  call CentXY(X0%,Y0%,X1%,Y1%)
	  call CutZoom(CCA%(),Y0%,X0%,ColScale%(),YU%,XL%,Y1%,X1%,S%,BO%)
	case chr$(0,71)                 '-- HOME
	  call LRB(413%,BO%,%Red)
	  call BlowUp(CCB%(1),CCA%(1),YU%,XL%)
	  call CpyB2B(CCA%(1),CCB%(1),%LMN)
	  if Q% = 2 then call Smooth(CCA%(),CCB%())
	  exit loop
      end select
    loop
    screen 0
    print# %UnitRPT, SLText$(92%);X0%;" /";Y0%
  case 3					'== Shrink Average
    A% = Quadrant%(177%)
    call Shrink(CCB%(1),CCA%(1),%False)
    call CpyQdr(CCA%(1),CCB%(1),A%,2%)
    print# %UnitRPT, SLText$(179%);" Quadrant";A%
  case 4					'== Shrink Bright
    A% = Quadrant%(177%)
    call Shrink(CCB%(1),CCA%(1),%True)
    call CpyQdr(CCA%(1),CCB%(1),A%,2%)
    print# %UnitRPT, SLText$(180%);" Quadrant";A%
  case 5					'== Copy Quadrant
    S% = Quadrant%(178%)
    D% = Quadrant%(177%)
    call CpyQdr(CCA%(1),CCA%(1),D%,S%)
    print# %UnitRPT, SLText$(181%);" Quadrant";S%;"-->";D%;Txt$
  case 6					'== Swap Quadrants
    S% = Quadrant%(178%)
    D% = Quadrant%(177%)
    call SwpQdr(CCA%(1),CCA%(1),D%,S%)
    print# %UnitRPT, SLText$(188%);" Quadrant";S%;"<==>";D%;Txt$
  case 7					'== Clear Quadrant
    A% = Quadrant%(177%)
    call FillWC(CCB%(1),0%,%LMN/2)
    call CpyQdr(CCA%(1),CCB%(1),A%,1%)
    print# %UnitRPT, SLText$(134%);" 0 Quadrant";A%;Txt$
  case 8					'== Invert Quadrant
    A% = Quadrant%(177%)
    call InvQdr(CCA%(1),A%)
    print# %UnitRPT, SLText$(75%);" Quadrant";A%;Txt$
  case 9					'== Toggle Bar
    call TogBar(CCA%(1))
  case else
    print Outch$(Q$)
end select
return
'
'
' Option-O: Frames Swapping
'----------------------------------------------------------------------------
'
OptO:
'
gosub OPHead
color %LCyan,%Black
print Center$(SLText$(118%),80)
color %Cyan,%Black
call MLText(15%,7%,"tf")
A% = Prompt%(12%,Q$)
color %LCyan,%Black
A$ = ""
select case A%
  case 1					'-- Restore backup to active
    call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
	 CCR%(),CCN$(),1%,3%,%False,0%,0%)
  case 2					'-- Get any into 1
    Z% = SelOpt%(SLText$(170%))
    call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
	 CCR%(),CCN$(),1%,Z%,%False,0%,0%)
  case 3					'-- Put 1 into any
    Z% = SelOpt%(SLText$(171%))
    call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
	 CCR%(),CCN$(),Z%,1%,%False,0%,0%)
  case 4					'-- Swap 1 with any
    Z% = SelOpt%(SLText$(172%) + "1: ")
    call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
	 CCR%(),CCN$(),1%,Z%,%True,0%,0%)
  case 5					'-- Swap any with any
    T% = SelOpt%(SLText$(172%))
    Z% = SelOpt%(SLText$(172%) + using$("#",T%) + ": ")
    call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
	 CCR%(),CCN$(),Z%,T%,%True,0%,0%)
  case 6					'-- Copy any into any
    T% = SelOpt%(SLText$(170%))
    Z% = SelOpt%(SLText$(171%))
    call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
	 CCR%(),CCN$(),Z%,T%,%False,0%,0%)
  case 7                                        '-- Fill/Clear any
    V% = SelOpt%("> " + SLText$(133%) + " [0;255] ? ")
    if V% < 0   then V% =   0
    if V% > 255 then V% = 255
    Z% = SelOpt%("> " + SLText$(132%) + " ? ")
    A$ = SLText$(134%) + ":" + using$("####",V%) + ", "
    select case Z%
      case 1
	call FillBC(CCA%(1),V%,%LMN)
	A$ = A$ + SLText$(129%) + SLText$(131%)
      case 2
	call FillBC(CCF%(1),V%,%LMN)
	A$ = A$ + SLText$(130%) + SLText$(131%)
      case 3
	call FillBC(CCC%(1),V%,%LMN)
	A$ = A$ + "Backup" + SLText$(131%)
      case 4
	call FillBC(CCD%(1,1),V%,%LMN)
	A$ = A$ + "#4" + SLText$(131%)
      case 5
	call FillBC(CCD%(1,97),V%,%LMN)
	A$ = A$ + "#5" + SLText$(131%)
      case else
	print Outch$(str$(Z%))
	return
    end select
    case else
      print Outch$(Q$)
      return
  end select
  if not A$ = "" then print# %UnitRPT, A$
return
'
'
' Option-P: Quadrant Handling
'----------------------------------------------------------------------------
'
OptP:
'
gosub OPHead
SF% = SelOpt%(SLText$(170%))
DF% = SelOpt%(SLText$(171%))
SQ% = Quadrant%(178%)
DQ% = Quadrant%(177%)
Z% = Confirm%("Quadrant: [RET] = " + SLText$(185%))
call AllFrames(CCA%(),CCB%(),CCC%(),CCD%(),CCF%(),_
     CCR%(),CCN$(),DF%,SF%,Z%,DQ%,SQ%)
return
'
'
' Option-Q: Background or Baseline clipping.
'----------------------------------------------------------------------------
'
OptQ:
'
color %LCyan,%Black
print SLText$(33%);MinV%;SLText$(112%);AvgByt%(CCA%(1),%LMN);":";
color %Yellow,%Black
line input Q$
Clp% = val(Q$)
if (Clp% < 0) or (Clp% > 255) then Clp% = MinV%
call LmtLBC(CCA%(1),Clp%,%LMN)
print# %UnitRPT, SLText$(76%);Clp%
print# %UnitRPT, space$(3);MaxMin$(CCA%(),MinV%,MaxV%)
return
'
'
' Option-R: High Brightness removing.
'----------------------------------------------------------------------------
'
OptR:
'
color %LCyan,%Black
print SLText$(34%);MaxV%;SLText$(112%);AvgByt%(CCA%(1),%LMN);":";
color %Yellow,%Black
line input Q$
Clp% = val(Q$)
if (Clp% < 1) or (Clp% > 255) then Clp% = MaxV%
call LmtHBC(CCA%(1),Clp%,%LMN)
print# %UnitRPT, SLText$(77%);Clp%
print# %UnitRPT, space$(3);MaxMin$(CCA%(),MinV%,MaxV%)
return
'
'
' Option-S: Stretching and Compressing
'           The results exeeding 255 may be limitted to 255 or folded, i.e.
'           only overrun is kept and rest lost. Underflow is set to 0.
'----------------------------------------------------------------------------
'
OptS:
'
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(35%),80)
color %Cyan,%Black
call MLText(23%,7%,"tf")
A% = Prompt%(12%,Q$)
color %LCyan,%Black
T% = 81
select case A%
  case 1					'-- * 1.5
    call MD15BA(CCA%(1),%False,%LMN)
    A$ = "* 1.5 (" + SLText$(142%) + ")"
  case 2					'-- * 2 limit
    call AddBas(CCA%(1),CCA%(1),255%,%LMN)
    A$ = "* 2 (" + SLText$(142%) + ")"
  case 3					'-- * 2 fold
    call ShlByt(CCA%(1),%LMN)
    A$ = "* 2 (" + SLText$(143%) + ")"
  case 4					'-- ln low
    call LogMul(CCA%(1),0%)
    A$ = SLText$(192%) + " (ln e)"
  case 5					'-- ln high
    call LogMul(CCA%(1),256%)
    A$ = SLText$(193%) + " (ln e)"
  case 6					'-- rescale normal
    call LogMul(CCA%(1),512%)
    A$ = SLText$(247%) + " mag (+)"
  case 7					'-- rescale inverse
    call LogMul(CCA%(1),768%)
    A$ = SLText$(247%) + " mag (-)"
  case 8					'-- Compress * 0.666
    call MD15BA(CCA%(1),%True,%LMN)
    A$ = " / 1.5"
    T% = 110
  case 9					'-- Compress * 0.5
    call ShrByt(CCA%(1),%LMN)
    A$ = " / 2"
    T% = 110
  case else
    print Outch$(Q$)
    return
end select
print# %UnitRPT, SLText$(T%);" ";A$
print# %UnitRPT, space$(3);MaxMin$(CCA%(),MinV%,MaxV%)
return
'
'
' Option-T: 2 Frame operations
'----------------------------------------------------------------------------
'
OptT:
'
call FraMani(CCA%(),CCF%(),CCC%(),CCD%(),Version$,CCN$(1),CCN$(2))
return
'
'
' Option-U: Color Shift. Lowest to bottom, highest to top, users choice.
'           Also, auto-stretch
'----------------------------------------------------------------------------
'
OptU:
'
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(79%),80)
Y% = csrlin
color %Cyan,%Black
locate 24,1
print Center$(MaxMin$(CCA%(),MinV%,MaxV%),80);
locate Y%,1
call MLText(12%,15%,"tf")
A% = Prompt%(43%,Q$)
color %Cyan,%Black
select case A%
  case 1
    Z% = MinV%
    call SubCBL(CCA%(1),MinV%,0%,%LMN)
    Q$ = SLText$(144%)
  case 2
    Z% = 255 - MaxV%
    call AddCBL(CCA%(1),Z%,255%,%LMN)
    Q$ = SLText$(145%)
  case 3
    Z% = SelOpt%(SLText$(80%) + space$(1))
    if Z% <   0 then Z% =   0
    if Z% > 255 then Z% = 255
    call SubCBL(CCA%(1),Z%,0%,%LMN)
    Q$ = SLText$(144%)
  case 4
    Z% = SelOpt%(SLText$(83%) + space$(1))
    if Z% <   0 then Z% =   0
    if Z% > 255 then Z% = 255
    call AddCBL(CCA%(1),Z%,255%,%LMN)
    Q$ = SLText$(145%)
  case 5
    Q$ = MaxMin$(CCA%(),MinV%,MaxV%) + " " + SLText$(246%)
    call Optimizer(CCA%())
  case else
    print Outch$(Q$)
    return
end select
print# %UnitRPT, Q$;":";
if A% = 5 then
  print# %UnitRPT, ""
else
  print# %UnitRPT, Z%
  print# %UnitRPT, space$(3);
end if
print# %UnitRPT, MaxMin$(CCA%(),MinV%,MaxV%)
color %White,%Black
return
'
'
' Option-V Filtering.
' ----------------------------------------------------------------------------
'
OptV:
'
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(122%),80)
color %Cyan,%Black
call MLText(16%,16%,"tf")
A% = Prompt%(21%,Q$)
select case A%
  case 1						'-- Invert
    call SQB(77%,23%,%Red)
    call XORMBA (CCA%(1),255%,%LMN)
    A$ = SLText$(75%)
    call SQB(77%,23%,%Green)
    print# %UnitRPT, A$
    print# %UnitRPT, space$(3);MaxMin$(CCA%(),MinV%,MaxV%)
  case 2						'-- AND/OR/XOR mask
    call LogMask(CCA%(),MinV%,MaxV%,Version$)
  case 3							'-- LPF
    call HPFLPF(CCA%(),CCB%(),CMasks%(),CMask$(),I%(),Version$,%True)
  case 4							'-- HPF
    call HPFLPF(CCA%(),CCB%(),CMasks%(),CMask$(),I%(),Version$,%False)
  case 5						'-- Statistical
    call Statist(CCA%(),CCB%(),I%(),Version$)
  case 6						'-- Contour
    call Contour(CCA%(),CCB%(),CMasks%(),CMask$(),I%(),Version$)
  case 7						'-- Unsharp Masking
    call Optimizer(CCA%())
    call CpyW2W(CCF%(1),CCA%(1),%LMN/2)			'frame 2=1
    call HPFLPF(CCA%(),CCB%(),CMasks%(),CMask$(),I%(),Version$,+1%)
    call CpyW2W(CCB%(1),CCF%(1),%LMN/2)
    call ShrByt(CCB%(1),%LMN)
    call AddBAS(CCA%(1),CCB%(1),255%,%LMN)
    call Optimizer(CCA%())				'-- Auto-Stretch
    call AvrgBA(CCA%(1),CCF%(1),%LMN)			'-- average
    call Optimizer(CCA%())				'-- Auto-Stretch
  case 8						'-- Smoothing
    call Smooth(CCA%(),CCB%())
  case else
    print Outch$(Q$)
end select
return
'
'
' Option-W: Saving of current or as Gallery file
'----------------------------------------------------------------------------
'
OptW:
'
print LogOn$(Version$,%White,%Red)
color %LCyan,%Black
print Center$(SLText$(239%),80)
color %Cyan,%Black
call MLText(29%,79%,"cf")
print
call MLText(31%,7%,"tf")
A% = Prompt%(12%,Q$)
if A% = 1 then							'--BYT Bxx
  Z% = WrtByt%(CCA%(),CCB%(),WRTFile$+FilExt$(%UnitBYT))
  if Z% then
    print SLText$(229%);Z%
  else
    color %Cyan,%Black
    print SLText$(42%);
    color %LCyan,%Black
    A$ = WRTFile$ + FilExt$(%UnitBYT)
    print A$
    print# %UnitRPT, SLText$(82%);" ";A$
    color %White,%Black
    Z$ = FilExt$(%UnitBYT)
    FilExt$(%UnitBYT) = IncrExt$(Z$)
  end if
else
  print LogOn$(Version$,%White,%Brown)
  color %Cyan,%Black
  select case A%
    case 2							'--CGE free
      T$ = FreeText$
    case 3							'--CGE Mac 4
      T$ = Mac4Text$(%True)
    case 4							'--CGE Dos 6
      T$ = Mac4Text$(%False)
    case 5							'--CGE dbf
      T$ = DbfText$
    case else
      print Outch$(Q$)
      return
  end select
  print
  print
  if not Confirm%(SLText$(242%)) then return
  CGEHead$ = T$ + chr$(26)
  open WRTFile$ + ".CGE" for binary as # %UnitAUX
  Handle% = fileattr(%UnitAUX,2)
  put$ # %UnitAUX, CGEHead$
  print SLText$(21%);WRTFile$;".CGE"
  call XDimBA(CCB%(1),CCA%(1),165%,192%)
  call BiNine(CCG%(1),CCB%(1))
  call XDimBA(CCA%(1),CCB%(1),192%,165%)
  A% = EncBie%(CCB%(1),CCG%(1),1760??)
  A% = WrBie%(CCB%(1),Handle%)
  close %UnitAUX
  if A% then
    print SLText$(243%);" ";A%
    print# %UnitRPT, SLText$(243%);" ";A%
  end if
  print# %UnitRPT, SLText$(244%);" ";WRTFile$;".CGE";
end if
delay 1
return
'
'
' Option-X: Process part/range of image
'----------------------------------------------------------------------------
'
OptX:
'
print LogOn$(Version$,%White,%Red)
Y% = csrlin
color %Cyan,%Black
locate 24,1
print Center$(MaxMin$(CCA%(),MinV%,MaxV%),80);
locate Y%,1
color %White,%Black
call MLText(13%,79%,"cf")
print
Y% = csrlin
color %Cyan,%Black
print SLText$(33%);MinV%;" ";
X% = pos(Y%)
color %Yellow,%Black
line input Q$
color %LCyan,%Black
L% = IntLmt%(0%,255%,val(Q$))
locate Y%,X%
print L%
incr Y%
color %Cyan,%Black
print SLText$(34%);MaxV%;" ";
X% = pos (Y%)
color %Yellow,%Black
line input Q$
H% = IntLmt%(0%,255%,val(Q$))
print LogOn$(Version$,%White,%Pink)
Y% = csrlin
color %Cyan,%Black
locate 24,1
print Center$(MaxMin$(CCA%(),MinV%,MaxV%),80);
locate Y%,1
color %LCyan,%Black
print Center$(SLText$(119%),80)
color %Cyan,%Black
call MLText(14%,19%,"tf")
A% = Prompt%(50%,Q$)
if A% < 1 or A% > 6 then
  print Outch$(Q$)
  return
end if
if not A% = 3 then call SQB(77%,23%,%Red)
if A% > 0 or A% < 6 then call CpyBRZ(CCB%(1),CCA%(1),H%,L%,%LMN)
Q$ = SLText$(146%)
B$ = ""
select case A%
  case 1						'-- remove
    call SubBas(CCA%(1),CCB%(1),0%,%LMN)
    A$ = SLText$(147%)
  case 2						'-- isolate
    call CpyB2B(CCA%(1),CCB%(1),%LMN)
    A$ = SLText$(148%)
  case 3						'-- stretch
    print LogOn$(Version$,%White,%Brown)
    color %LCyan,%Black
    print Center$(SLText$(35%),80)
    color %Cyan,%Black
    call MLText(23%,7%,"tf")
    A% = Prompt%(12%,Q$)
    if A% < 1 or A% > 9 then
      print Outch$(Q$)
      return
    end if
    color %LCyan,%Black
    print
    call SQB(77%,23%,%Red)
    call SubBas(CCA%(1),CCB%(1),0%,%LMN)
    select case A%
      A$ = SLText$(149%)
      case 1						'-- 1.5
	call MD15BA(CCB%(1),%False,%LMN)
	A$ = A$ + " * 1.5"
	B$ = SLText$(142%)
      case 2						'-- 2 limit
	call AddBas(CCB%(1),CCB%(1),255%,%LMN)
	A$ = A$ + " * 2"
	B$ = SLText$(142%)
      case 3						'-- 2 fold
	call ShlByt(CCB%(1),%LMN)
	A$ = A$ + " * 2"
	B$ = SLText$(143%)
      case 4						'-- ln low
	call LogMul(CCB%(1),0%)
	A$ = A$ + " " + SLText$(192%)
	B$ = "ln e"
      case 5						'-- ln high
	call LogMul(CCB%(1),256%)
	A$ = A$ + " " + SLText$(193%)
	B$ = "ln e"
      case 6						'-- rescale normal
	call LogMul(CCB%(1),512%)
	B$ = SLText$(247%) + " mag (+)"
      case 7						'-- rescale inverse
	call LogMul(CCB%(1),768%)
	B$ = SLText$(247%) + " mag (-)"
      case 8						'-- compress 1.5
        call SubBas(CCA%(1),CCB%(1),0%,%LMN)
        call MD15BA(CCB%(1),%True,%LMN)
        call OrBas(CCA%(1),CCB%(1),%LMN)
        A$ = SLText$(150%)
        A$ = A$ + " / 1.5"
      case 9						'-- compress 2
        call SubBas(CCA%(1),CCB%(1),0%,%LMN)
        call ShrByt(CCB%(1),%LMN)
        call OrBas(CCA%(1),CCB%(1),%LMN)
        A$ = SLText$(150%)
        A$ = A$ + " / 2"
    end select
    call OrBas(CCA%(1),CCB%(1),%LMN)
  case 4						'-- brighten
    Z% = IntLmt%(0%,255%,SelOpt%(SLText$(151%) + "? "))
    call AddBOR(CCA%(1),Z%,H%,L%,%LMN)
    A$ = SLText$(145%) + str$(Z%) + " " + SLText$(189%)
  case 5						'-- darken
    Z% = IntLmt%(0%,255%,SelOpt%(SLText$(152%) + "? "))
    call SubBOR(CCA%(1),Z%,H%,L%,%LMN)
    A$ = SLText$(144%) + str$(Z%) + " " + SLText$(190%)
  case 6						'-- Fill
    Z% = SelOpt%(SLText$(133%)+" "+using$("###",L%)+" "+using$("###",H%)+" ")
    call SetBCL(CCA%(1),Z%,H%,L%,%LMN)
    A$ = SLText$(134%) + str$(Z%) + ";"
end select
if not B$ = "" then B$ = " (" + B$ + ")"
print# %UnitRPT, A$;B$;" ";Q$;L%;"/";H%
call SQB(77%,23%,%Green)
return
'
'
' Option-Y: Saving of Table and Ascii Representation in report file
'----------------------------------------------------------------------------
'
OptY:
'
print
color %Cyan,%Black
print SLText$(71%);" ";
color %LCyan,%Black
print RPTFile$;
call AscTab(CCA%(),Y0%,YU%,X0%,XL%,ChrDec$,AR$(),TR$())
A$ = using$("####",XL%+8) + "/" + using$("###",YU%+8)
print# %UnitRPT, string$(80,"-")
print# %UnitRPT, SLText$(70%);" ";A$;chr$(13,10)
for N% = 0 to 16
  print# %UnitRPT, TR$(N%)
next N%
print# %UnitRPT, chr$(13,10)
for N% = 0 to 16
  print# %UnitRPT, AR$(N%)
next N%
print# %UnitRPT, SLText$(154%);": ";ChrDec$
print# %UnitRPT, string$(80,"-")
print ""
return
'
'
' Option-Z: Writing as PCL file
'----------------------------------------------------------------------------
'
OptZ:
'
print LogOn$(Version$,%White,%Pink)
Z$ = FilExt$(%UnitPCL)
call XDimBA(CCB%(1),CCA%(1),165%,192%)
color %LCyan,%Black
print Center$(SLText$(104%),80)
color %Cyan,%Black
call MLText(10%,12%,"tf")
A% = Prompt%(64%,Q$)
color %LCyan,%Black
select case Q$
  case chr$(27)
    return
  case "1"
    PRes% = 252
  case "2"
    PRes% = 248
  case "3"
    PRes% = 240
  case "4"
    PRes% = 224
  case else
    print "2";
    PRes% = 248
end select
print
color %Cyan,%Black
if Confirm%(SLText$(100%)) then PRes% = PRes% + 256
if Confirm%(SLText$(101%)) then X$ = "70" else X$ = "1618"
Z$ = FilExt$(%UnitPCL)
open WRTFile$ + Z$ for output as # %UnitPCL
call LinPCL(CCB%(),PRes%,X$)
close %UnitPCL
color %Cyan,%Black
print
print SLText$(102%);
color %LCyan,%Black
if X$ = "1618" then W$ = SLText$(156%) else W$ = SLText$(155%)
print# %UnitRPT, SLText$(102%);WRTFile$;Z$;W$
print WRTFile$;Z$;W$
Q$ = "COPY " + WRTFile$ + Z$ + " PRN /B"
W% = %True
print
Y% = csrlin
if not Confirm%(SLText$(105%)) then
  shell Q$
  print# %UnitRPT, SLText$(106%);" via DOS: ";Q$
  locate Y%,1
  if not Confirm%(SLText$(108%)) then
    W% = %False
    kill WRTFile$ + Z$
    print# %UnitRPT, SLText$(109%);WRTFile$;Z$
    color %Yellow,%White
    print Center$(SLText$(109%) + WRTFile$ + Z$,80);
    delay 1
  end if
end if
if W% then FilExt$(%UnitPCL) = IncrExt$(Z$)
color %White,%Black
return
'
'
CCDUSUB2:
'
'===========================-<920905>-================-<HoroSoft>-===========
'
