'960412 1426
'****************************************************************************
'* PROGRAM NAME: CCDUTIL .BAS   DATE: 25. 3.1993   INCLUDE IN: filename.typ *
'* LANGUAGE: Power BASIC 3.20  (Robert S.Zale)                              *
'* PURPOSE: CCD Astro Camera Util                                           *
'* INCLUDE FILES: ERROR3  .INC  Fatal error handler                         *
'*                IOTEXT  .INC  Set of Procedures for text handling.        *
'*                CCDUPROC.INC  Dedicated procedures.                       *
'*                CCDUFUNC.INC  Dedicated functions.                        *
'*                CCDUSUB1.INC  Subroutines for main program.               *
'*                CCDUSUB2.INC  Subroutines for Menu.                       *
'*                CCDUDAT .INC  Text and data.                              *
'* OBJECT FILES:  PBSTACK .OBJ  Power Basic 2 & 3 Stack handler for objects *
'*                ARRAYEXT.PBL  Byte, word and integer array functions.     *
'*                CLRSCRN .PBL  Hot supercool screen sweepers               *
'*                CCDUU1  .OBJ  CCDUTIL procedures                          *
'*                CCDUU2  .OBJ  CCDUTIL Flip procedures (8 bit)             *
'*                CCDUP   .OBJ  CCDUTIL & CCDPRINT procedures               *
'*                RLCEGEN .OBJ  Run Length Count Encoding Generator         *
'*                PB3GPUSE.PBU  General purpose functions and procedures.   *
'* INPUT FILES:   filename.LNX  Lynxx Image 12-bit full                     *
'*                filename.ALI  Artificial Lynxx Image 12-bit as 8-bit      *
'*                filename.ST4  ST-4 Image                                  *
'*                filename.ASI  Artificial ST-4 Image                       *
'*                filename.BYT  CCDUTIL "Home-Turf" format 8-bit RLCE       *
'*                filename.Bxx  CCDUTIL "Home-Turf" format 8-bit B00...B99  *
'* OUTPUT FILES:  filename.ALI  Artificial Lynxx Image 12-bit as 8-bit      *
'*                filename.ASI  Artificial ST-4 Image                       *
'*                filename.BYT  CCDUTIL "Home-Turf" format 8-bit            *
'*                filename.Bxx  CCDUTIL "Home-Turf" format 8-bit B00...B99  *
'*                filename.Dxx  Dotogram D00...D99 RLCE                     *
'*                filename.Pxx  PCL-format file P00...P99                   *
'*                filename.Bxx  CCDUTIL "Home-Turf" format 8-bit B00...B99  *
'*                filename.RPT  Report file                                 *
'*                filename.CGE  CCD Gallery Encoded 64x55 nibbles           *
'* RENAMED FILES: filename.Bxx --> filename.Zxx                             *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.94  8-APR-96 Added Hoopy screen clearers and Logo             *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.93 31-MAR-96 Made it FreeWare                                 *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.92  2-SEP-95 Recompiled from PB3.10 to PB3.20                 *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.91 11-FEB-95 Introduced Brightness calculations and limitted  *
'*               run, if not registered.                                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.83  1-JUN-94 Overwholed buggy RLCE-Generator and              *
'*               introduced Version CCDUtilV% = 283                         *
'*               Redid VidAry and WrtDoto to encode directly from EGA-RAM   *
'*               13-SEP-94 Enabled screen grabbing on A, b & D (CCDSUB2)    *
'*               17-SEP-94 Redid Unsharp Masking and Optimizer              *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.73 10-FEB-94 Rearranged menu and included CGE Files.          *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.63 30-DEC-93 Adjusted for new RLCE-ized BYT and DOT Formats.  *
'*                9-JAN-94 Combined Compressing S with Stretching from T.   *
'*               Introduced Binning into Menu T. Introduced distance        *
'*               measuring option in Menu I. The crosshair position in all  *
'*               images in I and J are marked by a blinking dot. The label  *
'*               Menu M can now be positioned by using the crosshair        *
'*               positions as set with G, H, I and J.                       *
'*               Bug fixes in RPT, chr$(25,26) and Q$-->A$ for odd output.  *
'*               11-JAN-94 Moved Inversion to Binning V-1-->T and rest up.  *
'*               Bug fix in Logical filtering.                              *
'*               25-JAN-94 Introduced 180 rotate without size-clipping.    *
'*               25-JAN-94 Added CGE files for CCDGALRY                     *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.53 24-DEC-93 Minimal adaption to be able to compile under     *
'*               PB 3.00c compiler instead of PB 2.10e, which just ran      *
'*               out of memory and needed BareBones Boot for an extra 16K.  *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.52 27-NOV-93 Bug fixes and adding of grid option              *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.42 20-JUN-93 Added Label insertion option.                    *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.32 26-APR-93 Last digit of version is PB number.              *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.00 24-MAR-93 Redid it from CCDUTIL V.1.35                     *
'* ------------------------------------------------------------------------ *
'* COMMENTS: Ported to PB 3.00 which is unusable: back to PB 2.10 8-APR-93  *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
' COMPILER DIRECTIVES
'----------------------------------------------------------------------------
'
'$alias data as "DSEG"	'or data segment name as used in .OBJ
'$code seg "CODE"	'or code segment name as used in .OBJ
'$huge			'for arrays > 64K
$cpu 8086		'8086/80286/80386
$debug map off		'on/off
$debug path off		'on/off
$debug unit off		'on/off
$debug pbdebug off	'on/off
$dim array		'all/array/none
$dynamic		'$static
$error all off		'bounds/numeric/overflow/stack/all on/off
$event off		'on/off
$float procedure	'emulate/npx/procedure
$lib com-,lpt-,graph+,cga+,ega+,vga+,herc-,fullfloat-,iprint-
$optimize speed		'size/speed
$option cntlbreak off	'cntlbreak/gosub on/off
$stack 4096		'1536...32767
$com 0			'0...32767
$sound 1		'1...4096
$string  8		'1/2/4/8/16/32
$compile exe		'memory/exe/chain/unit
'
'
' LIST OF SHARED (GLOBAL) VARIABLES
'----------------------------------------------------------------------------
'
shared Idiom%()
'
'
' LANGUAGE SELECTION AND VERSION NUMBER
'----------------------------------------------------------------------------
'
VN$      = "CCDUTIL V.2.94"
CCDUtilV% = 294
on error goto ErrorHandling
%True   = -1
%False  =  0
Chroma% = %True
dim Idiom%(0:2)			'0:E=true/D=false 1:SL-text-, 2:ML text-offs
English% = ComLinLan%(command$,"CCDTOOLS: "+VN$)
if English% then
  Idiom%(0) = %True		'English
  Idiom%(1) = 0			'SL offset
  Idiom%(2) = 0			'ML offset
  Version$ = "Lynxx & ST4 CCD Astro-Camera Image File Utility " + VN$
else
  Idiom%(0) = %False		'Deutsch
  Idiom%(1) = 300		'SL offset
  Idiom%(2) =  50		'ML offset
  Version$ = "Lynxx & ST4 CCD Astro-Kamera Bild Datei Werkzeug " + VN$
end if
'
'
' CONSTANTS COLORS and CPU-REGISTERS
'----------------------------------------------------------------------------
'
%Black     =  0        'COLORS, dark
%Blue      =  1
%Green     =  2
%Cyan      =  3
%Red       =  4
%Pink      =  5
%Brown     =  6
%White     =  7
%Gray      =  8        'COLORS, light
%LBlue     =  9
%LGreen    = 10
%LCyan     = 11
%LRed      = 12
%LPink     = 13
%Yellow    = 14
%LWhite    = 15
'
%DOSRead  = 63		'DOS function used at Encode/Decode for ST4 and ASI
%DOSWrite = 64		'  EDCST4
'
'
' FILE AND FRAME CONSTANTS
'----------------------------------------------------------------------------
'
%LMN = 31680			'Elements in arrays
%UnitAUX = 1			'Auxiliary file: usually output file
%UnitRPT = 2			'Report file
%UnitBYT = 3			'Byte file to save as Bxx
%UnitDOT = 4			'Doto file to save as Dxx
%UnitPCL = 5			'PCL File to save as Pxx
'
'
' Check and Confirm EGA Video Card
'----------------------------------------------------------------------------
'
%VBIOS = 16
%EGA   =  9
%VGA   = 12
%AX    =  1
%BX    =  2
screen 0
A% = BestVideo%
select case A%
  case 9
    EGAHere% = %True
    ScrMode% = 9
  case 12
    EGAHere% = %True
    VGAHere% = %True
    ScrMode% = 9
  case else
    EGAHere% = %False
    VGAHere% = %False
    ScrMode% = 0
end select
Chroma%  = %True
on error goto ErrorHandling
'
'
' Function and Procedure Declaration in external object: CLRSCRN.PBL
'----------------------------------------------------------------------------
'
declare function ClrScrnV%()
'declare sub ClsLR()
'declare sub ClsRL()
'declare sub ClsTB()
'declare sub ClsBT()
'declare sub ClsEC()
'declare sub ClsCE()
'declare sub ClsLC()
'declare sub ClsCL()
declare sub ClsHB()
'declare sub ClsVB()
declare sub HoroSoftLogo()
'
'
' Function and Procedure Declaration in external object: ARRAYEXT.PBL
'----------------------------------------------------------------------------
'
declare function ArrayExtV%()
declare sub SHLBYT(integer,integer)
declare sub SHRBYT(integer,integer)
declare sub ANDMBA(integer,integer,integer)
declare sub ORMBA (integer,integer,integer)
declare sub XORMBA(integer,integer,integer)
declare sub ADDCBL(integer,integer,integer,integer)
declare sub ADDBOR(integer,integer,integer,integer,integer)
declare sub SUBCBL(integer,integer,integer,integer)
declare sub SUBBOR(integer,integer,integer,integer,integer)
declare sub LMTLBC(integer,integer,integer)
declare sub LMTHBC(integer,integer,integer)
declare sub FILLBC(integer,integer,integer)
declare sub SetBCL(integer,integer,integer,integer,integer)
declare sub XDimBA(integer,integer,integer,integer)
declare sub SHLWRD(integer,integer)
declare sub SHRWRD(integer,integer)
declare sub FILLWC(integer,integer,integer)
declare sub ANDBAS(integer,integer,integer)
declare sub ORBAS (integer,integer,integer)
declare sub XORBAS(integer,integer,integer)
declare sub ADDBAS(integer,integer,integer,integer)
declare sub SUBBAS(integer,integer,integer,integer)
declare sub AvrgBA(integer,integer,integer)
declare sub SWAPBA(integer,integer,integer)
declare sub CPYB2B(integer,integer,integer)
declare sub CpyHBA(integer,integer,integer)
declare sub CpyLBA(integer,integer,integer)
declare sub CPYBRZ(integer,integer,integer,integer,integer)
declare sub SWAPWA(integer,integer,integer)
declare sub CPYW2W(integer,integer,integer)
declare sub CPYW2B(integer,integer,integer)
declare sub CPYB2W(integer,integer,integer)
declare sub MulCBL(integer,integer,integer,integer)
declare function MINBYT%(integer,integer)
declare function MAXBYT%(integer,integer)
declare function AVGBYT%(integer,integer)
declare function CNTBYT%(integer,integer,integer)
declare function MINWRD%(integer,integer)
declare function MAXWRD%(integer,integer)
'
'
' Function and Procedure Declaration in external units: CCDUU1.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function CCDUU1V%()
declare sub SetSix(integer,integer,integer)
declare sub ZoomD(integer,integer,integer)
declare sub ZoomC(integer,integer)
declare sub ZoomB(integer,integer,integer,integer,integer)
declare sub BlowUp(integer,integer,integer,integer)
declare sub VErDif(integer)
declare sub HErDif(integer)
declare sub CErDif(integer)
declare sub Dither(integer,integer,integer)
declare sub DScale(integer,integer,integer)
declare sub Raster(integer,integer)
declare sub RScale(integer)
declare sub Tiny(integer,integer,integer,integer)
declare sub Doto(integer,integer,integer,integer)
declare sub EquiBr(integer,integer,integer)
declare sub IsoHug(integer)
declare sub Shrink(integer,integer,integer)
declare sub CpyQdr(integer,integer,integer,integer)
declare sub TogBar(integer)
declare sub InvQdr(integer,integer)
declare sub SwpQdr(integer,integer,integer,integer)
declare sub MD15BA(integer,integer,integer)
declare sub LogMul(integer,integer)
declare sub VGACol(integer,integer,integer)
declare function LoBytI%(integer)
declare function HiBytI%(integer)
declare function LoNibI%(integer)
declare function HiNibI%(integer)
'
'
' Function and Procedure Declaration in external units: CCDUU2.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function CCDUU2V%()
declare sub DecLnx(integer,integer)
declare sub EncLnx(integer,integer,integer)
declare sub EDCST4(integer,string,integer,integer)
declare sub Copy5X(integer,integer,integer,integer)
declare sub VertY(integer,integer)
declare sub HAvrg(integer,integer,integer)
declare sub VAvrg(integer,integer)
declare sub ScaleX(integer,integer,integer)
declare sub FLIPXY(integer,integer)
declare sub RoTwic(integer)
declare sub MovLft(integer,integer)
declare sub SupImp(integer,integer,integer)
declare sub AConvt(integer,string)
declare sub ChrLin(integer,integer,string)
declare sub InsLbl(integer,integer,integer,integer,integer)
declare sub SHLUIm(integer,integer,integer,integer)
declare sub SHRDIm(integer,integer,integer,integer)
declare sub FilFrm(integer,integer,integer,integer,integer)
declare sub CutFrm(integer,integer,integer,integer,integer)
declare sub FrmFrm(integer,integer,integer,integer,integer)
declare sub FrmHln(integer,integer,integer,integer)
declare sub FrmVln(integer,integer,integer,integer)
declare sub HVGrid(integer,integer)
declare sub ToFreq(integer,integer,integer)
declare sub ConvUF(integer,integer,integer)
declare sub StatMF(integer,integer,integer)
declare sub BiNine(integer,integer)
declare sub CpyBox(integer,integer,integer,integer)
'
'
' Function and Procedure Declaration in external units: CCDUP.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function CCDUPV%()
declare sub OnePCL(integer,integer,string,integer)
declare sub RLEscn(string,integer,integer)
declare sub RLElin(string,integer,integer)
declare function BytWrd%(integer,integer)
declare function NibWrd%(integer,integer,integer,integer)
'
'
' Function and Procedure Declaration in external units: PB3GPUSE.INC/PBU
'----------------------------------------------------------------------------
'
declare function PB3GPUseV%()
declare function PBVer%(string)
declare function EscRet%()
declare function AddSlash$(string)
declare function Center$(string,integer)
declare function LogOn$(string,integer,integer)
declare function DateNorm$(integer)
declare function KeyIn$()
declare function ComLinLan%(string,string)
declare function IOPath$(string,string,string)
declare function IOFile$(integer,integer,string)
declare function Confirm%(string)
declare function Redo%(string)
declare function FileHere%(string)
declare function SizeOk%(string,long)
declare function ByteBin$(integer)
declare function SelOpt%(string)
declare function Outch$(string)
declare function IntLmt%(integer,integer,integer)
declare sub ClrLine()
declare sub Illegal(string,string)
'
'
' Function and Procedure Declaration in external units: RLCEGEN.ASM/OBJ
'----------------------------------------------------------------------------
'
declare function RlceGenV%()
declare function VidAry%(integer,integer,integer)
declare function EncBie%(integer,integer,word)
declare function WrBie%(integer,integer)
declare function DecBie%(integer,integer)
declare function RdBie%(integer,integer,word)
'
'
' OBJECTS AND UNITS LINK IN
'----------------------------------------------------------------------------
'
$link "PBSTACK.OBJ"
$link "ARRAYEXT.PBL"
$link "CLRSCRN.PBL"
$link "CCDUU1.OBJ"
$link "CCDUU2.OBJ"
$link "CCDUP.OBJ"
$link "RLCEGEN.OBJ"
$link "PB3GPUSE.PBU"
'
'
' SOURCE FILES TO BE INCLUDED
'----------------------------------------------------------------------------
'
$segment
$include "CCDUFUNC.INC"
$include "CCDUPROC.INC"
$segment
$include "IOTEXT.INC"
$include "CCDUSUB1.INC"
$include "CCDUSUB2.INC"
$segment
$include "ERROR3.INC"
$include "CCDUDAT.INC"
'
'
' FILE HANDLING VARIABLES
'----------------------------------------------------------------------------
'
Z% = fix(fre(-1)/1024)
Fatal$ = SLText$(237%) + str$(228-Z%) + "Kb"
if Z% < 228 then goto NoJob			'Needs about 493Kb
'
dim FilExt$(%UnitBYT:%UnitPCL)	'Byte, Doto and PCL type to count up
FilExt$(%UnitBYT) = ".B00"
FilExt$(%UnitDOT) = ".D00"
FilExt$(%UnitPCL) = ".P00"
'
dim FileTyp$(1:6)		'File Typ or File Extension
FileTyp$(1) = "LNX"
FileTyp$(2) = "ALI"
FileTyp$(3) = "ST4"
FileTyp$(4) = "ASI"
FileTyp$(5) = "BYT"
FileTyp$(6) = "B??"
'
dim FileSize&(1:6)		'File Size
FileSize&(1) = 47520
FileSize&(2) = 47520
FileSize&(3) = 31872
FileSize&(4) = 31872
FileSize&(5) = %LMN
FileSize&(6) = %LMN
'
'
' FRAME ARRAYS and Related Ones
'----------------------------------------------------------------------------
dim CCA%(1:%LMN/2)		'-- active frame 165 X 192 bytes
dim CCC%(1:%LMN/2)		'-- copy of active frame
dim CCF%(1:%LMN/2)		'-- passive frame
dim CCB%(1:%LMN/2+5)		'-- 165 X 192 bytes, universal use
dim CCD%(1:165,1:192)		'-- used to load and as frame 4 & 5
dim CCX%(0:4,1:192)		'-- 5 rows used for profil averaging
'				    also used for option H
dim CCR%(1:5)			'-- Rot-Flag. If rotated, false
dim CCT%(1:95)			'-- 7 lines, 27 characters max = 189 bytes
dim CCG%(1:3520)		'-- 64 columns, 55 lines for CGE file
CCR%(1) = %True			'-- Frame-1: CCA%
CCR%(2) = %True			'-- Frame-2: CCF%
CCR%(3) = %True			'-- Frame-3: CCC%
dim CCN$(1:5)			'-- Filename
CCN$(1) = "none"
CCN$(2) = "none"
CCN$(3) = "none"
CCN$(4) = "none"
CCN$(5) = "none"
'
'
' VERSION STRING VARIABLES
'----------------------------------------------------------------------------
'
ST4Info$ = chr$(190) + space$(190) + chr$(0)
GPCR$ = "(c) 1992-96 by H.-R.H. Wernli, CH-3952 Susten, Switzerland"
STCR$ = "Processed with " + VN$ + "; " + GPCR$
'
'
' COLOR SCALES AND FILTERS
'----------------------------------------------------------------------------
'
dim ColScale%(0:22)			'-- color scales
dim GrayScale%(0:15)			'-- gray scale
dim CMask$(0:15)			'-- Identifier
dim CMasks%(0:15,1:10)			'-- Convolving mask
dim I%(1:10)				'-- used convolution filter mask
call ArraySetUp(ColScale%(),GrayScale%(),CMasks%(),CMask$())
E$ = chr$(27)
RptH$ = E$+"&l0O"+E$+"&a10L"+E$+"(10U"+chr$(27)+"(s0p12h12v0s0b6t1Q"
'
'
' CHARACTER AND TABLE REPRESENTATION
'----------------------------------------------------------------------------
'
dim AR$(0:16)			'ASCII-Representation
dim TR$(0:16)			'Table Representation
for N% = 0 to 16
  AR$(N%) = string$(34,".")
  TR$(N%) = repeat$(17,"000 ")
next N%
ChrDec$ = ".abcdefghijklmnopqrstuvwxyz@ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789*"
LblSml$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.-=+/|\'"+chr$(34)+"<>[]: via*"
'
'
' OTHER VARIABLES
'----------------------------------------------------------------------------
'
InpPath$ = curdir$
OutPath$ = curdir$
Virgin%  = %True
'
'
'=================== START OF PROGRAM =======================================
'
'
'--------------- Test if Programm may be run or not -------------------------
'
print LogOn$(Version$,%Cyan,%Black)
print Describe$
'
'----------------- TestImage - File Load Selection --------------------------
'
'---- If Test Image option is selected, CCD% is filled with the Test data.
'
print LogOn$(Version$,%Cyan,%Black)
print Describe$
Y% = csrlin
locate Y%,1
color %White,%Black
if not Confirm%(SLText$(115%)) then
  I% = %False
  gosub GetDirPath
  OutPath$ = UsePath$
  if Virgin% then InpPath$ = UsePath$	'-- only the first time
  color %Cyan,%Black
  print SLText$(93%);
  call GenTestImg(CCD%())
  print " "
  call CpyW2B(CCA%(1),CCD%(1,1),%LMN)
  B$ = OutPath$ + "TESTPICT.BYT"
  Z% = WrtByt%(CCA%(),CCB%(),B$)
  if Z% then
    print SLText$(229%);Z%
    delay 1
  end if
end if
SyLyFlg% = %True
RPTFlag% = %False
'
'=================== SUPER LOOP START =======================================
'
do
  print LogOn$(Version$,%Brown,%Black)	'-- Get Outfile Dirspecs validated
  I% = %False
  gosub GetDirPath			'-- Get output path
  OutPath$ = UsePath$
  if Virgin% then InpPath$ = UsePath$	'-- only the first time
'
'---- No primary file yet: get it. Explain and ask for secondary file
'
  if CCN$(1) = "none" then
    NewSec%  = %False
    RPTFlag% = %False
    Scope%   = %True		'-- Used to ask for info in Menu I
    Menu1% = 0			'-- Reset Primary file
    Menu2% = 0			'-- Reset Secondary file
    gosub GetFileSpec
    CCN$(1) = UseFile$		'-- Primary or active filespecs
    LoadFile$ = StripExt$(AFile$)
    RPTFile$ = OutPath$ + LoadFile$ + ".RPT"
    WRTFile$ = OutPath$ + LoadFile$
    Menu1% = Menu%
    call ResetXY0S(X0%,Y0%,XS%,YS%)		'-- Reset Pointer & Stepsize
    print LogOn$(Version$,%Cyan,%Black)		'--Secondary file
    call MLText(5%,80%,"cs")
    if not Confirm%(SLText$(6%)) then
      gosub GetFileSpec
      CCN$(2)   = UseFile$	'-- Secondary or passive filespecs
      NewSec% = %True
      Menu2% = Menu%
    end if
'
'---- We come here from the Main Menu and have an active file. Query for
'     loading an active or a passive frame. For a new active frame, a new
'     report file is needed.
'
  else
    Menu1% = 0			'-- Reset Primary Menu
    Menu2% = 0			'-- Reset Secondary Menu
    do
      print LogOn$(Version$,%Cyan,%Black)
      print Describe$
      color %LCyan,%Black
      print Center$(SLText$(118%),80)
      color %Cyan,%Black
      call MLText(11%,20%,"tf")
      Y% = csrlin
      X% = 45
      locate 22,1
      color %White,%Black
      print SLText$(116%);" ";CCN$(1)
      print SLText$(117%);" ";CCN$(2)
      locate Y%,1
      A% = Prompt%(X%,Q$)
      select case Q$
	case chr$(13)			'== Do Nothing
	  exit loop
	case chr$(27)			'== EXIT
	  goto LogOff
	case "1"			'== Active Frame
	  gosub GetFileSpec
	  LoadFile$ = StripExt$(AFile$)
	  RPTFile$  = OutPath$ + LoadFile$ + ".RPT"
	  WRTFile$  = OutPath$ + LoadFile$
	  NewSec%   = %False
	  CCN$(1)   = UseFile$		'-- Primary or active filespecs
	  Menu1% = Menu%
	  call ResetXY0S(X0%,Y0%,XS%,YS%)	'-- Reset Pointer & Stepsize
	  FilExt$(%UnitBYT) = ".B00"		'-- Reset Byte extension
	  FilExt$(%UnitDOT) = ".D00"		'-- Reset Doto extension
	  FilExt$(%UnitPCL) = ".P00"		'-- Reset PCL  extension
	  if RPTFlag% then
	    print# %UnitRPT, space$(70);time$
	    print# %UnitRPT, string$(80,"=")
	    if not OldRPT$ = RPTFile$ then
	      close %UnitRPT			'-- Close report file
	      RPTFlag% = %False
              Scope% = %True			'-- Reset Telescope Flag
	    end if
	  end if
	  CCR%(1) = %True		'-- Image not yet rotated
	  exit loop
	case "2"			'== Passive Frame
	  gosub GetFileSpec
	  CCN$(2)  = UseFile$		'-- Secondary or passive filespecs
	  Menu2%   = Menu%
	  NewSec%  = %True
	  CCR%(2)  = %True		'-- Image not yet rotated
	  exit loop
      end select
      print Outch$(Q$)
    loop
  end if
'
'---- Open and prepare Report file.
'
  color %White,%Black
  if not RPTFlag% then
    OldRPT$  = RPTFile$
    RPTFlag% = %True
    open RPTFile$ for output as # %UnitRPT
    print# %UnitRPT, RptH$
    print# %UnitRPT, string$(80,"=")
    print# %UnitRPT, Center$(Version$,80)
    A$ = DateNorm$(English%) + " - " + time$
    print# %UnitRPT, Center$(A$,80)
    print# %UnitRPT, ""
    print# %UnitRPT, SLText$(116%);" ";CCN$(1)
    print# %UnitRPT, SLText$(117%);" ";CCN$(2)
    print# %UnitRPT, string$(80,"=")
  end if
'
'---- Load Active Frames into Arrays CCA%, CCC% and CCD%
'
  print LogOn$(Version$,%Cyan,%Blue)
  UseFile$ = CCN$(1)
  CCN$(3)  = UseFile$
  print Describe$
  select case Menu1%
    case 1, 2
      gosub GetLNX
      call CpyB2B(CCC%(1),CCA%(1),%LMN)		'-- Copy of active Frame
      CCR%(3) = %True
      gosub PutST4
      gosub PutByt
    case 3, 4
      gosub GetST4
      call CpyB2B(CCC%(1),CCA%(1),%LMN)		'-- Copy of active Frame
      CCR%(3) = %True
      gosub PutLnx
      gosub PutByt
    case 5, 6
      gosub GetByt
      call CpyB2B(CCC%(1),CCA%(1),%LMN)		'-- Copy of active Frame
      CCR%(3) = %True
      gosub PutLnx
      gosub PutST4
      if Menu1% = 6 then			'Rename .Bxx to .Zxx
	if InpPath$ = OutPath$ then
	  A$ = CCN$(1)
	  B$ = CCN$(1)
	  A% = instr(A$,".")
	  mid$(B$,A%+1) = "Z"
	  name A$ as B$				'Abort if filename exists!
	  color %LWhite,%Red
	  print Center$(SLText$(48%)+" "+A$+" --> "+B$,80)
	  delay 1
	  color %White,%Black
	end if
      end if
  end select
'
'---- Load Passive Frames into Array CCF%
'
  select case Menu2%
    UseFile$ = CCN$(2)
    case 1, 2
      gosub GetLNX
      call CpyB2B(CCF%(1),CCA%(1),%LMN)		'-- Passive Frame
      call CpyB2B(CCA%(1),CCC%(1),%LMN)		'-- Active frame from Copy
      CCR%(2) = %True
    case 3, 4
      gosub GetST4
      call CpyB2B(CCF%(1),CCA%(1),%LMN)		'-- Passive Frame
      call CpyB2B(CCA%(1),CCC%(1),%LMN)		'-- Active Frame from Copy
      CCR%(2) = %True
    case 5, 6
      gosub GetByt
      call CpyB2B(CCF%(1),CCA%(1),%LMN)		'-- Passive Frame
      call CpyB2B(CCA%(1),CCC%(1),%LMN)		'-- Active Frame from Copy
      CCR%(2) = %True
  end select
'
'
'|--------------- MAIN MENU LOOP START -------------------------------------
  do
    locate 1,1,1,6,7
    print LogOn$(Version$,%White,%Blue);
    color %Black,%Cyan
    locate 24,1
    print Center$(GPCR$,80);
    color %Cyan,%Black
    locate 24,1
    print Center$(MaxMin$(CCA%(),MinV%,MaxV%),80);
    locate 5,1
    color %LCyan,%Black
    print Center$(SLText$(24%),80)
    color %Cyan,%Black
    call MLText(3%,1%,"tf")
    A% = Prompt%(39%,Q$)
    color %White,%Black
    select case Q$
      case "A"		'-- 6 Images Display
	gosub OptA
      case "B"		'-- False Color Dithered
	gosub OptB
      case "C"		'-- Isophotal Curves
	gosub OptC
      case "D"		'-- Rastered Grayscale
	gosub OptD
      case "E"          '-- Intensity DotoGram (r) HoroSoft
	gosub OptE
      case "F"    	'-- Intensity Profile
	gosub OptF
      case "G"    	'-- Table of Values & ASCII-representation
	gosub OptG
      case "H"    	'-- Brightness measurements
	gosub OptH
      case "I"    	'-- Intensity Distribution & Measuring
	gosub OptI
      case "J"		'-- Intensity Graph
	gosub OptJ
      case "K"		'-- Part-Frame Handling
	gosub OptK
      case "L"          '-- Flip X, Flip Y and Rotate 90 CCW
	gosub OptL
      case "M"          '-- Insert Label
	gosub OptM
      case "N"		'-- Zoom / Shrink
	gosub OptN
      case "O"		'-- Frame Handling
	gosub OptO
      case "P"		'-- Quadrant Handling
	gosub OptP
      case "Q"          '-- Clip Low (Background)
	gosub OptQ
      case "R"          '-- Clip High (Ceiling)
	gosub OptR
      case "S"          '-- Expand/Stretch and Compress
	gosub OptS
      case "T"          '-- 2 Frame operations
	gosub OptT
      case "U"          '-- Color Shift
	gosub OptU
      case "V"          '-- Inversion and Convolution Filtering
	gosub OptV
      case "W"		'-- Save file
	gosub OptW
      case "X"		'-- Process range of intensities
	gosub OptX
      case "Y"		'-- Save Table and ASCII
	gosub OptY
      case "Z"		'-- PCL Level 3
	gosub OptZ
      case chr$(13)
	exit loop	'-- Frame Selection Menu
      case chr$(27)
	goto LogOff	'-- Back to DOS
      case else
	print Outch$(Q$)
    end select
  loop
'.|................... Main Menu Loop End ...................................
'
Virgin% = %False
loop
'
':::::::::::::::::::::: Super Loop End ::::::::::::::::::::::::::::::::::::::
'
'
'---- Let's call it a day. The program quits by logging off.
'
LogOff:
'
color %White,%Black
print LogOn$(Version$,%White,%Blue);
print Describe$
color %LWhite,%Green
A$ = VN$ + SLText$(66%)
print Center$(A$,80)
if RPTFlag% then
  print# %UnitRPT, space$(70);time$
  print# %UnitRPT, string$(80,"=")
  close
end if
color %LWhite,%Red
A$ = VN$ + "; " + GPCR$
print Center$(A$,80)
color %White,%Black
locate 22,1,1,6,7
goto About
'
'
'---- Here follows a rather simple error handler. The fatal system-error
'     handler is included in ERROR.INC
'
NoJob:
'
print
color %Yellow,%Red
A$ = SLText$(89%) + space$(1) + Fatal$
print Center$(A$,80);
color %LWhite,%Red
print Center$(SLText$(67%) + VN$ + SLText$(68%),80);
color %LCyan,%Blue
print Center$(SLText$(69%),80);
if RPTFlag% then
  print# %UnitRPT, A$
  print# %UnitRPT, space$(70);time$
  print# %UnitRPT, string$(80,"~")
  close
end if
color %White,%Black
locate 22,1,1,6,7
A$ = KeyIn$
goto About
'
'
About:
'
print "Info = F1 (2 sec)"
delay 2
if inkey$ = chr$(0,59) then
  print
  color %LWhite,%Black
  print "CCDUTIL .BAS Version";CCDUtilV%
  color %White,%Black
  print "CCDUFUNC.INC Version";CCDUFuncV%
  print "CCDUPROC.INC Version";CCDUProcV%
  print "CCDUSUB1.INC Version";CCDUSub1V%
  print "CCDUSUB2.INC Version";CCDUSub2V%
  print "CCDUDAT .INC Version";CCDUDatV%
  print "CCDUU1  .OBJ Version";CCDUU1V%
  print "CCDUU2  .OBJ Version";CCDUU2V%
  print "CCDUP   .OBJ Version";CCDUPV%
  print "IOTEXT  .INC Version";IOTextV%
  print "ERROR3  .INC Version";Error3V%
  print "PB3GPUSE.PBU Version";PB3GPUseV%
  print "CLRSCRN .PBL Version";ClrScrnV%
  print "ARRAYEXT.PBL Version";ArrayExtV%
  print "RLCEGEN .OBJ Version";RlceGenV%
  print "PBSTACK .OBJ Version 100"
  print "PowerBASIC  Revision";PBVer%(SV$);SV$
  print
  color %LWhite,%Blue
  call HoroSoftLogo
  color %White,%Black
  while not instat : wend
  Q$ = inkey$
  call ClsHB
end if
cls
system
'
'
'===================================-<920813>-=========-<HoroSoft>-==========
