;940421 1723
;****************************************************************************
;* PROGRAM NAME: CCDUU1  .ASM   DATE:  3.10.1992    LINK INTO: CCDUTIL.BAS  *
;* LANGUAGE: Turbo Assembler TASM 2.01                                      *
;* PURPOSE:  Procedures and functions for CCDUTIL                           *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01  2-JUN-94 Introduced Version CCDUU1V% = 101               *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00  3-OCT-92 Start - did not keep up with versions           *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 2.10:                 *
;*            = declare sub SetSix(integer,integer,integer)                 *
;*            = declare sub ZoomD(integer,integer,integer)                  *
;*            = declare sub ZoomC(integer,integer)                          *
;*            = declare sub ZoomB(integer,integer,integer,integer,integer)  *
;*            = declare sub BlowUp(integer,integer,integer,integer)         *
;*            = declare sub VErDif(integer)                                 *
;*            = declare sub HErDif(integer)                                 *
;*            = declare sub CErDif(integer)                                 *
;*            = declare sub Dither(integer,integer,integer)                 *
;*            = declare sub DScale(integer,integer,integer)                 *
;*            = declare sub Raster(integer,integer)                         *
;*            = declare sub RScale(integer)                                 *
;*            = declare sub Tiny(integer,integer,integer,integer)           *
;*            = declare sub Doto(integer,integer,integer,integer)           *
;*            = declare sub EquiBr(integer,integer,integer)                 *
;*            = declare sub IsoHug(integer)                                 *
;*            = declare sub Shrink(integer,integer,integer)                 *
;*            = declare sub CpyQdr(integer,integer,integer,integer)         *
;*            = declare sub TogBar(integer)                                 *
;*            = declare sub InvTog(integer,integer)                         *
;*            = declare sub SwpQdr(integer,integer,integer,integer)         *
;*            = declare sub MD15BA(integer,integer,integer)                 *
;*            = declare sub LogMul(integer,integer)                         *
;*            = declare sub VGACol(integer,integer,integer)                 *
;*            = declare function LoBytI%(integer)                           *
;*            = declare function HiBytI%(integer)                           *
;*            = declare function LoNibI%(integer)                           *
;*            = declare function HiNibI%(integer)                           *
;*            = $link "CCDUU1.OBJ" Needs PBSTACK.OBJ to be linked as well!  *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCUU1                                                 *
;* NOTE: Needs PBSTACK.OBJ to be linked in from CCDUTIL!                    *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
ega	equ	 12			;int 10h function
video	equ	 16			;int 10h video interrupt
getcon	equ	 11			;int 21h function get console status
dos	equ	 33			;int 21h DOS interrupt
color	equ	 15			;Light White for Dotos & Isophotes
drows	equ	330			;double rows    2 * 165
dcols	equ	384			;double columns 2 * 192
rows	equ	165			;165 rows
cols	equ	192			;192 columns
hrows	equ	 82			;half rows, 82 = fix(165/2)
hcols	equ	 96			;half columns, 96 = 192/2
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDUU1V%
;----------------------------------------------------------------------------
;
CCDUU1V		proc	far
		public	CCDUU1V
;
                call	pbastk
		mov	ax,101		;V.1.01
		xor	bl,bl
                jmp	bakbas
;
CCDUU1V	endp
;
;
; VARIABLES AND TABLES DEFINITIONS - Do NOT alter sequence!
;============================================================================
;
auxv1	db	0			;auxiliary variable 1
auxv2	db	0			;auxiliary variable 2
;
;
; Doto - dotogramm
;----------------------------------------------------------------------------
;
dotov	dw	0			;350: highest value, actually lowest
	dw	0			;384: X-position, initial right
	dw	0			;350: Y-position, initial bottom
	dw	0			;192: column counter
;
;
; SETSIX         # Image-Number: Right Shifts, Limit/Substractor, Y, X
;----------------------------------------------------------------------------
;
setsxv	dw	0207h,  1,  1		;#  1: 7, 2,  1,  1  upper-left
	dw	0406h,  1,223		;#  2: 6, 4,  1,223  upper-center
	dw	0805h,  1,446		;#  3: 5, 8,  1,446  upper-right
	dw	1004h,184,  1		;#  4: 4,16,184,  1  lower-left
	dw	1003h,184,223		;#  5: 3,16,184,223  lower-center
	dw	1002h,184,446		;#  6: 2,16,184,446  lower right
;
	dw	0805h,  1,  1		;#  7: 5, 8,  1,  1  Analyzing
	dw	1004h,184,  1		;#  8: 4,16,184,  1
	dw	0406h, 10,431		;#  9: 6, 4, 10,431
;
	dw	0406h,  1,447		;# 10: 6, 4,  1,447  Isophotes
	dw	0207h,184,447		;# 11: 7, 2,184,447    2 colors
	dw	0406h,184,447		;# 12: 6, 4,184,447    4 colors
	dw	0805h,184,447		;# 13: 5, 8,184,447    8 colors
	dw	1004h,184,447		;# 14: 4,16,184,447   16 colors
	dw	1003h,184,447		;# 15: 3,16,184,447   32 colors
	dw	1002h,184,447		;# 16: 2,16,184,447   64 colors
	dw	1001h,184,447		;# 17: 1,16,184,447  128 colors
;
	dw	1004h,  1,447		;# 18: 4,16,447,  1  Zooming
	dw	0805h,  1,447		;# 19: 5, 8,447,  1  Analysis
;
;
; Zoom-Dither           Right Shifts, Offset in ColScale?
;----------------------------------------------------------------------------
;
zoomdv	db	 7, 0			;#  1:  2 colors
	db	 6, 2			;#  2:  4 colors
	db	 5, 6			;#  3:  8 colors
	db	 4,14			;#  4: 16 colors rainbow
	db	 4,30			;#  5: 16 colors PC
	db	26,46			;#  6: 10 colors
;
;
; Quadrants for CpyQdr
;----------------------------------------------------------------------------
;
quadr	dw	15840			;Quadrant 1 Top Right
	dw	    0			;Quadrant 2 Top Left
	dw	   83			;Quadrant 3 bottom left
	dw	15923			;Quadrant 4 bottom right
;
;
; Logarithmic function tables: ascending and descending and hyperbolic
;----------------------------------------------------------------------------
;
;    Y = (ln(256/X)+1) * X - 1
;
loget	db     0,  6, 11, 15, 20, 24, 28, 31, 35, 38, 41, 45, 48, 51, 54, 57
	db    59, 62, 65, 67, 70, 73, 75, 77, 80, 82, 84, 87, 89, 91, 93, 95
	db    98,100,102,104,106,108,109,111,113,115,117,119,120,122,124,126
	db   127,129,131,132,134,135,137,139,140,142,143,145,146,147,149,150
	db   152,153,154,156,157,158,160,161,162,164,165,166,167,169,170,171
	db   172,173,174,175,177,178,179,180,181,182,183,184,185,186,187,188
	db   189,190,191,192,193,194,195,196,197,198,198,199,200,201,202,203
	db   204,204,205,206,207,208,208,209,210,211,211,212,213,214,214,215
	db   216,216,217,218,218,219,220,220,221,222,222,223,223,224,225,225
	db   226,226,227,228,228,229,229,230,230,231,231,232,232,233,233,234
	db   234,235,235,236,236,236,237,237,238,238,239,239,239,240,240,241
	db   241,241,242,242,242,243,243,243,244,244,244,245,245,245,246,246
	db   246,247,247,247,247,248,248,248,248,249,249,249,249,250,250,250
	db   250,250,251,251,251,251,251,252,252,252,252,252,252,252,253,253
	db   253,253,253,253,253,254,254,254,254,254,254,254,254,254,254,254
	db   254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
;
;
;    inverse Y = (ln(256/X)+1) * X - 1
;
	db     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1
	db     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2
	db     2,  2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  5,  5
	db     5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  8,  9
	db     9,  9, 10, 10, 10, 11, 11, 11, 12, 12, 12, 13, 13, 13, 14, 14
	db    14, 15, 15, 16, 16, 16, 17, 17, 18, 18, 19, 19, 19, 20, 20, 21
	db    21, 22, 22, 23, 23, 24, 24, 25, 25, 26, 26, 27, 27, 28, 29, 29
	db    30, 30, 31, 32, 32, 33, 33, 34, 35, 35, 36, 37, 37, 38, 39, 39
	db    40, 41, 41, 42, 43, 44, 44, 45, 46, 47, 47, 48, 49, 50, 51, 51
	db    52, 53, 54, 55, 56, 57, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66
	db    67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 80, 81, 82, 83
	db    84, 85, 86, 88, 89, 90, 91, 93, 94, 95, 97, 98, 99,101,102,103
	db   105,106,108,109,110,112,113,115,116,118,120,121,123,124,126,128
	db   129,131,133,135,136,138,140,142,144,146,147,149,151,153,155,157
	db   160,162,164,166,168,171,173,175,178,180,182,185,188,190,193,196
	db   198,201,204,207,210,214,217,220,224,227,231,235,240,244,249,255
;
;
;    Y = ln(X) * (255/ln(255))
;
	db     0,  0, 32, 51, 64, 74, 82, 90, 96,101,106,110,114,118,121,125
	db   128,130,133,135,138,140,142,144,146,148,150,152,153,155,157,158
	db   159,161,162,164,165,166,167,169,170,171,172,173,174,175,176,177
	db   178,179,180,181,182,183,184,184,185,186,187,188,188,189,190,191
	db   191,192,193,193,194,195,196,196,197,197,198,199,199,200,200,201
	db   202,202,203,203,204,204,205,206,206,207,207,208,208,209,209,210
	db   210,211,211,211,212,212,213,213,214,214,215,215,215,216,216,217
	db   217,218,218,218,219,219,220,220,220,221,221,221,222,222,223,223
	db   223,224,224,224,225,225,225,226,226,226,227,227,227,228,228,228
	db   229,229,229,230,230,230,231,231,231,231,232,232,232,233,233,233
	db   234,234,234,234,235,235,235,236,236,236,236,237,237,237,237,238
	db   238,238,238,239,239,239,239,240,240,240,240,241,241,241,241,242
	db   242,242,242,243,243,243,243,244,244,244,244,245,245,245,245,245
	db   246,246,246,246,247,247,247,247,247,248,248,248,248,248,249,249
	db   249,249,249,250,250,250,250,250,251,251,251,251,251,252,252,252
	db   252,252,253,253,253,253,253,254,254,254,254,254,254,255,255,255
;
;
;    inverse Y = ln(X) * (255/ln(255))
;
	db     0,  0,  0,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  3,  3
	db     3,  3,  3,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  6,  6,  6
	db     6,  6,  7,  7,  7,  7,  7,  8,  8,  8,  8,  8,  9,  9,  9,  9
	db    10, 10, 10, 10, 10, 11, 11, 11, 11, 12, 12, 12, 12, 13, 13, 13
	db    13, 14, 14, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17, 17, 17
	db    17, 18, 18, 18, 18, 19, 19, 19, 19, 20, 20, 20, 21, 21, 21, 21
	db    22, 22, 22, 23, 23, 23, 24, 24, 24, 24, 25, 25, 25, 26, 26, 26
	db    27, 27, 27, 28, 28, 28, 29, 29, 29, 30, 30, 30, 31, 31, 31, 32
	db    32, 32, 33, 33, 34, 34, 34, 35, 35, 35, 36, 36, 37, 37, 37, 38
	db    38, 39, 39, 40, 40, 40, 41, 41, 42, 42, 43, 43, 44, 44, 44, 45
	db    45, 46, 46, 47, 47, 48, 48, 49, 49, 50, 51, 51, 52, 52, 53, 53
	db    54, 55, 55, 56, 56, 57, 58, 58, 59, 59, 60, 61, 62, 62, 63, 64
	db    64, 65, 66, 67, 67, 68, 69, 70, 71, 71, 72, 73, 74, 75, 76, 77
	db    78, 79, 80, 81, 82, 83, 84, 85, 86, 88, 89, 90, 91, 93, 94, 96
	db    97, 98,100,102,103,105,107,109,111,113,115,117,120,122,125,127
	db   130,134,137,141,145,149,154,159,165,173,181,191,204,223,255,255
;
;
; ICI Color scale in Nibbles.            q1q2q3q4
;    q1: LB, ln - q2: LB, hn - q3: HB, ln - q4: HB hn
; Sequence (1/1/1/1)  2/1/1/1 - 2/1/2/1 - 2/1/2/2 - 2/2/2/2
;                2/1 1/1 2/1 2/1 2/1 2/2 2/2 2/2          color   1 / 2
;----------------------------------------------------------------------------
;
icicol	dw	 0000h					;  0-  3 blk/blk
	dw	 0800h,  0808h,  8808h,  8888h		;  4- 19 blk/gry
	dw	 8188h,  8181h,  8111h,  1111h		; 20- 35 gry/blu
	dw	 1911h,  1919h,  1999h,  9999h		; 36- 51 blu/BLU
	dw	 9599h,  9595h,  9555h,  5555h		; 52- 67 BLU/pnk
	dw	 5d55h,  5d5dh,  5dddh, 0ddddh		; 68- 83 pnk/PNK
	dw	0d4ddh, 0d4d4h, 0d444h,  4444h		; 84- 99 PNK/red
	dw	 4c44h,  4c4ch,  4ccch, 0cccch		;100-115 red/RED
	dw      0c6cch, 0c6c6h, 0c666h,  6666h		;116-131 RED/brn
	dw	 6866h,  6868h,  6888h			;132-143 brn/gry
	dw	 8e88h,  8e8eh,  8eeeh, 0eeeeh		;144-159 gry/YEL
	dw	0e2eeh, 0e2e2h, 0e222h,  2222h		;160-175 YEL/grn
	dw	 2a22h,  2a2ah,  2aaah, 0aaaah		;176-191 grn/GRN
	dw	0a3aah, 0a3a3h, 0a333h,  3333h		;192-207 GRN/cyn
	dw	 3b33h,  3b3bh,  3bbbh, 0bbbbh		;208-223 cyn/CYN
	dw	0b7bbh, 0b7b7h, 0bb77h,  7777h		;224-239 CYN/wht
	dw	 7f77h,  7f7fh,  7fffh, 0ffffh		;240-255 wht/WHT
;
; Intensity weighted colors for DAC grayscale conversion
;   Organized as above in nibbles
;----------------------------------------------------------------------------
;
	dw	 0000h,  0000h,  0001h			;  0-  9 blk/blk
	dw	 0100h,  0101h,  0111h,  1111h		; 10- 25 blk/blu
	dw	 1411h,  1414h,  1444h,  4444h		; 26- 41 blu/red
	dw	 4544h,  4545h,  4555h,  5555h		; 42- 57 red/pnk
	dw	 5855h,  5858h,  5888h,  8888h		; 58- 73 pnk/gry
	dw	 8288h,  8282h,  8222h,  2222h		; 74- 89 gry/grn
	dw	 2622h,  2626h,  2666h,  6666h		; 90-105 grn/brn
	dw	 6966h,  6969h,  6999h,  9999h		;106-121 brn/BLU
	dw	 9399h,  9393h,  9333h,  3333h		;122-137 BLU/cyn
	dw	 3c33h,  3c3ch,  3ccch, 0cccch		;138-153 cyn/RED
	dw	0cdcch, 0cdcdh, 0cdddh, 0ddddh		;154-169 RED/PNK
	dw	0d7ddh, 0d7d7h, 0d777h,  7777h		;170-185 PNK/wht
	dw	 7a77h,  7a7ah,  7aaah, 0aaaah		;186-201 wht/GRN
	dw	0abaah, 0ababh, 0abbbh, 0bbbbh		;202-217 GRN/CYN
	dw	0bebbh, 0bebeh, 0beeeh, 0eeeeh		;218-233 CYN/YEL
	dw	0efeeh, 0efefh, 0efffh, 0ffffh		;234-249 YEL/WHT
	dw	0ffffh					;250-255 WHT/WHT
;
RADIX 10
;
; PROCEDURE  prints a false color image with 165 X 192 dots.
;            V.2.01 is 16% faster than V.1.03 and 84 times faster than V.1.01
;     call SETSIX(CCA%(1),ColScale%(C%),ImgNr%)
;============================================================================
;
SETSIX	proc	far
	public	SETSIX
;
	call	pbastk			;CX = ImgNr%
	dec	cl			;option base 0
	mov	ax,cx			;AX=ImgNr
	add	ax,ax			;* 2
	add	ax,cx			;* 3
	add	ax,ax			;* 6: 6 bytes in table above
	lea	bx,setsxv		;BX=table start
	add	bx,ax			;BX points to appropriate entry
	add	bx,4			;BX points to X
	les	di,[bp+10]		;(ES:DI) = (ColSelect%(x))
	lds	si,[bp+14]		;(DS:SI) = (CCA%(1))
	xor	dx,dx			;DX = Col.Cntr 0...191
setsx1:	push	dx			;save column counter
	add	dx,cs:[bx]		;DX = X
	dec	bx
	dec	bx			;point to Y
	xor	cx,cx			;CX = Row Cntr 0...164
setsx2:	push	cx			;save row counter
	push	bx			;save table pointer
	add	cx,cs:[bx]		;CX = current Y
	push	cx			;save current Y
	dec	bx
	dec	bx			;point to X-start in table
	mov	cx,cs:[bx]		;CL=SHR, CH=limit
	lodsb				;AL=CCA%(n) - inc si
	shr	al,cl			;divide
setsx3:	cmp	al,ch			;check limit
	jc	setsx4			;if AL < CH, jump
	sub	al,ch			;substract limit
	jmp	short setsx3		;check again
setsx4:	xor	ah,ah			;AX = color number
	add	di,ax			;(ES:DI) = (ColScale%(colorAX))
	mov	ch,es:[di]		;CH = color to be used
	sub	di,ax			;point to start in ColScale%
	pop	ax			;AX = current Y
	mov	bx,dx			;BX = current X
	call	setdot			;pset (BX,AX),CH
	pop	bx			;get pointer
	pop	cx			;get row counter
	inc	cx			;next row
	cmp	cx,rows			;all done?
	jc	setsx2			;no, repeat
	inc	bx
	inc	bx			;set pointer to X
	pop	dx			;get column counter
	mov	ah,getcon		;get console
	int	dos			;check if key pressed
	inc	al			;AL= 0->1: none, 255->0 key
	jz	setsx5			;abort on key pressed
	inc	dx			;one column done
	cmp	dx,cols			;all done?
	jc	setsx1			;no, repeat
setsx5:	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
SETSIX	endp
;
;
; PROCEDURE draws dithered image for Zoom option B
;           Dedicated from Dither-Procedure. Needs only 43% of Dither time.
;     call ZoomD(CCA%(1),ColScale%(0),ImgNr%)
;----------------------------------------------------------------------------
;
ZOOMD	proc	far
	public	ZOOMD
;
	call	pbastk			;CX = ImgNr
	dec	cl			;option base 0
	add	cx,cx			;2 bytes per table entry
	lea	bx,zoomdv		;BX = start of table
	add	bx,cx			;BX points to table
	mov	cl,cs:[bx]		;CL = right shifts
	inc	bx
	mov	dl,cs:[bx]		;DL = start offset into ColScale%
	xor	dh,dh			;DX = start offset into ColScale%
	les	di,[bp+10]		;(ES:DI) = (ColScale%(0))
	add	di,dx			;(ES:DI) = (ColScale%(dx))
	lds	si,[bp+14]		;(DS:SI) = (CCA%(n))
	xor	bx,bx			;BX = X
zoomd1:	push	bx			;save X
	xor	ax,ax			;AX = Y
zoomd2:	push	ax			;save Y
	push	cx			;save shift number
	lodsb				;AL = CCA%(ax,bx) - inc si
	shr	al,cl			;AL = color offset
	xor	ah,ah			;AX = color offset
	add	di,ax			;(ES:DI) points to color
	mov	ch,es:[di]		;CH = color
	sub	di,ax			;(ES:DI) points to start again
	pop	dx			;pop shift number from stack
	pop	ax			;get Y
	pop	bx			;get X
	push	bx			;save X again
	call	setdot			;pset (bx,ax),ch
	inc	ax			;Y+1
	inc	bx			;X+1
	call	setdot			;pset (bx+1,ax+1),ch
	mov	cx,dx			;restore shifts
	inc	ax			;Y+2 = next sprite Y-start
	cmp	ax,drows		;330 reached?
	jc	zoomd2			;no, repeat
	pop	bx			;get X
	inc	bx
	inc	bx			;X+2 = next sprite X-start
	cmp	bx,dcols		;384 reached?
	jc	zoomd1			;no, repeat
	mov	bl,3			;3 parameters
	jmp	bakbas
;
ZoomD	endp
;
;
; PROCEDURE clears top-right and bottom-left pixel for zooming Option B
;     call ZoomC(YU%,XL%) Zoom-Clear. YU%=top, XL%=left corner
;----------------------------------------------------------------------------
;
ZOOMC	proc	far
	public	ZOOMC
;
	call	pbastk			;CX = XL%
	dec	cx			;option base 0
	add	cx,cx			;*2 for two pixels
	mov	bx,cx			;BX = X
	lds	si,[bp+10]		;(DS:SI) = (YU%)
	mov	ax,ds:[si]		;AX = YU%
	dec	ax			;option base 0
	add	ax,ax			;*2 for two pixels
	mov	dx,rows
	add	dx,ax                   ;DX = Y+hrows: limit
	mov	cx,cols
	add	cx,bx			;CX = X+hcols: limit
zoomc1: push	ax			;save Y start position
	push	cx			;save X limit
	xor	ch,ch			;color black
zoomc2:	inc	bx			;X+1: top right
	call	setdot			;clear dot
	dec	bx			;X
	inc	ax			;Y+1: bottom left
	call	setdot			;clear dot
	inc	ax			;Y+2 = new Y
	cmp	ax,dx			;limit reached?
	jc	zoomc2			;no, repeat
	pop	cx			;restore X-limit
	pop	ax			;restore start Y position
	inc	bx
	inc	bx			;X+2 = new X
	cmp	bx,cx			;limit reached?
	jc	zoomc1			;no, repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
ZOOMC	endp
;
;
; PROCEDURE highlights 96 X 82 square in zoomed image for option B
;     call ZoomB(CCA%(1),ColScale%(0),YU%,XL%,ImgNr%) - Zoom Bright
;----------------------------------------------------------------------------
;
ZOOMB	proc	far
	public	ZOOMB
;
	call	pbastk			;CX = ImgNr%
	mov	al,hcols		;columns counter
	mov	cs:auxv1,al		;initialize counter
	dec	cl			;option base 0
	add	cx,cx			;2 bytes per table entry
	lea	bx,zoomdv		;BX = start of table
	add	bx,cx			;BX points to table
	mov	cl,cs:[bx]		;CL = right shifts
	inc	bx
	mov	dl,cs:[bx]		;DL = start offset into ColScale%
	xor	dh,dh			;DX = start offset into ColScale%
	les	di,[bp+18]		;(ES:DI) = (ColScale%(0))
	add	di,dx			;(ES:DI) = (ColScale%(dx))
	lds	si,[bp+10]		;(DS:SI) = (XL%)
	mov	ax,ds:[si]		;AX = XL%
	dec	ax			;option base 0
	mov	dx,ax			;copy XL%-1
	mov	bl,rows
	mul	bl			;AX=(XL%-1)*165
	lds	si,[bp+14]      	;(DS:SI) = (YU%)
	mov	bx,ds:[si]		;BX = YU%
	dec	bx			;option base 0
	add	ax,bx			;AX = offset into CCA%
	lds	si,[bp+22]		;(DS:SI) = CCA%(1))
	add	si,ax			;(DS:SI) = CCA%(YU%-1,XL%-1)
	mov	ax,bx			;AX = XL%-1
	add	ax,ax			;AX = X
	mov	bx,dx			;BX = YU%-1
	add	bx,bx			;BX = Y
zoomb1:	push	ax			;save Y
	push	bx			;save X
	mov	ch,hrows		;CH = rows counter
zoomb2:	push	ax			;save Y
	push	cx			;save shift number
	lodsb				;AL = CCA%(ax,bx) - inc si
	shr	al,cl			;AL = color offset
	xor	ah,ah			;AX = color offset
	add	di,ax			;(ES:DI) points to color
	mov	ch,es:[di]		;CH = color
	sub	di,ax			;(DS:SI) points to start again
	pop	dx			;pop shift number from stack
	pop	ax			;get Y
	pop	bx			;get X
	push	bx			;save X again
	inc	bx			;X+1
	call	setdot			;pset (bx+1,ax),ch
	dec	bx			;X
	inc	ax			;Y+1
	call	setdot			;pset (bx,ax+1),ch
	mov	cx,dx			;restore shifts
	inc	ax			;Y+2 = next sprite Y-start
	dec	ch			;rows-1 until 0
	jnz	zoomb2			;no, repeat
	add	si,83			;skip rest and point into CCA?
	pop	bx			;get X
	pop	ax			;get Y start
	inc	bx
	inc	bx			;X+2 = next sprite X-start
	mov	dl,cs:auxv1		;get column counter
	dec	dl			;cols-1
	mov	cs:auxv1,dl		;update
	jnz	zoomb1			;no, repeat until 0
	mov	bl,5			;5 parameters
	jmp	bakbas
;
ZoomB	endp
;
;
; PROCEDURE  Blows up image in CCA% into CCB%. Used for Zooming option B
;     call BlowUp(CCB%(1),CCA%(1),YU%,XL%)
;----------------------------------------------------------------------------
;
BLOWUP	proc	far
	public	BLOWUP
;
	call	pbastk			;CX = XL%
	lds	si,[bp+10]
	mov	bx,ds:[si]		;BX = YU%
	lds	si,[bp+14]		;(DS:SI) = (CCA%(1))
	call	aryxyi			;set SI to CCA%(YU%,XL%)
	les	di,[bp+18]		;(ES:DI) = (CCB?(1))
	mov	dl,hcols		;96 columns to do
blowu1:	mov	cx,hrows		;82 rows to do
blowu2: lodsb				;AL = CCA?() - inc si
	mov	ah,al			;in AL and AH same value
	stosw				;YU% and YU% + 1 = value, row + 2
	mov	bx,163			;prepare for next column right
	add	bx,di			;2 + 163 = 165 further
	mov	es:[bx],ax		;store next 2 dots
	loop	blowu2
	mov	es:[di],al		;83th byte = 82th byte
	inc	bx
	inc	bx			;also for next column
	mov	es:[bx],al
	mov	bx,83			;(165-82) * 2 !
	add	si,bx			;point to next column
	mov	bx,166			;(165-82) * 2
	add	di,bx
	dec	dl			;columns - 1
	jnz	blowu1			;do next column
	mov	bl,4			;4 parameters to remove
	jmp	bakbas
;
BLOWUP	endp
;
;
; PROCEDURE takes uneven pixels and forms the even one in between using the
;           error diffusion method.
;           Array is CCA%(165,192), direction is vertical, i.e. columns.
;       call VErDif(CCA%(1))
;-----------------------------------------------------------------------------
;
VERDIF	proc	far
	public	VERDIF
;
	call	pbastk			;(DS:SI) = (CCA%(1))
	push	ds
	pop	es
	mov	di,si			;(ES:DI) = (CCA%(1))
	mov	ch,96			;96 columns
verdi0:	mov	cl,82			;82 lines
	xor	bx,bx			;no error bit
verdi1:	inc	di			;offset one for dest pixel
	lodsw				;AL = AH = pixel 1 and pixel 2
	mov	dl,ds:[si]		;get pixel 3
	xor	dh,dh			;DX = pixel 3
	xor	ah,ah			;AX = pixel 1
	add	ax,dx			;add pixel 1 & 3
	add	ax,bx			;add previous error
	mov	bl,al			;get low byte
	and	bl,1			;remove all bits exept bit 0
	shr	ax,1			;divide by 2
	stosb				;insert pixel
	dec	cl
	jnz	verdi1			;do all lines in this column
	add	di,166
	add	si,166			;next column
	dec	ch
	jnz	verdi0			;do all columns
	mov	bl,1			;1 parameter to remove
	jmp	bakbas
;
VERDIF	endp
;
;
; PROCEDURE takes uneven pixels and forms the even one in between using the
;           error diffusion method.
;           Array is CCB%(192,165), direction is horizontal, i.e. lines
;           Use XDimBA(CCB%(1),CCA%(1),165%,192%) prior calling.
;       call HErDif(CCB%(1))
;-----------------------------------------------------------------------------
;
HERDIF	proc	far
	public	HERDIF
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	push	ds
	pop	es
	mov	di,si			;(ES:DI) = (CCB%(1))
	mov	ch,83			;83 lines
herdi0:	mov	cl,95			;96-1 columns
	xor	bx,bx			;no error bit
herdi1:	inc	di			;offset one for dest pixel
	lodsw				;AL = AH = pixel 1 and pixel 2
	mov	dl,ds:[si]		;get pixel 3
	xor	dh,dh			;DX = pixel 3
	xor	ah,ah			;AX = pixel 1
	add	ax,dx			;add pixel 1 & 3
	add	ax,bx			;add previous error
	mov	bl,al			;get low byte
	and	bl,1			;remove all bits exept bit 0
	shr	ax,1			;divide by 2
	stosb				;insert pixel
	dec	cl
	jnz	herdi1			;do all columns in this line
	add	di,194
	add	si,194			;next column
	dec	ch
	jnz	herdi0			;do all lines
	mov	bl,1			;1 parameter to remove
	jmp	bakbas
;
HERDIF	endp
;
;
; PROCEDURE takes corner pixel in a 9 x 9 field and sets the center by the
;           error diffusion method.
;           Array is CCB%(192,165), direction is horizontal, i.e. lines
;           Use XDimBA(CCB%(1),CCA%(1),165%,192%) prior calling.
;       call CErDif(CCB%(1))
;-----------------------------------------------------------------------------
;
CERDIF	proc	far
	public	CERDIF
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	push	ds
	pop	es
	mov	di,si			;(ES:DI) = (CCB%(1))
	add	di,192			;point to center
	mov	ch,83			;83 lines
cerdi0:	mov	cl,95			;96-1 columns
	xor	bx,bx			;no error bit
cerdi1:	inc	di			;offset one for dest pixel
	lodsw				;AL = AH = pixel i1 and pixel i2
	push	si			;save position i3
	mov	dl,ds:[si]		;get pixel i3
	xor	dh,dh			;DX = pixel 3
	xor	ah,ah			;AX = pixel 1
	add	ax,dx			;add pixel 1 & 3
	add	si,384			;point to pixel i9
	mov	dl,ds:[si]		;get pixel at i9
	add	ax,dx			;AX = pixel i1+i3+i9
	dec	si
	dec	si			;point to pixel i7
	mov	dl,ds:[si]		;get pixel i7
	pop	si			;point to i3, new i1
	add	ax,dx			;AX = i1+i3+i9+i7
	add	ax,bx			;add previous error
	mov	bl,al			;get low byte
	and	bl,3			;remove all bits exept bit 0 and 1
	shr	ax,1			;divide by 2
	shr	ax,1			;divide by 4
	stosb				;insert pixel
	dec	cl
	jnz	cerdi1			;do all columns in this line
	add	di,194
	add	si,194			;next column
	dec	ch
	jnz	cerdi0			;do all lines
	mov	bl,1			;1 parameter to remove
	jmp	bakbas
;
CERDIF	endp
;
;


; PROCEDURE draws dithered image for option B
;           Mask is 252 for 64 cols and 248 for 32 cols
;           G% is offset: 0 for ICI, 128 for grayweighted
;     call Dither(CCA%(1),Mask%,G%)
;----------------------------------------------------------------------------
;
DITHER	proc	far
	public	DITHER
;
	call	pbastk                  ;CX = Scale offset
	push	cs
	pop	es			;ES = CS
	lea	di,icicol		;start of table
	add	di,cx			;(ES:DI) = start of appropriate table
	lds	si,[bp+10]
	mov	cx,ds:[si]		;CX = Mask%
	mov	dl,cl			;get mask
	mov	dh,cl			;copy
	xor	dh,252			;if Mask = 252: 0, if 248 = 4
	shr	dh,1			;DH either 0 or 2
	lds	si,[bp+14]		;(DS:SI) = (CCA%())
	mov	bx,128			;start column
dithe0:	mov	ax,0			;start row
dithe1: push	dx			;save mask and adder
	push	bx			;save columns
	push	ax			;save rows
	lodsb				;AL = magnitude
	and	al,dl			;mask
	shr	al,1			;ndx = (V .and. mask) / 2
	cmp	al,59			;if index > 58, value > 127
	jc	dithe2			;skip if value < 128
	add	al,dh			;add 0 or 2 if value > 127
dithe2:	xor	ah,ah			;AX = offset
	mov	bx,ax			;copy offset
	mov	ax,es:[di+bx]		;get 4 nibbles
	mov	dx,ax			;copy nibbles
	and	ax,00f0fh		;get low nibbles
	and	dx,0f0f0h		;get high nibbles
	mov	cl,4
	shr	dx,cl			;shift to low nibbles
	mov	ch,dh			;CH = color 2
	mov	cl,ah			;CL = color 1
	mov	dh,al			;DH = color 3, DL = color 4
	pop	ax			;get line
	pop	bx			;get column
	call	setdot			;X+1/Y+0 = quadrant 2, color 2
	mov	ch,cl			;get color 1
	inc	bx			;X=X+1
	call	setdot			;X+1/Y+0 = quadrant 1, color 1
	mov	cx,dx			;get color 4 and 3
	inc	ax			;Y=Y+1
	call	setdot			;X+1/Y+1 = quadrant 4, color 4
	mov	ch,cl			;get color 3
	dec	bx			;X=X+1-1
	call	setdot			;X+0/Y+1 = quadrant 3, color 3
	inc	ax			;Y=Y+1 next row
	pop	dx			;restore mask and adder. Stack ok
	cmp	ax,330			;max rows
	jc	dithe1			;do next row
	mov	ah,getcon		;get console
	int	dos			;check if key pressed
	inc	al			;AL= 0->1: none, 255->0 key
	jz	dithe3			;abort on key pressed
	inc	bx
	inc	bx			;next column
	cmp	bx,512			;384+128 max
	jc	dithe0			;do next column
dithe3:	mov	bl,3			;3 parameters
	jmp	bakbas
;
DITHER	endp
;
;
; PROCEDURE draws dithered Scale for option B
;           S% is size of box, 16 for 32 and 8 for 64 colors
;           Mask is 252 for 64 cols and 248 for 32 cols
;           G% is offset: 0 for ICI, 128 for grayweighted
;     call DScale(S%,Mask%,G%)
;----------------------------------------------------------------------------
;
DSCALE	proc	far
	public	DSCALE
;
	call	pbastk                  ;CX = Scale offset
	push	cs
	pop	ds			;DS = CS
	lea	si,icicol		;start of table
	add	si,cx			;(SS:DI) = start of appropriate table
	les	di,[bp+10]
	mov	cx,es:[di]		;CX = Mask%
	mov	dl,cl			;get mask
	mov	dh,cl			;copy
	xor	dh,252			;if Mask = 252: 0, if 248 = 4
	shr	dh,1			;DH either 0 or 2
	les	di,[bp+14]
	mov	cl,es:[di]		;CL = S%
	mov	di,si			;copy start
	mov	bx,64			;start column
	xor	ch,ch			;CH = value 0-255
dscal0:	mov	ax,333			;start row
dscal1:	push	dx			;save Mask & adder
	push	cx			;save S% and counter 0-255
	push	ax			;save rows
	and	ch,dl			;mask
	shr	ch,1			;ndx = (V .and. mask) / 2
	cmp	ch,59			;if index > 58, value > 127
	jc	dscal2			;skip if value < 128
	add	ch,dh			;add 0 or 2 if value > 127
dscal2:	mov	cl,ch			;get offset
	xor	ch,ch			;CX = offset
	add	si,cx			;point to word in table
	mov	ax,ds:[si]		;get 4 nibbles
	mov	dx,ax			;copy nibbles
	and	ax,00f0fh		;get low nibbles
	and	dx,0f0f0h		;get high nibbles
	mov	cl,4
	shr	dx,cl			;shift to low nibbles
	mov	ch,dh			;CH = color 2
	mov	cl,ah			;CL = color 1
	mov	dh,al			;DH = color 3, DL = color 4
	pop	ax			;get line
	call	setdot			;X+1/Y+0 = quadrant 2, color 2
	mov	ch,cl			;get color 1
	inc	bx			;X=X+1
	call	setdot			;X+1/Y+0 = quadrant 1, color 1
	mov	cx,dx			;get color 4 and 3
	inc	ax			;Y=Y+1
	call	setdot			;X+1/Y+1 = quadrant 4, color 4
	mov	ch,cl			;get color 3
	dec	bx			;X=X+1-1
	call	setdot			;X+0/Y+1 = quadrant 3, color 3
	mov	si,di			;restore start
	inc	ax			;Y=Y+1 next row
	pop	cx                      ;restore S% and value
	pop	dx			;restore mask and adder. Stack ok
	cmp	ax,348			;max rows
	jc	dscal1			;do next row
	cmp	ch,255			;check 255
	jc	dscal3			;skip
	dec	ch			;assure no overrun into carry
dscal3:	inc	ch			;next value
	inc	bx
	inc	bx			;next column
	cmp	bx,577			;max
	jc	dscal0			;do next column
	mov	bl,3			;3 parameters
	jmp	bakbas
;
DSCALE	endp
;
;
; PROCEDURE draws rastered image for option D
;     call Raster(CCA%(1),GrayScale%(0))
;----------------------------------------------------------------------------
;
RASTER	proc	far
	public	RASTER
;
	call	pbastk			;(DS:SI) = GrayScale%(0))
	mov	cx,ds
	mov	es,cx
	mov	di,si			;(ES:DI) = (GrayScale%(0))
	lds	si,[bp+10]		;(DS:SI) = (CCA%(f,n))
	mov	bx,128			;BX = X
raste1:	push	bx			;save X
	xor	ax,ax			;AX = Y
raste2:	push	ax			;save Y
	lodsb				;AL = CCA%(ax,bx) - inc si
	xor	ah,ah			;AX = CCA%(ax,bx)
	mov	cl,4			;divisor 255/16 = 16 [0;15]
	shr	al,cl			;AL = GrayScale number
	add	al,al			;2 bytes or 4 nibbles
	add	di,ax			;calculate offset into GrayScale
	mov	dx,es:[di]		;get all four colors
	sub	di,ax			;reset GrayScale pointer
	mov	bx,dx			;BX = col 1, 2, 3 & 4
	shr	dx,cl			;DX=col 3 & 4 move high to low nibble
	mov	cx,bx			;CX = col 1, 2, 3 & 4
	mov	bx,0f0fh		;BX = nibble mask
	and	dx,bx			;DX = colors 3 & 4
	and	cx,bx			;CX = colors 1 & 2
	pop	ax			;get Y
	pop	bx			;get X
	push	bx			;save X again
	call	setdot			;pset (bx,ax),ch
	mov	ch,cl			;get color 2
	inc	ax			;Y+1
	inc	bx			;X+1
	call	setdot			;pset (bx+1,ax+1),ch
	mov	ch,dl			;get color 3
	dec	ax			;Y
	call	setdot			;pset (bx+1,ax),ch
	mov	ch,dh			;get color 4
	inc	ax			;Y+1
	dec	bx			;X
	call	setdot			;pset (bx,ax+1),ch
	inc	ax			;Y+2 = next sprite Y-start
	cmp	ax,drows		;330 reached?
	jc	raste2			;no, repeat
	pop	bx			;get X
	mov	ah,getcon		;get console
	int	dos			;check if key pressed
	inc	al			;AL= 0->1: none, 255->0 key
	jz	raste5			;abort on key pressed
	inc	bx
	inc	bx			;X+2 = next sprite X-start
	cmp	bx,512			;128+384 reached?
	jc	raste1			;no, repeat
raste5:	mov	bl,2			;2 parameters
	jmp	bakbas
;
RASTER	endp
;
;
; PROCEDURE draws scale for rastered image for option D
;     call RScale(GrayScale%(0))
;----------------------------------------------------------------------------
;
RSCALE	proc	far
	public	RSCALE
;
	call	pbastk			;(DS:SI) = GrayScale%(0))
	mov	di,si			;DI = copy of SI
	mov	bx,64			;BX = X
	xor	ch,ch			;CH = color counter 0-255
rscal0:	mov	ax,333			;AX = Y
rscal1: push	cx			;save 0-255 counter
	push	bx			;save X
	push	ax			;save Y
	mov	al,ch			;get color
	xor	ah,ah			;AX = CCA%(ax,bx)
	mov	cl,4			;divisor 255/16 = 16 [0;15]
	shr	al,cl			;AL = GrayScale number
	add	al,al			;2 bytes or 4 nibbles
	add	si,ax			;calculate offset into GrayScale
	mov	dx,ds:[si]		;get all four colors
	mov	si,di			;reset GrayScale pointer
	mov	bx,dx			;BX = col 1, 2, 3 & 4
	shr	dx,cl			;DX=col 3 & 4 move high to low nibble
	mov	cx,bx			;CX = col 1, 2, 3 & 4
	mov	bx,0f0fh		;BX = nibble mask
	and	dx,bx			;DX = colors 3 & 4
	and	cx,bx			;CX = colors 1 & 2
	pop	ax			;get Y
	pop	bx			;get X
	call	setdot			;pset (bx,ax),ch
	mov	ch,cl			;get color 2
	inc	ax			;Y+1
	inc	bx			;X+1
	call	setdot			;pset (bx+1,ax+1),ch
	mov	ch,dl			;get color 3
	dec	ax			;Y
	call	setdot			;pset (bx+1,ax),ch
	mov	ch,dh			;get color 4
	inc	ax			;Y+1
	dec	bx			;X
	call	setdot			;pset (bx,ax+1),ch
	pop	cx			;get value counter
	inc	ax			;Y+2 = next sprite Y-start
	cmp	ax,348			;348 reached?
	jc	rscal1			;no, repeat
	inc	ch			;next color
	inc	bx
	inc	bx			;X+2 = next sprite X-start
	cmp	bx,577			;64+512 reached?
	jc	rscal0			;no, repeat
	mov	bl,1			;1 parameter
	jmp	bakbas
;
RSCALE	endp
;
;
; PROCEDURE draws small 17 X 17 zoomed image for option E
;     call Tiny(CCA%(1),ColScale%(C%),YU%,XL%)
;----------------------------------------------------------------------------
;
TINY	proc	far
	public	TINY
;
	call	pbastk			;CX = XL%
	lds	si,[bp+10]
	mov	bx,ds:[si]		;BX = YU%
	lds	si,[bp+18]		;(DS:SI) = (CCA%(1))
	call	aryxyi  		;set DS:SI to CCA%(YU%,XL%)
	les	di,[bp+14]		;(ES:DI) = (ColScale%(C%))
	mov	bx,203			;BX = X
	mov	dh,17			;column counter
tiny1:  push	dx			;save column counter
	mov	ax,98			;AX = Y
	mov	dl,17			;row counter
tiny2:  push	ax			;save Y
	lodsb				;AL = CCA?(ax,bx) - inc si
	xor	ah,ah			;AX = CCA?(ax,bx)
	mov	cl,4			;divisor 255/16 = 16 [0;15]
	shr	al,cl			;AL = ColScale number
	add	di,ax			;(ES:DI) points to color
	mov	ch,es:[di]		;CH = color
	sub	di,ax			;(ES:DI) points to start again
	pop	ax			;get Y
tiny3:	mov	dh,4			;4 pixels horizontal CL=4
tiny4:	call	setdot			;set dot
	inc	ax			;next vertical position
	dec	dh			;all vertical done?
	jnz	tiny4			;no, repeat
	sub	ax,4			;reset vertical position
	inc	bx			;next horizontal position
	dec	cl			;all horizontal done?
	jnz	tiny3			;no, repeat
	sub	bx,4			;reset X
	add	ax,4			;Y+4
	dec	dl			;pixel in row done, are any left?
	jnz	tiny2			;no, repeat
	add	bx,4			;next column of pixels
	add	si,148			;165-17
	pop	dx			;get column counter
	dec	dh			;all done?
	jnz	tiny1			;no, repeat
	mov	bl,4			;4 parameters
	jmp	bakbas
;
TINY	endp
;
;
; PROCEDURE  draws DotoGram(r) - Essentially copy of first working version
;            option I
;    call Doto(CCA%(1),LAV%,HAV%,D%) where D% > 128=MUL else DIV D%-128
;============================================================================
;
DOTO	proc	far
	public	DOTO
;
	call	pbastk			;CX = D%
	mov	ch,cl			;CL = CH = D%
	and	cx,32895		;CL .and. 127, CH .and. 128
	mov	bx,cx			;BH=0:div, BH=128:mul, BL=operator
	lds	si,[bp+10]		;(DS:SI) = (HAV%)
	mov	dh,ds:[si]		;DH = HAV%
	lds	si,[bp+14]		;(DS:SI) = (LAV%)
	mov	dl,ds:[si]		;DL = LAV%
	lds	si,[bp+18]		;(DS:SI) = (CCA%(1))
	mov	ax,31679		;AX = offset to {CCA?(165,192)}
	add	si,ax			;(DS:SI) = last byte of CCA%
	lea	di,dotov		;variables pointer
	push	cs
	pop	es			;(ES:DI) = (dotov)
	std				;set direction flag: descending
	mov	ax,350			;-- Initialize variables
	mov	es:[di+4],ax		;reset Y-position to bottom
	mov	es:[di],ax		;reset TopVal
	mov	ax,192
	mov	es:[di+6],ax		;restore column counter
	mov	ax,384
	mov	es:[di+2],ax		;reset column start
;
; This is the outer loop, drawing each column from the most right one to the
; most left one. We first test, whether a key was pressed. If so, we exit
; drawing - though, considering the speed, this will hardly be necessary.
;
doto0:  mov	ah,getcon		;get console
	int	dos			;so we can abort
	inc	al			;255=true
	jnz	doto1			;continue if not
	jmp	short doto10		;restore all
doto1:	mov	cx,165			;get row number to use
;
; This is the inner loop, drawing each line from bottom to top. We must assure
; that hidden dots are not plotted. Also, the limits must be tested and finally
; the division performed.
;
doto2:	lodsb				;AL = CCA%() - dec si
	xor	ah,ah			;AX = CCA%()
	cmp	dl,al			;check LAV% < value
	jc	doto3			;if >= LAV%, skip
	mov	al,dl			;value = LAV%
doto3:	cmp	al,dh			;check value < HAV%
	jc	doto4			;if value <= HAV%, skip
	mov	al,dh			;value = HAV%
doto4:	sub	al,dl			;move to LAV% level
	jnc	doto5			;if no underflow, jump
	xor	al,al			;else set to 0
doto5:	cmp	bh,0			;check division
	jnz	doto6			;go multiplication
	div	bl			;divide by D%
	jmp	short doto7		;continue
doto6:	mul	bl			;multiply
	jnc	doto7			;if no carry, continue
	mov	al,255			;else set highest value
doto7:	xor	ah,ah			;clear rest
	push	bx			;save D% and division limit
	push	cx			;save lines counter
	push	dx			;save HAV% and LAV%
	push	ds			;save data segment
	mov	dx,es:[di+4]		;get Y position
	sub	dx,ax			;calculate Y position
	mov	ax,dx			;AX=line, Y-pos
	mov	dx,es:[di]		;get top val, i.e. the smallest yet
	cmp	ax,dx			;is the new one smaller?
	jnc	doto8			;if larger, skip plot
	mov	es:[di],ax		;set new low value
	mov	bx,es:[di+2]		;get X position
	mov	ch,color		;color
	call	setdot			;display dot
;
; The dot is plotted, or the plotting has been skipped. We must restore the
; environment and point 2 lines up. The inner loop ends here as well.
;
doto8:	dec	word ptr es:[di+4]
	dec	word ptr es:[di+4]	;move two lines up
	pop	ds			;restore data segment
	pop	dx			;restore HAV% and LAV%
	pop	cx			;restore lines counter
	pop	bx			;restore D% and division limit
	dec	cx			;one row done
	jz	doto9			;jump if all
	jmp	doto2			;do rows
;
; A full vertical dot-bar is plotted and we have to adjust all variables for
; the next column. If all columns are plotted, we exit here, because this is
; the end of the outer loop.
;
doto9:	mov	ax,350
	mov	es:[di+4],ax		;reset Y-position to bottom
	mov	es:[di],ax		;reset TopVal
	dec	word ptr es:[di+2]
	dec	word ptr es:[di+2]	;advance two columns (X-position)
	dec     word ptr es:[di+6]	;update column counter
	jz	doto10			;if zero, finished
	jmp	doto0			;do all
doto10:	mov	bl,4			;4 parameters
	jmp	bakbas
;
DOTO	endp
;
;
; PROCEDURE  Calculates equal-brightness lines - Isophotes. Option K
;     call EquiBr(CCA%(1),CCB%(1),S%)
;============================================================================
;
EQUIBR	proc	far
	public	EQUIBR
;
	call	pbastk			;CX = S% - CL = number of right shifts
	mov	ch,165			;CH = multiplicand
	lds	si,[bp+10]		;(DS:SI) = (CCB%(1))
	les	di,[bp+14]		;(ES:DI) = (CCA%(1))
	xor	bh,bh			;clear column counter
;
; Calculate the offset into CCB% and get value. If dot is set already, skip
; search part.
;
equib1:	xor	bl,bl			;clear row counter
equib2:	push	di			;save base pointer to CCA%
	push	si			;save base pointer to CCB%
	push	bx			;save counters
	mov	al,bh			;get column counter
	xor	ah,ah			;be sure AH is cleared
	mul	ch			;calculate column offset
	mov	dl,bl
	xor	dh,dh			;dx = row count
	add	ax,dx			;offset byte wise
	mov	bx,ax
	add	bx,si			;BX points to CCB%
	mov	si,bx			;SI points to CCB%
	mov	bl,byte ptr[si]		;get value in CCB%
	cmp	bl,255			;is it already set
	jnc	equib5			;if already set, skip the rest
;
; This is the search part. The offset into CCA% is calculated and the value
; fetched and shifted according to S%. Then, the dot below, below right and
; right of the reference dot are accessed, the values properly divided and
; compared against the reference dot. If any of the three dots has a value
; different to the one of the reference dot, it is set at the appropriate
; location in CCB%
;
	add	di,ax			;DI points to CCA%
	mov	al,es:[di]		;get value in CCA%
	shr	al,cl			;divide
	inc	di			;point to next value
	inc	si			;point to CCB% right
	mov	dl,es:[di]		;get value right
	shr	dl,cl			;divide
	cmp	al,dl			;are they same
	jz	equib3			;if same, do nothing
	mov	byte ptr[si],255	;if different, set dot
equib3:	mov	bx,165
	mov	dx,bx
	add	si,bx
	add	di,dx			;DI points to right down in CCA%
	mov	dl,es:[di]		;get value
	shr	dl,cl			;divide
	cmp	al,dl			;are they same
	jz	equib4			;if same, do nothing
	mov	byte ptr[si],255	;if different, set dot
equib4:	dec	di			;point to down
	dec	si			;point to down
	mov	dl,es:[di]		;get value
	shr	dl,cl			;divide
	cmp	al,dl			;are they same
	jz	equib5			;if same, do nothing
	mov	byte ptr[si],255	;if different, set dot
;
; Here, the loops end. The counters and the base pointers are restored. The
; counters decremented and the inner and outer loops are repeated accordingly.
;
equib5: pop	bx			;restore counters
	pop	si			;restore CCB% pointer
	pop	di			;restore CCA% pointer
	inc	bl			;increment row counter
	cmp	bl,163			;all rows
	jc	equib2			;do whole row
	inc	bh			;increment column counter
	cmp	bh,190			;all columns
	jc	equib1			;do whole image
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
EQUIBR	endp
;
;
; PROCEDURE draws enlarged isophotes, option K
;           Derived from Dither, dedicated for isophotes: 84% of Dither time
;     call IsoHug(CCB%(1)) (huge isophotes)
;----------------------------------------------------------------------------
;
ISOHUG	proc	far
	public	ISOHUG
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	xor	bx,bx			;BX = X
	mov	cl,color			;CL = color mask
isohu1:	xor	dx,dx			;DX = Y
isohu2:	lodsb				;AL = CCB%(x) - inc si
	and	al,cl			;if AL=255, AL=color, else AL=Black
	mov	ch,al			;CH = color
	mov	ax,dx			;AX = Y
	call	setdot			;pset (bx,ax),ch
	inc	bx			;X+1
	call	setdot			;pset (bx+1,ax),ch
	inc	ax			;Y+1
	call	setdot			;pset (bx+1,ax+1),ch
	dec	bx			;X
	call	setdot			;pset (bx,ax+1),ch
	inc	ax			;Y+2
	mov	dx,ax			;DX = Y
	cmp	dx,drows		;Y=330?
	jc	isohu2			;repeat for all Y
	mov	ah,getcon		;get console
	int	dos			;check if key pressed
	inc	al			;AL= 0->1: none, 255->0 key
	jz	isohu3			;abort on key pressed
	inc	bx
	inc	bx			;X+2
	cmp	bx,dcols		;X=384?
	jc	isohu1			;repeat for all X
isohu3:	mov	bl,1			;1 parameter
	jmp	bakbas
;
ISOHUG	endp
;
;
; PROCEDURE  De-zooms or shrinks image in CCA% into image CCB% into Quadrant
;            2 (top left). F%=0: Average, F%<>0:max
;            call Shrink(CCB%(1),CCA%(1),F%)
;----------------------------------------------------------------------------
;
SHRINK	proc	far
	public	SHRINK
;
	call	pbastk			;CX% = F%
	mov	bl,cl			;BL = flag. 0=Avrg, else max
	lds	si,[bp+10]		;(DS:SI) = (CCA%())
	les	di,[bp+14]		;(ES:DI) = (CCB%())
	mov	cx,15840		;31680 bytes
	xor	ax,ax
	rep	stosw			;clear CCB%
	les	di,[bp+14]		;(ES:DI) = (CCB%)
	mov	bh,96			;columns
	inc	si			;skip top row
shrin0:	mov	cx,82			;82 rows
shrin1:	add	si,165			;point to top right
	lodsb				;AL=top right, point to bottom right
	mov	dh,al			;BH=TR
	mov	dl,ds:[si]		;DL=bottom right
	sub	si,166			;point to top left
	lodsb				;top left, point to bottom left
	mov	ah,al			;AH=TL
	lodsb				;AL=bottom left, point to next top left
	cmp	bl,0			;if zero, avrg
	jnz	shrin2			;max
	push	dx			;DL=BR, DH=TR
	push	dx
	push	ax			;AL=BL, AH=TL
	xor	ah,ah			;clear high order byte
	pop	dx			;DH=TL
	mov	dl,dh			;DL=TL
	xor	dh,dh
	add	ax,dx			;AX=TL+BL
	pop	dx
	xor	dh,dh
	add	ax,dx			;AX=TL+BL+BR
	pop	dx
	mov	dl,dh
	xor	dh,dh
	add	ax,dx			;AX=TL+BL+BR+TR
	shr	ax,1			;/2
	shr	ax,1			;/4 4 values
	jmp	short shrin5		;continue later
shrin2:	cmp	ah,al			;check higher
	jc	shrin3
	mov	al,ah
shrin3:	cmp	dl,al			;check higher
	jc	shrin4
	mov	al,dl
shrin4:	cmp	dh,al			;check higher
	jc	shrin5
	mov	al,dh
shrin5:	stosb				;store average
	loop	shrin1			;repeat 82 times
	add	di,83			;next column dest pointer
	add	si,166			;2 columns done
	dec	bh			;do 96 times
	jnz	shrin0			;repeat
	mov	bl,3			;3 parameters
	jmp	bakbas
;
SHRINK	endp
;
;
; PROCEDURE copies any quadrant in any other quadrant.
;           call CpyQdr(CCA%(1),CCB%(1),QA%,QB%)
;----------------------------------------------------------------------------
;
CPYQDR	proc	far
	public	CPYQDR
;
	call	pbastk			;CX = QB% = source quadrant
	lds	si,[bp+10]
	mov	dx,ds:[si]		;DX = QA% = dest quadrant
	lea	bx,quadr		;offset to table
	mov	ax,bx			;copy offset
	push	cs
	pop	ds
	dec	cl			;option base 0
	shl	cl,1			;* 2 for words
	add	bx,cx			;BX = offset to srce quadrant table
	dec	dl			;option base 0
	shl	dl,1			;* 2 for words
	add	ax,dx			;AX = offset to dest quadrant table
	mov	cx,[bx]			;CX = offset into source array
	mov	bx,ax
	mov	dx,[bx]			;DX = offset into dest array
	lds	si,[bp+14]		;(DS:SI) = (CCB%()) source array
	les	di,[bp+18]		;(ES:DI) = (CCA%()) dest array
	add	si,cx			;source start
	add	di,dx			;dest start
	mov	dx,83			;DX = offset to add
	mov	bx,24580		;BH=96 BL=4
cpyqd0:	mov	cx,41			;41 words = 82 bytes
	rep	movsw			;transfer column
	add	si,dx			;next source column
	add	di,dx			;next dest column
	dec	bh			;one column done
	jnz	cpyqd0			;repeat
	lds	si,[bp+18]		;point to start of dest array
	xor	ah,ah			;AH=0 to clear
	call	clrtog			;clear central line
	jmp	bakbas			;BL = 4
;
CPYQDR	endp
;
;
; PROCEDURE invertes central row for tiled images
;           call TogBar(CCA%(1))
;----------------------------------------------------------------------------
;
TOGBAR	proc	far
	public	TOGBAR
;
	call	pbastk			;(DS:SI) = (CCA%())
	mov	ah,255			;toggle mask
	mov	bl,1			;one parameter to remove
	call	clrtog			;clear
	jmp	bakbas
;
TOGBAR	endp
;
;
; PROCEDURE inverts quadrant.
;           call InvQdr(CCA%(1),Q%)
;----------------------------------------------------------------------------
;
INVQDR	proc	far
	public	INVQDR
;
	call	pbastk			;CX = QB% = source quadrant
	les	di,[bp+10]		;(ES:DI) = (CCA%())
	lea	bx,quadr		;offset to table
	push	cs
	pop	ds
	dec	cl			;option base 0
	shl	cl,1			;* 2 for words
	add	bx,cx			;BX = offset to quadrant table
	mov	cx,[bx]			;CX = offset into array
	add	di,cx			;start
	mov	dx,83			;DX = offset to add
	mov	bx,24578		;BH=96 BL=2
invqd0:	mov	cx,41			;41 words = 82 bytes
invqd1:	mov	ax,es:[di]		;get to bytes at a time
	xor	ax,65535		;invert
	stosw				;store word, inc di twice
	loop	invqd1			;repeat
	add	di,dx			;next column
	dec	bh			;one column done
	jnz	invqd0			;repeat
	jmp	bakbas			;BL = 2
;
INVQDR	endp
;
;
; PROCEDURE swaps any two quadrants.
;           call SwpQdr(CCA%(1),CCB%(1),QA%,QB%)
;----------------------------------------------------------------------------
;
SWPQDR	proc	far
	public	SWPQDR
;
	call	pbastk			;CX = QB% = source quadrant
	lds	si,[bp+10]
	mov	dx,ds:[si]		;DX = QA% = dest quadrant
	lea	bx,quadr		;offset to table
	mov	ax,bx			;copy offset
	push	cs
	pop	ds
	dec	cl			;option base 0
	shl	cl,1			;* 2 for words
	add	bx,cx			;BX = offset to srce quadrant table
	dec	dl			;option base 0
	shl	dl,1			;* 2 for words
	add	ax,dx			;AX = offset to dest quadrant table
	mov	cx,[bx]			;CX = offset into source array
	mov	bx,ax
	mov	dx,[bx]			;DX = offset into dest array
	lds	si,[bp+14]		;(DS:SI) = (CCB%()) source array
	les	di,[bp+18]		;(ES:DI) = (CCA%()) dest array
	add	si,cx			;source start
	add	di,dx			;dest start
	mov	dx,83			;DX = offset to add
	mov	bx,24580		;BH=96 BL=4
swpqd0:	mov	cx,82			;82 bytes
swpqd1:	mov	al,ds:[si]		;get source byte
	mov	ah,es:[di]		;get dest byte
	mov	ds:[si],ah		;swap and store
	inc	si			;point to next source
	stosb				;swap and store, point to next dest
	loop	swpqd1			;repeat
	add	si,dx			;next source column
	add	di,dx			;next dest column
	dec	bh			;one column done
	jnz	swpqd0			;repeat
	jmp	bakbas			;BL = 4
;
SWPQDR	endp
;
;
; PROCEDURE multiplies or divides every element with a factor 1.5
;           Flag is true (-1) for division.
;           Multiplication: Z = V + (V/2)
;           Division: Z = ((V + (V/2) * 2) - (V/4) - (V/16)) / 4
;                     division error: < 0.6%
;           call MD15BA(CCA%(1),Flag%,%LMN)
;----------------------------------------------------------------------------
;
MD15BA	proc	far
	public	MD15BA
;
	call	pbastk			;CX = elements
	lds	si,[bp+10]		;(DS:SI) = (Flag%)
	mov	dl,ds:[si]		;DL = Flag%
	les	di,[bp+14]		;(ES:DI) = (CCA%())
	xor	dh,dh			;DH = 0 to compare with flag
md15b0:	mov	al,es:[di]		;get element
	xor	ah,ah			;AX = element
	mov	bx,ax			;BX = copy
	shr	bx,1			;element / 2
	add	ax,bx			;element * 1.5
	cmp	dl,dh			;check mul/div flag
	jz	md15b1			;if zero, multiplication: done
	shl	ax,1			;element * 3
	shr	bx,1			;element / 4
	sub	ax,bx			;ele = ele*3-ele/4
	shr	bx,1			;element / 8
	shr	bx,1			;element / 16
	sub	ax,bx			;ele = ele*3-ele/4-ele/16
	shr	ax,1			;/2
	shr	ax,1			;/2
	jmp	short md15b2
md15b1:	cmp	ax,256			;check overflow
	jc	md15b2			;if not, jump
	mov	al,255			;set to limit
md15b2:	stosb				;store result
	loop	md15b0			;repeat
	mov	bl,3			;3 parameters
	jmp	bakbas
;
MD15BA	endp
;
;
; PROCEDURE uses logarithmic table to stretch
;              Offset% =   0 for Stretch log low  intensity
;              Offset% = 256 for Stretch log high intensity
;              Offset% = 512 for Scale for mag normal
;              Offset% = 768 for Scale for mag inverse
;      call LogMul(CCA%(1),Offset%)
;----------------------------------------------------------------------------
;
LOGMUL	proc	far
	public	LOGMUL
;
	call	pbastk			;CX = 0, 256, 512 or 1024
	lea	si,loget		;start of table
	add	si,cx			;table 1 or 2 to use
	mov	cx,31680		;elements
	les	di,[bp+10]		;(ES:DI) = (CCA%())
	xor	bh,bh			;clear bh
	push	cs
	pop	ds
logmu0:	mov	bl,es:[di]		;BX = element, table offset
	mov	al,[si+bx]		;get replacement element
	stosb				;save it
	loop	logmu0			;repeat
	mov	bl,2			;2 parameters
	jmp	bakbas
;
LOGMUL	endp
;
;
; PROCEDURE draws 16 grayscales if VGA is present
;    call VGACol(ColScale%(7),D%,CCA%(1))
;----------------------------------------------------------------------------
;
VGACOL	proc	far
	public	VGACOL
;
	call	pbastk			;(DS;SI) = (CCA%(1))
	les	di,[bp+10]		;access divisor
	mov	cl,es:[di]		;CL = 4 or 5 for 16 or 8 colors
	les	di,[bp+14]		;(ES:DI) = (ColScale%(7))
	mov	dx,128			;column 128 - 512 (BX)
vgaco0:	xor	ax,ax			;AX = line number 1 - 331
vgaco1: push	ax			;save line number
	lodsb				;AL = value
	mov	bl,al
	shr	bl,cl			;div by 16 or 32
	xor	bh,bh
	pop	ax			;get line number
	mov	ch,es:[di+bx]		;get color
	mov	bx,dx			;BX = column number
	call	setdot			;set dot at quadrant 2
	inc	bx
	call	setdot			;set dot at quadrant 1
	inc	ax
	call	setdot			;set dot at quadrant 4
	dec	bx
	call	setdot			;set dot at quadrant 3
	inc	ax			;point to next line
	cmp	ax,drows		;all done?
	jc	vgaco1			;repeat for 165 lines
	inc	bx
	inc	bx			;point to next column
	mov	dx,bx
	push	dx			;save column pointer
	mov	ah,getcon		;get console
	int	dos			;check if key pressed
	pop	dx			;restore column pointer
	inc	al			;AL= 0->1: none, 255->0 key
	jz	vgaco2			;abort on key pressed
	cmp	dx,512			;check all done
	jc	vgaco0			;repeat 192 times
vgaco2:	mov	bl,3			;3 parameters
	jmp	bakbas
;
VGACOL	endp
;
;
;============================================================================
; LOCAL SUBROUTINES AREA - Subroutines are Public and may be accessed by any
; of the above procedures.
;============================================================================
;
; SUBROUTINE - Set a dot. AX=line, BX=column, CH=color. No Reg destroyed!
; Derived from PIXPTR and SETPIX from PC-Intern 2.0, pp 679-680 by Michael
; Tischer. ISBN 3-89011-331-1.    New version does not destroy any register.
;----------------------------------------------------------------------------
;
SETDOT	proc	near			;define procedure near
;
; Part-1: Save environment and calculate proper dot position within EGA-RAM
;
	push	es			;save ES
	push	dx			;save DX anyway
	push	cx			;CH=primary, CL=secondary color
	push	ax			;save Y
	push	bx			;save X
	mov	cl,bl			;save LO-byte of column
	mov	dx,80			;line length in characters
	mul	dx			;AX=line*80
	shr	bx,1
	shr	bx,1
	shr	bx,1			;columns / 8
	add	bx,ax			;+line offset
	mov	ax,40960		;video-RAM segment A000h
	mov	es,ax			;ES=segment of video-RAM
	and	cl,7			;clear bits 8...4 of column
	xor	cl,7			;swap bits 0..3 = 7-CL
	mov	ah,1			;keep bit 0 only
;
; Part-2: Draw actual dot directly into appropriate bit-plane
;
	mov	dx,974			;port 3CEh of EGA-controller
	shl	ah,cl			;mask for bit to change
	mov	al,8			;bit-mask register
	out	dx,ax			;write to EGA Bit-Mask-register
	mov	ax,5 + (2 shl 8)	;register and mode value
	out	dx,ax			;write to EGA Mode-register
	mov	ax,3 + (0 shl 8)	;register number
	out	dx,ax			;write to EGA Function-register
	mov	al,es:[bx]		;load latches
	mov	es:[bx],ch		;load color into bit-planes
;
; Part-3: Restore environment for EGA-Controller and CCTINY
;
	mov	ax,8 + (255 shl 8)	;reset old bit mask
	out	dx,ax			;write old value into Bit-Mask
	mov	ax,5			;old value for Mode
	out	dx,ax			;reset Mode-register
	mov	ah,3			;old value for Function Select AH=0
	out	dx,ax			;reset Function-Select register
	pop	bx			;restore X
	pop	ax			;restore Y
	pop	cx			;restore colors
	pop	dx			;restore DX
	pop	es			;restore ES
	ret
;
SETDOT	endp
;
;
; SUBROUTINE calculates offset into array provided X and Y are given
;            Expects BX=Y, CX=X, DS:SI=CCA(1) - returns DS:SI = CCA(Y,X)
;            X and Y option base 1!
;----------------------------------------------------------------------------
;
ARYXYI	proc	near
;
	dec	cl			;X-1
	dec	bl			;Y-1
	mov	ax,165			;multiplicand
	mul	cl			;AX = (X-1)*165
	add	ax,bx			;AX = (X-1)*165+Y-1
	add	si,ax			;(CCA(Y,X) option base 0
	ret
;
ARYXYI	endp
;
;
; SUBROUTINE clears or toggles central row for tiled image. It expects:
;            DS:SI points to start in array, AH=0: clear, AH=255 Toggle
;----------------------------------------------------------------------------
;
CLRTOG	proc	near
;
	mov	cx,192			;192 columns
	add	si,82			;offset to first row
	mov	dx,165			;offset for row to row
	cmp	ah,0
	jnz	clrto0			;if zero, set to 0
	xor	al,al
	jmp	short clrto1
clrto0:	mov	al,ds:[si]		;get byte
	xor	al,ah			;toggle
clrto1:	mov	ds:[si],al		;clear row 83
	add	si,dx			;jump to next column
	loop	clrto1			;clear line
	ret
;
CLRTOG	endp
;
;
; FUNCTIONS are derived from PB2EXT to be able to compile CCDUTIL for
;           PB 2.10e with PB 3.00c.
;============================================================================
;
; FUNCTION returns low byte value as integer from Integer
;    A% = LoBytI%(B%)
;------------------------------------------------------------------------------
;
LOBYTI	proc	far
	public	LOBYTI
;
	call	pbastk			;CX = B%
	mov	al,cl			;get low byte
	xor	ah,ah			;clear high byte
	mov	bl,1			;1 parameter
	jmp	bakbas			;exit
;
LOBYTI	endp
;
;
; FUNCTION returns high byte value as integer from Integer
;    A% = HiBytI%(B%)
;------------------------------------------------------------------------------
;
HIBYTI	proc	far
	public	HIBYTI
;
	call	pbastk			;CX = B%
	mov	al,ch			;get low byte
	xor	ah,ah			;clear high byte
	mov	bl,1			;1 parameter
	jmp	bakbas			;exit
;
HIBYTI	endp
;
;
; FUNCTION returns low nibble value as integer from Integers low byte
;    A% = LoNibI%(B%)
;------------------------------------------------------------------------------
;
LONIBI	proc	far
	public	LONIBI
;
	call	pbastk			;CX = B%
	mov	al,cl			;get low byte
	and	ax,15			;keep low nibble only
	mov	bl,1			;1 parameter
	jmp	bakbas			;exit
;
LONIBI	endp
;
;
; FUNCTION returns high nibble value as integer from Integers low byte
;    A% = HiNibI%(B%)
;------------------------------------------------------------------------------
;
HINIBI	proc	far
	public	HINIBI
;
	call	pbastk			;CX = B%
	mov	al,cl			;get low byte
	mov	cl,4			;shift counter
	shr	al,cl			;move high nibble to low position
	and	ax,15			;keep nibble only
	mov	bl,1			;1 parameter
	jmp	bakbas			;exit
;
HINIBI	endp
;
;
code	ends
	end
;
;=======================-<920815 HoroSoft, CH-3952 Susten>-==================
;
