;950212 0846
;****************************************************************************
;* PROGRAM NAME: CCDUU2  .ASM   DATE:  3.10.1992    LINK INTO: CCDUTIL .BAS *
;* LANGUAGE: Turbo Assembler TASM 2.0                                       *
;* PURPOSE:  Procedures for CCDUTIL                                         *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.15 12-FEB-95 Introduced Brightness calculation               *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.14  2-JUN-94 Introduced Version CCDUU2V% = 114               *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.13 25-JAN-94 Introduced ROtate TWICe & BiNine procedures.    *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.12 27-NOV-93 To fix bug in Frame Cut [K], introduced FRMHLN  *
;*                          and FRMVLN line clearer, added grid option.     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.11 26-SEP-93 Direct Lynxx and ST4 file read/write added      *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.10 26-MAR-93 Redid it for PB3 and CCDUTIL 2.00               *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.03  4-MAR-93 Renamed to CCDUC from CCDFLIP.                  *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.02  8-NOV-92 Fixed serious bug in rotation part.             *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01 18-SEP-92 (17-OCT-92 extracted from CCDRTNS.ASM)          *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 2.10 or 3.00:         *
;*            = declare function CCDUU2V%()                                 *
;*            = declare sub DecLnx(integer,integer)                         *
;*            = declare sub EncLnx(integer,integer,integer)                 *
;*            = declare sub EDCST4(integer,string,integer,integer)          *
;*            = declare sub Copy5X(integer,integer,integer,integer)         *
;*            = declare sub VertY(integer,integer)                          *
;*            = declare sub HAvrg(integer,integer,integer)                  *
;*            = declare sub VAvrg(integer,integer)                          *
;*            = declare sub ScaleX(integer,integer,integer)                 *
;*            = declare sub FLIPXY(integer,integer)                         *
;*            = declare sub RoTwic(integer)                                 *
;*            = declare sub MovLft(integer,integer)                         *
;*            = declare sub SupImp(integer,integer,integer)                 *
;*            = declare sub AConvt(integer,string)                          *
;*            = declare sub ChrLin(integer,integer,string)                  *
;*            = declare sub InsLbl(integer,integer,integer,integer,integer) *
;*            = declare sub SHLUIm(integer,integer,integer,integer)         *
;*            = declare sub SHRDIm(integer,integer,integer,integer)         *
;*            = declare sub FilFrm(integer,integer,integer,integer,integer) *
;*            = declare sub CutFrm(integer,integer,integer,integer,integer) *
;*            = declare sub FrmFrm(integer,integer,integer,integer,integer) *
;*            = declare sub FrmHln(integer,integer,integer,integer)         *
;*            = declare sub FrmVln(integer,integer,integer,integer)         *
;*            = declare sub HVGrid(integer,integer)                         *
;*            = declare sub ToFreq(integer,integer,integer)                 *
;*            = declare sub ConvUF(integer,integer,integer)                 *
;*            = declare sub StatMF(integer,integer,integer)                 *
;*            = declare sub BiNine(integer,integer)                         *
;*            = declare sub CpyBox(integer,integer,integer,integer)         *
;*            = $link "CCDUU2.OBJ"   and PBSTACK.OBJ !!                     *
;*             call FLIPXY(CCD%(1,1),Mode%)                                *
;*                                    Mode% = 1: Y-axis flip                *
;*                                    Mode% = 2: X-axis flip                *
;*                                    Mode% = 3: rotate 90 CCW             *
;*             call Pix43C(I1%,I2%,B$)                                     *
;*           Assemble this routine using TASM as:                           *
;*             = TASM CCDUU2                                                *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
rows	equ	165			;165 rows
cols	equ	192			;192 columns
hrows	equ	 82			;half rows, 82 = fix(165/2)
hcols	equ	 96			;half columns, 96 = 192/2
dos	equ	 33			;21h DOS interrupt
readf	equ	 63			;DOS Function 3Fh Read
writef	equ	 64			;DOS Function 40h Write
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
	extrn	GetStrLoc:far		;GetStrLoc
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = CCDUU2V%
;----------------------------------------------------------------------------
;
CCDUU2V		proc	far
		public	CCDUU2V
;
                call	pbastk
		mov	ax,114		;V.1.14
		xor	bl,bl
                jmp	bakbas
;
CCDUU2V	endp
;
;
; DATA AREA
;============================================================================
;
; Ascii to Character Decoder. 0...31 = 0, 128...255 = 0, 240 = 5, 248 = 9
;----------------------------------------------------------------------------
;
ASCHAR	db	 0, 0,10, 0, 0, 0, 0, 9, 0, 0, 8, 2, 0, 3, 1, 5	  ; 32... 47
	db	15,16,17,18,19,20,21,22,23,24,51, 0,11, 4,12, 0	  ; 48... 63
	db	 0,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39	  ; 64... 79
	db	40,41,42,43,44,45,46,47,48,49,50,13, 7,14, 0, 0	  ; 80... 95
	db	 9,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39	  ; 96...111
	db	40,41,42,43,44,45,46,47,48,49,50, 0, 6, 0, 0, 0	  ;112...127
;
; Character Decoder: Characters are 5 by 5 bits, to be used as 7 by 7
;----------------------------------------------------------------------------
;
CHRDAT	db	  0,  0,  0,  0,  0		; 0 blank
	db	  0,  0,  0, 96, 96		; 1 .
	db	 16, 16,124, 16, 16		; 2 +
	db	  0,  0,124,  0,  0		; 3 -
	db	  0,124,  0,124,  0		; 4 =
	db	  4,  8, 16, 32, 64		; 5 /
	db	 16, 16,  0, 16, 16		; 6 |
	db	 64, 32, 16,  8,  4		; 7 \
	db	 32, 80, 32,  0,  0		; 8  via *
	db	 96, 32, 64,  0,  0		; 9 '
	db	108, 36, 72,  0,  0		;10 "
	db	  8, 16, 32, 16,  8		;11 <
	db	 32, 16,  8, 16, 32		;12 >
	db	 56, 32, 32, 32, 56		;13 [
	db	 56,  8,  8,  8, 56		;14 ]
	db	 56, 76, 84,100, 56		;15 0
	db	 56, 72,  8,  8, 28		;16 1
	db	 56, 68, 24, 32,124		;17 2
	db	120,  4, 56,  4,120		;18 3
	db	 72, 72,124,  8,  8		;19 4
	db	124, 64,120,  4,120		;20 5
	db	 60, 64,120, 68, 56		;21 6
	db	124,  8, 16, 32, 64		;22 7
	db	 56, 68, 56, 68, 56		;23 8
	db	 56, 68, 60,  4, 56		;24 9
	db	 16, 40, 68,124, 68		;25 A
	db	120, 68,120, 68,120		;26 B
	db	 60, 64, 64, 64, 60		;27 C
	db	120, 68, 68, 68,120		;28 D
	db	124, 64,120, 64,124		;29 E
	db	124, 64,120, 64, 64		;30 F
	db	 60, 64, 76, 68, 60		;31 G
	db	 68, 68,124, 68, 68		;32 H
	db	124, 16, 16, 16,124		;33 I
	db	124,  4,  4, 68, 56		;34 J
	db	 68, 72,112, 72, 68		;35 K
	db	 64, 64, 64, 64,124		;36 L
	db	 68,108, 84, 68, 68		;37 M
	db	 68,100, 84, 76, 68		;38 N
	db	 56, 68, 68, 68, 56		;39 O
	db	120, 68,120, 64, 64		;40 P
	db	 56, 68, 84, 76, 56		;41 Q
	db	120, 68,120, 72, 68		;42 R
	db	 60, 64, 56,  4,120		;43 S
	db	124, 16, 16, 16, 16		;44 T
	db	 68, 68, 68, 68, 56		;45 U
	db	 68, 68, 68, 40, 16		;46 V
	db	 68, 68, 84, 84, 56		;47 W
	db	 68, 40, 16, 40, 68		;48 X
	db	 68, 40, 16, 16, 16		;49 Y
	db	124,  8, 16, 32,124		;50 Z
	db	  0, 24,  0, 24,  0		;51 :
;
; Sound frequency decoder. Equal tempered scale. A-1...Cis-7
;----------------------------------------------------------------------------
;
FREQTB	dw	  55,   58,   62,   65,   69,   73,   78,   82	;  0- 31
	dw	  87,   92,   98,  104,  110,  117,  123,  131	; 32- 63
	dw	 139,  147,  156,  165,  175,  185,  196,  208	; 64- 95
	dw	 220,  233,  247,  262,  277,  294,  311,  330	; 96-127
	dw	 349,  370,  415,  440,	 466,  494,  523,  554	;128-159
	dw	 587,  622,  659,  698,	 740,  784,  831,  880	;160-191
	dw	 982,  988, 1047, 1109,	1175, 1244, 1319, 1397	;192-223
	dw	1480, 1568, 1661, 1760, 1865, 1976, 2093, 2217	;224-255
;
; Convolving Filters Mask
;----------------------------------------------------------------------------
;
convi1	dw	0			;I%( 1) top left
convi2	dw	0			;I%( 2) upper
convi3	dw	0			;I%( 3) top right
convi4	dw	0			;I%( 4) left
convi5	dw	0			;I%( 5) center
convi6	dw	0			;I%( 6) right
convi7	dw	0			;I%( 7) bottom left
convi8	dw	0			;I%( 8) lower
convi9	dw	0			;I%( 9) bottom right
convi0	dw	0			;I%(10) sum buffer
;
; Median Filter Sorting Buffer
;----------------------------------------------------------------------------
;
srtbuf	db	9 dup (0)		;positions i0...i9
;
;
; PROCEDURES
;============================================================================
;
; PROCEDURE  reads 12 bit Lynx file into CCD% and converts it to 16 bits
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call DecLnx(Handle%,CCD%(1,1))
;============================================================================
;
DECLNX	proc	far
	public	DECLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = DOS File-Handle
	mov	ah,readf		;AH = function read
	mov	cx,47520		;CX = number of bytes to read
	push	cx			;save bytes
	int	dos			;read whole file
	pop	cx			;restore bytes
	jc	decly1			;error
	cmp	ax,cx			;check all read
	jnz	decly1			;error
	lds	si,[bp+6]		;(DS:SI) = (CCD%(1,1))
	les	di,[bp+6]		;(ES:DI) = (CCD%(1,1))
	add	si,47519		;point to last byte loaded
	add	di,63359		;point to last byte in CCD%
	std				;set direction flag to descending
	mov	cx,23760		;23760 x 2 = 47520
	rep	movsw			;copy to last element
	inc	si			;point to first element
	inc	di			;point to first dest element at 15840
	xchg	si,di			;swap source and dest pointers
	push	es
	push	ds
	pop	es
	pop	ds			;swap source and dest segments
	mov	cx,15840		;15840 x 3 = 47520
	cld				;clear direction flag to ascending
decly0:	movsb				;copy low byte-1
	lodsb				;AL = byte-2H Byte-1H
	mov	ah,al			;AH copy of Byte-1H
	and	al,15			;remove high nibble
	stosb				;store Byte-1H
	movsb				;copy low byte-2
	mov	al,ah			;get Byte-2H
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1			;Byte-2H high- to low nibble
	stosb				;store Byte-2H
	loop	decly0			;repeat
	mov	ax,-1			;true flag
	jmp	short decly2		;store flag and return
decly1:	xor	ax,ax			;flag false
decly2:	les	di,[bp+10]		;point to Handle%
	stosw				;return flag
	mov	bl,2			;2 parameters
	jmp	bakbas
;
DECLNX	endp
;
;
; PROCEDURE  writes 12 bit Lynx file from 16-bit CCD% and multiplies by 16
;            if SyLyFlg% is true.
;            Byte-1: Pixel-1 low byte
;            Byte-2: Pixel-1 high byte at low nibble position
;            Byte-2: Pixel-2 high byte at high nibble position
;            Byte-3: Pixel-2 low byte
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EncLnx(Handle%,SyLyFlg%,CCD%(1,1))
;============================================================================
;
ENCLNX	proc	far
	public	ENCLNX
;
	call	pbastk			;(DS:SI) = (CCD%(1,1))
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = SyLyFlg%
	mov	di,si			;copy start pointer or array
	push	ds
	pop	es
	cmp	bx,0			;is SyLyFlg% reset?
	jz	encly1			;skip multiplication
	mov	cx,31680		;CX = elements to multiply
encly0:	mov	ax,es:[di]		;get value
	shl	ax,1			;AX x  2
	shl	ax,1			;AX x  4
	shl	ax,1			;AX x  8
	shl	ax,1			;AX x 16
	stosw				;save multiplied word
	loop	encly0
encly1:	mov	di,si			;get start of array
	mov	dx,si			;start of buffer
	mov	cx,15840		;15840 x 3 = 47520
encly2:	movsb				;copy byte-1L
	lodsb				;get byte-1H
	and	al,15			;clear high nibble
	mov	ah,al			;save byte-1H
	lodsb				;get byte-2L
	mov	bl,al			;put byte-2L aside
	lodsb				;get byte-2H
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1			;byte-2H to high nibble
	or	al,ah			;combine byte-2H and byte-1H
	stosb				;store both nibbles
	mov	al,bl			;get byte-2L
	stosb				;store byte-2L
	loop	encly2			;repeat
	mov	ah,writef		;function 40h write to file
	les	di,[bp+14]
	mov	bx,es:[di]		;BX = handle
	mov	cx,47520		;CX = number of bytes to write
	push	cx			;save byte counter
	int	dos			;write it
	pop	cx			;restore byte count
	xor	dx,dx			;assume error
	jc	encly3			;error
	cmp	ax,cx			;test wether all bytes are written
	jnz	encly3			;jump if not
	dec	dx			;DX = -1 = True
encly3:	lds	si,[bp+14]
	mov	ds:[si],dx		;save flag
	mov	bl,3			;3 parameters
	jmp	bakbas
;
ENCLNX	endp
;
;
; PROCEDURE  either reads or writes ST4 File into/from CCB% and the 166th
;            line into/from R$. F% has 63 or 64 respectively.
;            On Entry: Handle% = DOS File-Handle
;            On Exit:  Handle% = True (-1) if successfull, else False (0)
;    call EDCST4(F%,R$,Handle%,CCB%(1))
;============================================================================
;
EDCST4	proc	far
	public	EDCST4
;
	call	pbastk			;(DS:SI) = (CCB%(1))
	mov	dx,si			;(DS:DX) = Buffer
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 31680 bytes
	mov	cx,31680		;165 x 192
	push	cx			;save it for compare later on
	int	dos
	pop	cx			;restore counter
	mov	dx,0			;assume error
	jc	edcst0			;error
	cmp	ax,cx
	jnz	edcst0			;error
	lds	si,[bp+14]		;(DS:SI) = (R$)
	mov	cx,ds:[si]
	push	cx
	call	GetStrLoc		;locate R$
	mov	ds,dx			;segment
	mov	dx,ax			;offset
	les	di,[bp+10]
	mov	bx,es:[di]		;BX = Handle%
	mov	cx,192			;1 x 192
	les	di,[bp+18]		;access F%
	mov	ax,es:[di]
	mov	ah,al			;read or write 192 bytes
	int	dos
	jc	edcst0			;error
	cmp	ax,192
	jnz	edcst0			;error
	mov	dx,-1			;no error flag
edcst0:	lds	si,[bp+10]		;(ES:DI) = (Handle%)
	mov	ds:[si],dx		;save flag
	mov	bl,4			;4 parameters
	jmp	bakbas
;
EDCST4	endp
;
;
; PROCEDURE  copies up to 5 lines from CCB into CCX as words. Option J
;            Get pointers into CCA%, CCX%, the VR% value and F%. Copy from
;            CCA%(F%) 192 bytes into CCX%(n,1) VR% times.
;    call Copy5X(CCA%(F%),CCX%(0,1),VR%,F%)
;============================================================================
;
COPY5X	proc	far
	public	COPY5X
;
	call	pbastk			;CX = F%
	dec	cl			;F% - 1
	lds	si,[bp+10]		;point to VR%
	mov	bl,ds:[si]		;BL=VR%
	les	di,[bp+14]		;(ES:DI) = CCX%(0,1) = dest
	lds	si,[bp+18]		;(DS:SI) = (CCA%(1)  = srce
	add	si,cx			;(DS:SI) = (CCA%(F%-1)) bytewise
	xor	ah,ah			;clear high byte
copyo:	push	si			;save srce pointer
	push	di			;save dest pointer
	mov	cx,192			;192 columns per row to copy
copyi:	mov	al,ds:[si]		;get value from CCA%
	mov	es:[di],ax		;store value in CCX%
	add	si,165			;offset 1 x 165 to next column
	add	di,10			;offset 2 x 5
	loop	copyi			;repeat 192 times
	pop	di			;restore dest pointer
	pop	si			;restore srce pointer
	inc	si			;point to next in source
	inc	di
	inc	di			;point to next in dest
	dec	bl			;decrement VR%
	jnz	copyo			;repeat 0, 2 or 4 times
	mov	bl,4			;3 parameters to remove
	jmp	bakbas
;
COPY5X	endp
;
;
; PROCEDURE  returns Y0% - (CCX%(0,1:192). Option J
;    call VertY(CCX%(0,1),Y0%
;============================================================================
;
VERTY	proc	far
	public	VERTY
;
	call	pbastk			;CX = Y0%
	mov	bx,cx			;BX = Y0%
	lds	si,[bp+10]		;point to CCX%(0,N%)
	mov	cx,192			;192 values
verty1:	mov	dx,ds:[si]		;DX = CCX%(0,CX)
	mov	ax,bx			;AX = Y0%
	sub	ax,dx			;AX = Y0% - CCDX%(0,N%)
	jnc	verty2			;if no carry, ok
	xor	ax,ax			;set negative to zero
verty2:	mov	ds:[si],ax		;store for second one
	add	si,10			;point to next
	loop	verty1			;repeat 192 times
	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
VERTY	endp
;
;
; PROCEDURE  calculates line averages for HR% values for VR% lines
;            Get pointer into CCX% and the values of HR% and VR%. Add each
;            value in a line HR% times and store the result as HR% times
;            consecutive same values for VR% lines. Option J
;     call HAvrg(CCX%(0,1),HR%,VR%)
;============================================================================
;
HAVRG 	proc	far
	public	HAVRG
;
	call	pbastk			;CX = VR%
	mov	dl,cl			;DL = VR%
	lds	si,[bp+10]		;(DS:SI) = (HR%)
	mov	bl,ds:[si]		;BL = HR%
	lds	si,[bp+14]		;(DS:SI) = (CCX%(0,1)) = srce & dest
havrg1:	push	si			;save original pointer
	mov	ax,192			;192 times or less
	div	bl			;192, 96 or 48 times
	xor	ch,ch
	mov	cl,al			;CX=columns counter
havrg2:	mov	di,si			;save srce addr
	mov	bh,bl			;copy HR% = counter
	xor	ax,ax			;clear accu
havrg3:	add	ax,ds:[si]		;accumulate result
	add	si,10			;point to next source
	dec	bh			;decrement HR%
	jnz	havrg3			;repeat 0, 1 or 3 times
	div	bl			;calculate average
	xor	ah,ah			;clear rest
	mov	si,di			;get srce addr, now dest addr
	mov	bh,bl			;reset HR%
havrg4:	mov	ds:[si],ax		;store value
	add	si,10			;point to next dest
	dec	bh			;decrement HR%
	jnz	havrg4			;repeat 0, 1 or 3 times
	mov	si,di			;get srce addr
	mov	ax,10			;offset is 10 per column
	mul	bl			;calculate offset to next untreated val
	add	si,ax
	loop	havrg2			;repeat 192, 96 or 48 times
	pop	si			;restore start of line address
	inc	si
	inc	si			;start of next line
	dec	dl			;decrement VR%
	jnz	havrg1			;repeat 0, 2 or 4 times
	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
HAVRG 	endp
;
;
; PROCEDURE  calculates 192 column averages for VR% lines. Option J
;            Get pointer into CCX% and calculate average for VR% columns the
;            whole line of 192 wide.
;     call VAvrg(CCX%(0,1),VR%)
;============================================================================
;
VAVRG 	proc	far
	public	VAVRG
;
	call	pbastk			;CX = VR%
	mov	bl,cl			;BL = VR%
	lds	si,[bp+10]		;point to CCX%(0,1)
	mov	cx,192			;there are 192 columns in a line
vavrg1:	mov	di,si			;keep pointer
	mov	bh,bl			;BH=VR%
	xor	ax,ax			;clear accumulator
vavrg2:	add	ax,ds:[si]		;accumulate values
	inc	si
	inc	si			;point to next srce
	dec	bh			;decrement VR%
	jnz	vavrg2			;repeat 0, 2 or 4 times
	div	bl			;calculate average
	xor	ah,ah			;dismiss rest
	mov	si,di			;get pointer back
	mov	ds:[si],ax		;store result in top line only
	add	si,10			;point to next column
	loop	vavrg1			;repeat 192 times
	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
VAVRG 	endp
;
;
; PROCEDURE  calculates 192 column averages for VR% lines. Option J
;            Get pointer into CCX%(0,1), the scale factor SF% and the
;            Multiply/Divide Flag MD%. If MD% is true, multiply full row by
;            SF%, else divide by SF%
;     call ScaleX(CCX%(0,1),SF%,MD%)
;============================================================================
;
SCALEX	proc	far
	public	SCALEX
;
	call	pbastk			;CX = MD%
	mov	bh,cl			;BH = MD%
	lds	si,[bp+10]		;point to SF%
	mov	bl,ds:[si]		;BL=SF%
	lds	si,[bp+14]		;point to CCX%(0,1)
	mov	cx,192			;there are 192 columns in a line
	cmp	bh,0			;check flag
	jz	scale3			;if zero, attenuate (divide)
scale1:	mov	ax,ds:[si]		;get value
	mul	bl			;multiply, amplify
	jnc	scale2			;if no carry, ah=0
	mov	al,255			;set limit, since byte result only
scale2:	xor	ah,ah			;clear high byte anyway
	mov	ds:[si],ax		;store value
	add	si,10			;point to next value in 1st row
	loop	scale1			;repeat 192 times
	jmp	short scale4		;done
scale3:	mov	ax,ds:[si]		;get value
	div	bl			;divide AL=AX/BL, AH=AL MOD BL
	xor	ah,ah			;clear rest
	mov	ds:[si],ax		;store difference
	add	si,10			;point to next value in 1st row
	loop	scale3			;repeat 192 times
scale4:	mov	bl,3			;3 parameters to remove
	jmp	bakbas
;
SCALEX	endp
;
;
; PROCEDURE  flips image along either X- or Y axis or rotates it 90 ccw
;----------------------------------------------------------------------------
;
FLIPXY	proc	far
	public	FLIPXY                  ;whatever name
;
; First, we get the start address of CCA%(1) and the Flip%-Mode
;
	call	pbastk			;save environment
	mov	ax,cx			;AX=Flag
	lds	si,[bp+10]		;access CCA%(1)
	dec	al			;if Y-axis (1), AL is now 0
	jnz	noty			;if not Y, test next
	jmp	short yaxis		;if Y, handle it
noty:	dec	al			;if X-axis (2), AL is now 0
	jnz	notx			;if not X, test next
	jmp	short xaxis		;if X, handle it
notx:	dec	al			;if CCW (3), AL is now 0
	jnz	notccw			;exit
	jmp	ccw			;if CCW, handle it
notccw:	mov	bl,2			;2 parameters to remove
	jmp	bakbas
;
; The Y-Axis flip is performed here. The flip is along the Y-axis and this
; flips left/right. The generalized procedure is:
;
;   for Rx = 1 to fix(X/2)         where X:  max. columns (192)
;     for Cy = 1 to Y                    Y:  max. rows (165)
;       Pa = (Rx-1) * Y + Cy-1           Rx: actual X-position
;       Pb = (X-Rx) * Y + Cy-1           Cy: actual Y-position
;     next Cy                            Pa: position of dot-A
;   next Rx                              Pb: position of dot-B
;
yaxis:	xor	bx,bx			;clear Rx
yaxis1:	inc	bx			;next Rx
	xor	cx,cx			;reset Cy
yaxis2:	inc	cx			;next Cy
	mov	ax,bx			;get Rx
	dec	ax			;calculate (Rx-1)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (Rx-1)*Y
	add	ax,cx			;calculate (Rx-1)*Y+Cy
	dec	ax			;calculate (Rx-1)*Y+Cy-1
	add	ax,si			;AX=offset to element-A
	push	ax			;save offset to element-A
	mov	ax,cols			;get columns
	sub	ax,bx			;calculate (X-Rx)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (X-Rx)*Y
	add	ax,cx			;calculate (X-Rx)*Y+Cy
	dec	ax			;calculate (X-Rx)*Y+Cy-1
	add	ax,si			;AX=offset to element-B
	pop	dx			;DX=offset to element-A
	push	si			;save offset to CCA%(1)
	mov	si,ax			;SI=address of element-B
	mov	di,dx			;DI=address of element-A
	mov	al,ds:[si]		;get element-B
	mov	dl,ds:[di]		;get element-A
	mov	ds:[si],dl		;store element-A at element-B
	mov	ds:[di],al		;store element-B at element-A
	pop	si			;restore offset to CCA%(1)
	cmp	cx,rows			;check if thru
	jc	yaxis2			;do all Cy
	cmp	bx,hcols		;check if thru
	jc	yaxis1			;do half of Rx
	mov	bl,2			;2 parameters
	jmp	bakbas			;exit
;
; The X-Axis flip is performed here. The flip is along the X-axis and this
; flips up/down. The generalized procedure is:
;
;   for Cy = 1 to fix(Y/2)         where X:  max. columns (192)
;     for Rx = 1 to X                    Y:  max. rows (165)
;       Pa = (Rx-1) * Y + Cy-1           Rx: actual X-position
;       Pb = (Rx-1) * Y + Y-Cy           Cy: actual Y-position
;     next Rx                            Pa: position of dot-A
;   next Cy                              Pb: position of dot-B
;
xaxis:	xor	cx,cx			;clear Cy
xaxis1:	inc	cx			;next Cy
	xor	bx,bx			;reset Rx
xaxis2:	inc	bx			;next Rx
	mov	ax,bx			;get Rx
	dec	ax			;calculate (Rx-1)
	mov	dx,rows			;get Y=165
	mul	dx			;calculate (Rx-1)*Y
	mov	dx,ax			;save this one in DX
	add	ax,cx			;calculate (Rx-1)*Y+Cy
	dec	ax			;calculate (Rx-1)*Y+Cy-1
	add	ax,si			;AX=offset to element-A
	push	ax			;save address of element-A
	push	dx			;save (Rx-1)*Y
	mov	dx,rows			;get rows
	sub	dx,cx			;calculate (Y-Cy)
	pop	ax			;get (Rx-1)*Y
	add	dx,ax			;calculate (Rx-1)*Y + Y - Cy
	add	dx,si			;DX=offset to element-B
	pop	ax			;restore offset to element-A
	push	si			;save offset to CCA%(1)
	mov	si,ax			;SI=address of element-A
	mov	di,dx			;DI=address of element-B
	mov	al,ds:[si]		;get element-A
	mov	dl,ds:[di]		;get element-B
	mov	ds:[si],dl		;store element-B at element-A
	mov	ds:[di],al		;store element-A at element-B
	pop	si			;restore offset to CCA%(1)
	cmp	bx,cols			;check if 192
	jc	xaxis2			;do all Rx
	cmp	cx,hrows		;check if 82
	jc	xaxis1			;do half of Cy
	mov	bl,2			;2 parameters
	jmp	bakbas  		;exit
;
; We handle 90 degrees rotation in counterclock wise direction of a squarred
; image. The generalized procedure is:
;
;   for Rx = 1 to fix(Y/2)         where Y:  max. rows and columns (165)
;     for Cy = Rx to Y-Rx                Rx: actual X-position
;       Pa = (Rx-1) * Y + Cy-1           Cy: actual Y-position
;       Pb = (Cy-1) * Y + Y-Rx           Pa: top-left corner
;       Pc = (Y-Rx) * Y + Y-Cy           Pb: botton-left corner
;       Pd = (Y-Cy) * Y + Rx-1           Pc: botton-right corner
;     next Cy                            Pd: top-right corner
;   next Rx
;
; Moving is done in concentric circles from the edge inward. The positions
; move as follows: Save A, D-->A, C-->D, B-->C, Restore A to B.
;
ccw:	xor	bx,bx			;clear Rx
ccw1:	mov	cx,bx			;Cy = Rx
	inc	bx			;next Rx
ccw2:   inc	cx			;next Cy
	mov	ax,bx			;Rx
	dec	ax			;(Rx-1)
	mov	dx,rows			;Y = 165
	mul	dx			;(Rx-1)*Y
	add	ax,cx			;(Rx-1)*Y+Cy
	dec	ax			;(Rx-1)*Y+Cy-1
	add	ax,si			;address-A
	mov	di,ax			;DI=addr-A
	mov	al,ds:[di]		;get value-A
	push	ax			;save value-A
	mov	dx,rows			;Y
	mov	ax,dx			;Y
	sub	ax,cx			;(Y-Cy)
	mul	dx			;(Y-Cy)*Y
	add	ax,bx			;(Y-Cy)*Y+Rx
	dec	ax			;(Y-Cy)*Y+Rx-1
	add	ax,si			;address-D
	push	si			;save CCD% base address
	mov	si,ax			;SI=address
	mov	al,ds:[si]		;get value-D
	mov	ds:[di],al		;move to addr-A
	mov	di,si			;DI=addr-D
	pop	si			;restore CCD% base address
	mov	dx,rows			;Y
	mov	ax,dx			;Y
	sub	ax,bx			;(Y-Rx)
	mul	dx			;(Y-Rx)*Y
	add	ax,rows			;(Y-Rx)*Y+Y
	sub	ax,cx			;(Y-Rx)*Y+Y-Cy
	add	ax,si			;addr-C
	push	si			;save CCD% base address
	mov	si,ax			;SI=address
	mov	al,ds:[si]		;get value-C
	mov	ds:[di],al		;move to addr-D
	mov	di,si			;DI=addr-C
	pop	si			;restore CCD% base address
	mov	dx,rows			;Y
	mov	ax,cx			;Cy
	dec	ax			;(Cy-1)
	mul	dx			;(Cy-1)*Y
	add	ax,rows			;(Cy-1)*Y+Y
	sub	ax,bx			;(Cy-1)*Y+Y-Rx
	add	ax,si			;addr-B
	push	si			;save CCD% base address
	mov	si,ax			;SI=address
	mov	al,ds:[si]		;get value-B
	mov	ds:[di],al		;move to addr-C
	mov	di,si			;DI=addr-B
	pop	si			;restore CCD% base address
	pop	ax			;get value-A
	mov	ds:[di],al		;move value-A to B
	mov	ax,rows			;Y
	sub	ax,bx			;Y-Rx
	cmp	cx,ax			;Cy <= (Y-Rx)?
	jnc	ccw3
	jmp	ccw2
ccw3:	cmp	bx,hrows		;Y/2
	jnc	ccw4			;all done
	jmp	ccw1			;for RX = 1 to Y/2
ccw4:	mov	bl,2			;2 parameters
	jmp	bakbas			;exit
;
FLIPXY	endp
;
;
; PROCEDURE rotates twice by 180 without loosing part of image bytewise.
;           This is an improvement over FlipIt twice.
;    call RoTwic(CCB%(1))
;----------------------------------------------------------------------------
;
ROTWIC	proc	far
	public	ROTWIC
;
	call	pbastk			;(DS:SI) = (CCB%(1))
        les	di,[bp+6]		;(ES:DI) = (CCB%(1))
        mov	ax,31679		;end of array
        add	ax,di
        mov	di,ax			;(ES:DI) = (CCB%(15840-1))
        mov	cx,15840		;elements / 2
rotwi1:	mov	al,ds:[si]		;get top left
	mov	bl,es:[di]		;get bottom right
        mov	es:[di],al		;top left to bottom right
        mov	ds:[si],bl		;bottom right to top left
        inc	si			;next top source/dest
        dec	di			;next bottom source/dest
        loop	rotwi1			;all elements
	mov	bl,1			;one parameter
        jmp	bakbas
;
ROTWIC	endp
;
;
; PROCEDURE moves column byte wise left within array from A% hence
;     call MovLft(CCA%(1),A%)
;----------------------------------------------------------------------------
;
MOVLFT	proc	far
	public	MOVLFT
;
	call	pbastk			;A% [0:27]
	lds	si,[bp+10]		;(DS:SI) = (CCA%(1))
	add	si,cx			;(DS:SI) = (CCA%(A%/2))
	les	di,[bp+10]		;(ES:DI) = (CCA%(1))
	mov	dx,27			;DX = 27+165=192
	xor	ax,ax			;AX = 0
	mov	bl,165			;row counter
	mov	bh,13			;fill counter
movlf1:	mov	cl,82			;82*2=164 - CH = 0 anyway
	rep	movsw			;move 164 bytes as 82 words
	movsb				;move 165th byte
	mov	cl,bh
	rep	stosw			;13*2=26 bytes to clear
	stosb				;27th byte to clear
	add	si,dx			;source + 27
	dec	bl			;next row
	jnz	movlf1
	mov	bl,2			;1 parameter
	jmp	bakbas
;
MOVLFT	endp
;
;
; PROCEDURE superimposes isophotal curves on image
;     call SupImp(CCA%(1),CCB%(1),M%)      where
;      M% = 0: White,  M% = 1: Black,  M% = 2: inverted
;----------------------------------------------------------------------------
;
SUPIMP	proc	far
	public	SUPIMP
;
	call	pbastk			;CX = M%
	mov	bl,cl			;BL = M%
	mov	bh,255			;BH = color of set iso-dot
	mov	cx,31680		;CX = counter
	lds	si,[bp+10]		;(DS:SI) = (CCB%())
	les	di,[bp+14]		;(ES:DI) = (CCA%())
supim0:	mov	ah,es:[di]		;AH = image dot
	lodsb				;AL = iso dot, SI+1
	cmp	al,bh			;check if set
	jz	supim1			;if set, jump
	mov	al,ah			;AL = image dot
	jmp	short supim2		;store
supim1:	cmp	bl,0			;is it white
	jz	supim2			;yes, white from iso to img
	xor	al,al			;white iso dot to black img dot
	cmp	bl,1			;check if black
	jz	supim2			;yes, we've prepared that
	mov	al,ah			;get img dot
	xor	al,bh			;invert
supim2:	stosb				;save it, DI+1
	loop	supim0			;repeat
	mov	bl,3			;3 parameters
	jmp	bakbas
;
SUPIMP	endp
;
;
; PROCEDURE converts ascii-string into 5x5 character codes.
;           X$ on entry: ascii, on exit: codes. L% = len(X$)
;     call AConvt(L%,X$)
;----------------------------------------------------------------------------
;
ACONVT	proc	far
	public	ACONVT
;
	call	pbastk			;CX = X$ handle
	push	cx			;get$loc expects handle on stack
	call	GetStrLoc		;(DX:AX) = (X$)
	mov	es,dx
	mov	di,ax			;(ES:DI) = (X$)
	lds	si,[bp+10]		;(DS:SI) = (L%)
	mov	cx,ds:[si]		;CX = L%
	jcxz	aconv2			;if L% = 0 then X$ = "", skip
	push	cs
	pop	ds			;DS = CS
	lea	si,aschar		;SI = start of table
	xor	bh,bh			;clear high byte
aconv0: xor	al,al			;assume blank for < 32 or > 127
	mov	bl,es:[di]		;get ascii from X$
	cmp	bl,32			;check < 32
	jc	aconv1			;jump if < 32 - code 0
	cmp	bl,128			;check > 127
	jnc	aconv1          	;jump if > 127 - code 0
	sub	bl,32			;substract 32, table starts there
	mov	al,ds:[si+bx]		;get corresponding code
aconv1:	stosb				;replace ascii by code
	loop	aconv0			;repeat for length of string
aconv2:	mov	bl,2			;2 parameters
	jmp	bakbas
;
ACONVT	endp
;
;
; PROCEDURE creates label in CCT%() from data in X$ with string length L%
;     call ChrLin(CCT%(1),L%,X$)
;----------------------------------------------------------------------------
;
CHRLIN	proc	far
	public	CHRLIN
;
	call	pbastk			;CX = handle of X$
	push	cx			;X$ handle onto stack
	call	GetStrLoc
	mov	ds,dx
	mov	si,ax			;(DS:SI) = (X$)
	les	di,[bp+10]
	mov	cx,es:[di]		;CX = L%
	jcxz	chrli2			;skip if X$ = ""
	les	di,[bp+14]		;(ES:DI) = (CCT%())
	mov	dx,cx			;DX = L%
	xor	al,al			;black
	rep	stosb			;clear top line
	mov	cx,dx			;CX = L%
chrli0:	push	di			;save dest offset
	push	cx			;save L% counter
	lea	bx,chrdat		;BX = start of table
	mov	cx,5			;5 bytes per table entry
	lodsb				;get character from X$
	mul	cl			;AX = offset
	add	bx,ax			;BX points to correct byte in table
chrli1:	mov	al,cs:[bx]		;get byte
	mov	es:[di],al		;store byte
	add	di,dx			;calculate start of next line
	inc	bx			;point to next byte in table
	loop	chrli1			;repeat for 5 bytes
	xor	al,al			;clear low line
	mov	es:[di],al
	pop	cx			;restore L% counter
	pop	di			;restore dest offset
	inc	di			;point to next char at line 2
	loop	chrli0			;repeat L% times
chrli2:	mov	bl,3			;3 parameters
	jmp	bakbas
;
CHRLIN	endp
;
;
; PROCEDURE inserts a label into a picture.
;           F% = 1: black on white
;           F% = 2: white on black (already inverted)
;           F% = 3: black on transparent
;           F% = 4: white on transparent (already inverted)
;           L% is length, P% start position, CCT%() source and CCB%() dest
;     call InsLbl(CCB%(1),CCT%(1,1),P%,F%,L%)
;----------------------------------------------------------------------------
;
INSLBL	proc	far
	public	INSLBL
;
	call	pbastk			;CX = L% length of string
	lds	si,[bp+10]
	mov	bl,ds:[si]		;BL = F% (1, 2, 3 , 4)
	lds	si,[bp+14]
	mov	dx,ds:[si]		;DX = position offset
	lds	si,[bp+18]		;(DS:SI) = (CCT%())
	les	di,[bp+22]		;(ES:DI) = (CCB%())
	add	di,dx			;offset to start
	mov	dx,cx			;DX = L%
	mov	cx,7			;7 lines
inslb0:	push	cx			;save lines counter
	push	di			;save dest
	mov	cx,dx			;get string length
inslb1: push	cx			;save string length counter
	lodsb				;AL = 5 (8) pixels of chr
	mov	ah,al			;AL = pixels
	mov	cx,7			;7 bits
inslb2: xor	al,al			;assume black
	shl	ah,1			;move bit into carry
	jc	inslb3			;bit set = black
	dec	al			;AL = 255
inslb3:	cmp	bl,3			;check F% < 3
	jc	inslb5			;all done
	mov	bh,es:[di]		;get image pixel
	jz	inslb4			;if F% = 3 jump
	or	al,bh			;F% = 4
	jmp	short inslb5		;ready
inslb4:	and	al,bh			;F% = 3
inslb5:	stosb				;save pixel
	loop	inslb2			;repeat for 5 bits
	pop	cx			;get string length counter
	loop	inslb1			;repeat for whole length
	pop	di			;get previous position
	add	di,192			;next line
	pop	cx			;get lines counter
	loop	inslb0			;repeat for 7 lines
	mov	bl,5			;5 parameters
	jmp	bakbas
;
INSLBL	endp
;
;
; PROCEDURE shifts image left by N% columns or up by N% rows and fills rest
;           with F%. Assumes that array is reorganized by XDimBA for Left
;     for LEFT shift: call SHLUIm(CCB%(1),%True,F%,N%)
;     for  UP  shift: call SHLUIm(CCB%(1),%False,F%,N%)
;----------------------------------------------------------------------------
;
SHLUIM	proc	far
	public	SHLUIM
;
	call	pbastk			;CX = N%, number of columns to shift
	lds	si,[bp+10]
	mov	al,ds:[si]		;AL = filler byte
	lds	si,[bp+14]
	mov	ah,ds:[si]		;AH = Flag. True=Left, False=Up
	lds	si,[bp+18]		;(DS:SI) = (CCB%())
	les	di,[bp+18]		;(ES:DI) = (CCB%())
	add	si,cx			;(DS:SI) = start in source
	mov	dx,cx			;DX = N%, either column or row
	mov	bh,192			;BH = columns
	mov	bl,165			;BL = rows
	inc	ah			;-1 + 1 = 0
	jz	shlui0			;jump if true
	xchg	bh,bl			;BL = rows, BH = columns
shlui0:	mov	cl,bh			;CX = inner counter
	sub	cx,dx			;CX = line or column length
	rep	movsb			;move left 1 col or up 1 row
	mov	cx,dx			;now rest
	rep	stosb			;fill with F%
	add	si,dx			;point to next col/row start
	dec	bl			;one row/col done
	jnz	shlui0			;repeat row/col times
	mov	bl,4			;4 parameters
	jmp	bakbas
;
SHLUIM	endp
;
;
; PROCEDURE shifts image right by N% columns or down by N% rows and fills rest
;           with F%. Assumes that array is reorganized by XDimBA for Right
;     for RIGHT shift: call SHRDIm(CCB%(1),%True,F%,N%)
;     for  DOWN shift: call SHRDIm(CCB%(1),%False,F%,N%)
;----------------------------------------------------------------------------
;
SHRDIM	proc	far
	public	SHRDIM
;
	call	pbastk			;CX = N%, number of columns to shift
	lds	si,[bp+10]
	mov	al,ds:[si]		;AL = filler byte
	lds	si,[bp+14]
	mov	ah,ds:[si]		;AH = Flag. True=Left, False=Up
	lds	si,[bp+18]		;(DS:SI) = (CCB%())
	les	di,[bp+18]		;(ES:DI) = (CCB%())
	mov	bx,31679		;offset to end of array
	add	si,bx			;point to end
	add	di,bx
	std				;direction flag downwards
	sub	si,cx			;(DS:SI) = start in source
	mov	dx,cx			;DX = N%, either column or row
	mov	bh,192			;BH = columns
	mov	bl,165			;BL = rows
	inc	ah			;-1 + 1 = 0
	jz	shrdi0			;jump if true
	xchg	bh,bl			;BL = rows, BH = columns
shrdi0:	mov	cl,bh			;CX = inner counter
	sub	cx,dx			;CX = line or column length
	rep	movsb			;move left 1 col or up 1 row
	mov	cx,dx			;now rest
	rep	stosb			;fill with F%
	sub	si,dx			;point to next col/row start
	dec	bl			;one row/col done
	jnz	shrdi0			;repeat row/col times
	mov	bl,4			;4 parameters
	jmp	bakbas
;
SHRDIM	endp
;
;
; PROCEDURE fills part of frame with filler byte F%. P% has start position
;           in CCB%(), X% is the length of a column, Y% the number of rows
;     call FilFrm(CCB%(1),F%,X%,Y%,P%)
;----------------------------------------------------------------------------
;
FILFRM	proc	far
	public	FILFRM
;
	call	pbastk			;CX = P%, offset into CCB%
	lds	si,[bp+10]
	mov	bl,ds:[si]		;BL = Y%
	lds	si,[bp+14]
	mov	dx,ds:[si]		;DX = X%
	lds	si,[bp+18]
	mov	al,ds:[si]		;AL = filler byte
	les	di,[bp+22]		;(ES:DI) = (CCB%())
	add	di,cx			;start
filfr0:	mov	cx,dx			;get X%
	rep	stosb			;fill one line with length X%
	mov	cx,192			;full line length
	sub	cx,dx			;calculate rest of line (192-X%)
	add	di,cx			;point to next line start
	dec	bl			;one row done
	jnz	filfr0			;repeat until done
	mov	bl,5			;5 parameters
	jmp	bakbas
;
FILFRM	endp
;
;
; PROCEDURE copies part frame with size X% / Y% start position P%
;           The use of XDimBA is assumed
;     call CutFrm(CCA%(1),CCB%(1),X%,Y%,P%)
;----------------------------------------------------------------------------
;
CUTFRM	proc	far
	public	CUTFRM
;
	call	pbastk			;CX = P%
	lds	si,[bp+10]
	mov	bl,ds:[si]		;BL = Y%
	lds	si,[bp+14]
	mov	dx,ds:[si]		;DX = X%
	lds	si,[bp+18]		;(DS:SI) = (CCB%())
	les	di,[bp+22]		;(ES:DI) = (CCA%())
	add	si,cx			;source start
	add	di,cx			;dest start
	mov	ax,192			;all columns
	sub	ax,dx			;rest of columns
cutfr0:	mov	cx,dx			;number of columns
	rep	movsb			;copy one line
	add	si,ax			;start of next source line
	add	di,ax			;start of next dest line
	dec	bl			;one line done
	jnz	cutfr0			;repeat Y% times
	mov	bl,5			;5 parameters
	jmp	bakbas
;
CUTFRM	endp
;
;
; PROCEDURE frames a frame. Frame size is X%/Y%, start position is P%
;           Color is 0=Black, 255=White 256 = inverse
;     call FrmFrm(CCB%(1),C%,X%,Y%,P%)
;----------------------------------------------------------------------------
;
FRMFRM	proc	far
	public	FRMFRM
;
	call	pbastk			;CX = P%
	lds	si,[bp+10]
	mov	bl,ds:[si]		;BL = Y%
	dec	bl
	dec	bl			;substract upper & lower line
	lds	si,[bp+14]
	mov	dx,ds:[si]		;DX = X%
	lds	si,[bp+18]
	mov	ax,ds:[si]		;AH=inv-flg, AL=color
	les	di,[bp+22]		;(ES:DI) = (CCB%())
	add	di,cx			;start
	mov	cx,dx			;line length
	or	ah,ah			;zero set if zero
	jz	frmfr4	         	;color of frame in AL
	mov	ah,255			;xor mask
frmfr1: mov	al,es:[di]		;get byte
	xor	al,ah			;invert byte
	stosb				;save it
	loop	frmfr1			;do whole line
	mov	cx,192			;full line
	sub	cx,dx			;rest of line
frmfr2:	add	di,cx			;point to next line
	mov	al,es:[di]		;get left
	xor	al,ah
	stosb				;left column
	add	di,dx
	dec	di
	dec	di			;point to right
	mov	al,es:[di]		;get right
	xor	al,ah			;invert
	stosb				;right column
	dec	bl			;one line done
	jnz	frmfr2			;repeat Y-2 lines
	add	di,cx			;point to last line
	mov	cx,dx
frmfr3:	mov	al,es:[di]		;get byte
	xor	al,ah			;invert
	stosb				;save it
	loop	frmfr3			;repeat for
	jmp	short frmfr6		;all done
frmfr4:	rep	stosb			;top row
	mov	cx,192			;full line
	sub	cx,dx			;rest of line
frmfr5:	add	di,cx			;point to start of next line
	stosb				;left column
	add	di,dx
	dec	di
	dec	di			;point to right column
	stosb				;right column
	dec	bl			;for Y-2 rows
	jnz	frmfr5
	add	di,cx			;point to last line
	mov	cx,dx
	rep	stosb			;bottom line
frmfr6:	mov	bl,5			;5 parameters
	jmp	bakbas
;
FRMFRM	endp
;
;
; PROCEDURE frames a horizontal line. Line size is X%, start position is P%
;           Color is 0=Black, 255=White 256 = inverse
;     call FrmHln(CCB%(1),C%,X%,P%)
;----------------------------------------------------------------------------
;
FRMHLN	proc	far
	public	FRMHLN
;
	call	pbastk			;CX = P%
	lds	si,[bp+10]
	mov	bx,ds:[si]		;BX = X%
	lds	si,[bp+14]
	mov	ax,ds:[si]		;AH=inv-flg, AL=color
	les	di,[bp+18]		;(ES:DI) = (CCB%())
	add	di,cx			;start
	mov	cx,bx			;line length
	or	ah,ah			;zero set if zero
	jz	frmhl1	         	;color of frame in AL
	mov	ah,255			;xor mask
frmhl0: mov	al,es:[di]		;get byte
	xor	al,ah			;invert byte
	stosb				;save it
	loop	frmhl0			;do whole line
	jmp	short frmhl2		;all done
frmhl1:	rep	stosb			;do line
frmhl2:	mov	bl,4			;4 parameters
	jmp	bakbas
;
FRMHLN	endp
;
;
; PROCEDURE frames a vertical line. Line size is Y%, start position is P%
;           Color is 0=Black, 255=White 256 = inverse
;     call FrmVln(CCB%(1),C%,Y%,P%)
;----------------------------------------------------------------------------
;
FRMVLN	proc	far
	public	FRMVLN
;
	call	pbastk			;CX = P%
	lds	si,[bp+10]
	mov	bx,ds:[si]		;BX = Y%
	lds	si,[bp+14]
	mov	ax,ds:[si]		;AH=inv-flg, AL=color
	lds	si,[bp+18]		;(DS:SI) = (CCB%())
	add	si,cx			;start
	mov	cx,bx			;column length
	mov	dx,192			;offset to next column
	or	ah,ah			;zero set if zero
	jz	frmvl1	         	;color of frame in AL
	mov	ah,255			;xor mask
frmvl0: mov	al,ds:[si]		;get byte
	xor	al,ah			;invert byte
	mov	ds:[si],al		;save it
	add	si,dx			;point to next line, same column
	loop	frmvl0			;do whole column
	jmp	short frmvl2		;all done
frmvl1:	mov	ds:[si],al		;store byte in column
	add	si,dx			;point to next column
	loop	frmvl1			;do column
frmvl2:	mov	bl,4			;4 parameters
	jmp	bakbas
;
FRMVLN	endp
;
;
; PROCEDURE inserts a grid of 20x 15y in the color C%
;           Color is 0=Black, 255=White 256 = inverse
;     call HVGrid(CCB%(1),C%)
;----------------------------------------------------------------------------
;
HVGRID	proc	far
	public	HVGRID
;
	call	pbastk			;CX = C%
	mov	ax,cx			;AX = C%
	lds	si,[bp+10]		;(DS:SI) = (CCB%(1))
	les	di,[bp+10]		;(ES:DI) = (CCB%(1))
	mov	cx,165			;165 lines
	mov	dx,20			;20-40-60-80-100-120-140-160-180
	dec	si			;compensate
	or	ah,ah			;if AH=0 then AL either 0 or 255
	jz	hvgri4			;black or white
	mov	ah,255			;inverting mask
hvgri0:	mov	bl,9			;9 vertical bars
hvgri1:	add	si,dx			;next column
	mov	al,ds:[si]		;get byte
	xor	al,ah			;invert
	mov	ds:[si],al		;store byte
	dec	bl
	jnz	hvgri1			;do one line
	add	si,12			;180 + 12 + 20: next line
	loop	hvgri0			;do all lines
	mov	dx,2688			;15-30-45-60-75-90-105-120-135-150
	mov	bl,10			;10 horizontal lines
hvgri2:	add	di,dx			;point to next line+15
	mov	cx,192			;192 columns
hvgri3:	mov	al,es:[di]		;get byte
	xor	al,ah			;invert
	stosb				;store byte
	loop	hvgri3			;one line
	dec	bl			;one line done
	jnz	hvgri2			;do 10 lines
	jmp	short hvgri8		;inverse done

hvgri4:	mov	bl,9			;9 vertical bars
hvgri5:	add	si,dx			;next column
	mov	ds:[si],al		;store byte
	dec	bl
	jnz	hvgri5			;do one line
	add	si,12			;180 + 12 + 20: next line
	loop	hvgri4			;do all lines
	mov	dx,2688			;15-30-45-60-75-90-105-120-135-150
	mov	bl,10			;10 horizontal lines
hvgri6:	add	di,dx			;point to next line+15
	mov	cx,192			;192 columns
	rep	stosb			;store byte
	dec	bl			;one line done
	jnz	hvgri6			;do 10 lines
hvgri8:	mov	bl,2			;2 parameters
	jmp	bakbas
;
HVGRID	endp
;
;

; PROCEDURE returns converted frequencies
;           Z% = start, N% = number of bytes
;     call ToFreq(CCX%(0,1),CCA%(Z%),N%)
;----------------------------------------------------------------------------
;
TOFREQ	proc	far
	public	TOFREQ
;
	call	pbastk			;CX = N%
	lds	si,[bp+10]		;(DS:SI) = (CCA%())
	les	di,[bp+14]		;(ES:DI) = (CCX%())
	lea	bx,freqtb		;BX frequency table
	mov	dx,bx			;DX frequency table
tofre0:	lodsb				;get value
	xor	ah,ah			;clear upper byte
	and	al,252			;use only 6 high bits
	shr	al,1			;/2 actually /4 but 2 bytes per word
	add	bx,ax			;point to right word in freqtb
	mov	ax,cs:[bx]		;get frequency
	stosw				;store it
	add	di,8			;point to next 2nd dimension
	mov	bx,dx			;BX start of freqtbl
	loop	tofre0			;repeat N% times
	mov	bl,3			;3 parameters
	jmp	bakbas
;
TOFREQ	endp
;
;
; PROCEDURE is an universal convolving filter. CCA%([1;31680]) is destination
;           CCB%([1;31680]) is source and I%([1;10]) is: 1=i1, 2=i2,
;           3=i3,...,9=i9,10=sum(i1:i9).
;     call ConvUF(CCA%(1),CCB%(1),I%(1))
;=============================================================================
;
CONVUF	proc	far
	public	CONVUF
;
	call	pbastk			;(DS:SI) = (I%(1))
	mov	cx,10			;10 variables to fetch
	lea	di,convi1		;point to buffer start
	push	cs
	pop	es
	rep	movsw			;copy vars
	lds	si,[bp+10]		;point to CCB%
	les	di,[bp+14]		;point to CCA%
	mov	cx,15840		;number of words
	rep	movsw			;copy for frame
	lds	si,[bp+10]		;point to CCB%
	les	di,[bp+14]		;point to CCA%
	add	si,192			;skip 1st row
	add	di,192			;skip 1st row
	mov	cl,163			;163 rows
convu0:	push	cx
	mov	cl,190			;190 columns
	inc	si			;skip 1st column
	inc	di
convu1:	sub	si,193			;point to i1
	call	convlv			;convolve and return pixel in AL
	stosb				;save pixel, increment destination
	loop	convu1			;repeat for all columns
	inc	si
	inc	di			;skip last column
	pop	cx			;get lines counter
	loop	convu0			;repeat 163 times
	mov	ax,convi0		;get sum
	cmp	ax,0			;if zero contour filter
	jnz	convu2			;not contour, skip frame copy
	lds	si,[bp+14]		;get dest array
	call	cpyfrm			;copy frame
convu2:	mov	bl,3			;3 params to remove
	jmp	bakbas
;
CONVUF	endp
;
;
; PROCEDURE is an universal statistical filter. CCA%([1;31680]) is destination
;           CCB%([1;31680]). I%(10) is flag: False (0) = minimum,
;           True (-1) = maximum and +1 = median filter. I%([1;9]) is mask,
;           values either 0 or 1.
;     call StatMF(CCA%(1),CCB%(1),I%(1))
;=============================================================================
;
STATMF	proc	far
	public	STATMF
;
	call	pbastk			;DS:SI) = (I%(1))
	mov	cx,10			;10 variables to fetch
	lea	di,convi1		;point to buffer start
	push	cs
	pop	es
	rep	movsw			;copy vars
	lds	si,[bp+10]		;point to CCB%
	les	di,[bp+14]		;point to CCA%
	add	si,192			;skip 1st row
	add	di,192			;skip 1st row
	mov	cl,163			;163 rows
statf0:	push	cx			;save row counter
	mov	cl,190			;190 columns to do
	inc	si			;skip 1st column
	inc	di			;skip 1st column
statf1: push	cx			;save column counter
	sub	si,193			;point to i1
	lea	bx,convi1		;point to i1-mask
	lea	dx,srtbuf		;start of sort buffer
	xor	ah,ah			;reset buffer counter
	call	cpybuf			;find i1, i2, i3, si=(i3)
	add	si,190			;point to i4
	call	cpybuf			;find i4, i5, i6, si=(i6)
	add	si,190			;point to i7
	call	cpybuf			;find i7, i8, i9, si=(i9)
	sub	si,192			;point to i6 = next
	lea	bx,srtbuf		;point to sort buffer
	xor	ch,ch
	mov	cl,ah			;CX=number of values in srtbuf
	mov	dx,convi0		;get I%(10) flag
	call	findmm			;return in AL pixel value
	stosb				;store result, inc di
	pop	cx			;restore column counter
	loop	statf1			;repeat 190 times
	inc	si			;skip last column
	inc	di			;skip last column
	pop	cx			;get row counter
	loop	statf0			;repeat 163 times
	lds	si,[bp+14]		;get dest array
	call	cpyfrm			;copy frame
	mov	bl,3			;3 params to remove
	jmp	bakbas
;
STATMF	endp
;
;
; PROCEDURE creates 3 X 3 binning, reducing size to 64 x 55. Assumes col/row
;           organization. Bytes are reduced to nibbles.
;    call BiNine(CCG%(1),CCA%(1))
;----------------------------------------------------------------------------
;
BININE	proc	far
	public	BININE
;
	call	pbastk			;(DS:SI) = (CCA%(1))
        les	di,[bp+10]		;(ES:DI) = (CCG%(1))
        mov	ch,55			;55 rows
	mov	bl,144			;9 Bytes with only 4 bits
binin0:	mov	cl,64			;64 columns
binin1:	xor	dh,dh			;accumulator clear
        xor	ah,ah			;clear upper byte
        lodsb				;get one bytes
        mov	dl,al
        lodsb				;get byte 2
        add	dx,ax			;accumulate
        mov	al,ds:[si]		;get byte 3
        add	dx,ax			;accumulate
        add	si,190			;point to next row
        lodsb				;get byte 4
        add	dx,ax			;accumulate
        lodsb				;get byte 5 (center)
        add	dx,ax			;accumulate
        mov	al,ds:[si]		;get byte 6
        add	dx,ax			;accumulate
        add	si,190			;point to 3rd row
        lodsb				;get byte 7
        add	dx,ax			;accumulate
        lodsb				;get byte 8
        add	dx,ax			;accumulate
        mov	al,ds:[si]		;get byte 9
        add	ax,dx			;accumulate
        div	bl			;9 pixels, only 4 bits used
        stosb				;one pixel done
        sub	si,383			;point back to next
        dec	cl			;one byte done
        jnz	binin1			;do 64 bytes
        add	si,384			;point 3 lines down
        dec	ch			;one row done
        jnz	binin0			;do 55 lines
;
        lds	si,[bp+10]		;(DS:SI) = (CCG%(1))
	les	di,[bp+10]		;(ES:DI) = (CCG%(1))
        mov	cx,1760			;64 x 55 / 2
binin3:	lodsw				;get 2 bytes
        shl	ah,1
        shl	ah,1
        shl	ah,1
        shl	ah,1			;move even byte to high nibble
        or	al,ah			;add even byte
        stosb				;save it
        loop	binin3			;repeat
        mov	bl,2			;2 parameters
        jmp	bakbas
;
BININE	endp
;
;
; PROCEDURE copies from CCA% at O% box with size S% square into CCG%. This
;           is used for brightness calculations. CCA is organized 165x192.
;    call CpyBox(CCG%(1),CCA%(1),O%,S%)
;----------------------------------------------------------------------------
;
CPYBOX	proc	far
	public	CPYBOX
;
	call	pbastk			;(DS:SI) = (S%), CX=S%
        les	di,[bp+10]		;(ES:DI) = (O%)
        mov	ax,es:[di]		;AX% = O%
        lds	si,[bp+14]		;(DS:SI) = (CCA%(1))
        add	si,ax                   ;add O%, (DS:SI) = source
        les	di,[bp+18]		;(ES:DI) = (CCG%(1)) = dest
        mov	bh,cl			;BH=copy of S%
        mov	bl,cl			;BL=row counter, CL=column counter
cpybo0:	rep	movsb			;copy one row
	dec	bl			;one row done
        jz	cpybo1			;all done
        mov	cl,bh			;get columns
	add	si,rows			;next line
        sub	si,cx			;back to left column
        jmp	short cpybo0		;repeat
cpybo1:	mov	bl,4			;4 parameters
        jmp	bakbas
;
CPYBOX	endp
;
;
;============================================================================
; LOCAL SUBROUTINES AREA - Subroutines are Public and may be accessed by any
; of the above procedures.
;============================================================================
;
;
; SUBROUTINE convolves. DS:SI points to i1a on entry and to i5b on exit.
;            AL has valid pixel value on exit
;----------------------------------------------------------------------------
;
CONVLV	proc	near
;
	lodsb				;AL=i1
	xor	ah,ah			;AX=i1
	imul	convi1			;DX:AX=i1*I%(1)
	mov	bx,ax			;BX=accumulator, dismiss DX
	lodsb				;AL=i2
	xor	ah,ah			;AX=i2
	imul	convi2			;DX:AX=i2*I%(2)
	add	bx,ax			;BX=accumulator, dismiss DX
	mov	al,ds:[si]		;AL=i3
	xor	ah,ah			;AX=i3
	imul	convi3			;DX:AX=i3*I%(3)
	add	bx,ax			;BX=accumulator, dismiss DX
	add	si,190			;point to i4
	lodsb				;AL=i4
	xor	ah,ah			;AX=i4
	imul	convi4			;DX:AX=i4*I%(4)
	add	bx,ax			;BX=accumulator, dismiss DX
	lodsb				;AL=i5
	xor	ah,ah			;AX=i5
	imul	convi5			;DX:AX=i5*I%(5)
	add	bx,ax			;BX=accumulator, dismiss DX
	mov	al,ds:[si]		;AL=i6
	xor	ah,ah			;AX=i6
	imul	convi6			;DX:AX=i6*I%(6)
	add	bx,ax			;BX=accumulator, dismiss DX
	add	si,190			;point to i7
	lodsb				;AL=i7
	xor	ah,ah			;AX=i7
	imul	convi7			;DX:AX=i7*I%(7)
	add	bx,ax			;BX=accumulator, dismiss DX
	lodsb				;AL=i8
	xor	ah,ah			;AX=i8
	imul	convi8			;DX:AX=i8*I%(8)
	add	bx,ax			;BX=accumulator, dismiss DX
	mov	al,ds:[si]		;AL=i9
	xor	ah,ah			;AX=i9
	imul	convi9			;DX:AX=i9*I%(9)
	add	ax,bx			;AX=sum(i1*I%(1):i9*I%(9))
	sub	si,192			;point to next i5
	mov	bx,convi0		;BX=I%(10)=divisor
	cmp	bx,0			;test divisor zero, contour filters
	jz	convl4			;Mask sum zero: contour filter
	cmp	ax,0			;test sum against 0
	jz	convl2			;prevent division by zero
	js	convl3			;negative sum results in zero
	cwd				;convert to double word DX:AX
	div	bx			;divide
convl1:	cmp	ax,256			;should not exeed 255
	jc	convl2			;if < 256 ok
	mov	al,255			;set to maximum
convl2:	ret
convl3:	xor	al,al			;set to zero
	ret
convl4:	add	ax,128			;rise into positive
	cmp	ax,0			;check for sign bit
	js	convl3			;of still negative
	jmp	short convl1		;check > 255
;
CONVLV	endp
;
;
; SUBROUTINE test wether pixel should be considered or not and if so, copies
;            it into sort-buffer for later treatment. Three consecutive
;            pixels are treated. DS:SI points to left value and points to
;            right one on exit. BX points to convi1/4/7/0, DX to srtbuf.
;----------------------------------------------------------------------------
;
CPYBUF	proc	near
;
	lodsb			;AL=i1/i4/i7
	mov	cx,cs:[bx]	;CX=I%(1)/I%(4)/I%(7)
	inc	bx
	inc	bx		;point to convi2/5/8
	cmp	cl,ch		;CL=0 or 1, CH=0
	jz	cpybu1		;if zero, do not consider pixel
	xchg	bx,dx		;BX=srtbuf
	mov	cs:[bx],al	;keep pixel
	xchg	bx,dx		;BX points to convi2/5/8
	inc	dx		;point to next entry in sort buffer
	inc	ah		;increment byte counter
cpybu1:	lodsb			;AL=i2/i5/i8
	mov	cx,cs:[bx]	;CX=I%(2)/I%(5)/I%(8)
	inc	bx
	inc	bx		;point to convi3/6/9
	cmp	cl,ch		;CL=0 or 1, CH=0
	jz	cpybu2		;if zero, do not consider pixel
	xchg	bx,dx		;BX=srtbuf
	mov	cs:[bx],al	;keep pixel
	xchg	bx,dx		;BX points to convi3/6/9
	inc	dx		;point to next entry in sort buffer
	inc	ah		;increment byte counter
cpybu2:	mov	al,ds:[si]	;AL=i3/i6/i9
	mov	cx,cs:[bx]	;CX=I%(3)/I%(6)/I%(9)
	inc	bx
	inc	bx		;point to convi4/7/0
	cmp	cl,ch		;CL=0 or 1, CH=0
	jz	cpybu3		;if zero, do not consider pixel
	xchg	bx,dx		;BX=srtbuf
	mov	cs:[bx],al	;keep pixel
	xchg	bx,dx		;BX points to convi4/7/0
	inc	dx		;point to next entry in sort buffer
	inc	ah		;increment byte counter
cpybu3:	ret			;3 pixels done
;
CPYBUF	endp
;
;
; SUBROUTINE finds Maximum, Minimum or Median value of pixels found in
;            sort buffer. BX points to srtbuf, CX has number of valid
;            pixel in buffer. DX=-1: Max, DX=0: Min, DX=1:Med
;----------------------------------------------------------------------------
;
FINDMM	proc	near
;
	dec	cx		;counter -1 = pairs to check
	mov	ax,cs:[bx]	;get 2 values
	inc	bx		;point to next item
	cmp	dx,0		;test zero
	jz	findm3		;continue for MINIMUM filter
	cmp	dx,1		;check 1
	jz	sortem		;continue for MEDIAN filter
;
; Maximum filter. Find the highest value in the buffer
;
findm0:	cmp	ah,al		;assume AL > AH
	jc	findm1		;jump if AL > AH
	mov	al,ah		;make AL > AH
findm1:	inc	bx		;point to next pixel
	mov	ah,cs:[bx]	;next value
findm2:	loop	findm0		;check all values for maximum
	ret			;return with AL highest value
;
; Minimum Filter. Find the lowest value in the buffer
;
findm3:	cmp	al,ah		;assume AL < AH
	jc	findm4		;jump if AL < AH
	mov	al,ah		;make AL < AH
findm4:	inc	bx		;point to next pixel
	mov	ah,cs:[bx]	;next value
findm5:	loop	findm3		;check all values for minimum
	ret			;return with AL lowest value
;
; Median Filter. First, all valid values are sorted in ascending order
;
sortem:	push	cx		;will be needed when looking for median
	mov	dx,cx		;DX=number of pairs to sort
	dec	bx		;point to 1st item
sorte0:	push	bx		;save position in buffer
	mov	cx,dx		;get pairs counter
sorte1: inc	bx		;point to next item
	mov	ah,cs:[bx]	;get next value in buffer
	cmp	al,ah		;assume AL < AH
	jc	sorte2		;jump if AH > AL
	xchg	al,ah		;make AH > AL
	mov	cs:[bx],ah	;replace with higher value
sorte2:	loop	sorte1		;repeat for all pairs
	pop	bx		;restore al-pointer
	mov	cs:[bx],al	;replace with lowest value
	inc	bx		;start at next
	mov	al,cs:[bx]	;get next value
	dec	dx		;one pair less
	jnz	sorte0		;repeat for pairs-1
;
; Find median value in buffer with 5 or 9 values and return it in AL
;
	pop	cx			;number of pairs to check
	lea	bx,srtbuf		;start of sort buffer
	shr	cl,1			;divide by 2 = median value
	add	bx,cx			;point to median value
	mov	al,cs:[bx]		;get median value
	ret				;AL=median value
;
FINDMM	endp
;
;
; SUBROUTINE takes frame 2/2 191/164 and copies it to 1/1 192/165.
;            Assumes DS:SI points to 1st element of destination array.
;----------------------------------------------------------------------------
;
CPYFRM	proc	near
;
	push	ds
	push	si
	pop	di
	pop	es			;ES:DI = DS:SI
	mov	cx,192			;192 columns in line 1
	add	si,cx			;source is line 2
	mov	bx,si			;save line 2, column 1
	mov	dx,di			;save line 1, column 1
	add	di,cx			;point to line 2
	mov	cl,163			;163 lines to do
cpyfr1:	inc	si			;point to column 2
	movsb				;copy col.2 to col.1
	add	si,188			;col 3+188=191
	add	di,190			;col 2+190=192
	movsb				;copy col.191 to col.192
	inc	si			;point to column 1
	loop	cpyfr1			;repeat for 163 lines
	mov	cl,192			;192 columns for line 165
	sub	si,cx			;point to line 165, column 1
	rep	movsb			;copy line 164 to line 163
	mov	cl,192			;192 columns for line 1
	mov	si,bx			;point to line 2 column 1
	mov	di,dx			;point to line 1 column 1
	rep	movsb			;copy top line
	ret
;
CPYFRM	endp
;
;
code	ends
	end
;
;=======================-<920815 HoroSoft, CH-3952 Susten>-==================
;
