'960311 1035
' ****************************************************************************
' * PROGRAM NAME: ERROR3  .INC    DATE:  9.10.1991  INCLUDE IN: almost g/p   *
' * LANGUAGE: Power BASIC 3.20   Robert S.Zale                               *
' * PURPOSE: Error list & error handler                                      *
' * INCLUDE FILES: none.                                                     *
' * INPUT FILES: none.                                                       *
' * OUTPUT FILES: none.                                                      *
' * ------------------------------------------------------------------------ *
' * VERSION:  2.32  MAR-96 Added Error Address for Fatal Errors              *
' * ------------------------------------------------------------------------ *
' * VERSION:  2.31  JUN-94 Introduced Version Error3V% = 231                 *
' * ------------------------------------------------------------------------ *
' * VERSION:  2.30  MAR-93 Power BASIC 3.00c                                 *
' * ------------------------------------------------------------------------ *
' * VERSION:  2.20  DEC-91 Power BASIC 2.10e                                 *
' * ------------------------------------------------------------------------ *
' * VERSION:  2.10         Turbo BASIC 1.00e                                 *
' * ------------------------------------------------------------------------ *
' * COMMENTS: Expects flag Chroma%, True=color, False=monochrome             *
' *           Closes files: remove if none open!                             *
' * ======================================================================== *
' * AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
' ****************************************************************************
'
'
Error3V% = 232
'
'
goto SkipError				'if used as include
'
' ERROR HANDLING: Very primitive, but identifies error and aborts in any case.
' ----------------------------------------------------------------------------
'
ErrorHandling:
'
screen 0
if Chroma% then color %LRed else color 25
print
print "* *   F A T A L  E R R O R   /   B  S A R T I G E R  F E H L E R   * *"
print
restore ErrorMessages
do
  read E%,C%,D$
  if (E% = err) or (E% = 999) then exit loop
loop
if Chroma% then color C% else color 9
print D$
print
color %LWhite
print "Offender is probably:    / Schuldiger ist wahrscheinlich:"
print
select case C%
  case = 10
    print "either you or me!        /  entweder Sie oder ich!"
    print "if you:                  /  falls Sie:"
    print "wrong video mode         /  falscher Video Modus"
    print "illegal input            /  illegale Eingabe"
  case = 11
    print "unknown entity!          /  unbekantes Wesen!"
  case = 12
    print "you, the user!           / Sie, als Benutzer(in)!"
  case = 13
    print "possibly the programmer!  /  mglicherweise der Programmierer!"
    print "H.-R.H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland."
  case = 14
    print "the device or hardware!  /  das Gert oder die Hardware!"
end select
print
if Chroma% then color %LRed else color 26
print "* *  ABORT  ON  ERROR    /    ABBRUCH  DURCH  FEHLER"
print
'
A! = errnum
B! = err
C& = eradr
print "Error Number:";A!;" -";B!,"Error Address:";C&
color %White
print
line input "Please press ---> [RET] <--- drcken, bitte ";D$
close
print
system
'
'
' DATA for Error messages
'      Error number, color, english / german
'      Color-key: Pink=programmer, Red=User, Yellow=Device, Cyan=unknown
' ----------------------------------------------------------------------------
'
ErrorMessages:
'
data   0,11,"DOS-access / DOS-Zugriff"
data   1,13,"NEXT without FOR / NEXT ohne FOR"
data   2,13,"wrong datatype in READ / falscher Datentyp bei READ"
data   3,13,"RETURN without GOSUB / RETURN ohne GOSUB"
data   4,13,"out of data / nicht gengend DATA-Elemente"
data   5,10,"illegal function call / illegaler Funktionsaufruf"
data   6,10,"overflow / berlauf"
data   7,12,"out of memory / nicht genug Speicher"
data   8,11,"undefined error / nicht definiert"
data   9,13,"subscript out of range / Index unzulig"
data  10,13,"dublicate definition / doppelte Definition"
data  11,10,"division by zero / Division durch Null"
data  12,11,"undefined Error / nicht definiert"
data  13,13,"type mismatch / unpassender Datentyp"
data  14,12,"out of string space / String Speicher voll"
data  15,13,"string too long / Stringlnge zu gro"
data  16,11,"undefined Error / nicht definiert"
data  17,11,"undefined Error / nicht definiert"
data  18,11,"undefined Error / nicht definiert"
data  19,13,"no RESUME / ON ERROR Routine ohne Abschluss"
data  20,13,"RESUME without error / RESUME ohne vorhergehenden Fehler"
data  21,11,"undefined Error / nicht definiert"
data  22,11,"undefined Error / nicht definiert"
data  23,11,"undefined Error / nicht definiert"
data  24,14,"COM-device time-out / COM-Timeout"
data  25,14,"device fault / Peripherieprobleme"
data  26,11,"undefined Error / nicht definiert"
data  27,14,"printer out of paper / kein Papier im Drucker"
data  28,11,"undefined Error / nicht definiert"
data  50,13,"FIELD overflow / unpassende FIELD-Gre"
data  51,11,"internal error / interner Fehler"
data  52,13,"bad file number / unzulige Dateinummer"
data  53,12,"file not found / Datei nicht gefunden"
data  54,13,"bad file mode, GET$/PUT$ illegal / GET$/PUT$ nicht erlaubt"
data  55,13,"file already open / Datei bereits geffnet"
data  56,11,"Undefined Error / nicht definiert"
data  57,14,"device I/O error / Gerte I/O Fehler"
data  58,12,"file already exists / Dateiname existiert bereits"
data  59,11,"bad record length / falsche Datensatzlnge"
data  60,11,"undefined Error / nicht definiert"
data  61,14,"disk(ette) full / Diskette/Festplatte voll"
data  62,12,"input past end / Dateiende berschritten"
data  63,12,"bad record number / illegale Datensatznummer"
data  64,12,"bad file name / unzuliger Dateiname"
data  65,11,"undefined Error / nicht definiert"
data  66,11,"undefined Error / nicht definiert"
data  67,12,"too many files in root directory / Stamm-Verzeichnis voll"
data  68,14,"device unavailable / Peripheriegert nicht verfgbar"
data  69,14,"COM-buffer overflow / COM-Puffer-berlauf"
data  70,12,"read-only diskette / Diskette schreibgeschtzt"
data  71,12,"disk not ready / Laufwerk nicht bereit"
data  72,14,"disk media error / Spur/Sektor defekt"
data  73,13,"feature unavailable / Erweiterung nicht verfgbar"
data  74,12,"RENAME on across disks / RENAME auf verschiedenen Laufwerken"
data  75,12,"file/path access error / Datei gegen Zugriff gesperrt"
data  76,12,"path not found / Suchweg existiert nicht"
data 201,13,"out of stack space / Stackpuffer voll"
data 202,13,"temporary string memory full / temporrer Stringspeicher voll"
data 203,13,"mismatched common variables / unterschiedliche COMMON-Variablen"
data 204,13,"mismatched program options / unterschiedliche Programmoptionen"
data 205,13,"mismatched program revisions / unterschiedliche Programmversionen"
data 206,12,"invalid program file / unzulige Programm-Datei"
data 207,13,"array static / statische Array"
data 208,13,"invalid string handle / ungltige Stringkennung"
data 209,12,"incompatible mouse driver / unkompatibler Maustreiber"
data 241,13,"far heap corrupt / Heapspeicher korrupt"
data 242,14,"string/array memory corrupt / String/Arrayspeicher zerstrt"
data 243,13,"CHAIN/RUN from EXE-file only / CHAIN/RUN nur von EXE Datei"
data 244,13,"missing library / Bibliothek nicht vorhanden"
data 245,13,"CHAIN/RUN too big / CHAIN/RUN zu gro"
data 256,12,"requires DOS 2.0 or later / bentigt DOS 2.0 oder spter"
data 257,14,"missing numeric coprocessor / kein Koprozessor"
data 258,14,"program too big to fit in memory / Programm zu gro"
data 259,14,"80286/80386 CPU required / bentigt 80286/80386 Prozessor"
data 999,11,"unknown error / gibt's nicht"
'
SkipError:
'
'===============-<End of ERROR3.INC>-==========-<911009 HoroSoft>-===========
'
