'960410 1417
'****************************************************************************
'* PROGRAM NAME: PB3GPUSE.INC    DATE:  9.10.1991   INCLUDE IN: anyprog.BAS *
'* LANGUAGE: Power BASIC 3.00c/3.10 /3.20  (Robert S. Zale)                 *
'* PURPOSE: Power Basic 3.xx General Purpose Use Functions & Procedures.    *
'* INCLUDE FILES: none.                                                     *
'* INPUT FILES: none.                                                       *
'* OUTPUT FILES: none                                                       *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.13 10-APR-96: Added StripSlash$ function                      *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.12 10-OCT-90: Introduced TL$ function from ZX80 times         *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.11 30-SEP-90: Recompiled with PB 3.20                         *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.10  1-JUN-94: Introduced PB3GPUseV-function and RetExt$       *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.09 26-May-94: Introduced JulianDay, modified WeekDay          *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.08  6-May-94: Bugfix in ComLinLan                             *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.07  2-MAR-94: Bugfix in WeekDay                               *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.06  6-FEB-94: Bugfix in ClrLine                               *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.05 15-JAN-94: Bugfix in IOPath$ and IOFile$                   *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.04 14-NOV-93: Added WeekDay function                          *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.03 21-MAY-93: Redid from PB2GPUSE.INC                         *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.02 16-MAR-93: Renamed from FUNCTION to GPFUNCT for PB 3.00a.  *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.01 13-AUG-92: improved AddSlash with l/r-trimming.            *
'* ------------------------------------------------------------------------ *
'* VERSION: 2.00 derived from TurboBASIC 1.00e.                             *
'* ------------------------------------------------------------------------ *
'* COMMENTS: Made a Unit of it (16-MAR-93)                                  *
'* ======================================================================== *
'* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
'****************************************************************************
'
'
$cpu 8086		'works for all computers
'
'
' CONSTANTS
'============================================================================
'
%Black     =  0        'COLORS, dark
%Blue      =  1
%Green     =  2
%Cyan      =  3
%Red       =  4
%Pink      =  5
%Brown     =  6
%White     =  7
%Gray      =  8        'COLORS, light
%LBlue     =  9
%LGreen    = 10
%LCyan     = 11
%LRed      = 12
%LPink     = 13
%Yellow    = 14
%LWhite    = 15
'
%True      = -1        'LOGIC
%False     =  0
'
'
' FUNCTION returns Version number x 100
'    V% = PB3GPUseV%
'----------------------------------------------------------------------------
'
function PB3GPUseV%() public
  PB3GPUseV% = 213
end function
'
'
'FUNCTION returns PowerBASIC version as integer, e.g. 320 for 3.20. The
'         string variable SV$ returns the subrevision letter, e.g. " "
'         Tested with PB 3.10 and PB 3.20 - 30.Sept.95
' Usage: PRINT PBVer%(SV$);SV$
'----------------------------------------------------------------------------
'
function PBVer%(SV$) public
  SV$ = chr$(pbvRevltr)
  PBVer% = val(hex$(pbvRevision))
end function
'
'
' FUNCTION waits until either ESC or RET key is pressed and returns
'          True if ESC, or False if RET was pressed.
'  Usage: if EscRet% then print "You've pressed the Escape-Key"
'----------------------------------------------------------------------------
'
function EscRet% public
  local A$
  A$ = ""
  do
    A$ = inkey$
    if A$ = chr$(13) then
      EscRet% = %False
      exit loop
    end if
    if A$ = chr$ (27) then
      EscRet% = %True
      exit loop
    end if
  loop
end function
'
'
' FUNCTION  adds a Backslash to a dir-spec string if there is none yet.
'           Can be used for Path formatting.
'  Usage: UsePath$ = AddSlash$(RawPath$)
'----------------------------------------------------------------------------
'
function AddSlash$(DirSpec$) public
  local A$,B$
  A$ = DirSpec$
  B$ = ltrim$(A$)
  A$ = rtrim$(B$)
  if not A$ = "" then
    if not right$(A$,1) = "\" then
      A$ = A$ + "\"
    end if
  end if
  AddSlash$ = ucase$(A$)
end function
'
'
' FUNCTION returns from A$ a string without a terminating slash
'   This is the inverse of AddSlash
'----------------------------------------------------------------------------
'
function StripSlash$(A$) public
  local Z$
  Z$ = A$
  if right$(A$,1) = "\" then Z$ = left$(A$,len(A$)-1)
  StripSlash$ = Z$
end function
'
'
' FUNCTION centers Text$ to MaxCol%. Left and right edges are filled
'          with blanks. If length of Text$ exeeds MaxCol%, it is
'          trunctated to MaxCol%.
'  Usage: print Center$("HoroSoft",80);
'----------------------------------------------------------------------------
'
function Center$(Text$,MaxCol%) public
  local SL%,FC%,U$,I$
  U$  = Text$
  SL% = len(U$)
  FC% = MaxCol% - SL%
  if FC% < 0 then
    U$ = left$(Text$,MaxCol%)
    FC% = 0
  end if
  I$ = space$(FC% / 2) + U$ + space$(MaxCol%)
  Center$ = left$(I$,MaxCol%)
end function
'
'
' FUNCTION prints logon bar, starting at screen bottom and moving up to
'          the top. Color is set to 5, 1 and color the white, black.
'          LogOn$ makes use of Center$-function.
'  Usage: print LogOn$(Version$,FG%,BG%); <-- note semi-colon!
'----------------------------------------------------------------------------
'
function LogOn$(Version$,F%,B%) public
  cls
  FL% = F% + 8
  color F%,B%
  print " ";string$(76,"");" ";
  print " ";
  color FL%,B%
  print Center$(Version$,76);
  color F%,B%
  print " ";
  print " ";string$(76,"");" ";
  color 7,0
  locate 5,1
  LogOn$ = ""
end function
'
'
' FUNCTION returns normalized date for continental Europe if LFlag%
'          False, if True for English speaking countries.
'  Usage: print DateNorm$(%English)
'----------------------------------------------------------------------------
'
MonthTable:
data Januar,Februar,Mrz,April,Mai,Juni,Juli
data August,September,Oktober,November,Dezember
data January,February,March,April,May,June,July
data August,September,October,November,December
'
function DateNorm$(LFlag%) public
  local D$,M$,Y$,A$,A%,N%
  D$ = date$
  A% = val(left$(D$,2))
  if LFlag% then A% = A% + 12
  restore MonthTable
  for N% = 1 to A%
    read M$
  next N%
  Y$ = right$(D$,4)
  A% = val(mid$(D$,4,2))
  D$ = right$(ltrim$(space$(2) + str$(A%)),2)
  DateNorm$ = D$ + "." + M$ + space$(1) + Y$
end function
'
'
' FUNCTION returns Julian Day number.
'          DY% = DateYear, DM%=DateMonth,  DD%=DateDay
'          TH% = TimeHour, TM%=TimeMinute, TS%=TimeSecond in UTC!
'  Usage: JulDay# = JulianD#(DY%,DM%,DD%,TH%,TM%,TS%)
'----------------------------------------------------------------------------
'
function JulianDay#(DY%,DM%,DD%,TH%,TM%,TS%) public
  local B%,JD0#,UT!
  if DM% <= 2 then
    decr DY%
    DM% = DM% + 12
  end if
  B% = int(DY% / 400) - int(DY% / 100)
  if ((DY% = 1582) and (DM% = 10) and (DD% < 5)) then B% = -2
  JD0# = int(365.25 * DY%) + int(30.60001 * (DM% + 1)) + B% + 1720996 + DD%
  UT! = TS% / 3600 + TM% / 60 + TH%
  JulianDay# = JD0# + UT! / 24
end function
'
'
' FUNCTION returns weekday in German if LFlag% is False, if True in English
'          Calculates Julian Day number first from system date.
'  Usage: print WeekDay$(%English)
'----------------------------------------------------------------------------
'
DayTable:
data Tuesday,Wednesday,Thursday,Friday,Saturday,Sunday,Monday
data Dienstag,Mittwoch,Donnerstag,Freitag,Samstag,Sonntag,Montag
'
function WeekDay$(LFlag%) public
  local D%,J%,M%,N%,Y%,B%,JD0#,J&,D$
  D$ = date$
  M% = val(left$(D$,2))
  D% = val(mid$(D$,4,2))
  Y% = val(right$(D$,4))
  JD0# = JulianDay#(Y%,M%,D%,0,0,0)
  J& = int  (JD0# / 7)
  J% = int(((JD0# / 7 - J&) * 7) + 1.0005)
  if not LFlag% then J% = J% + 7
  restore DayTable
  for N% = 1 to J%
    read D$
  next N%
  WeekDay$ = D$
end function
'
'
' FUNCTION  waits until a key is pressed and returns it in uppercase.
'  Usage: A$ = KeyIn$
'-----------------------------------------------------------------------------
'
function KeyIn$ public
  while not instat
  wend
  KeyIn$ = ucase$(inkey$)
end function
'
'
' FUNCTION returns True for English and False for German. If command line
'          C$ is empty, queries. V$ holds a small description.
'  Usage: English% = ComLinLan%(command$,Version$)
'-----------------------------------------------------------------------------
'
function ComLinLan%(C$,V$) public
  local A%,B%,C%,A$,B$
  B$ = ucase$(C$)
  print LogOn$(V$,%White,%Black)
  locate 10,1
  B% = 1
  A% = instr(1,B$,"-E")
  C% = instr(1,B$,"/E")
  if A% > 0 or C% > 0 then B% = -1
  A% = instr(1,B$,"-D")
  A% = instr(1,B$,"/D")
  if A% > 0 or C% > 0 then B% = 0
  if B% = 1 then
    B$ = "Language Selection:  [RET] = English  -  [ESC] = German"
    print Center$(B$,80)
    B$ = "Sprach Wahl:  [ESC] = Deutsch  -  [RET] = Englisch"
    print Center$(B$,80)
    B% = not EscRet%
  end if
  cls
  ComLinLan% = B%
end function
'
'
' FUNCTION returns a validated Path. P$ holds the prompting message, D$ the
'          default path when RET is pressed and T$ a yes/no prompt used in
'          ValidFlg function. P$ is printed at the current cursor position.
'          The cursor position is set to column 1 of the next line.
'  Usage: UsePath$ = IOPath$("Enter Path:",curdir$,"RET=ok, ESC=redo")
'----------------------------------------------------------------------------
'
function IOPath$(P$,D$,T$) public
  local Y0?,X0?,X1?,A$,B$,Q$
  Y0? = csrlin
  X0? = pos(Y0?)
  color %LCyan,%Black
  print P$;" ";
  X1? = pos(Y0?)
  do
    locate Y0?,X1?
    color %Brown,%Black
    print D$;
    call ClrLine
    color %Yellow,%Black
    locate Y0?,X1?
    line input Q$
    locate Y0?,X1?
    if Q$ = "" then Q$ = D$
    A$ = ltrim$(rtrim$(Q$))
    if right$(A$,1) = "\" then A$ = left$(A$,len(A$)-1)
    print A$;
    call ClrLine
    locate Y0?,X1?
    if Confirm%(T$) then exit loop
  loop
  B$ = AddSlash$(A$)
  color %Cyan,%Black
  locate Y0?,X0?
  print P$;" ";
  color %LCyan,%Black
  print B$
  color %White,%Black
  call ClrLine
  IOPath$ = B$
end function
'
'
' FUNCTION prompts in language L% (True=English, False=Deutsch) for a file-
'          name with (F%=True) or without (F%=False) file extension. The
'          filename is returned in uppercase with or without extension (F%).
'  Usage: FileName$ = IOFile$(English%,%True,"[RET]=ok, [ESC]=redo")
'----------------------------------------------------------------------------
'
function IOFile$(L%,F%,T$) public
  local Y0?,X0?,X1?,A$,B$,C$,D$,Q$,I$
  Y0? = csrlin
  X0? = pos(Y0?)
  A$ = "File to open with"
  B$ = "out"
  C$ = " filetyp"
  if F% then B$ = ""
  if not L% then
    A$ = "Datei zu ffnen "
    B$ = "ohne"
    C$ = " Dateierweiterung"
    if F% then B$ = "mit"
  end if
  D$ = A$ + B$ + C$ + ": "
  color %LCyan,%Black
  print D$;
  X1? = pos(Y0?)
  do
    call ClrLine
    color %Yellow,%Black
    line input Q$
    A$ = ltrim$(rtrim$(Q$))
    if F% then I$ = ucase$(A$) else I$ = StripExt$(A$)
    locate Y0?,X1?
    print I$;
    call ClrLine
    locate Y0?,X1?
    if Confirm%(T$) then exit loop
  loop
  locate Y0?,X0?
  color %Cyan,%Black
  print D$;" ";
  color %LCyan,%Black
  print I$
  color %White,%Black
  call ClrLine
  IOFile$ = I$
end function
'
'
' FUNCTION  Preserves current cursor position and prints on the line below
'           T$ in light cyan. Waits until either ESC or RET is pressed and
'           returns True for RET and False for ESC. The text is cleared
'           and the cursor position is restored.
'  Usage: if Confirm%("ESC=Not Ok, RET=Continue")
' ---------------------------------------------------------------------------
'
function Confirm%(T$) public
  local Y0?,X0?,Y1?,X1?
  Y0? = csrlin
  X0? = pos(Y0?)
  print
  Y1? = csrlin
  X1? = pos(Y1?)
  color %LCyan,%Black
  print T$;
  color %White,%Black
  Confirm% = not EscRet%
  locate Y1?,X1?
  call ClrLine
  locate Y0?,X0?
end function
'
'
' FUNCTION  Preserves current cursor position and prints on the line below
'           T$ in light white on red. Waits until either ESC or RET is
'           pressed and returns True for RET and False for ESC. The text is
'           cleared and the cursor position is restored.
'  Usage: if Redo%("RET=Redo - ESC=Abort")
' ---------------------------------------------------------------------------
'
function Redo%(T$) public
  local Y0?,X0?,Y1?,X1?
  Y0? = csrlin
  X0? = pos(Y0?)
  print
  Y1? = csrlin
  X1? = pos(Y1?)
  color %LWhite,%Red
  print T$;
  color %White,%Black
  Redo% = not EscRet%
  locate Y1?,X1?
  call ClrLine
  locate Y0?,X0?
end function
'
'
' FUNCTION lists available files. If there are files available in directory
'          D$ with file extension E$, a list is printed in green and the flag
'          set to True, else it is set to false and an appropriate info is
'          issued according to L% (True for English, False for Deutsch).
'  Usage: Flag% = ListFiles%(curdir$,"*",English%)
' ----------------------------------------------------------------------------
'
function ListFiles%(D$,E$,L%) Public
  local A$,B$
  B$ = D$ + "*." + E$
  A$ = dir$(B$)
  if L% then
    print "Available/Used Filenames: ";
  else
    print "Verfgbare/Benutzte Dateien: ";
  end if
  if not A$ = "" then
    print
    color %Green,%Black
    files B$
    ListFiles% = %True
  else
    color %LWhite,%Red
    if L% then print " > None Available "; else print " > Keine Verfgbar ";
    color %LWhite,%Green
    if L% then print " None Used < " else print " Keine Benutzt < "
    ListFiles% = %False
  end if
  color %White,%Black
  print
end function
'
'
' FUNCTION strips file extension. Full name has either a full valid
'          filename.typ or only filename. Returned is filename only.
'  Usage: Filename$ = StripExt$(FullFilename$)
'----------------------------------------------------------------------------
'
function StripExt$(F$) public
  local A%,A$
  A$ = F$
  A% = instr(F$,".")
  if not A% = 0 then A$ = left$(F$,A%-1)
  StripExt$ = ucase$(A$)
end function
'
'
' FUNCTION returns file extension from a full filename.
'  Usage RetExt$(F$)
'----------------------------------------------------------------------------
'
function RetExt$(F$) public
  local A%,A$
  A$ = F$ + space$(3)
  A% = instr(F$,".")
  if not A% = 0 then A$ = mid$(F$,A%+1,3) else A$ = space$(3)
  RetExt$ = ucase$(A$)
end function
'
'
' FUNCTION returns True if file can be found, otherwise false.
'  Usage: if FileHere% then open F$ for input as # 1
'----------------------------------------------------------------------------
'
function FileHere%(F$) public
  if not dir$(F$) = "" then FileHere% = %True else FileHere% = %False
end function
'
'
' FUNCTION opens file with full filespecs in P$, compares size against S&
'          and returns true if they are the same. The file is closed
'          thereafter.
'  Usage: if SizeOk%("C:\TEMP-BUF\TEST.BAS",16384& then print "OK"
'----------------------------------------------------------------------------
'
function SizeOk%(F$,S&) public
  local A%,V&
  A% = freefile
  open F$ for binary as # A%
  V&= lof(A%)
  close A%
  if V& = S& then SizeOk% = %True else SizeOk% = %False
end function
'
'
' FUNCTION formats a byte-integer into an 8-character binary string.
'  Usage: print ByteBin$(187%)
'----------------------------------------------------------------------------
'
function ByteBin$(Z%) public
  local A$
  If Z% < 256 then A$ = "00000000" else A$ = "++++++++"
  ByteBin$ = right$(A$+bin$(Z%),8)
end function
'
'
' FUNCTION prints T$ in light cyan, queries for option, resets cursor and
'          color to cyan.
'          Usage: A% = SelOpt%("> Enter Number: ")
'-----------------------------------------------------------------------------
'
function SelOpt%(T$) public
  local Q$,X?,Y?
  Y? = csrlin
  X? = pos(Y?)
  locate Y?,1
  call ClrLine
  color %LCyan,%Black
  print T$;
  color %Yellow,%Black
  line input "";Q$
  locate Y?,1
  color %Cyan,%Black
  print T$;
  locate Y?,X?
  SelOpt% = val(Q$)
end function
'
'
' FUNCTION  Echoes A$ at current cursor position in yellow on read, beeps
'           and returns in white on black. Use it in a loop.
'           Use as: Print Ouch$(A$)
'----------------------------------------------------------------------------
'
function Outch$(A$) public
  color %Yellow,%Red
  print A$;
  color %White,%Black
  beep
end function
'
'
' FUNCTION  puts V% into low/high limit of L%, H%
'----------------------------------------------------------------------------
'
function IntLmt%(L%,H%,V%) public
  local A%
  A% = V%
  if V% < L% then A% = L%
  if V% > H% then A% = H%
  IntLmt% = A%
end function
'
'
' FUNCTION returns leftmost character of T$ and removes that character
'          from T$. If T$=Null$, TL$=Null$.
'          TL$ = Truncate Length. From SinclairBASIC ZX80.
' Usage: while not A$="":print TL$(A$):wend
'----------------------------------------------------------------------------
'
function TL$(T$) public
  local A%
  A% = len(T$)
  select case A%
    case 0
      T$ = ""
      A$ = ""
    case 1
      A$ = T$
      T$ = ""
    case else
      A$ = left$(T$,1)
      T$ = right$(T$,A%-1)
  end select
  TL$ = A$
end function
'
'
' PROCEDURE clears from the current cursor position the rest of the line.
'           Is non-destructive for the current cursor position.
'  Usage: print A$; : call ClrLine
'----------------------------------------------------------------------------
'
sub ClrLine public
  local Y?,X?,X0?
  Y? = csrlin
  X? = pos(Y?)
  X0? = 80 - X?
  locate Y?,X?
  incr X0?
  print space$(X0?);
  locate Y?,X?
end sub
'
'
' PROCEDURE echoes illegal input in Q$ and writes text in T$ in yellow on
'           red on the next line. After a beep, 1 second is waited, the
'           warning erased and the cursors reset to their initial position.
'  Usage: call Illegal(Query$,"< Illegal Input. Repeat!")
'----------------------------------------------------------------------------
'
sub Illegal(Q$,T$) public
  local Y?,X?,Z?
  Y? = csrlin
  X? = pos(Y?)
  print
  color %Yellow,%Red
  print " >";Q$;T$;
  Z? = csrlin
  beep
  delay 1
  locate Z?,1
  color %White,%Black
  call ClrLine
  locate Y?,X?
end sub
'
'
'=====================-<End of PB3GPUSE.INC>-=========-<911010 HoroSoft>-====
'
