;930521 1007
;****************************************************************************
;* PROGRAM NAME: PBSTACK. ASM   DATE: 18. 3.1993    LINK INTO: all    .BAS  *
;* LANGUAGE: Turbo Assembler TASM 1.0 or Microsoft Assembler MASM 5.0       *
;* PURPOSE: Far Procedures to save and restore PB 2.10a environment.        *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION: 1.00 18-MAR-93:                                                 *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Assembly objects to access these: *
;*             = extrn  PBASTK:far                                          *
;*             = extrn  BAKBAS:far                                          *
;*              call   PBASTK                                              *
;*              jmp    BAKBAS (BL = # of parameters)                       *
;*           Assemble this routine using TASM as:                           *
;*             = TASM PBSTACK                                               *
;* -------------------------------------------------------------------------*
;* NOTE: SS and SP registers are not saved. Do not use them!                *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
code	segment	byte
	assume	cs:code
;
; PROCEDURE  saves environment of Power BASIC, resets the direction flag to
;            ascending and sets stack such that BP+6 accesses right-most
;            parameter.
;            On Exit: DS:SI points to right-most parameter
;                     CX    holds right-most parameter
;----------------------------------------------------------------------------
;
PBASTK	proc	far
	public	PBASTK
;
	pop	bx			;get segment of return address
	pop	ax			;get return address
	push	bp			;save base pointer
	mov	bp,sp			;get stack pointer position
	push	ds			;save data segment
	push	di			;save dest index
	push	si			;save srce index
	pushf				;save flags
	cld				;clear direction flag - ascending
	lds	si,[bp+6]		;DS:SI point to parameter
	mov	cx,ds:[si]		;CX is parameter
	push	ax			;push return address
	push	bx			;push return segment
	retf				;back to far caller
;
PBASTK	endp
;
;
; PROCEDURE is extension of PBASTK. The Power Basic 2.10a environment is
;           restored. DX:AX may hold double word for functions.
;           On Entry: BL = number of parameters to remove (0...7)
;----------------------------------------------------------------------------
;
BAKBAS	proc	far
	public	BAKBAS
;
	popf				;restore flags
	pop	si			;restore srce index
	pop	di			;restore dest index
	pop	ds			;restore data segment
	pop	bp			;restore base pointer
	xor	ch,ch			;clear CH
	mov	cl,bl			;get number of parameters
	jcxz	ba0bas			;if no parameter, jump
	dec	cl			;one parameter less
	dec	bl			;one parameter less
	add	cl,cl			;*2
	add	cl,bl			;*3 - 3 bytes for RETF param opcode
	lea	bx,baxbas		;get address of list start
	add	bx,cx			;BX = jump address
	jmp	bx			;jump to exit
baxbas:	retf	 4			;1 param
	retf	 8			;2 params
	retf	12			;3 params
	retf	16			;4 params
	retf	20			;5 params
	retf	24			;6 params
	retf	28			;7 params
ba0bas:	retf				;0 params
;
BAKBAS	endp
;
code	ends
	end
;
;=======================-<930318 HoroSoft, CH-3952 Susten>-==================
;