;940605 0908
;****************************************************************************
;* PROGRAM NAME: RLCEGEN .ASM   DATE:  3.10.1992    LINK INTO: any     .BAS *
;* LANGUAGE: Turbo Assembler TASM 2.01                                      *
;* PURPOSE:  RLCE encoding and decoding generator                           *
;* INCLUDE FILES: none.                                                     *
;* OBJECT FILES:  none.                                                     *
;* INPUT FILES:   none.                                                     *
;* OUTPUT FILES:  none.                                                     *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.05 31-MAY-94 Completely re-done encoder. Incomprehensible    *
;*                behavours in older version - sometimes ok, sometimes not. *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.04 30-MAY-94 Severe bugs fixed in encoder. Bug fix V.1.03    *
;*                could be reverse-engineered. Encoder starts assuming      *
;*           first two bytes do not match. Now they may or may not.         *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.03  9-FEB-94 Bug fix in encoder. First byte becomes same     *
;*                 value as second byte. Since encoder starts assuming      *
;*           the first two bytes match, so they must be made to.            *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.02 30-DEC-93 Added EGA video copy options                    *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.01 27-DEC-93 Scheme works smoothly!                          *
;* ------------------------------------------------------------------------ *
;* VERSION:  1.00 25-DEC-93 Start of Labour.                                *
;* ------------------------------------------------------------------------ *
;* COMMENTS: Write the following lines in Power BASIC 3.00c                 *
;*            = declare functiom VidAry??(byte,byte,word)                   *
;*            = declare function AryVid??(byte,byte)                        *
;*            = declare function RLCEGENV%()                                *
;*            = declare function EncBie%(integer,integer,word)              *
;*            = declare function DecBie%(integer,integer)                   *
;*            = declare function WrBie%(integer,integer)                    *
;*            = declare function RdBie%(integer,integer,word)               *
;*            = declare sub VidAry(integer)                                 *
;*            = $link "RLCEGEN.OBJ"   and PBSTACK.OBJ !!                    *
;*           Assemble this routine using TASM as:                           *
;*             = TASM RLCEGEN                                               *
;* NOTE: The right most variable is on top of the stack (LIFO)!             *
;* ------------------------------------------------------------------------ *
;* RLCE Run Length Count Encoding Data Format                               *
;*  Filesize: Variable, max 5 bytes more than actual data - 65560           *
;*   First  2 bytes: Integer: absolute file size, including these two       *
;*   Second 2 bytes: Integer: data size uncompressed                        *
;*     Third byte : Multi-Purpose Counter (MPC)                             *
;*  MPC: Bits 0 to 6: Counter 1 to 127                                      *
;*       Bit 7                                                              *
;*           0 = If Bits 0 - 6 = 0: Uncompressed Data File                  *
;*                  within data: error - illegal condition                  *
;*           0 =  else : <counter> bytes to be copied, uncompressed         *
;*           1 = If Bits 0 - 6 = 0: illegal condition - error               *
;*           1 =  else : following byte to be replicated <counter> times    *
;* ------------------------------------------------------------------------ *
;* >>> This Generator can be used for other purposes as well <<<            *
;*  The name BIE was originaly coined for Byte-Image-Encoded. This scheme   *
;*  works now for any data with a size < 65531.                             *
;* ======================================================================== *
;* AUTHOR: Hans-Ruedi H. Wernli, Pletschgasse, CH-3952 Susten, Switzerland. *
;****************************************************************************
;
;
; CONSTANTS DEFINITIONS - They are of global use
;----------------------------------------------------------------------------
;
dos	equ	   33			;DOS Function Interrupt 21h
readf	equ	   63			;DOS Function 3Fh Read
writef	equ	   64			;DOS Function 40h Write
vidseg	equ	40960			;EGA/VGA segment address
;
;
; EXTERNALS DEFINITIONS
;----------------------------------------------------------------------------
;
	extrn	pbastk:far		;save PB environment
	extrn	bakbas:far		;restore PB environment
;
;
; GENERAL DEFINITION
;----------------------------------------------------------------------------
;
code	segment	byte
	assume	cs:code
;
;
varmax	dw	0			;max size
;
;
; VERSION
;============================================================================
;
; FUNCTION returns Version of this package in decimal x 100
;     V% = RLCEGENV%
;----------------------------------------------------------------------------
;
RLCEGENV	proc	far
		public	RLCEGENV
;
                call	pbastk
		mov	ax,106		;V.1.06
		xor	bl,bl
                jmp	bakbas
;
RLCEGENV	endp
;
;
; PROCEDURES
;============================================================================
;
; FUNCTIONS
;============================================================================
;
; FUNCTION  gets white-plane from EGA/VGA video memory and encodes it
;           directly into WDD. Actually, only the stack is prepared so that
;           procedure EncBie can take over. The function returns the
;           data length. X? is just a dummy address, replaced by Video addr.
;     D?? = VgaAry(WDD?(1,1),X?,VSize??)
;----------------------------------------------------------------------------
;
VIDARY	proc	far
	public	VIDARY
;
	call	pbastk			;CX = VSize??
        xor	ax,ax			;EGA/VGA video offset address
        mov	[bp+10],ax              ;source offset onto stack
        mov	ax,vidseg		;EGA/VGA video segment
        mov	[bp+12],ax		;source segment onto stack
	jmp	encbi0			;encode
;
VIDARY	endp
;
;
; FUNCTION  puts white-plane into EGA/VGA video memory by decoding it
;           directly from WDD. Actually, only the stack is prepared so that
;           procedure DecBie can take over. The function should return 0.
;           X? is just a dummy address, replaced by Video addr.
;     D?? = AryVga(X?,WDD?(1,1))
;----------------------------------------------------------------------------
;
ARYVID	proc	far
	public	ARYVID
;
	call	pbastk			;we do not need X% here
        xor	ax,ax			;EGA/VGA video offset address
        mov	[bp+10],ax              ;destination offset onto stack
        mov	ax,vidseg		;EGA/VGA video segment
        mov	[bp+12],ax		;destination segment onto stack
	jmp	decbi0			;decode
;
ARYVID	endp
;
;
; FUNCTION  encodes data from array CCB% the array CCA% which must have a
;           size of Elements% + 5 bytes. If resulting filesize is greater
;           then Elements+5, data will be stored uncompressed.
;           GetVGA jumps to label EncBi0 after arranging stack.
;     Factor! = EncBIE%(CCB%(1),CCA%(1),Elements??) / Elements??
;----------------------------------------------------------------------------
;
ENCBIE	proc	far
	public	ENCBIE
;
	call	pbastk			;CX = Elements?? - byte counter (BC)
encbi0:	mov	ax,cx			;AX = BC
        lds	si,[bp+10]		;(DS:SI) = (CCA%(1)) = srce ptr
        les	di,[bp+14]		;(ES:DI) = (CCB%(1)) = dest ptr
        stosw				;dummy filesize = BC
        stosw				;actual data size = BC
        add	ax,di			;max filesize-1 for compressed
        mov	varmax,ax		;store max size for compressed
;
; Copy-Decider. This part counts number of different bytes in a row until
; either two similiar bytes are found next to each other, or all bytes
; have been scanned.
;
enccd0:	xor	dx,dx			;reset CC (Copy Counter)
enccd1:	lodsb				;AL=reference byte, SI+1
	mov	ah,ds:[si]		;AH=compare byte : next byte
        cmp	al,ah			;check match
        jz	enccb0			;if match, copy CC bytes
        inc	dx			;CC+1
        dec	cx			;BC-1
        jnz	enccd1			;repeat until BC=0 or match
;
; Unmatching bytes are copied. They get a counter-byte in front of them
; If the filesize would be longer when compressed than if not, the bytes
; are just copied. Program continues at 'ENCSO' store only in that case.
; Otherwise, matching bytes are searched for in Replica Decider.
;
enccb0:	mov	ax,dx			;get CC
	shl	ax,1			;CC * 2
        mov	al,ah			;calculate number of counter bytes
        xor	ah,ah			; that have to be inserted along
        add	ax,3			; with bytes. Good up to 32767
        add	ax,dx			;add number of bytes to copy
        cmp	varmax,ax		;check size overrun
        jnc	enccb1			;compress if  varmax
        jmp	encso0			;store only, compression > non comp.
enccb1:	cmp	cx,0			;all bytes compared?
	jz	enccb2			;if yes, skip
        dec	si			;point to 1st match byte
enccb2:	sub	si,dx			;point to 1st un-matching byte
	push	cx			;save BC
        xor	cx,cx			;CX = multiple-127 counter
enccb3:	cmp	dx,128			;CC > 127?
	jc	enccb4			;if CC [0;127], continue below
        sub	dx,127			;divide CC by 127 old-fashion
        inc	cx			;CX = CC  \  127
        jmp	short enccb3		;DX = CC mod 127
enccb4:	jcxz	enccb6			;if CC \ 127 = 0
	mov	bx,cx			;BX = multiple-127 counter
        mov	ax,127			;AL = counter byte: 127
enccb5:	mov	cx,ax			;CX = 127: counter for byte copy
	stosb				;insert counter byte
        rep	movsb			;copy 127 bytes
        dec	bx			;multiple-127 counter minus one
        jnz	enccb5			;repeat
enccb6:	cmp	dx,0			;check CC mod 127 = 0
	jz	enccb7			;CC mod 127 = 0
        mov	al,dl			;get CC mod 127, i.e. rest
        xor	ah,ah			;make AX = CC mod 127
        mov	cx,ax			;CX = repetition counter
        stosb				;insert copy counter
        rep	movsb			;copy remaining bytes
enccb7:	pop	cx			;restore CC
	cmp	cx,0			;check if all done
        jnz	encrd0			;no, decide replicate
        jmp	encend			;all done
;
; Replica-Decider counts number of subsequent similiar bytes until either
; two different bytes are found or all bytes have been scanned.
;
encrd0: xor	dx,dx			;reset RC (Replicate Counter)
encrd1:	lodsb				;AL=reference byte
	mov	ah,ds:[si]		;AH=compare byte : next byte
        cmp	al,ah			;check match
        jnz	encrc0  		;if not match, replicate RC bytes
        inc	dx			;RC+1
        dec	cx			;BC-1
        jnz	encrd1  		;repeat until BC=0 or non-match
;
; The similiar bytes are stored. There is only a counter-byte and a
; sample of the byte that has to be replicated by the decoder. If only
; two bytes are equal, they are compressed anyway. A look-ahead is
; performed to assure the byte-pair(s) to be stored do not overrun the
; prescribed filesize. If they would, all data is just copied without
; compression. In this case, the program would continue at label ENCSO.
; Otherwise, non-matching bytes are searched for in Copy Decider.
;
encrc0:	cmp	cx,0			;last byte reached?
        jz	encrc1			;yes, skip
	inc	dx			;RC+1 one match more
        dec	cx			;BC-1 one byte less
encrc1:	mov	bx,dx			;get RC
        shl	bx,1			;calculate number of bytes nrrded
        shl	bh,1			; in dest to store these replica
        mov	bl,bh			; actually RC / 127 * 2
        xor	bh,bh			; + 2 for remaining
        add	bx,8			;good for up to 32767 datasize
        add	bx,di			;calculate expected dest
        cmp	varmax,bx		;check if overrun is to be expected
        jnc	encrc2			;if new dest  varmax, compress
        jmp	encso0			;excess filesize: store only
encrc2:	push	cx			;save BC
	mov	ah,al			;AH = byte to replicate
        xor	cx,cx			;reset multiple-127 counter
encrc3:	cmp	dx,128			;RC > 127?
	jc	encrc4			;if RC [0;127], continue below
        sub	dx,127			;divide RC by 127 old-fashion
        inc	cx			;CX = RC  \  127
        jmp	short encrc3		;DX = RC mod 127
encrc4:	jcxz	encrc5			;if RC \ 127 = 0
	mov	al,255			;set bit-7 + 127
        rep	stosw			;AL = counter, AH = byte to replicate
encrc5:	cmp	dx,0			;check RC mod 127 = 0
	jz	encrc6			;if RC mod 127 = 0
        mov	al,dl			;get counter
        or	al,128			;set bit-7
        stosw				;AL = counter, AH = byte to replicate
encrc6:	pop	cx			;restore BC
	cmp	cx,0			;check all done
        jz	encend			;if all done
        jmp	enccd0			;continue finding unmatching bytes
;
; Would the data be compressed, the filesize would exeed the one would the
; bytes just be stored without compression. This is of course of no use.
; Hence, the data is just copied.
;
encso0:	lds	si,[bp+ 6]		;(DS:SI) = (Elements??)
	mov	cx,ds:[si]		;CX = Elements??
        lds	si,[bp+10]		;(DS:SI) = (CCA%(1)) = srce ptr
        les	di,[bp+14]		;(ES:DI) = (CCB%(1)) = dest ptr
        add	di,4			;skip filesize and datasize
        xor	al,al			;no compression flag
        stosb				;store flag
        rep	movsb			;copy all bytes
;
; This is the end. Just insert the actual filesize at address 0 and 1
; relative to the start of the file. The WrtBie function reads this to
; determine, how many bytes have to be written to the file.
; The Decoder needs this value as well to know how many bytes there are
; to decode to prevent array overrun and program crash.
;
encend:	mov	ax,di			;get end pointer - to be returned
        les	di,[bp+14]		;(ES:DI) = (CCB%(1)) = dest ptr
        stosw				;insert actual filesize
	mov	bl,3			;3 parameter
	jmp	bakbas
;
ENCBIE	endp
;
;
; FUNCTION decodes data from array CCB% the array CCA% which must have a
;          size of Elements% + 5 bytes. Returns 0 if ok, else difference
;          of data bytes expected and decoded
;           PutVGA jumps to label DecBi0 after arranging stack.
;     if not DecBIE%(CCA%(1),CCB%(1)) then ok
;----------------------------------------------------------------------------
;
DECBIE	proc	far
	public	DECBIE
;
	call	pbastk			;(DS:SI) = (CCB%(1))
decbi0:	les	di,[bp+10]		;(ES:DI) = (CCA%(1))
        lodsw				;AX = filesize
        lodsw				;AX = data size
        mov	dx,ax			;DX = data size
        mov	al,ds:[si]		;AL = MPC
        cmp	al,0			;if 0, not compressed
        jnz	decbi1			;compressed, jump
        inc	si			;point to 1st data byte
        mov	cx,dx			;get data size
        rep	movsb			;uncompressed copy
        mov	dx,cx			;bytes remaining
        jmp	short decbi3
decbi1:	lodsb				;AL = MPC
	mov	ah,al			;copy
        and	ah,128			;isolate bit 7
        jz	decbi2
        and	al,127			;isolate counter
        jz	decbi3			;error condition
        xor	ah,ah
        mov	cx,ax			;CX = replica counter
        lodsb				;get byte to replicate
	mov	ah,255			;-1 = replicate
        call	chkend			;check end
        jc	decbi3			;all done
        rep	stosb			;copy it
        jmp	short decbi1		;until all done
decbi2:	and	al,127			;isolate copy counter
	jz	decbi3			;error condition
        xor	ah,ah
        mov	cx,ax			;CX = copy counter
	mov	ah,0			;0 = copy
        call	chkend			;check if end reached
        jc	decbi3			;all done
        rep	movsb			;copy bytes
        jmp	short decbi1		;until all done
decbi3: mov	ax,dx			;DX should be zero
	mov	bl,2			;2 parameter
	jmp	bakbas
;
DECBIE	endp
;
;
; FUNCTION writes BIE-File. It is assumed as open. Handle% has the DOS
;          handle and CCA% the data to be written.
;          WrBie% returns zero if ok, else DOS error code
;    if not WrBie%(CCA%(1),Handle%) then ok
;----------------------------------------------------------------------------
;
WRBIE	proc	far
	public	WRBIE
;
	call	pbastk			;CX = Handle
        mov	bx,cx			;BX = DOS Handle
        lds	si,[bp+10]		;(DS:SI) = (CCA%(1))
        mov	cx,ds:[si]		;CX = bytes to write
        mov	dx,si			;DS:DX = buffer start
        mov	ah,writef		;DOS Function 21h, 40h
        int	dos			;write it
        jc	wrbie1			;carry, not ok, AX = error code
        xor	ax,ax			;no carry, AX = 0
wrbie1:	mov	bl,2			;2 parameters
	jmp	bakbas
;
WRBIE	endp
;
;
; FUNCTION reads BIE-File. It is assumed as open. Handle% has the DOS
;          handle, CCA% the data to be read and Bytes how many bytes to read
;          RdBie% returns zero if ok, else DOS error code
;    if not RdBie%(CCA%(1),Handle%,Bytes%) then ok
;----------------------------------------------------------------------------
;
RDBIE	proc	far
	public	RDBIE
;
	call	pbastk			;CX = Bytes
        lds	si,[bp+10]		;access handle
        mov	bx,ds:[si]		;BX = DOS handle
        lds	si,[bp+14]		;access CCA%
        mov	dx,si			;DS:DX = buffer
        mov	ah,readf		;DOS function 21h, 3fh
	int	dos			;read CX bytes
        jc	rdbie1			;error code in AX
        xor	ax,ax
rdbie1:	mov	bl,3			;3 parameters
	jmp	bakbas
;
RDBIE	endp
;
;
; LOCAL SUBROUTINES
;============================================================================
;
; SUBROUTINE checks end of data. Returns carry if data end.
;            AH = -1 for replicate and 0 for copy
;----------------------------------------------------------------------------
;
CHKEND	proc	near
;
        cmp	dx,cx			;is rest of data > data to rep/cop
        jnc	chken2			;if yes, ok
        mov	cx,dx			;else only rest of bytes
        mov	dx,0			;clear DX
	inc	ah			;check replicate
        jz	chken1			;go replicate
        rep	movsb			;copy
        jmp	short chken2
chken1: rep	stosb			;replicate
chken2: sub	dx,cx			;adjust counter
	ret
;
;
CHKEND	endp
;
;
code	ends
	end
;
;=======================-<931225 HoroSoft, CH-3952 Susten>-==================
;
